SystemOrganization addCategory: #SqueakSVN!
SystemOrganization addCategory: #'SqueakSVN-AcceptanceTests'!
SystemOrganization addCategory: #'SqueakSVN-Base'!
SystemOrganization addCategory: #'SqueakSVN-Base-Test'!
SystemOrganization addCategory: #'SqueakSVN-Requests'!
SystemOrganization addCategory: #'SqueakSVN-Requests-Test'!
SystemOrganization addCategory: #'SqueakSVN-Serializing'!
SystemOrganization addCategory: #'SqueakSVN-Serializing-Test'!
SystemOrganization addCategory: #'SqueakSVN-TestBase'!
SystemOrganization addCategory: #'SqueakSVN-TestBase-Test'!
SystemOrganization addCategory: #'SqueakSVN-TestCategory'!
SystemOrganization addCategory: #'SqueakSVN-OBSystemBrowser'!
SystemOrganization addCategory: #'SqueakSVN-UITests'!
SystemOrganization addCategory: #'SqueakSVN-Tools'!
SystemOrganization addCategory: #'SqueakSVN-Tools-Nodes'!
SystemOrganization addCategory: #'SqueakSVN-Commands'!
SystemOrganization addCategory: #'SqueakSVN-Commands-Test'!
SystemOrganization addCategory: #'SqueakSVN-Diffing'!
SystemOrganization addCategory: #'SqueakSVN-Diffing-Tests'!
SystemOrganization addCategory: #'SqueakSVN-Environment'!
SystemOrganization addCategory: #'SqueakSVN-Environment-Test'!
SystemOrganization addCategory: #'SqueakSVN-RepositoryBrowsing'!

!String methodsFor: '*SqueakSVN' stamp: 'rkrk 3/26/2008 15:48'!
forSvnPrimitive

	^ {(self , (Character value: 0) asString) convertToSystemString} asOrderedCollection.! !

!String methodsFor: '*SqueakSVN' stamp: 'rt 4/25/2008 15:11'!
forSvnPrimitiveAsString

	^ self forSvnPrimitive first! !

!String methodsFor: '*SqueakSVN' stamp: 'rkrk 5/12/2008 04:35'!
pathForSvn

	"SVN needs path strings in a canonical form"
	| returnPath |
	self flag: #TODO.
	returnPath := (self collect: [:c | c = $\ ifTrue: [$/] ifFalse: [c]]) withoutAnyClosingSlashs.
	((returnPath at: 4 ifAbsent: [^returnPath]) = $/) ifFalse: [^returnPath].
	^ (returnPath copyFrom: 1 to: 3), (returnPath copyFrom: 5 to: returnPath size).! !

!String methodsFor: '*SqueakSVN' stamp: 'rt 5/7/2008 13:37'!
withoutAnyClosingSlashs

	((self endsWith: '/') or: [self endsWith: '\'])
		ifFalse: [^ self].
	^ (self copyFrom: 1 to: self size - 1) withoutAnyClosingSlashs! !

!OBMetaNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/17/2008 10:58'!
svnFilters

	^ filters! !

!OBMetaNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/17/2008 10:54'!
svnWithAllChildrenDo: aBlock

	"Copied from OBRefactory"
	self svnWithAllChildrenDo: aBlock seen: IdentitySet new! !

!OBMetaNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/17/2008 10:56'!
svnWithAllChildrenDo: aBlock seen: aSet

	"Copied from OBRefactory"
	(aSet includes: self) ifTrue: [ ^ self ].
	aSet add: self.
	aBlock value: self.
	self edges do: [ :each | each metaNode svnWithAllChildrenDo: aBlock seen: aSet ]! !

Morph subclass: #SVNObservingMorph
	instanceVariableNames: 'process ppro'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

!SVNObservingMorph methodsFor: 'menus' stamp: 'rkrk 3/16/2008 06:57'!
changeColor

	| mgr ratio |
	mgr := SVNTestDirectoryManager getInstance.
	(mgr basicTestDirectories size = 0 or: [mgr svnAwareTestDirectories size = 0])
		ifTrue: [^ Color blue].
	ratio := mgr numberOfCleanBasicTestDirectories < mgr numberOfCleanSvnAwareTestDirectories
		ifTrue: [mgr numberOfCleanBasicTestDirectories / mgr basicTestDirectories size]
		ifFalse: [mgr numberOfCleanSvnAwareTestDirectories / mgr svnAwareTestDirectories size].
	self color: (Color r: 1 - ratio g: ratio b: 0).! !

!SVNObservingMorph methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 18:57'!
correctPosition

	self position: self world position x @ (self world height - self height - 20).! !

!SVNObservingMorph methodsFor: 'event handling' stamp: 'rkrk 3/16/2008 07:01'!
handlesMouseDown: evt

	^ true! !

!SVNObservingMorph methodsFor: 'event handling' stamp: 'rkrk 3/16/2008 07:02'!
mouseDown: evt

	SVNTestDirectoryManager reCreate! !

!SVNObservingMorph methodsFor: 'stepping and presenter' stamp: 'rt 3/20/2008 16:07'!
start

	process := [
		[self
			correctPosition;
			changeColor.
		(Delay forSeconds: 5) wait] repeat
	] forkAt: Processor userBackgroundPriority.! !

!SVNObservingMorph methodsFor: 'stepping and presenter' stamp: 'rkrk 3/16/2008 04:03'!
stop

	process terminate.! !

OBReadOnlyDefinition subclass: #OBSVNBlameDefinition
	instanceVariableNames: 'blame blameArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNBlameDefinition methodsFor: 'accessing' stamp: 'cop 3/6/2008 13:28'!
blame
	^blame! !

!OBSVNBlameDefinition methodsFor: 'accessing' stamp: 'cop 4/3/2008 13:24'!
blameArray
	^blameArray! !

!OBSVNBlameDefinition methodsFor: 'initialize-release' stamp: 'cop 3/6/2008 12:58'!
initialize
	super initialize.
	blame := false.! !

!OBSVNBlameDefinition methodsFor: 'callbacks' stamp: 'cop 4/3/2008 13:23'!
setBlameArray: anArray
	blameArray := anArray.
	blame := true.! !

OBReadOnlyDefinition subclass: #OBSVNDiffDefinition
	instanceVariableNames: 'oldText newText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

OBSVNDiffDefinition class
	instanceVariableNames: 'oldText newText'!

OBSVNDiffDefinition class
	instanceVariableNames: 'oldText newText'!

!OBSVNDiffDefinition class methodsFor: 'class initialization' stamp: 'cop 5/5/2008 15:44'!
from: anOldText to: aNewText
	
	^self new 
		oldText: anOldText;
		newText: aNewText! !

!OBSVNDiffDefinition methodsFor: 'accessing' stamp: 'cop 5/5/2008 16:55'!
newText

	^newText! !

!OBSVNDiffDefinition methodsFor: 'accessing' stamp: 'cop 5/5/2008 16:56'!
newText: aText

	newText := aText! !

!OBSVNDiffDefinition methodsFor: 'accessing' stamp: 'cop 5/5/2008 16:56'!
oldText

	^oldText! !

!OBSVNDiffDefinition methodsFor: 'accessing' stamp: 'cop 5/5/2008 16:56'!
oldText: aText

	oldText := aText! !

!ToolBuilder methodsFor: '*SqueakSVN' stamp: 'rkrk 5/13/2008 01:19'!
diffSpec

	^ DiffSpec! !

OBCmdMultiView subclass: #OBSVNCmdMultiView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNCmdMultiView methodsFor: 'execution' stamp: 'cop 5/10/2008 20:19'!
execute
	|viewType labels aSVNMethod svnLabels |
	labels := #(Source Bytecode Decompile PrettyPrint).
	svnLabels := #(#Blame).
	
	aSVNMethod := requestor browser svnEnvironment findSvnMethodForMethod: (target theClass lookupSelector: target selector).	
	
	(Smalltalk hasClassNamed: 'DiffMorph')
		ifTrue: [svnLabels := svnLabels, #(#Diff)].
		
	aSVNMethod ifNotNil:
		[labels := labels, svnLabels.].
	viewType := OBChoiceRequest labels: labels.
	viewType ifNotNil: [
		(svnLabels includes: viewType)
		ifTrue: [self perform: (#toggle, viewType, #:) asSymbol with: aSVNMethod ]
		ifFalse: [self perform: (#toggle, viewType) asSymbol]].
	! !

!OBSVNCmdMultiView methodsFor: 'utils' stamp: 'cop 4/7/2008 17:36'!
setBlameArrayInDefinitionPanelForBlame: anArray

	(requestor announce: OBAboutToChange) isVetoed
		ifFalse: [requestor
				announce: (OBSVNBlameDefinition new setBlameArray: anArray;
							 yourself)]! !

!OBSVNCmdMultiView methodsFor: 'utils' stamp: 'cop 5/5/2008 17:07'!
setDiffInDefinitionPanelFrom: anOldText To: aNewText 

	(requestor announce: OBAboutToChange) isVetoed
		ifFalse: [requestor
				announce: (OBSVNDiffDefinition from: anOldText to: aNewText)]! !

!OBSVNCmdMultiView methodsFor: 'utils' stamp: 'rkrk 5/10/2008 19:03'!
toggleBlame: aSVNMethod
	
	self setBlameArrayInDefinitionPanelForBlame: aSVNMethod blame tableCollection.! !

!OBSVNCmdMultiView methodsFor: 'utils' stamp: 'cop 5/13/2008 10:35'!
toggleDiff: aSVNMethod
	
	| svnRevision catText |
	aSVNMethod isModified
		ifTrue: [svnRevision := SVNRevision base]
		ifFalse: [svnRevision := SVNRevision head].
	catText := (SVNCatRequest target: aSVNMethod file forRevision: svnRevision) execute contentOfTarget.
	aSVNMethod isModified
		ifTrue: [self setDiffInDefinitionPanelFrom: catText To: aSVNMethod source]
		ifFalse: [self setDiffInDefinitionPanelFrom: aSVNMethod source To: catText]! !

OBMetagraphBuilder subclass: #OBSVNMetagraphBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNMetagraphBuilder methodsFor: 'private' stamp: 'rkrk 3/6/2008 11:21'!
populateClassNode
     super populateClassNode.
	(self classMetaNode)
		addFilter: OBSVNStatusIconClassFilter new! !

!OBSVNMetagraphBuilder methodsFor: 'private' stamp: 'rkrk 4/12/2008 22:01'!
populateMetaclassNode

     super populateMetaclassNode.
	(self metaclassMetaNode)
		addFilter: OBSVNStatusIconClassFilter new.! !

!OBSVNMetagraphBuilder methodsFor: 'private' stamp: 'rkrk 3/6/2008 11:19'!
populateMethodNode

	self methodMetaNode 
		ancestrySelector: #isDescendantOfMethod:; "What's that? 'Needed??"
		addFilter: OBSVNStatusIconMethodFilter new! !

!OBMorphBuilder methodsFor: '*SqueakSVN' stamp: 'cop 4/8/2008 17:21'!
panelArea: aDefinitionPanel with: aBlock 
	| morph definitionMorph textMorph |
	morph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;		
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself. 
			
	definitionMorph := (RectangleMorph new)
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;	
		minWidth: 300;	
		wrapCentering: #center;
		cellPositioning: #topLeft;
		rubberBandCells: true;
		layoutInset: 2;
		cellInset: 2;
		color: Color white;
		yourself.     

	textMorph := aDefinitionPanel createContentMorph.		
     aDefinitionPanel setContentMorph: textMorph.		
	definitionMorph addMorphBack: textMorph.	
	morph addMorphBack: definitionMorph.
			
	current ifNotNil: [current addMorphBack: morph].
	self current: morph do: aBlock.
     ^definitionMorph! !

!OBMorphBuilder methodsFor: '*SqueakSVN' stamp: 'rkrk 4/7/2008 22:33'!
svnPane: aColumn with: aBlock 
	| pane divider |
	pane := OBPane new.
	pane
		model: aColumn;
		height: Preferences standardCodeFont height * 3.2;
		vResizing: #rigid;
		hResizing: #spaceFill;
		clipSubmorphs: true;
		color: Color transparent;
		cellInset: 0;
		borderWidth: 0;
		layoutPolicy: ProportionalLayout new;
		addList: (self listMorphForColumn: aColumn).
	"current ifNotNil: [current pushPane: pane]."
"	self halt."
	current ifNotNil: 
		[current addMorphBack: pane.
			self current: pane do: aBlock.
			divider := (BorderedSubpaneDividerMorph horizontal)
				color: aColumn browser defaultBackgroundColor duller;
				styleWith: OBMorphBuilder new.
			current addMorphBack: divider].
	^ pane! !

!CompiledMethod methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 22:33'!
includedInSvnEnvironment: svnEnvironment

	^ (svnEnvironment findSvnMethodForMethodRef: self methodReference) notNil! !

TestCase subclass: #SVNTestCase
	instanceVariableNames: 'sut hasTouchedFileSystem hasModifiedSVNDummy directoryManager slash svnRegistry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

SVNTestCase subclass: #SVNAuthenticationRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNAuthenticationRequestTest methodsFor: 'running' stamp: 'rt 4/24/2008 12:16'!
setUp

	super setUp.
	self willNeedRepositoryAndWorkingCopy.

	"remember the auth values ?"
	
	"set username and password to test values"
	(SVNAuthenticationRequest onUsername: 'AuthTestUser' andPassword: 'AuthTestKey') execute.! !

!SVNAuthenticationRequestTest methodsFor: 'running' stamp: 'rt 4/21/2008 18:52'!
tearDown

	"try to reset"
	(SVNAuthenticationRequest onUsername: 'DEFAULTUSER' andPassword: 'PASSWORD') execute.
	

	super tearDown! !

!SVNAuthenticationRequestTest methodsFor: 'tests' stamp: 'rt 4/24/2008 12:10'!
testSetUsersValuesInNewInstance

	| name key |
	name := 'Name'.
	key := 'Key'.
	
	sut := SVNAuthenticationRequest onUsername: name andPassword: key.
	self assert: sut username = name.
	self assert: sut password = key.! !

!SVNAuthenticationRequestTest methodsFor: 'tests' stamp: 'rt 4/24/2008 12:09'!
testSetUsersValuesInOldInstance

	| name key |
	sut := SVNAuthenticationRequest onUsername: 'Name' andPassword: 'Key'.
	
	name := 'NewName'.
	key := 'NewKey'.
	
	sut onUsername: name andPassword: key.
	self assert: sut username = name.
	self assert: sut password = key.! !

!SVNAuthenticationRequestTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 22:20'!
testUseUsersInput

	| project log |
	sut := 'UseUsersInputTestUser'.
	(SVNAuthenticationRequest onUsername: sut andPassword: 'UseUsersInputTestKey') execute.
	
	project := SVNProject
		checkoutProject: 'TestPro'
		fromURL: self repositoryURLPath
		inWorkingCopy: (SVNDirectory on: self workingCopyPath).
	
	log := project revisionInfos last.
	self assert: log author = sut! !

SVNTestCase subclass: #SVNBlameRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNBlameRequestTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/10/2008 19:20'!
testAcessingBlameLines

	sut := SVNBlameLinesRequest new.
	"#(1 2 3 4 5 ... 15)"
	sut blameLines: (1 to: 3 * sut numberOfItemsInLine) asArray.
	self assert: sut numberOfLinesRead = 3.
	self assert: (sut line: 1 at: 1) = 1.
	self assert: (sut line: 1 at: 4) = 4.
	self assert: (sut line: 1 at: 5) = 5.
	self assert: (sut line: 2 at: 1) = 6.
	self assert: (sut line: 3 at: 5) = 15.! !

!SVNBlameRequestTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/10/2008 19:17'!
testSvnGetBlameLinesFor

	| firstLine secondLine svnFile |
	self willNeedRepositoryAndWorkingCopy.
	"Prepare the authentication baton"
	(SVNAuthenticationRequest onUsername: 'DEFAULTUSER' andPassword: '') execute.
	firstLine := 'A line'.
	secondLine := 'Another line'.
	
	"Create file with content and commit it twice"
	svnFile := self defaultSVNDirectory
		createFileNamed: 'someFile'
		withContent: firstLine , String cr.
	svnFile
		store;
		commit; "First Revision"
		content: firstLine, String cr, secondLine;
		store;
		commit. "Second Revision"
	
	"exercise"
	sut := SVNBlameLinesRequest target: svnFile.
	sut execute.

	"assert"
	self assert: sut numberOfLines = 2.
	self assert: sut numberOfLinesRead = sut numberOfLines.
	self assert: (sut revisionForLine: 1) = '1'.
	self assert: (sut contentForLine: 1) = firstLine.
	self assert: (sut revisionForLine: 2) = '2'.
	self assert: (sut contentForLine: 2) = secondLine.
	
	self flag: #TODO. "Fix this"
	"self assert: ((sut authorForLine: 1) = 'DEFAULTUSER' )."
	"self assert: ((sut authorForLine: 2) = 'DEFAULTUSER' )."! !

SVNTestCase subclass: #SVNCatRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNCatRequestTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/8/2008 02:17'!
testSimpleCat01

	"(self selector: #testSimpleCat01) debug"
	| svnFile result fileContent |
	self willNeedRepositoryAndWorkingCopy.
	fileContent := 'this is content more'.
	svnFile := self defaultSVNDirectory
		createFileNamed: 'fileForCatTest'
		withContent: fileContent.
	svnFile
		store;
		commit.
	sut := SVNCatRequest target: svnFile forRevision: (SVNRevision number: 1).
	sut execute.
	result := sut contentOfTarget.
	self assert: result = fileContent.! !

!SVNCatRequestTest methodsFor: 'as yet unclassified' stamp: 'test 5/9/2008 11:19'!
testSimpleCat02

	"(self selector: #testSimpleCat02) run"
	| svnFile result fileContent |
	self willNeedRepositoryAndWorkingCopy.
	fileContent := 'this is content more'.
	svnFile := self defaultSVNDirectory
		createFileNamed: 'fileForCatTest'
		withContent: fileContent.
	svnFile
		store;
		commit;
		content: 'blablablabla';
		store;
		commit.
	sut := SVNCatRequest target: svnFile forRevision: (SVNRevision number: 1).
	sut execute.
	result := sut contentOfTarget.
	self assert: result = fileContent.! !

SVNTestCase subclass: #SVNClassOnlyInOneProjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-AcceptanceTests'!

!SVNClassOnlyInOneProjectTest methodsFor: 'helper' stamp: 'per 4/29/2008 10:47'!
createClassNamed: nameOfClass

	^ Object
		subclass: nameOfClass asSymbol
		instanceVariableNames: 'i1'
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category.! !

!SVNClassOnlyInOneProjectTest methodsFor: 'helper' stamp: 'per 4/29/2008 10:47'!
nameOfAClass
	^ 'ClassCreatedInSVNAccepatanceTests'! !

!SVNClassOnlyInOneProjectTest methodsFor: 'running' stamp: 'per 4/29/2008 10:48'!
tearDown

	super tearDown.
	Smalltalk
		at: self nameOfAClass asSymbol
		ifPresent: [:class | class removeFromSystemUnlogged].! !

!SVNClassOnlyInOneProjectTest methodsFor: 'tests' stamp: 'per 4/30/2008 13:16'!
test01

	| svnProject01 svnProject02 workingCopyDir nameOfProject01 nameOfProject02 revision |
	self willNeedRepositoryAndWorkingCopy.
	
	"Create new project. Add SVNDummy Class to the project and commit."
	nameOfProject01 := 'FirstProject'.
	nameOfProject02 := 'SecondProject'.
	
	svnProject01 := SVNProject named: nameOfProject01.
	workingCopyDir := SVNDirectory on: self workingCopyPath.
	svnProject01
		directory: (workingCopyDir createSubDirectoryNamed: nameOfProject01);
		addClass: self svnDummy;
		commit;
		removeClass: self svnDummy;
		commit.
	
	svnProject02 := SVNProject named: nameOfProject02.
	svnProject02
		directory: (workingCopyDir createSubDirectoryNamed: nameOfProject02);
		addClass: self svnDummy;
		commit.

	revision:= svnProject01 svnInfo revision.
	revision number: svnProject01 svnInfo revision number -1.
	svnProject01 updateToRevision: revision.	
	
	self assert: (svnProject01 versionedClasses noneSatisfy: [:ea |
		ea theName = self svnDummy name asString])! !

SVNTestCase subclass: #SVNClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClassTest subclass: #PoolDictionariesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 3/12/2008 13:41'!
nameOfPoolDictionary
	^ 'TestStoringAndRestoringOfPoolDictionariesClass'! !

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 3/12/2008 13:17'!
nameOfTestClass
	^ 'PoolDictionariesTestClass'! !

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 3/12/2008 13:41'!
setUp
	
	super setUp.
	
	self willTouchFileSystem.
	self willNeedRepositoryAndWorkingCopy.
	
	self assert: (Smalltalk at: self nameOfPoolDictionary asSymbol ifAbsent: [nil]) isNil.
	self deny: (Smalltalk hasClassNamed: self nameOfTestClass).
	
	Smalltalk at: (self nameOfPoolDictionary asSymbol) put: (Dictionary new).
	
	Object
		subclass: self nameOfTestClass asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: self nameOfPoolDictionary
		category: self class category asString.! !

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 3/17/2008 15:12'!
tearDown

	super tearDown.
	
	(Smalltalk classNamed: self nameOfTestClass) removeFromSystem.
	Smalltalk removeKey: self nameOfPoolDictionary asSymbol.
	
	self assert: (Smalltalk at: self nameOfPoolDictionary asSymbol ifAbsent: [nil]) isNil.
	self deny: (Smalltalk hasClassNamed: self nameOfTestClass).! !

!PoolDictionariesTest methodsFor: 'as yet unclassified' stamp: 'rt 4/27/2008 00:56'!
testStoringAndRestoringOfPoolDictionaries

	| svnProject |
	svnProject := SVNProject checkoutProject: 'TestPro' fromURL: self repositoryURLPath inWorkingCopy: (SVNDirectory on: self workingCopyPath).
	
	svnProject addClass: (Smalltalk classNamed: self nameOfTestClass).
	svnProject commit.

	(Smalltalk classNamed: self nameOfTestClass) removeFromSystem.
	self deny: (Smalltalk classNamed: self nameOfTestClass) notNil.
	
	Smalltalk removeKey: self nameOfPoolDictionary asSymbol.
	self assert: (Smalltalk at: self nameOfPoolDictionary asSymbol ifAbsent: [nil]) isNil.
	
	"restore"
	OSProcess waitForCommand: 'svn revert -R ', svnProject directory path.
	svnProject restoreAndLoad.
	
	"check"
	self assert: (Smalltalk at: self nameOfPoolDictionary asSymbol ifAbsent: [nil]) notNil.
	self assert: (Smalltalk hasClassNamed: self nameOfTestClass).
	
	self assert: (Smalltalk at: self nameOfTestClass asSymbol) poolDictionaryNames = (OrderedCollection with: self nameOfPoolDictionary asSymbol).! !

SVNClassTest subclass: #SVNClassExternalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNClassExternalTest methodsFor: 'tests' stamp: 'rt 5/12/2008 19:06'!
testRevertClassWithAddedMethod

	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	sut := (SVNClass forExistingClass: self svnDummy)
		directory: (self svnDirectoryForWorkingCopy
			createSubDirectoryNamed: self svnDummy asString);
		establishSvnFilesAndDirectories;
		store;
		yourself.
	sut directory store.
	sut commitWithMessage: 'Added SVNDummy'.
	
	self svnDummy compile: self selectorForMethodWhichIsNotInSvnDummy.
	sut
		addCompiledMethod: self svnDummy >> self selectorForMethodWhichIsNotInSvnDummy;
		store.
	sut directory store.
	sut revert.
	sut versionedMethods isEmpty.! !

!SVNClassExternalTest methodsFor: 'tests' stamp: 'rt 5/12/2008 19:06'!
testUpdateClassWithMethodToRevisionWithoutMethod

	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	
	sut := (SVNClass forExistingClass: self svnDummy)
		directory: (self svnDirectoryForWorkingCopy
			createSubDirectoryNamed: self svnDummy asString);
		establishSvnFilesAndDirectories;
		store;
		yourself.
	sut directory store.
	sut commitWithMessage: 'Added SVNDummy'.
	
	self svnDummy compile: self selectorForMethodWhichIsNotInSvnDummy.
	sut
		addCompiledMethod: self svnDummy >> self selectorForMethodWhichIsNotInSvnDummy;
		store.
	sut directory store.
	sut commitWithMessage: 'Added a method'.
	
	sut updateToRevision: (SVNRevision number: ( (sut versionedMethods detect: [:me |
		me theName = self selectorForMethodWhichIsNotInSvnDummy asString]) revisionInfos last revision) - 1).
	
	self deny: ((sut versionedMethods collect: [:me | me theName])
		includes: self selectorForMethodWhichIsNotInSvnDummy asString)! !

!SVNClassTest methodsFor: 'assertion' stamp: 'rkrk 4/1/2008 18:14'!
assertDirectoryEntriesEstablishedIn: svnClass

	| rootDir |
	self flag: #TODO. "Mapping details"
	rootDir := svnClass directory.
	rootDir theName = svnClass theName.
	
	self assert: (rootDir directoryExists: 'class').
	self assert: (rootDir directoryExists: 'instance').
	"class details"
	self assert: (rootDir fileExists: 'category').
	self assert: (rootDir fileExists: 'classInstanceVariables').
	self assert: (rootDir fileExists: 'classVariables').
	self assert: (rootDir fileExists: 'comment').
	self assert: (rootDir fileExists: 'instanceVariables').
	self assert: (rootDir fileExists: 'poolDictionaries').
	self assert: (rootDir fileExists: 'superclass').! !

!SVNClassTest methodsFor: 'assertion' stamp: 'rt 3/10/2008 13:18'!
assertSVNClass: aSVNClass hasStateFromSystemClass: aClass 
	| instanceMethodSelectors expectedMethodSelectors classMethodSelectors expectedclassMethodSelectors |
	self assert: aSVNClass theName = aClass name.
	self assert: aSVNClass superclassName = aClass superclass name.
	self assert: aSVNClass instanceVariables = aClass instVarNames.
	self assert: aSVNClass classVariables = aClass classVarNames.
	self assert: aSVNClass classInstanceVariables = aClass class instVarNames.
	self assert: aSVNClass comment = aClass comment.
	self assert: aSVNClass category = aClass category.
	self flag: #TODO.
	"Implementation details about the file mapping
	are spread here"
	instanceMethodSelectors := (aSVNClass versionedMethods select: [:each | each isPartOfMetaclass not])
				collect: [:each | each theName].
	expectedMethodSelectors := aClass methodDict
				collect: [:each | each selector asString].
	self assert: instanceMethodSelectors asSet = expectedMethodSelectors asSet.
	classMethodSelectors := (aSVNClass versionedMethods select: [:each | each isPartOfMetaclass])
				collect: [:each | each theName].
	expectedclassMethodSelectors := aClass class methodDict
				collect: [:each | each selector asString].
	self assert: classMethodSelectors asSet = expectedclassMethodSelectors asSet! !

!SVNClassTest methodsFor: 'helper' stamp: 'rkrk 4/15/2008 00:35'!
configureSVNClass: svnClass forLoadingClassNamed: aString 
	
	self assert: (Smalltalk hasClassNamed: aString) not.
	svnClass
		theName: aString asString;
		superclassName: 'Object';
		instanceVariables: #('a');
		classVariables: #('A');
		classInstanceVariables: #('b');
		poolDictionaries: #();
		comment: '';
		category: self class category.! !

!SVNClassTest methodsFor: 'helper' stamp: 'mu 4/23/2008 14:10'!
methodSelector
	^ #m2! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 4/30/2008 10:16'!
newClassName
	^ 'NeuerDummy'! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 4/23/2008 14:48'!
testAddMethod

	"Setup"
	| className svnMethod1 svnMethod2 |
	sut := SVNClass new.
	className := 'PleaseDoNotExist'.
	self
		configureSVNClass: sut
		forLoadingClassNamed: className.
	sut establishSvnFilesAndDirectories.
	svnMethod1 := SVNMethod new
		theName: 'blabla';
		nameOfClass: className;
		establishSvnFilesAndDirectories;
		yourself.
	svnMethod2 := SVNMethod new
		theName: 'blabla';
		nameOfClass: className , ' class';
		establishSvnFilesAndDirectories;
		yourself.
	"Execution"
	sut
		addMethod: svnMethod1;
		addMethod: svnMethod2.
	"Assertion"
	self assert: (sut versionedMethods includes: svnMethod1).
	self assert: (sut versionedMethods includes: svnMethod2).
	self assert: ('*' , className , '*' match: svnMethod1 file basePath).
	self assert: ('*instance*' match: svnMethod1 file basePath).
	self assert: ('*class*' match: svnMethod2 file basePath).! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'mu 4/23/2008 13:52'!
testAllClassMethodsExists
	"Setup"
	| expectedFileNames directoryOfMethods actualFileNames |
	sut := self createDummyClassForTests.
	self defaultSVNDirectory addSubdirectory: sut directory.
	"Execution"
	sut store.
	self flag: #TODO.
	"Mapping implementation is spread here..."
	directoryOfMethods := sut directory getSubDirectoryNamed: self classClass.
	"Assertion"
	expectedFileNames := (self svnDummy class methodDict collect: 
				[ :each | each selector asString ]) asSet.
	actualFileNames := directoryOfMethods files collect: 
				[ :each | each theName ].
	self assert: expectedFileNames asSet = actualFileNames asSet! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'mu 4/23/2008 13:46'!
testAllInstanceMethodsExists
	"Setup"
	| expectedFileNames directoryOfMethods actualFileNames |
	sut := self createDummyClassForTests.
	self defaultSVNDirectory addSubdirectory: sut directory.
	"Execution"
	sut store.
	self flag: #TODO.
	"Mapping implementation is spread here..."
	directoryOfMethods := sut directory getSubDirectoryNamed: self classInstance.
	"Assertion"
	self assert: directoryOfMethods notNil.
	expectedFileNames := (self svnDummy methodDict collect: 
				[ :each | each selector asString ]) asSet.
	actualFileNames := directoryOfMethods files collect: 
				[ :each | each theName ].
	self assert: expectedFileNames = actualFileNames asSet! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 4/23/2008 14:44'!
testCreatingForExistingClassInitializesSVNClassCorrectly

	"Execution"
	sut := self createDummyClassForTests.
	"Assertion"
	self
		assertSVNClass: sut
		hasStateFromSystemClass: self svnDummy.
	self assertDirectoryEntriesEstablishedIn: sut
		! !

!SVNClassTest methodsFor: 'tests restoring' stamp: 'mu 4/23/2008 13:59'!
testCreatingForSerializedClassInitializesSVNClassCorrectly

	| classFilesCreator |
	"Setup"
	classFilesCreator := self createDummyClassForTests.
	self defaultSVNDirectory addSubdirectory: classFilesCreator directory.
	"Execution"
	classFilesCreator store.
	sut := SVNClass restoreFrom: classFilesCreator directory.
	"Assertion"
	self
		assertSVNClass: sut
		hasStateFromSystemClass: self svnDummy.! !

!SVNClassTest methodsFor: 'tests' stamp: 'test 4/23/2008 14:42'!
testDeleteClass

	| svnClass class |
	"Setup"
	class := Object
				subclass: #OnlyForThisTest
				instanceVariableNames: ''
				classVariableNames: ''
				poolDictionaries: ''
				category: self class category asString.
	svnClass := SVNClass forExistingClass: class.
	"Execution"
	class removeFromSystem.
	"Assertion"
	self assert: (svnClass theClass isNil).
	! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 4/23/2008 14:14'!
testEqual

	| sut1 sut2 |
	"Setup"
	sut1 := self createDummyClassForTests.
	sut2 := self createDummyClassForTests.
	"Assertion"
	self assert: sut1 = sut2.! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 4/23/2008 14:13'!
testGetSVNMethodsFromClass

	| expectedInstanceMethods expectedClassMethods |
	"Setup"
	sut := self createDummyClassForTests.
	"Expected"
	expectedInstanceMethods := self svnDummy methodDict collect: [:each |
		SVNMethod forExistingMethod: each].
	expectedClassMethods := self svnDummy class methodDict collect: [:each |
		SVNMethod forExistingMethod: each].
	"Assertion"
	self assert: sut versionedMethods = (expectedInstanceMethods union: expectedClassMethods) asSet.! !

!SVNClassTest methodsFor: 'tests restoring' stamp: 'mu 4/23/2008 13:57'!
testLoadClass
	
	| className |
	"Setup"
	sut := SVNClass new.
	className := 'SVNDummy99'.
	self
		configureSVNClass: sut
		forLoadingClassNamed: className.
	"Execution"
	[sut load.
	"Assertion"
	self assert: (Smalltalk hasClassNamed: className).
	self flag: #TODO. "Test for the correct initialization of
	variables and comment	of the created class!!"
	] ensure: [Smalltalk
				at: className asSymbol
				ifPresent: [:class | class removeFromSystemUnlogged]].! !

!SVNClassTest methodsFor: 'tests restoring' stamp: 'rkrk 5/13/2008 06:54'!
testLoadClassWithRemovedInstVars
	
	"(self selector: #testLoadClassWithRemovedInstVars) run"
	self willModifySVNDummy.
	sut := SVNClass forExistingClass: self svnDummy.
	sut instanceVariables: sut instanceVariables copyWithoutFirst.
	sut load.
	self assert: self svnDummy instVarNames size = sut instanceVariables size.
	sut instanceVariables do: [:ea |
		self assert: (self svnDummy instVarNames includes: ea)].! !

!SVNClassTest methodsFor: 'tests restoring' stamp: 'mu 4/23/2008 13:54'!
testLoadExistingClassAndRestoreDeletedMethod
	
	| methodSelector |
	"Setup"
	methodSelector := #m2.
	sut := SVNClass forExistingClass: self svnDummy.
	self svnDummy removeSelector: methodSelector.
	"Execution"
	sut load.
	"Assertion"
	self assert: (self svnDummy selectors includes: methodSelector).! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 4/23/2008 14:21'!
testLoadingAExistingClassWithoutAMethodShouldRemoveTheMethod
	"Setup"
	| class |
	self flag: #TODO.	"why ? a class with unversioned methods should not lose all methods."
	self willModifySVNDummy.
	class := self svnDummy.
	"Execution"
	sut := SVNClass forExistingClass: class.
	self assert: (class selectors includes: self methodSelector).
	sut removeSVNMethod: 
		(SVNMethod forExistingMethod: class >> self methodSelector).
	sut load.
	"Assertion"
	self deny: (class selectors includes: self methodSelector).
	self restoreSVNDummy! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 4/26/2008 16:40'!
testModifyInstanceVariables

	| svnClass |
	self
		willModifySVNDummy;
		willNeedRegistry.
	self svnEnvironment addSvnProject: self createSvnProjectWithSvnDummy.
	self svnDummy addInstVarName: 'newVar'.
	svnClass := self svnEnvironment findSvnClassFor: self svnDummy.
	self assert: svnClass notNil.
	self assert: (svnClass instanceVariables includes: 'newVar').! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 4/23/2008 14:08'!
testNotEqual

	| sut1 sut2 |
	"Setup"
	sut1 := SVNClass forExistingClass: self svnDummy.
	sut2 := SVNClass forExistingClass: self class.
	"Assertion"
	self deny: sut1 = sut2.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 02:52'!
testRemovIngAMethodAlsoRemovesFiles

	| svnMethod |
	"(self selector: #testRemovIngAMethodAlsoRemovesFiles) run"
	"Setup"
	sut := self createDummyClassForTests .
	svnMethod := sut versionedMethods
		detect: [:ea | ea theName = self methodSelector asString]
		ifNone: [self assert: false].
	"Execution"
	sut removeSVNMethod: svnMethod.
	"Assertion"
	self deny: (sut versionedMethods includes: svnMethod).
	self flag: #TODO. "Get rid of instance/class ... use accessors or such"
	self assert: ((sut directory getSubDirectoryNamed: 'instance') files
		noneSatisfy: [:ea | ea theName = self methodSelector asString]).! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 4/23/2008 14:07'!
testRemoveClassFromVersioningControl

	| svnProject svnClass |
	"Setup"
	self flag: #TODO.
	self willTouchFileSystem.
	svnProject := SVNProject named: 'TestPro'.
	svnProject directory: (self defaultSVNDirectory createSubDirectoryNamed: svnProject theName).
	svnClass := SVNClass forExistingClass: self svnDummy.
	svnProject addSVNClass: svnClass.
	"Execution"
	svnProject removeClass: self svnDummy.
	"Assertion"
	self deny: (svnProject versionedClasses includes: svnClass).! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 02:45'!
testRemoveMethod

	| svnMethod |
	"Setup"
	sut := self createDummyClassForTests .
	svnMethod := sut versionedMethods
		detect: [:ea | ea theName = self methodSelector asString]
		ifNone: [self assert: false].
	"Execution"
	sut removeSVNMethod: svnMethod.
	"Assertion"
	self deny: (sut versionedMethods includes: svnMethod).! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 4/30/2008 13:25'!
testRenameSVNClass
	| aClass svnClass |
	self willModifySVNDummy.
	self willNeedRepositoryAndWorkingCopy.
	sut := SVNProject named: 'TestPro'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'TestPro').
	aClass := self svnDummy.
	sut addClass: aClass.
	sut commit.
	svnClass := SVNClass forExistingClass: aClass.
	svnClass renameSVNClass: self newClassName.
	sut commit.
	self assert: [sut directory directoryExists: self newClassName].
	self assert: [sut versionedClasses includes: self newClassName].
	self deny: [sut directory directoryExists: (self svnDummy name asString)]! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 04:02'!
testRestoreRemovesNoLongerExistingMethods

	| methodSelector sizeOfVersionedMethods svnDir |
	"(self selector: #testRestoreRemovesNoLongerExistingMethods) run"
	"Setup"
	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	"prepare"
	"self halt."
	sut := self createDummyClassForTests.
	sut store.
	methodSelector := #m2.
	sizeOfVersionedMethods := sut versionedMethods size.
	svnDir := self defaultSVNDirectory.
	svnDir addSubdirectory: sut directory.
	svnDir store.
	(FileDirectory on: (sut directory getSubDirectoryNamed: 'instance') path)
		deleteFileNamed: methodSelector.
	"exercise"
	sut restoreAndLoad.
	self assert: sut versionedMethods size = (sizeOfVersionedMethods - 1).
	self deny: (self svnDummy selectors includes: methodSelector).! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 02:02'!
testSetWithSVNClassesAreEqual

	"(self selector: #testSetWithSVNClassesAreEqual) run"
	| set1 set2 anotherOne |
	sut := SVNClass forExistingClass: self svnDummy.
	anotherOne := (SVNClass forExistingClass: self svnDummy).
	self assert: sut = anotherOne.
	set1 := Set with: sut.
	set2 := Set with: anotherOne.
	self assert: set1 = set2.
	self assert: set1 = set1 copy.! !

!SVNClassTest methodsFor: 'tests' stamp: 'cop 4/23/2008 13:00'!
testStatus

	| svnMethod svnDir |
	self willNeedRepositoryAndWorkingCopy.
	svnDir := self defaultSVNDirectory.
	sut := SVNClass forExistingClass: self svnDummy.
	svnDir addSubdirectory: sut directory.
	svnMethod := SVNMethod new
		theName: 'blublu';
		nameOfClass: 'SVNDummy class';
		source: 'blub';
		establishSvnFilesAndDirectories;
		yourself.
	sut addMethod: svnMethod;
		store.
	sut directory store.
	self assert: sut status = #added.! !

!SVNClassTest methodsFor: 'tests' stamp: 'cop 4/23/2008 13:02'!
testStatusForClassMethods

	| svnMethod svnDir |
	self willNeedRepositoryAndWorkingCopy.
	svnDir := self defaultSVNDirectory.
	sut := SVNClass forExistingClass: self svnDummy.
	svnDir addSubdirectory: sut directory.
	sut 	store.
	sut directory store.
	sut commit.
	svnMethod := SVNMethod new
		theName: 'blublu';
		nameOfClass: 'SVNDummy class';
		source: 'blub';
		establishSvnFilesAndDirectories;
		yourself.
	sut addMethod: svnMethod;
		store.
	sut directory store.
	self assert: sut status = #modified.
	self assert: sut statusClassMethods = #modified.! !

!SVNClassTest methodsFor: 'tests' stamp: 'cop 4/23/2008 13:02'!
testStatusForComment

	| svnDir |
	self willNeedRepositoryAndWorkingCopy.
	svnDir := self defaultSVNDirectory.
	sut := SVNClass forExistingClass: self svnDummy.
	svnDir addSubdirectory: sut directory.
	sut 	store.
	sut directory store.
	sut commit.
	sut comment: 'Something'.
	sut 	store.
	sut directory store.
	self assert: sut status = #modified.
	self assert: sut statusComment = #modified.! !

!SVNClassTest methodsFor: 'tests' stamp: 'cop 4/23/2008 13:02'!
testStatusForInstanceMethods

	| svnMethod svnDir |
	self willNeedRepositoryAndWorkingCopy.
	svnDir := self defaultSVNDirectory.
	sut := SVNClass forExistingClass: self svnDummy.
	svnDir addSubdirectory: sut directory.
	sut 	store.
	sut directory store.
	sut commit.
	svnMethod := SVNMethod new
		theName: 'blublu';
		nameOfClass: 'SVNDummy';
		source: 'blub';
		establishSvnFilesAndDirectories;
		yourself.
	sut addMethod: svnMethod;
		store.
	sut directory store.
	self assert: sut status = #modified.
	self assert: sut statusInstanceMethods = #modified.! !

!SVNClassTest methodsFor: 'tests storing' stamp: 'mu 4/23/2008 13:47'!
testWriteCommentFile

	| createdFile |
	"Setup"
	sut := self createDummyClassForTests.
	self defaultSVNDirectory addSubdirectory: sut directory.
	"Execution"
	sut store.
	createdFile := sut directory getFileNamed: sut nameForCommentFile.
	"Assertion"
	self assert: (sut directory fileExists: sut nameForCommentFile).
	self assert: self svnDummy comment = createdFile content.! !

SVNClassTest subclass: #SVNRevisionInfoClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNRevisionInfoClassTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 18:55'!
testSvnRevisionInfos01

	sut := SVNClass forExistingClass: self svnDummy.
	sut store.
	self assert: sut revisionInfos isEmpty.! !

!SVNRevisionInfoClassTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 18:54'!
testSvnRevisionInfos02

	| svnDir |
	self willNeedRepositoryAndWorkingCopy.
	svnDir := self defaultSVNDirectory.
	sut := SVNClass forExistingClass: self svnDummy.
	svnDir addSubdirectory: sut directory.
	sut store.
	sut directory store.
	self assert: sut revisionInfos isEmpty.! !

!SVNRevisionInfoClassTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 20:14'!
testSvnRevisionInfos03

	| svnDir |
	self willNeedRepositoryAndWorkingCopy.
	svnDir := self defaultSVNDirectory.
	sut := SVNClass forExistingClass: self svnDummy.
	svnDir addSubdirectory: sut directory.
	sut store.
	sut directory store.
	sut commit.
	self assert: sut revisionInfos size = 1.! !

!SVNRevisionInfoClassTest methodsFor: 'tests' stamp: 'test 5/12/2008 22:29'!
testSvnRevisionInfos04

	| svnEnvironment svnProject |
	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy;
		willNeedRegistry.
	"Create Project with SVNDummy and check if class changes in SVNDummy have an effect"
	svnEnvironment := self createEnvironmentWithCurrentProjectAndSvnDummy.
	self assert: svnEnvironment svnProjects size = 1.
	svnProject := svnEnvironment svnProjects anyOne.
	sut := svnEnvironment findSvnClassFor: self svnDummy.
	self assert: sut notNil.
	self svnDummy addInstVarName: 'newInstVar'.
	svnProject store; commit.
	self svnDummy compile: 'totallyNewMethod '.
	svnProject store; commit.
	self assert: sut revisionInfos size = 2. "Adding a method affects not the class -
		is this a good idea???"! !

SVNTestCase subclass: #SVNClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClientTest subclass: #SVNClientExternalTest
	instanceVariableNames: 'fileToAdd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClientExternalTest subclass: #SVNCApiClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNCApiClientTest methodsFor: 'helper' stamp: 'mu 5/13/2008 13:49'!
newFileName

	^ 'NewFileName'! !

!SVNCApiClientTest methodsFor: 'running' stamp: 'rkrk 3/13/2008 22:07'!
setUp

	super setUp.
	sut := SVNCApiClient new.! !

!SVNCApiClientTest methodsFor: 'running' stamp: 'rkrk 3/14/2008 02:01'!
tearDown
	super tearDown.
	"self halt."! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 3/20/2008 13:57'!
testCleanupDirectory

	| workingDir |
	workingDir := FileDirectory on: self workingCopyPath , self slash , '.svn'.
	(workingDir fileNamed: 'lock') close.
	self assert: (workingDir fileExists: 'lock').
	
	sut svnCleanupDirectory: self workingCopyPath.
	
	self deny: (workingDir fileExists: 'lock').! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 22:18'!
testCountOfCommitLogs

	| path file request |
	self flag: #TODO. "This test do not uses the api client anymore.
	Move to RevisionInfoRequestTest or, if redundant, delete it!!"
	"----------------------------------------------------------------------"
	path := self workingCopyPath.
	request := SVNRevisionInfosRequest target: (SVNDirectory on: path). "equals defaultSVNDirectory!!"
	request execute.
	self assert: 1 = request commitLogs size.
	
	file := path, self slash, 'fileToAdd'.
	self createFile: file.
	sut svnAdd: file.
	sut svnCommit: {file}.
	
	request := SVNRevisionInfosRequest target: (SVNDirectory on: path).
	request execute.
	self assert: 2 = request commitLogs size.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 22:18'!
testCountOfCommitLogsIfTargetIsUnversioned

	| file request |
	self flag: #TODO. "This test do not uses the api client anymore.
	Move to RevisionInfoRequestTest or, if redundant, delete it!!"
	"----------------------------------------------------------------------"
	file := self workingCopyPath , self slash , 'aFile'.
	self createFile: file.
	request := SVNRevisionInfosRequest target: (SVNFile on: file).
	request execute.
	self assert: 0 = request commitLogs size.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 5/11/2008 01:37'!
testGetHeadRevision

	| result |
	result := (SVNInfoRequest headRevisionOf: self defaultSVNDirectory) number.
	self assert: result = 0. ! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 01:18'!
testSVNAdd

	| path |
	path := self workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	self 
		assertFile: fileToAdd
		wasSVNAddedIn: self workingCopyPath! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 02:08'!
testSvnAddPropertyWithValueTo

	| path fstream propertyPath propertiesContents |
	path := self workingCopyPath , self slash , fileToAdd.
	propertyPath := FileDirectory on: self workingCopyPath , self slash ,'.svn', self slash, 'props'.
	sut svnAdd: path.
	sut svnAddProperty: 'propertyName' WithValue: 'value' To: path.
	
	fstream := propertyPath readOnlyFileNamed: 'testFile.svn-work'.
	propertiesContents := fstream contents.
	fstream close.
	
	self assert: (propertiesContents includesSubString: 'propertyName').
	self assert: (propertiesContents includesSubString: 'value').
	! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:41'!
testSvnCheckoutHeadRevision

	| workingcopyDirectory workingCopyPath |
	workingCopyPath := self workingCopyPath.
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	"create a new head revision"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: {workingCopyPath , self slash , fileToAdd}.

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut
		svnCheckoutHeadRevisionFrom: self repositoryURLPath
		to: workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:40'!
testSvnCheckoutRevisionByNumber

	"create new revisions"
	| firstFileName pathToFirstFile secondFileName pathToSecondFile workingcopyDirectory workingCopyPath |
	workingCopyPath := self workingCopyPath.
	firstFileName := 'fileForFirstRevision'.
	pathToFirstFile := workingCopyPath , self slash , firstFileName.
	self createFile: pathToFirstFile.
	self assertThatFiles: {firstFileName} existsIn: workingCopyPath.
	sut svnAdd: pathToFirstFile.
	sut svnCommit: {pathToFirstFile}.
	
	secondFileName := 'fileForSecondRevision'.
	pathToSecondFile := workingCopyPath , self slash , secondFileName.
	self createFile: pathToSecondFile.
	self assertThatFiles: {secondFileName} existsIn: workingCopyPath.
	sut svnAdd: pathToSecondFile.
	sut svnCommit: {pathToSecondFile}.
	
	"recover the first revision"
	sut
		svnCheckoutRevisionByNumber: 1
		from: self repositoryURLPath
		to: workingCopyPath.
	
	"check if successed"
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	self assert: (workingcopyDirectory fileExists: firstFileName).
	self deny: (workingcopyDirectory fileExists: secondFileName).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 5/11/2008 01:40'!
testSvnCommit

	| startRevision endRevision svnFile |
	svnFile := self defaultSVNDirectory createFileNamed: fileToAdd.
	startRevision := (SVNInfoRequest headRevisionOf: self defaultSVNDirectory) number.
	svnFile
		store;
		commit.
	endRevision := (SVNInfoRequest headRevisionOf: self defaultSVNDirectory) number.
	self assert: startRevision + 1 = endRevision! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 18:16'!
testSvnCommitWithMessageAndRevsionNumber

	| svnFile commitLogs firstLogMessage secondLogMessage |
	
	firstLogMessage := 'this is a log message'.
	secondLogMessage := 'this is another logMessage'.

	svnFile := self defaultSVNDirectory createFileNamed: fileToAdd.
	svnFile store. "store also svn adds the file"
	"Commit the file, than change its contents and commit it a second time"
	sut
		svnCommit: {svnFile path}
		withMessage: firstLogMessage.
	"change the file for committing it a second time"
	svnFile content: '123'; store.
	sut
		svnCommit: {svnFile path}
		withMessage: secondLogMessage.
	 
	"assertion"
	commitLogs := svnFile commitLogs.
	self assert: commitLogs size = 2. "Two commits were done"
	self assert: commitLogs first revision = 1.
	self assert: commitLogs first comment = firstLogMessage.
	self assert: commitLogs second revision = 2.
	self assert: commitLogs second comment = secondLogMessage.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:34'!
testSvnDeleteFromWorkingCopyWithCommittedItems

	| file dir |
	file := self workingCopyPath , self slash , 'file'.
	dir := self workingCopyPath , self slash , 'dir'.
	
	self createFile: file.
	(FileDirectory on: dir) assureExistence.
	
	sut svnAdd: file.
	sut svnAdd: dir.
	sut svnCommit: {file. dir}.
	
	sut svnDeleteTargetsFromWorkingCopy: {file. dir}.
	
	self assert: (FileDirectory new directoryExists: dir).
	self deny: (FileDirectory new fileExists: file).
	
	sut svnCommit: {dir. file}.
	
	self deny:
			((FileDirectory new fileExists: file) or:
			[(FileDirectory new directoryExists: dir)])! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 04:40'!
testSvnDeleteFromWorkingCopyWithUncommittedItems

	| file1 file2 dir1 dir2 workingCopyPathTemplate |
	workingCopyPathTemplate := self workingCopyPath , self slash.
	file1 := workingCopyPathTemplate , 'file1'.
	file2 := workingCopyPathTemplate , 'file2'.
	dir1 := workingCopyPathTemplate , 'dir1'.
	dir2 := workingCopyPathTemplate , 'dir2'.
	
	self createFile: file1.
	self createFile: file2.
	(FileDirectory on: dir1) assureExistence.
	(FileDirectory on: dir2) assureExistence.
	
	sut svnAdd: file2.
	sut svnAdd: dir2.
	
	sut svnDeleteTargetsFromWorkingCopy: {file1. file2. dir1. dir2}.
	
	self deny:
			((FileDirectory new fileExists: file1) or:
			[(FileDirectory new fileExists: file2)] or:
			[(FileDirectory new directoryExists: dir1)] or:
			[(FileDirectory new directoryExists: dir2)])! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 5/10/2008 19:13'!
testSvnGetPropertyFrom

	| svnFile propKey propValue properties |
	svnFile := self defaultSVNDirectory createFileNamed: fileToAdd.
	propKey := 'propertyName'.
	propValue := 'value'.
	svnFile properties at: propKey put: propValue.
	svnFile store.
	"assert"
	properties := (SVNPropertiesRequest target: svnFile) execute; properties.
	self assert: (properties includesKey: propKey).
	self assert: propValue = (properties at: propKey).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'mu 5/13/2008 14:38'!
testSvnRename

	| svnFile svnFile2 |
	self halt.
	"prepare"
	svnFile := SVNFile named: fileToAdd basePath: self workingCopyPath.
	svnFile addEntry;
		commit.
	"execute"
	svnFile svnRenameEntry: svnFile path to: self workingCopyPath, self slash, self newFileName.
	svnFile2 := SVNFile named: self newFileName basePath: self workingCopyPath.
	"assert"
	self deny: [svnFile existsOnDisk].
	self assert: [svnFile2 existsOnDisk].! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 5/3/2008 19:18'!
testSvnResolvedTarget

	| originalContent fileName fileInFirstWC fileInSecondWC changedContent changedContent2 |
	self willNeedRepositoryAndTwoWorkingCopies.
	originalContent := 'ABCabcXYZxyz'.
	fileName := 'fileForUpdate'.
	"Create file in first directory and commit"
	fileInFirstWC := SVNFile
		named: fileName
		basePath: self workingCopyPath
		content: originalContent.
	fileInFirstWC
		store;
		commit.
	"Access file in second WC, change and commit"
	self svnDirectoryForWorkingCopy2 update.
	fileInSecondWC := SVNFile
		named: fileName
		basePath: self workingCopyPath2.
	fileInSecondWC read.
	self assert: fileInSecondWC content = originalContent.
	changedContent := '1234ABC12343749rzcnoqixuh'.
	fileInSecondWC
		content: changedContent;
		store;
		commit.
	"Change first file and update"
	changedContent2 := 'sjk gnalkj bskjjbcsklj nv'.
	fileInFirstWC
		content: changedContent2;
		store;
		update;
		read.
	self assert: fileInFirstWC status isConflicted.
	fileInFirstWC resolved.
	self deny: fileInFirstWC status isConflicted.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 3/20/2008 11:17'!
testSvnRevert

	| file text |
	file := self workingCopyPath , self slash , fileToAdd.
	sut svnAdd: file.
	sut svnCommit: {file}.
	
	FileStream 
		forceNewFileNamed: file
		do: [:stream | stream nextPutAll: 'content'].
	
	sut svnRevertTargets: {file}.
	
	FileStream 
		readOnlyFileNamed: file
		do: [:stream | text := stream contents.].
	
	self deny: text size ~= 0.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 23:07'!
testSvnUpdateTargetsToHeadRevision

	| workingcopyDirectory pathToFile workingCopyPath |
	workingCopyPath := self workingCopyPath.
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create a new head revision"
	pathToFile := self pathTo: fileToAdd inDir: workingCopyPath.
	sut svnAdd: pathToFile.
	sut svnCommit: {pathToFile}.

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut svnUpdateTargetsToHeadRevision: {SVNDirectory on: workingCopyPath}.
	
	"check if succeeded"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 22:54'!
testSvnUpdateTargetsToRevisionByNumber

	| workingcopyDirectory secondFile pathToFile pathToSecondFile workingCopyPath |
	workingCopyPath := self workingCopyPath.
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	"create new revisions"
	pathToFile := self pathTo: fileToAdd inDir: workingCopyPath.
	sut svnAdd: pathToFile.
	sut svnCommit: {pathToFile}.
	
	secondFile := 'fileForSecondRevision'.
	pathToSecondFile := self pathTo: secondFile inDir: workingCopyPath.
	self createFile: pathToSecondFile.
	sut svnAdd: pathToSecondFile.
	sut svnCommit: {pathToSecondFile}.

	"recover the first revision"
	sut 
		svnUpdateTargets: {SVNDirectory on: workingCopyPath}
		toRevisionByNumber: 1.

	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile)! !

!SVNClientExternalTest methodsFor: 'helper' stamp: 'rkrk 2/7/2008 15:45'!
createFile: fullPathOfFile

	(FileStream newFileNamed: fullPathOfFile) close.! !

!SVNClientExternalTest methodsFor: 'running' stamp: 'rkrk 3/14/2008 02:06'!
setUp

	super setUp.
	self willNeedRepositoryAndWorkingCopy.
	
	fileToAdd := 'testFile'.
	self createFile: self workingCopyPath , self slash , 'testFile'.! !

SVNClientExternalTest subclass: #SVNCommandLineClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNCommandLineClientTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:41'!
setUp

	super setUp.
	sut := SVNCommandLineClient new.! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'pe 2/26/2008 13:25'!
testCommandForAddProperty


	| key value path result expected |
	sut := SVNCommandLineClient new.
	key := 'irgendEinKey'.
	value := 'irgendEinValue'.
	path := SmalltalkImage current imagePath.
	result := sut buildCmdPropset: key value: value for: path.
	expected := 'svn propset ' , key , ' ' , value , ' ' , path.
	self assert: result = expected.! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 01:19'!
testSVNAdd

	| path |
	path := self workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	self 
		assertFile: fileToAdd
		wasSVNAddedIn: self workingCopyPath! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 01:49'!
testSvnCheckoutHeadRevision

	| workingcopyDirectory |
	workingcopyDirectory := FileDirectory on: self workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: self workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: self workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut
		svnCheckoutHeadRevisionFrom: self repositoryURLPath
		to: self workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'pe 4/11/2008 13:10'!
testSvnCheckoutRevisionByNumber

	| workingcopyDirectory secondFile |
	workingcopyDirectory := FileDirectory on: self workingCopyPath.
	"create new revisions"
	sut svnAdd: self workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: self workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: self workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: self workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: self workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	sut
		svnCheckoutRevisionByNumber: 1
		from: self repositoryURLPath
		to: self workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:32'!
testSvnUpdateTargetsToHeadRevision

	| workingcopyDirectory |
	workingcopyDirectory := FileDirectory on: self workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: self workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: self workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut svnUpdateTargetsToHeadRevision: (Array with: self workingCopyPath).
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 17:32'!
testSvnUpdateTargetsToRevisionByNumber

	| workingcopyDirectory secondFile |
	workingcopyDirectory := FileDirectory on: self workingCopyPath.
	
	"create new revisions"
	sut svnAdd: self workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: self workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: self workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: self workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: self workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	sut svnUpdateTargets: (Array with: self workingCopyPath) toRevisionByNumber: 1.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

!SVNClientTest methodsFor: 'running' stamp: 'rkrk 2/24/2008 23:55'!
setUp

	super setUp.
	sut := SVNClient new.! !

!SVNClientTest methodsFor: 'tests' stamp: 'test 3/26/2008 00:04'!
testBackslashToSlash

	| validPath |
	validPath := 'C:\test\test' pathForSvn.
	self	assert: validPath = 'C:/test/test'.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:43'!
testCommandLineNormalizePathInsertsQuotationMarks

	| string expected result |
	sut := SVNCommandLineClient new.
	string := 'blabla/blabla'.
	expected := '"' , string , '"'.
	result := sut normalizePath: string.
	self assert: expected = result.! !

!SVNClientTest methodsFor: 'tests' stamp: 'test 3/26/2008 00:05'!
testRemoveDoubbleBackslash

	| validPath |
	validPath := 'C:\\test\test' pathForSvn.
	self	assert: validPath = 'C:/test/test'.! !

!SVNClientTest methodsFor: 'tests' stamp: 'test 3/26/2008 00:05'!
testRemoveLastSlash

	| path |
	path := 'C:\test\test\' pathForSvn.
	self assert: path = 'C:/test/test'.! !

SVNTestCase subclass: #SVNCommandTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands-Test'!

SVNCommandTestCase subclass: #SVNAddToCurrentProjectCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands-Test'!

SVNAddToCurrentProjectCommandTest subclass: #SVNAddClassToCurrentProjectCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands-Test'!

!SVNAddClassToCurrentProjectCommandTest methodsFor: 'helper' stamp: 'mu 4/30/2008 11:59'!
methodSelector

	^ #m1! !

!SVNAddClassToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 13:28'!
testAddTarget

	"Class is not versioned return nil"
	| node environment svnProject svnClass |
	"prepare"
	environment := self createEnvironmentWithEmptyProject.
	node := self 
		createNodeOfClass: OBClassNode
		on: self svnDummy
		withEnvironment: environment.
	sut := SVNAddClassToCurrentProjectCommand on: node	for: self.
	"exercise"
	sut addTargetToCurrentProject.
	"assert"
	svnProject := environment svnProjects anyOne.
	self assert: svnProject versionedClasses size = 1.
	svnClass := svnProject versionedClasses anyOne.
	self assert: svnClass theClass = self svnDummy.! !

!SVNAddClassToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:52'!
testIsActiveForClassNodeWhenTargetIsNotVersioned

	"prepare"
	| node |
	node := self 
		createNodeOfClass: OBClassNode
		on: self svnDummy
		withEnvironment:  self createEnvironmentWithEmptyProject.
	sut := SVNAddClassToCurrentProjectCommand on: node for: self.
	"exercise and assert"
	self assert: sut isActive.! !

!SVNAddClassToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 19:46'!
testIsNotActiveForOtherNodes

	"prepare"
	| node |
	node := self 
		createNodeOfClass: OBMethodNode
		on: self methodRefOfSvnDummyM2
		withEnvironment: self createSvnEnvironment.
	sut := SVNAddClassToCurrentProjectCommand on: node for: self.
	"exercise and assert"
	self deny: sut isActive.
	node := self 
		createNodeOfClass: OBClassCategoryNode
		on: self class category
		withEnvironment: self createSvnEnvironment.
	sut target: node.
	self deny: sut isActive.! !

!SVNAddClassToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:43'!
testIsNotActiveIfTargetIsInCurrentProject

	"prepare"
	| node |
	node := self 
		createNodeOfClass: OBClassNode
		on: self svnDummy
		withEnvironment:  self createEnvironmentWithCurrentProjectAndSvnDummy.
	sut := SVNAddClassToCurrentProjectCommand on: node for: self.
	"exercise and assert"
	self deny: sut isActive.! !

SVNAddToCurrentProjectCommandTest subclass: #SVNAddMethodToCurrentProjectCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands-Test'!

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'helper' stamp: 'rkrk 4/23/2008 14:01'!
inSvnDummyCompileNewMethodNamed: methodSelector

	self deny: (self svnDummy includesSelector: methodSelector).
	self svnDummy compile: methodSelector asString , ' 1 + 2 + 3'.! !

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'helper' stamp: 'rkrk 4/23/2008 13:56'!
selectorForNewSvnDummyMethod

	^ #methodForAddmethodCommandTest! !

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'as yet unclassified' stamp: 'rkrk 4/23/2008 14:01'!
tearDown

	super tearDown.
	(self svnDummy includesSelector: self selectorForNewSvnDummyMethod)
		ifFalse: [^ self].
	self svnDummy removeSelectorSilently: self selectorForNewSvnDummyMethod.! !

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 13:41'!
testAddTargetWhenClassIsNotVersioned

	"Class is not versioned return nil"
	| node environment svnProject svnMethod |
	"prepare"
	environment := self createEnvironmentWithEmptyProject.
	node := self 
		createNodeOfClass: OBMethodNode
		on: (self svnDummy >> #m2) methodReference
		withEnvironment: environment.
	sut := SVNAddMethodToCurrentProjectCommand on: node for: self.
	"exercise"
	sut addTargetToCurrentProject.
	"assert"
	svnProject := environment svnProjects anyOne.
	self assert: svnProject versionedClasses size = 0.
	self assert: svnProject versionedMethods size = 1.
	svnMethod := svnProject versionedMethods anyOne.
	self assert: svnMethod methodSelector = #m2.! !

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:25'!
testAddTargetWhenClassIsVersioned

	"Class is not versioned return nil"
	| node environment svnProject svnClass methodSel |
	self willModifySVNDummy.
	"prepare. There must be a node with an unversioned method"
	environment := self createEnvironmentWithCurrentProjectAndSvnDummy.
	svnClass := environment svnProjects anyOne versionedClasses anyOne. "There is only one"
	methodSel := self selectorForNewSvnDummyMethod.
	self inSvnDummyCompileNewMethodNamed: methodSel.
	node := self 
		createNodeOfClass: OBMethodNode
		on: (self svnDummy >> methodSel) methodReference
		withEnvironment: environment.
	sut := SVNAddMethodToCurrentProjectCommand on: node for: self.
	"method should not be versioned yet"
	self deny: (svnClass versionedMethods anySatisfy: [:ea | ea theName = methodSel asString]).
	"exercise"
	sut addTargetToCurrentProject.
	"assert"
	svnProject := environment svnProjects anyOne.
	self assert: svnProject versionedMethods isEmpty.
	self assert: (svnProject versionedClasses includes: svnClass).
	self assert: (svnClass versionedMethods anySatisfy: [:ea | ea theName = methodSel asString]).! !

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rt 5/8/2008 18:44'!
testAddTargetWhenClassIsVersioned2

	"Class is not versioned return nil"
	| node environment svnProject svnClass methodSel |
	self willModifySVNDummy.
	"prepare. There must be a node with an unversioned method"
	environment := self createEnvironmentWithCurrentProjectAndSvnDummy.
	svnClass := environment svnProjects anyOne versionedClasses anyOne. "There is only one"
	methodSel := self selectorForNewSvnDummyMethod.
	self inSvnDummyCompileNewMethodNamed: methodSel.
	node := OBMethodNode on: (self svnDummy >> methodSel) methodReference.
	
	sut := SVNAddMethodToCurrentProjectCommand
		on: node
		for: (OBSVNSystemBrowser new
			svnEnvironment: environment;
			yourself).
	
	"method should not be versioned yet"
	self deny: (svnClass versionedMethods anySatisfy: [:ea | ea theName = methodSel asString]).
	"exercise"
	sut addTargetToCurrentProject.
	"assert"
	svnProject := environment svnProjects anyOne.
	self assert: svnProject versionedMethods isEmpty.
	self assert: (svnProject versionedClasses includes: svnClass).
	self assert: (svnClass versionedMethods anySatisfy: [:ea | ea theName = methodSel asString]).! !

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:55'!
testIsActiveForMethodNodeWhenTargetisNotVersioned01

	"prepare"
	| node |
	node := self
		createNodeOfClass: OBMethodNode
		on: self methodRefOfSvnDummyM2
		withEnvironment: self createEnvironmentWithEmptyProject.
	sut := SVNAddMethodToCurrentProjectCommand on: node for: self.
	"exercise and assert"
	self assert: sut isActive.! !

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 22:15'!
testIsActiveForMethodNodeWhenTargetisNotVersioned02

	"prepare"
	| node environment |
	self willModifySVNDummy.
	environment := self createEnvironmentWithCurrentProjectAndSvnDummy.
	self inSvnDummyCompileNewMethodNamed: self selectorForNewSvnDummyMethod.
	node := self
		createNodeOfClass: OBMethodNode
		on: (self svnDummy >> self selectorForNewSvnDummyMethod) methodReference
		withEnvironment: environment.
	sut := SVNAddMethodToCurrentProjectCommand on: node for: self.
	"exercise and assert"
	self assert: sut isActive.! !

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 19:46'!
testIsNotActiveForOtherNodes

	"prepare"
	| node |
	node := self 
		createNodeOfClass: OBClassNode
		on: self svnDummy
		withEnvironment: self createSvnEnvironment.
	sut := SVNAddMethodToCurrentProjectCommand on: node for: self.
	"exercise and assert"
	self deny: sut isActive.
	node := self 
		createNodeOfClass: OBClassCategoryNode
		on: self class category
		withEnvironment: self createSvnEnvironment.
	sut target: node.
	self deny: sut isActive.! !

!SVNAddMethodToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:55'!
testIsNotActiveIfTargetIsInCurrentProject

	"prepare"
	| node |
	node := self
		createNodeOfClass: OBMethodNode
		on: self methodRefOfSvnDummyM2
		withEnvironment: self createEnvironmentWithCurrentProjectAndSvnDummy.
	sut := SVNAddMethodToCurrentProjectCommand on: node for: self.
	"exercise and assert"
	self deny: sut isActive.! !

!SVNAddToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 23:27'!
testFindSvnProjectOfTarget01
	"Class is not versioned return nil"
	"prepare"
	| node |
	node := self 
		createNodeOfClass: OBClassNode
		on: self class
		withEnvironment: self createEnvironmentWithCurrentProjectAndSvnDummy.	"any class which is not in the environment will do"
	sut := SVNAddClassToCurrentProjectCommand 
		on: node
		for: self.
	"exercise and assert"
	self assert: sut findSvnProjectOfSVNElementOfTarget isNil! !

!SVNAddToCurrentProjectCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 23:27'!
testFindSvnProjectOfTarget02
	"Class is not versioned return nil"
	"prepare"
	| node |
	node := self 
		createNodeOfClass: OBClassNode
		on: self svnDummy
		withEnvironment: self createEnvironmentWithCurrentProjectAndSvnDummy.
	sut := SVNAddClassToCurrentProjectCommand 
		on: node
		for: self.
	"exercise and assert"
	self assert: sut findSvnProjectOfSVNElementOfTarget notNil! !

!SVNCommandTestCase methodsFor: 'helper' stamp: 'cop 4/23/2008 13:45'!
createNodeOfClass: aNodeClass on: target withEnvironment: svnEnv
	
	"Create a OBNode. Due to the way we access SVNEnvironments (via a filter),
	we also need a metaNode. Pretty ugly instantiation..."
	| metaNode filter node |
	metaNode := OBMetaNode new.
	filter := SVNOBEnvironmentFilter with: svnEnv.
	metaNode addFilter: filter.
	node := aNodeClass on: target.
	node metaNode: metaNode.
	^ node.! !

!SVNCommandTestCase methodsFor: 'helper' stamp: 'rkrk 4/23/2008 17:16'!
mockNodeOfKind: aClass withEnvironment: svnEnv svnElement: svnElement

	^ self createNodeOfClass: aClass on: svnElement withEnvironment: svnEnv! !

SVNCommandTestCase subclass: #SVNCommitCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands-Test'!

!SVNCommitCommandTest methodsFor: 'helper' stamp: 'rkrk 5/4/2008 19:48'!
createEnvironmentForProject: aProject 
	
	| environment |
	environment := self createSvnEnvironment.
	self deny: (environment svnProjects includes: aProject).
	environment
		addSvnProject: aProject;
		currentProject: aProject.
	^ environment! !

!SVNCommitCommandTest methodsFor: 'helper' stamp: 'mu 4/30/2008 12:55'!
createMethodNodeWithEnviroment: environment 
	| node |
	node := self 
		createNodeOfClass: OBMethodNode
		on: self methodRefOfSvnDummyM2
		withEnvironment: environment.
	^ node! !

!SVNCommitCommandTest methodsFor: 'helper' stamp: 'mu 4/30/2008 12:59'!
createProjectAndAddDummyClass
	| project |
	self willNeedRepositoryAndWorkingCopy.
	project := SVNProject named: 'TestPro'.
	self defaultSVNDirectory addSubdirectory: project directory.
	project addClass: self svnDummy.
	^ project! !

!SVNCommitCommandTest methodsFor: 'helper' stamp: 'mu 4/30/2008 13:01'!
createProjectAndAddMethodFromDummy
	| project |
	self willNeedRepositoryAndWorkingCopy.
	project := SVNProject named: 'TestPro'.
	self defaultSVNDirectory addSubdirectory: project directory.
	project addMethod: self svnDummy >> #m2.
	^ project! !

!SVNCommitCommandTest methodsFor: 'tests' stamp: 'mu 4/30/2008 12:59'!
testIsActiveForCommitedClassWhenCommitAMethod
	"prepare"
	| node project environment |
	project := self createProjectAndAddDummyClass.
	environment := self createEnvironmentForProject: project.
	project commit.
	node := self createMethodNodeWithEnviroment: environment.
	sut := SVNCommitCommand 
		on: node
		for: self.
	"exercise and assert"
	self assert: sut isActive! !

!SVNCommitCommandTest methodsFor: 'tests' stamp: 'mu 4/30/2008 13:09'!
testIsActiveForCommitedProjectWhenCommitAMethod
	"prepare"
	| node project environment |
	project := self createProjectAndAddMethodFromDummy.
	environment := self createEnvironmentForProject: project.
	project commit.
	node := self createMethodNodeWithEnviroment: environment.
	sut := SVNCommitCommand 
		on: node
		for: self.
	"exercise and assert"
	self assert: sut isActive! !

!SVNCommitCommandTest methodsFor: 'tests' stamp: 'mu 4/30/2008 12:59'!
testIsNotActiveForAddedClassWhenCommitAMethod
	"prepare"
	| node project environment |
	project := self createProjectAndAddDummyClass.
	environment := self createEnvironmentForProject: project.
	project store.	"We need the status"
	node := self createMethodNodeWithEnviroment: environment.
	sut := SVNCommitCommand 
		on: node
		for: self.
	"exercise and assert"
	self deny: sut isActive! !

!SVNCommitCommandTest methodsFor: 'tests' stamp: 'mu 4/30/2008 13:05'!
testIsNotActiveForAddedProjectWhenCommitAMethod
	"prepare"
	| node project environment |
	project := self createProjectAndAddMethodFromDummy.
	environment := self createEnvironmentForProject: project.
	project store.
	node := self createMethodNodeWithEnviroment: environment.
	sut := SVNCommitCommand 
		on: node
		for: self.
	"exercise and assert"
	self deny: sut isActive! !

SVNCommandTestCase subclass: #SVNDeleteClassCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands-Test'!

!SVNDeleteClassCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:18'!
testIsActiveForNodes

	| node |
	node := self
		mockNodeOfKind: OBClassNode
		withEnvironment: self createEnvironmentWithCurrentProjectAndSvnDummy
		svnElement: self svnDummy.
	sut := SVNDeleteClassCommand on: node for: self.
	
	self assert: sut isActive.! !

!SVNDeleteClassCommandTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 19:48'!
testIsNotActiveForOtherNodes

	"prepare"
	| node |
	node := self 
		createNodeOfClass: OBMethodNode
		on: self methodRefOfSvnDummyM2
		withEnvironment: self createSvnEnvironment.
	sut := SVNDeleteClassCommand on: node for: self.
	"exercise and assert"
	self deny: sut isActive.
	node := self 
		createNodeOfClass: OBClassCategoryNode
		on: self class category
		withEnvironment: self createSvnEnvironment.
	sut target: node.
	self deny: sut isActive.! !

!SVNDeleteClassCommandTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 19:48'!
testIsNotActiveWhenTargetIsNoSvnProject

	| node |
	node := self
		mockNodeOfKind: OBClassNode
		withEnvironment: self createSvnEnvironment
		svnElement: self svnDummy.
	sut := SVNDeleteClassCommand on: node for: self.
	
	self deny: sut isActive.! !

!SVNDeleteClassCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 22:35'!
testIsNotActiveWhenTargetIsNotInCurrentSvnProject

	| node environment anotherSvnProject |
	environment := self createEnvironmentWithCurrentProjectAndSvnDummy.
	anotherSvnProject := SVNProject named: 'NothingInMe'.
	environment
		addSvnProject: anotherSvnProject;
		currentProject: anotherSvnProject.
	node := self
		mockNodeOfKind: OBClassNode
		withEnvironment: environment
		svnElement: self svnDummy.
	sut := SVNDeleteClassCommand on: node for: self.
	
	self deny: sut isActive.! !

SVNCommandTestCase subclass: #SVNDeleteMethodCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands-Test'!

!SVNDeleteMethodCommandTest methodsFor: 'tests' stamp: 'rkrk 4/23/2008 17:33'!
testIsActiveForNodes

	| node |
	node := self 
		createNodeOfClass: OBMethodNode
		on: self methodRefOfSvnDummyM2
		withEnvironment: self createEnvironmentWithCurrentProjectAndSvnDummy.
	sut := SVNDeleteMethodCommand on: node for: self.
	self assert: sut isActive.! !

!SVNDeleteMethodCommandTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 19:48'!
testIsNotActiveForOtherNodes

	"prepare"
	| node |
	node := self 
		createNodeOfClass: OBMethodNode
		on: self methodRefOfSvnDummyM2
		withEnvironment: self createSvnEnvironment.
	sut := SVNDeleteMethodCommand on: node for: self.
	"exercise and assert"
	self deny: sut isActive.
	node := self 
		createNodeOfClass: OBClassCategoryNode
		on: self class category
		withEnvironment: self createSvnEnvironment.
	sut target: node.
	self deny: sut isActive.! !

SVNCommandTestCase subclass: #SVNDeleteProjectCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands-Test'!

!SVNDeleteProjectCommandTest methodsFor: 'tests' stamp: 'cop 4/24/2008 15:28'!
testDeleteProject
	"prepare"
	| node |
	svnEnvironment := self createEnvironmentWithEmptyProject.
	node := SVNProjectNode element: svnEnvironment svnProjects anyOne svnEnvironment: svnEnvironment.
	sut := SVNDeleteProjectCommand on: node for: self.
	
	"exercise and assert"
	self assert: sut isActive.
	self assert: svnEnvironment svnProjects isEmpty not.
	
	sut deleteProjectIn: svnEnvironment.
	self assert: svnEnvironment svnProjects isEmpty.
	! !

SVNTestCase subclass: #SVNCommitLogTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNCommitLogTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 18:57'!
testRevisionAuthorDateString
	| commitLogString aCommitLog |
	aCommitLog := SVNRevisionInfo 
		withRevision: 1
		author: 'Michi'
		date: (DateAndTime 
				year: 2008
				month: 1
				day: 1
				hour: 1
				minute: 0)
		comment: 'aComment'.
	commitLogString := aCommitLog revisionAuthorDateString.
	self assert: '1 - Michi 1 January 2008 1:00 am' = commitLogString! !

SVNTestCase subclass: #SVNConflictSolverTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNConflictSolverTest methodsFor: 'tests' stamp: 'cop 4/29/2008 15:05'!
testResolveMine
	| originalContent fileName fileInFirstWC fileInSecondWC changedContent changedContent2 |
	self willNeedRepositoryAndTwoWorkingCopies.
	originalContent := 'ABCabcXYZxyz'.
	fileName := 'fileForUpdate'.
	"Create file in first directory and commit"
	fileInFirstWC := SVNFile 
		named: fileName
		basePath: self workingCopyPath
		content: originalContent.
	fileInFirstWC
		store;
		commit.
	"Access file in second WC, change and commit"
	self svnDirectoryForWorkingCopy2 update.
	fileInSecondWC := SVNFile 
		named: fileName
		basePath: self workingCopyPath2.
	fileInSecondWC read.
	self assert: fileInSecondWC content = originalContent.
	changedContent := '1234ABC12343749rzcnoqixuh'.
	fileInSecondWC
		content: changedContent;
		store;
		commit.
	"Change first file and update"
	changedContent2 := 'sjk gnalkj bskjjbcsklj nv'.
	fileInFirstWC
		content: changedContent2;
		store;
		update;
		read.
	self assert: fileInFirstWC status isConflicted.
	SVNConflictSolver new resolveWithMine: fileInFirstWC.
	fileInFirstWC
		read;
		resolved.
	self assert: fileInFirstWC status isConflicted not.
	self assert: fileInFirstWC content = changedContent2! !

!SVNConflictSolverTest methodsFor: 'tests' stamp: 'cop 4/29/2008 15:10'!
testResolveTheirs
	| originalContent fileName fileInFirstWC fileInSecondWC changedContent changedContent2 |
	self willNeedRepositoryAndTwoWorkingCopies.
	originalContent := 'ABCabcXYZxyz'.
	fileName := 'fileForUpdate'.
	"Create file in first directory and commit"
	fileInFirstWC := SVNFile 
		named: fileName
		basePath: self workingCopyPath
		content: originalContent.
	fileInFirstWC
		store;
		commit.
	"Access file in second WC, change and commit"
	self svnDirectoryForWorkingCopy2 update.
	fileInSecondWC := SVNFile 
		named: fileName
		basePath: self workingCopyPath2.
	fileInSecondWC read.
	self assert: fileInSecondWC content = originalContent.
	changedContent := '1234ABC12343749rzcnoqixuh'.
	fileInSecondWC
		content: changedContent;
		store;
		commit.
	"Change first file and update"
	changedContent2 := 'sjk gnalkj bskjjbcsklj nv'.
	fileInFirstWC
		content: changedContent2;
		store;
		update;
		read.
	self assert: fileInFirstWC status isConflicted.
	SVNConflictSolver new resolveWithTheirs: fileInFirstWC.
	fileInFirstWC
		read;
		resolved.
	self assert: fileInFirstWC status isConflicted not.
	self assert: fileInFirstWC content = changedContent! !

SVNTestCase subclass: #SVNCreateNewProjectAndCommitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-AcceptanceTests'!

!SVNCreateNewProjectAndCommitTest methodsFor: 'helper' stamp: 'rkrk 3/1/2008 01:08'!
createClassNamed: nameOfClass

	^ Object
		subclass: nameOfClass asSymbol
		instanceVariableNames: 'i1'
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'helper' stamp: 'rkrk 3/1/2008 01:06'!
createMethodM1For: class

	class compile: 'm1' , String cr , '^ ''Heeeee Yaaaahhhhhhh'''.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'helper' stamp: 'rkrk 3/1/2008 01:06'!
createMethodM2For: class

	class compile: 'm2: argument' , String cr , '^ argument asString'.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'helper' stamp: 'rkrk 3/4/2008 02:18'!
nameOfAClass
	^ 'ClassCreatedInSVNAccepatanceTests'! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'running' stamp: 'rkrk 3/4/2008 05:40'!
tearDown

	super tearDown.
	Smalltalk
		at: self nameOfAClass asSymbol
		ifPresent: [:class | class removeFromSystemUnlogged].
	self flag: #TODO.
	self restoreSVNDummy.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'tests' stamp: 'rkrk 5/12/2008 13:42'!
test01

	"(self selector: #test01) run"
	| svnProject class workingCopyDir readSVNProject projectName readDirectory |
	self flag: #TODO. "Merge with test02"
	self willNeedRepositoryAndWorkingCopy.
	"Create new project. Create new class. Add it to the project and commit."
	projectName := 'NewProject'.
	svnProject := SVNProject named: projectName.
	class := self createClassNamed: self nameOfAClass.
	self createMethodM1For: class.
	self createMethodM2For: class.
	"self halt."
	workingCopyDir := SVNDirectory on: self workingCopyPath.
	svnProject
		directory: (workingCopyDir createSubDirectoryNamed: projectName);
		addClass: class;
		commit.
	"Read the project"
	readDirectory := SVNDirectory named: projectName basePath: self workingCopyPath.
	readDirectory read.
	readSVNProject := SVNProject restoreFrom: readDirectory.
	
	self assert: readSVNProject = svnProject.! !

!SVNCreateNewProjectAndCommitTest methodsFor: 'tests' stamp: 'rkrk 5/12/2008 13:43'!
test02

	"(self selector: #test02) run"
	| svnProject newSVNProject svnClass newWorkingCopyDirectory newWorkingCopyPath |
	self willNeedRepositoryAndWorkingCopy.
	"create and modify a SVNProject"
	svnClass := SVNClass
		name: self nameOfAClass
		superclassName: 'Object'
		instanceVariables: {}
		classVariables: Set new
		classInstanceVariables: {}
		poolDictionaries: OrderedCollection new
		comment: ''
		category: 'neu'.
	svnClass isVersioned: true.
	"define a working copy directory"
	svnProject := SVNProject checkoutProject: 'TestProject' fromURL: self repositoryURLPath inWorkingCopy:  (SVNDirectory on: self workingCopyPath).
	svnProject addSVNClass: svnClass.
	"commit the changes"
	svnProject commit.
	"self halt."
	"delete project and working copy"
	svnProject unload.
	self deny: (Smalltalk hasClassNamed: self nameOfAClass).
	"checkout the project in a new working copy"
	newWorkingCopyPath := self pathForTests , self slash , 'newWorkingCopy'.
	newWorkingCopyDirectory := SVNDirectory on: newWorkingCopyPath.
	newSVNProject := SVNProject
		checkoutProject: 'TestProject' 
		fromURL: self repositoryURLPath
		inWorkingCopy: newWorkingCopyDirectory.
	"load it into the system"
	newSVNProject load.
	"check if the old state is restored"
	self assert: (Smalltalk hasClassNamed: self nameOfAClass).
	self flag: #TODO. "Check if methods are there"! !

SVNTestCase subclass: #SVNCreateProjectDialogTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-UITests'!

SVNCreateProjectDialogTest class
	instanceVariableNames: 'pathForTests'!

SVNCreateProjectDialogTest class
	instanceVariableNames: 'pathForTests'!

!SVNCreateProjectDialogTest methodsFor: 'setUp' stamp: 'rkrk 3/4/2008 02:10'!
fullPath

	^ FileDirectory fullPathForURI: ''! !

!SVNCreateProjectDialogTest methodsFor: 'setUp' stamp: 'rt 5/7/2008 13:58'!
setUp
	super setUp.
	sut := (SVNCreateProjectDialog new)
				svnProject: SVNInformationGathererForSVNProject new;
				yourself! !

!SVNCreateProjectDialogTest methodsFor: 'converting' stamp: 'rkrk 4/7/2008 13:10'!
testWorkingCopyPath

	| path |
	path := self fullPath , 'workingCopy'.
	self assert: (sut setProjectWorkingCopyPath: path).
	self assert: (path = sut projectWorkingCopyPath).! !

!SVNCreateProjectDialogTest methodsFor: 'converting' stamp: 'rkrk 4/7/2008 13:12'!
testWorkingCopyPathRelative

	| path |
	path := 'workingCopy'.
	self assert: (sut setProjectWorkingCopyPath: path).
	self assert: (sut projectWorkingCopyPath = (self fullPath , path)).! !

!SVNCreateProjectDialogTest methodsFor: 'converting' stamp: 'rkrk 4/7/2008 16:01'!
testWorkingCopyPathWithBackSlash

	| fullpath path |
	path := 'workingCopy' , self slash , 'subdir'.
	
	sut setProjectWorkingCopyPath: path.
	fullpath := self fullPath , path.
	
	self assert: fullpath = sut projectWorkingCopyPath.! !

!SVNCreateProjectDialogTest methodsFor: 'converting' stamp: 'rkrk 4/7/2008 13:13'!
testWorkingCopyPathWithSlash

	| path fullpath |
	path := './workingCopy/subdir'.
	
	self assert: (sut setProjectWorkingCopyPath: path).
	fullpath := self fullPath , 'workingCopy' , self slash , 'subdir'.
	
	self assert: fullpath = sut projectWorkingCopyPath.! !

SVNTestCase subclass: #SVNDiffCreatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Diffing-Tests'!

!SVNDiffCreatorTest methodsFor: 'tests' stamp: 'rkrk 5/13/2008 07:22'!
testDiffEmptyProjectAgainstProjectWithAddedClassAndMethods

	"(self selector: #testDiffEmptyProjectAgainstProjectWithAddedClassAndMethods) debug"
	| svnPro1 svnPro2 |
	svnPro1 := self createEmptySvnProject.
	svnPro2 := self createSvnProjectWithSvnDummy.
	
	sut := SVNDiffCreator diff: svnPro1 against: svnPro2.
	self assert: sut differences size =
		(self svnDummy selectors size + self svnDummy class selectors size + 1). "1 for the class itself"! !

!SVNDiffCreatorTest methodsFor: 'tests' stamp: 'rkrk 5/12/2008 17:47'!
testDiffEqualProjects

	| svnPro1 svnPro2 |
	svnPro1 := self createSvnProjectWithSvnDummy.
	svnPro2 := self createSvnProjectWithSvnDummy.
	sut := SVNDiffCreator diff: svnPro1 against: svnPro2.
	self assert: sut differences isEmpty.! !

!SVNDiffCreatorTest methodsFor: 'tests' stamp: 'rkrk 5/13/2008 03:07'!
testDiffProjectWithAClassAgainstProjectWithChangedClass01

	| svnPro1 svnPro2 diff oldSvnClass |
	svnPro1 := self createSvnProjectWithSvnDummy.
	svnPro2 := self createSvnProjectWithSvnDummy.
	self assert: svnPro2 versionedClasses size = 1.
	oldSvnClass := svnPro2 versionedClasses anyOne.
	self assert: oldSvnClass instanceVariables notEmpty.
	oldSvnClass instanceVariables: oldSvnClass instanceVariables asOrderedCollection removeLast.
	
	sut := SVNDiffCreator diff: svnPro1 against: svnPro2.
	self assert: sut differences size = 1.
	diff := sut differences detect: [:ea | ea isClassDifference] ifNone: [self assert: false].
	self assert: svnPro1 versionedClasses size = 1.
	self assert: diff newSvnElement == svnPro1 versionedClasses anyOne.
	self assert: diff oldSvnElement = oldSvnClass.! !

!SVNDiffCreatorTest methodsFor: 'tests' stamp: 'rkrk 5/13/2008 07:59'!
testDiffProjectWithAClassAgainstProjectWithNoClass01

	| svnPro1 svnPro2 diff |
	svnPro1 := self createSvnProjectWithSvnDummy.
	svnPro2 := self createEmptySvnProject.
	sut := SVNDiffCreator diff: svnPro1 against: svnPro2.
	self assert: sut differences size >= 1.
	diff := sut differences detect: [:ea | ea isClassDifference] ifNone: [self assert: false].
	self assert: svnPro1 versionedClasses size = 1.
	self assert: diff newSvnElement == svnPro1 versionedClasses anyOne.
	self assert: diff oldSvnElement = nil.! !

!SVNDiffCreatorTest methodsFor: 'tests' stamp: 'rkrk 5/13/2008 08:00'!
testDiffProjectWithAClassAgainstProjectWithNoClass02

	| svnPro1 svnPro2 diff |
	svnPro1 := self createEmptySvnProject.
	svnPro2 := self createSvnProjectWithSvnDummy.
	sut := SVNDiffCreator diff: svnPro1 against: svnPro2.
	self assert: sut differences size >= 1.
	diff := sut differences detect: [:ea | ea isClassDifference] ifNone: [self assert: false].
	self assert: svnPro2 versionedClasses size = 1.
	self assert: diff oldSvnElement == svnPro2 versionedClasses anyOne.
	self assert: diff newSvnElement = nil.! !

!SVNDiffCreatorTest methodsFor: 'tests' stamp: 'rkrk 5/13/2008 03:33'!
testGenerateMethodDiffsWhenNoDiffsExists

	| svnClass |
	svnClass := SVNClass forExistingClass: self svnDummy.
	sut := SVNDiffCreator new.
	sut generateMethodDifferencesOf: svnClass and: svnClass.
	self assert: sut differences isEmpty.! !

!SVNDiffCreatorTest methodsFor: 'tests' stamp: 'rkrk 5/13/2008 03:45'!
testGenerateMethodDiffsWithOneDiff

	| svnClass1 svnClass2 svnMethod diff |
	svnClass1 := SVNClass forExistingClass: self svnDummy.
	svnClass2 := SVNClass forExistingClass: self svnDummy.
	svnMethod := svnClass2 versionedMethods detect: [:ea | ea theName = 'm1'].
	svnMethod source: 'm2 ''ugagagagaggaga'''.
	sut := SVNDiffCreator new.
	sut generateMethodDifferencesOf: svnClass1 and: svnClass2.
	self assert: sut differences size = 1.
	diff := sut differences anyOne.
	self assert: diff oldSvnElement = svnMethod! !

!SVNDiffCreatorTest methodsFor: 'tests' stamp: 'rkrk 5/13/2008 02:49'!
testSvnClassStrinRepresantation

	| svnClass expected |
	svnClass := (SVNClass forExistingClass: self svnDummy).
	expected := 'Object subclass: #SVNDummy
	instanceVariableNames: ''i1 i2''
	classVariableNames: ''C1 C2''
	classInstanceVariableNames: ''IC1 IC2''
	poolDictionaries: ''''
	category: #''SqueakSVN-Base-Test'''.
	
	self assert: svnClass asString = expected
	
	"(DiffMorph from: svnClass asString to: expected) openInWindow"! !

SVNTestCase subclass: #SVNDiffSummaryRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNDiffSummaryRequestTest methodsFor: 'tests' stamp: 'test 5/10/2008 17:21'!
testSvnDiffSummerizeAdded
	| diffSummary startRevision endRevision svnFile |
	self willNeedRepositoryAndWorkingCopy.
	svnFile := self defaultSVNDirectory createFileNamed: 'testFile'.
	svnFile
		store;
		commit.
	startRevision := SVNRevision number: 0.
	endRevision := SVNInfoRequest headRevisionOf: svnFile.
	
	diffSummary := SVNDiffSummaryRequest target: svnFile fromRevision: startRevision toRevision: endRevision.
	self assert: diffSummary summaryKind = #added! !

!SVNDiffSummaryRequestTest methodsFor: 'tests' stamp: 'test 5/10/2008 17:36'!
testSvnDiffSummerizeDelete

	| diffSummary startRevision endRevision svnFile |
	self willNeedRepositoryAndWorkingCopy.
	svnFile := self defaultSVNDirectory createFileNamed: 'testFile'.
	svnFile
		store;
		commit.
	startRevision := SVNRevision number: 1.
	
	svnFile
		remove.
	self defaultSVNDirectory commit.
	endRevision := SVNRevision number: 2.
	
	diffSummary := SVNDiffSummaryRequest target: svnFile fromRevision: startRevision toRevision: endRevision.
	self assert: diffSummary summaryKind = #deleted.! !

!SVNDiffSummaryRequestTest methodsFor: 'tests' stamp: 'test 5/10/2008 17:21'!
testSvnDiffSummerizeModified

	| diffSummary startRevision endRevision svnFile |
	self willNeedRepositoryAndWorkingCopy.
	svnFile := self defaultSVNDirectory createFileNamed: 'testFile'.
	svnFile
		store;
		commit.
	startRevision := SVNInfoRequest headRevisionOf: svnFile.
	
	svnFile
		content: 'bla';
		store;
		commit.
	endRevision := SVNInfoRequest headRevisionOf: svnFile.
	
	diffSummary := SVNDiffSummaryRequest target: svnFile fromRevision: startRevision toRevision: endRevision.
	self assert: diffSummary summaryKind = #modified.! !

!SVNDiffSummaryRequestTest methodsFor: 'tests' stamp: 'test 5/10/2008 17:22'!
testSvnDiffSummerizeNormal

	| diffSummary startRevision endRevision svnFile svnFile2 |
	self willNeedRepositoryAndWorkingCopy.
	svnFile := self defaultSVNDirectory createFileNamed: 'testFile'.
	svnFile
		store;
		commit.
	startRevision := SVNInfoRequest headRevisionOf: svnFile.
	
	svnFile2 := self defaultSVNDirectory createFileNamed: 'testFile2'.
	svnFile2
		store;
		commit.
	endRevision := SVNInfoRequest headRevisionOf: svnFile2.
	
	diffSummary := SVNDiffSummaryRequest target: svnFile fromRevision: startRevision toRevision: endRevision.
	self assert: diffSummary summaryKind = #normal.! !

SVNTestCase subclass: #SVNDirectoryEntryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing-Test'!

SVNDirectoryEntryTest subclass: #SVNDirectoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing-Test'!

!SVNDirectoryTest methodsFor: 'running' stamp: 'test 3/15/2008 02:33'!
setUp

	super setUp.
	self willTouchFileSystem.
	sut := SVNDirectory
		named: 'svnDirectoryWhichIsTested'
		basePath: self pathForTests.! !

!SVNDirectoryTest methodsFor: 'tests svn funtions' stamp: 'rkrk 3/13/2008 14:31'!
testAddDirectory

	| directoryName |
	self willNeedRepositoryAndWorkingCopy.
	directoryName := 'DirectoryForSvnAdd'.
	sut := SVNDirectory
		named: directoryName
		basePath: self workingCopyPath.
	sut store.
	sut svnAdd.
	self
		assertFile: directoryName
		wasSVNAddedIn: self workingCopyPath.! !

!SVNDirectoryTest methodsFor: 'tests adding and removing' stamp: 'rkrk 3/5/2008 01:33'!
testAddFilesWithPropertiesWhichAreInTheEndEqual

	| filename assoc |
	sut := SVNDirectory
		named: 'svnDir'
		basePath: self pathForTests.
	filename := 'fileName'.
	assoc := 'key' -> 'value'.
	(sut createFileNamed: filename) properties add: assoc.
	(sut createFileNamed: filename) properties add: assoc.

	self assert: sut files size = 1.! !

!SVNDirectoryTest methodsFor: 'tests adding and removing' stamp: 'rkrk 4/1/2008 19:09'!
testAddSubdirectories

	| dir1 dir2 |
	"setup"
	sut := SVNDirectory
		named: 'rootDir'
		basePath: self pathForTests.
	dir1 := SVNDirectory named: 'depth1'.
	dir2 := SVNDirectory named: 'depth2'.
	dir1 addSubdirectory: dir2.
	"exercise"
	sut addSubdirectory: dir1.
	"assert"
	self assert: sut path = dir1 basePath.
	self assert: dir1 path = dir2 basePath.! !

!SVNDirectoryTest methodsFor: 'tests adding and removing' stamp: 'rkrk 4/1/2008 19:04'!
testAddTwoTimesTheSameFile

	| file |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	file := SVNFile named: 'test'.
	sut
		addFile: file;
		addFile: file.
	self assert: sut files size = 1.
! !

!SVNDirectoryTest methodsFor: 'tests adding and removing' stamp: 'test 4/2/2008 16:53'!
testAlreadyExistingFileIsReplacedWhenAdded

	"And the state of the existing file is considered"
	| resultFile fileName file1 file2 |
	fileName := 'TheFile'.
	file1 := SVNFile named: fileName.
	file1
		content: 'abc_xyz';
		properties: (Dictionary with: 'a' -> 'b').
	sut addFile: file1.
	file2 := SVNFile named: fileName.
	file2
		content: 'Howdey Hoooo!!';
		properties: (Dictionary with: '123' -> '456').
	sut addFile: file2.
	self assert: sut files size = 1.
	resultFile := sut files anyOne.
	self assert: resultFile = file2.! !

!SVNDirectoryTest methodsFor: 'tests svn funtions' stamp: 'rt 3/14/2008 15:49'!
testCommitARemovedDirectory

	| fileName |
	"create"

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNDirectory
				named: 'TestDir'
				basePath: self workingCopyPath.
	fileName := 'iAmAFile'.
	sut
		createFileNamed: fileName;
		store;
		commit.
	
	self svnClientDo: [:client | client
		svnCheckoutHeadRevisionFrom: self repositoryURLPath
		to: self workingCopyPath, '2'].
	self
		assertThatFiles: {fileName}
		existsIn: (self workingCopyPath , '2', self slash, sut theName).
	
	"remove"
	sut
		remove;
		commit.
	
	"check"
	self svnClientDo: [:client | client
		svnCheckoutHeadRevisionFrom: self repositoryURLPath
		to: self workingCopyPath, '2'].
	self deny: (FileDirectory on: self workingCopyPath , '2', self slash, sut theName) exists.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/2/2008 16:39'!
testCreateFile

	| fileName expectedFile resultFile |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	fileName := 'aNewFile'.
	sut createFileNamed: fileName.
	expectedFile := SVNFile  
		named: fileName
		basePath: sut path.
	self assert: sut files size = 1.
	resultFile := sut files anyOne.
	self assert: expectedFile = resultFile.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/2/2008 16:39'!
testCreateSubDirectory

	| subDirectoryName expectedDirectory resultDirectory |
	subDirectoryName := 'subDirectory'.
	sut createSubDirectoryNamed: subDirectoryName.
	expectedDirectory := SVNDirectory 
		named: subDirectoryName
		basePath: sut path.
	self assert: sut subdirectories size = 1.
	resultDirectory := sut subdirectories anyOne.
	self assert: expectedDirectory = resultDirectory.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'test 3/5/2008 00:13'!
testCreateTwoTimesTheSameFile

	| fileName |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	fileName := 'teest'.
	sut
		createFileNamed: fileName;
		createFileNamed: fileName.
	self assert: sut files size = 1.
! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'test 3/5/2008 00:10'!
testCreateTwoTimesTheSameFileWithContent

	| fileName content |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	fileName := 'teest'.
	content := 'abc'.
	sut
		createFileNamed: fileName
		withContent: content.
	sut
		createFileNamed: fileName
		withContent: content.
	self assert: sut files size = 1.
! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/25/2008 00:19'!
testCreateWithOn

	sut := SVNDirectory on: self pathForTests.
	FileDirectory
		splitName: self pathForTests
		to: [:dirPath :localName |
			self assert: sut basePath = dirPath.
			self assert: sut theName = localName].
	! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 05:30'!
testDelete

	| fileName |
	self willTouchFileSystem.
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	sut store.
	sut recursivelyDo: [:svnDirectoryEntry |
		svnDirectoryEntry delete].
	self deny: (FileDirectory on: sut path) exists! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:50'!
testDirectoryExists

	| directoryName |
	directoryName := 'iAmADirectory'.
	sut createSubDirectoryNamed: directoryName.
	self assert: (sut directoryExists: directoryName).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/2/2008 17:08'!
testDontStoreSubdirectoriesMultipleSubdirectoriesWithTheSameName

	| newSubdir1 newSubdir2 subdirFromSut key value |
	newSubdir1 := SVNDirectory named: 'subdir' basePath: sut path.
	sut addSubdirectory: newSubdir1.
	newSubdir2 := SVNDirectory named: 'subdir' basePath: sut path.
	key := 'key'.
	value := 'value'.
	newSubdir2 properties at: key put: value.
	sut addSubdirectory: newSubdir2.
	self assert: sut subdirectories size = 1.
	subdirFromSut := sut subdirectories anyOne.
	self assert: (subdirFromSut properties at: key) = value.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:32'!
testFileExists

	| fileName |
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	self assert: (sut fileExists: fileName).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/6/2008 14:58'!
testFilesMustHaveTheCorrectBasePath01

	| newFile |
	newFile := SVNFile
		named: 'new'
		basePath: 'Not/existing'.
	sut addFile: newFile.
	self assert: newFile basePath = sut path.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 02:01'!
testGatherPathsOfAllElements

	| dirName fileName expected1 expected2 result |
	dirName := 'dir1'.
	fileName := 'file1'.
	sut
		createSubDirectoryNamed: dirName;
		createFileNamed: fileName.
	expected1 := sut path , self slash , dirName.
	expected2 := sut path , self slash , fileName.
	result := sut recursivelyGatherPathsOfAllElements.
	self assert: result size = 2.
	self assert: (result includes: expected1).
	self assert: (result includes: expected2).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:36'!
testGetFileNamed

	| fileName svnFile |
	fileName := 'iAmAFile'.
	svnFile := sut createFileNamed: fileName.
	self assert: (sut getFileNamed: fileName) = svnFile.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/29/2008 23:08'!
testGetRevision

	"(self selector: #testGetRevision) run"
	| svnDir |
	self willNeedRepositoryAndWorkingCopy.
	svnDir := self defaultSVNDirectory createSubDirectoryNamed: 'svnDir'.
	"svnDir revision."! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:53'!
testGetSubDirectoryNamed

	| directoryName svnDirectory |
	directoryName := 'iAmADirectory'.
	svnDirectory := sut createSubDirectoryNamed: directoryName.
	self assert: (sut getSubDirectoryNamed: directoryName) = svnDirectory.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 01:49'!
testReadExistingDirectory

	self
		createDirNamed: sut theName
		in: sut basePath.
	self shouldnt: [sut read] raise: Error .! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'per 4/21/2008 11:08'!
testReadNonExistingDirectory

	sut := SVNDirectory
		named: 'blablabla'
		basePath: 'auf\dem\Mond'.
	"self shouldnt: [sut read] raise: Error."
	self assert: sut subdirectories isEmpty.
	self assert: sut files isEmpty.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 02:24'!
testReadWhenFileAndSubdirectoriesAreDeleted

	| fileName subDirName |
	self willTouchFileSystem.
	"Create a SVNDirectory and add a file and a subdirectory to it. Store. Delete the file and subdirectory
	and let the sut do a read. The file and subdirectory should be removed."
	"(self selector: #testReadWhenFileAndSubdirectoriesAreDeleted) run"
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	fileName := 'file'. subDirName := 'subdir'.
	sut
		createFileNamed: fileName;
		createSubDirectoryNamed: subDirName;
		store.
	self assert: sut files size = 1.
	self assert: sut subdirectories size = 1.
	self assertThatFiles: {fileName. subDirName} existsIn: sut path.
	(FileDirectory on: sut path) deleteFileNamed: fileName.
	(FileDirectory on: sut path) deleteDirectory: subDirName.
	self denyThatFiles: {fileName. subDirName} existsIn: sut path.
	sut read.
	self assert: sut files size = 0.
	self assert: sut subdirectories size = 0.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 00:54'!
testRecursiveReadOnlyWithDirectories

	| subDirPath subDirName subSubDirPath subSubDirName expectedSVNSubDirectory |
	self willTouchFileSystem.
	"1st level. Create real directory for the topmost SVNDirectory."
	subDirPath := self createDirNamed: sut theName in: sut basePath.
	"2nd level. Create a directory in the topmost SVNDirectory"
	subDirName := 'subdir'.
	subSubDirPath := self createDirNamed: subDirName in: subDirPath.
	"3rd level. Create a subdirectoy to the directory created just now. "
	subSubDirName := 'subsubdir'.
	self createDirNamed: subSubDirName in: subSubDirPath.
	
	"Now create the equivalent SVNDirectories"
	expectedSVNSubDirectory := SVNDirectory
		named: subDirName
		basePath: subDirPath.
	expectedSVNSubDirectory createSubDirectoryNamed: subSubDirName.
	
	sut read.
	
	self assert: sut subdirectories size = 1.
	self assert: (sut subdirectories includes: expectedSVNSubDirectory).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 02:52'!
testRecursiveReadOnlyWithFiles

	| fileName content pathToFile expectedSvnFile |
	"Create real directory"
	self
		createDirNamed: sut theName
		in: sut basePath.
	"Create a file"
	fileName := 'someFile'.
	content := 'blupfi'.
	pathToFile := self pathTo: fileName inDir: sut path.
	self inFile: pathToFile write: content.
	"Create SVNFile equivalent"
	expectedSvnFile := SVNFile 
		named: fileName
		basePath: sut path
		content: content.
	"exercise"
	sut read.
	self assert: (sut files includes: expectedSvnFile)! !

!SVNDirectoryTest methodsFor: 'tests svn funtions' stamp: 'rt 3/14/2008 15:46'!
testSVNRemove

	| fileName |
	self willTouchFileSystem.
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	sut remove.
	
	self deny: (FileDirectory on: sut path) exists! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 02:04'!
testSetWithDirsAreEqual01

	"(self selector: #testSetWithDirsAreEqual01) run"
	| set1 set2 |
	sut := SVNDirectory named: 'svnDirectory' basePath: self pathForTests.
	sut
		createFileNamed: 'blabla';
		createSubDirectoryNamed: 'ugauga'.
	set1 := Set with: sut.
	set2 := Set with: sut.
	self assert: set1 = set2.
	self assert: set1 = set1 copy.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 02:06'!
testSetWithDirsAreEqual02

	"(self selector: #testSetWithDirsAreEqual02) run"
	| set1 set2 anotherOne |
	sut := (SVNClass forExistingClass: self svnDummy) directory.
	anotherOne := (SVNClass forExistingClass: self svnDummy) directory.
	sut = anotherOne.
	set1 := Set with: sut.
	set2 := Set with: anotherOne.
	self assert: set1 = set2.
	self assert: set1 = set1 copy.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 02:22'!
testSetWithDirsAreEqual03

	"(self selector: #testSetWithDirsAreEqual03) run"
	| set1 set2 subDir svnFile |
	sut := SVNDirectory named: 'svnDirectory' basePath: self pathForTests.
	subDir := SVNDirectory named: 'subDir'.
	(subDir createFileNamed: 'uga') properties at: 'aaa' put: 'bbbb'.
	svnFile := SVNFile named: 'file' basePath: '/asfsd/sadfdsaf/sdfds'.
	svnFile properties at: 'aaa' put: 'bbbb'.
	sut addSubdirectory: subDir.
	subDir addFile: svnFile.
	set1 := Set with: sut.
	set2 := Set with: sut copy.
	self assert: set1 = set2.
	self assert: set1 = set1 copy.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'cop 5/3/2008 15:54'!
testStoreDirectory

	sut store.
	self
		assertThatDirectories: {sut theName}
		existsIn: self pathForTests.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 02:03'!
testStoreDirectoryWithFile

	| fileName |
	self willTouchFileSystem.
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	sut store.
	self
		assertThatFiles: {fileName}
		existsIn: sut path.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 02:03'!
testStoreLotsOfDirectoriesAndFiles

	| fileName subDirName subDirFileName subSubDirName subSubDirFileName subDir subSubDir |
	self willTouchFileSystem.
	fileName := 'file'.
	subDirName := 'subDir'.
	subDirFileName := 'subDirFileName'.
	subSubDirName := 'subsubDir'.
	subSubDirFileName := 'subSubDirFileName'.

	sut createFileNamed: fileName.
	subDir := sut createSubDirectoryNamed: subDirName.
	subDir createFileNamed: subDirFileName.
	subSubDir := subDir createSubDirectoryNamed: subSubDirName.
	subSubDir createFileNamed: subSubDirFileName.
	
	sut store.
	self assertThatFiles: {fileName. subDirName} existsIn: sut path.
	self assertThatFiles: {subDirFileName. subSubDirName} existsIn: subDir path.
	self assertThatFiles: {subSubDirFileName} existsIn: subSubDir path.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 5/10/2008 16:08'!
testStoreProperties

	| propertyDict |
	self willNeedRepositoryAndWorkingCopy.
	sut := SVNDirectory
		named: 'bla2'
		basePath: self workingCopyPath.
	propertyDict := Dictionary new.
	propertyDict at: 'key1' put: 'value1'.
	propertyDict at: 'key2' put: 'value2'.
	sut properties: propertyDict.
	sut store.
	self assertThatProperties: propertyDict areAddedTo: sut.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/6/2008 14:59'!
testSubdirectoriesMustHaveTheCorrectBasePath01

	| newDir |
	newDir := SVNDirectory
		named: 'blupf'
		basePath: 'not/existing/path'.
	sut addSubdirectory: newDir.
	self assert: newDir basePath = sut path.! !

!SVNDirectoryTest methodsFor: 'tests svn funtions' stamp: 'rkrk 4/1/2008 19:04'!
testSvnAddDirectory

	| directoryName |
	self willNeedRepositoryAndWorkingCopy.
	directoryName := 'DirectoryForSvnAdd'.
	sut := SVNDirectory
		named: directoryName
		basePath: self workingCopyPath.
	sut store.
	sut svnAdd.
	self
		assertFile: directoryName
		wasSVNAddedIn: self workingCopyPath.! !

!SVNDirectoryTest methodsFor: 'tests svn funtions' stamp: 'rkrk 4/1/2008 19:04'!
testSvnAddDirectoryWithSubdirectoriesAndFiles

	| directoryName subDirectoryName fileName subDir |
	self willNeedRepositoryAndWorkingCopy.
	directoryName := 'DirectoryForSvnAdd'.
	subDirectoryName := 'SubDirectory'.
	fileName := 'file'.
	sut := SVNDirectory
		named: directoryName
		basePath: self workingCopyPath.
	subDir := sut createSubDirectoryNamed: subDirectoryName.
	subDir createFileNamed: fileName.
	sut store.
	sut svnAdd.
	self
		assertFile: directoryName
		wasSVNAddedIn: self workingCopyPath.
	self
		assertFile: subDirectoryName
		wasSVNAddedIn: sut path.
	self
		assertFile: fileName
		wasSVNAddedIn: sut path.! !

SVNDirectoryEntryTest subclass: #SVNFileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing-Test'!

!SVNFileTest methodsFor: 'running' stamp: 'test 3/15/2008 02:33'!
setUp

	super setUp.
	self willTouchFileSystem.
	sut := SVNFile
		named: 'SVNFileCreatedDuringTests'
		basePath: self pathForTests.! !

!SVNFileTest methodsFor: 'tests delete' stamp: 'rt 3/14/2008 15:50'!
testCommitARemovedFile
	| client fileName |
	"create"
	client := SVNCApiClient new.
	self willNeedRepositoryAndWorkingCopy.
	fileName := 'otherSVNFile'.
	sut := SVNFile named: fileName basePath: self workingCopyPath.
	sut store.
	client svnAdd: sut path.
	client svnCommit: {  (sut path)}.
	client svnCheckoutHeadRevisionFrom: self repositoryURLPath to: self workingCopyPath , '2'.
	self assert: ((FileDirectory on: self workingCopyPath , '2') fileExists: fileName).
	
	"remove"
	sut remove.
	client svnCommit: {sut path}.
	
	"check"
	client svnCheckoutHeadRevisionFrom: self repositoryURLPath to: self workingCopyPath , '2'.
	self deny: ((FileDirectory on: self workingCopyPath , '2') fileExists: fileName)! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 5/12/2008 16:29'!
testConvertIllegalFileName01

	sut theName: 'selectorwithcolon:'.
	self deny: (sut filename includes: $:).! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 5/12/2008 16:30'!
testConvertIllegalFileName02

	sut theName: '//'.
	self assert: sut filename = (SVNPath on: sut theName) asEncodedString.! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 5/12/2008 13:47'!
testCreateMethodWithAsciiInName

	sut := SVNFile
		named:  'm1%3A'
		basePath: self pathForTests.
	self assert: sut theName = 'm1:'.! !

!SVNFileTest methodsFor: 'tests delete' stamp: 'rkrk 3/4/2008 05:12'!
testDelete

	| fileName |
	self willTouchFileSystem.
	fileName := 'otherSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	sut store.
	sut delete.
	self deny: ((FileDirectory on: sut basePath) fileExists: fileName)! !

!SVNFileTest methodsFor: 'tests delete' stamp: 'rkrk 3/4/2008 05:14'!
testDeletenonExistingFile

	| fileName |
	fileName := 'otherSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	self shouldnt: [sut delete] raise: Error.
! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/5/2008 20:22'!
testEqualFilesStoredInSet

	| fileName content file1 file2 assoc set dir |
	self willTouchFileSystem.
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file1 store.
	dir := self defaultSVNDirectory.
	dir read.
	dir commit.
	file2 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	assoc := 'key' -> 'value'.
	file1 properties add: assoc.
	file2 properties add: assoc.
	set := Set with: file1 with: file2.
	self assert: set size = 1.
	self assert: file1 = file2.! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:34'!
testEquals

	| fileName content file1 file2 assoc |
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file2 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	assoc := 'key' -> 'value'.
	file1 properties add: assoc.
	file2 properties add: assoc.
	self assert: file1 = file2! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:52'!
testEquals02

	| file1 file2 set |
	file1 := SVNFile readFrom:  '(SVNFile basicNew instVarAt: 1 put: ''comment''; instVarAt: 2 put: ''/Users/robertkrahn/studium/SWA/squeak/squeakSVN/images/soft/svnTests/workingCopy/TestPro/SimpleDummyClassForSVNProjectTest''; instVarAt: 3 put: ((Dictionary new)); instVarAt: 4 put: ''A SimpleDummyClassForSVNProjectTest is xxxxxxxxx.

Instance Variables
''; yourself)'.

	file2 := SVNFile readFrom: '(SVNFile basicNew instVarAt: 1 put: ''comment''; instVarAt: 2 put: ''/Users/robertkrahn/studium/SWA/squeak/squeakSVN/images/soft/svnTests/workingCopy/TestPro/SimpleDummyClassForSVNProjectTest''; instVarAt: 3 put: ((Dictionary new)); instVarAt: 4 put: ''A SimpleDummyClassForSVNProjectTest is xxxxxxxxx.

Instance Variables
''; yourself)'.

	set := Set with: file1 with: file2.
	self assert: set size = 1.! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 5/12/2008 16:31'!
testFilenamesWithUmlauts

	| svnFile |
	self willTouchFileSystem.
	svnFile := SVNFile
		named:  'mp'
		basePath: self pathForTests.
	self assert: svnFile filename =  'm%25C3%25B6p'.! !

!SVNFileTest methodsFor: 'tests restore' stamp: 'rkrk 3/4/2008 01:11'!
testReadFileContents

	| fileName content fullPath |
	self willTouchFileSystem.
	fileName := 'someSVNFile'.
	sut := SVNFile 
		named: fileName
		basePath: self pathForTests.
	self assert: sut content isEmpty.
	content := 'blabla' , String cr , 'blupf blupf'.
	fullPath := self pathTo: fileName inDir: self pathForTests.
	self 
		inFile: fullPath
		write: content.
	sut read.
	self assert: sut content = content! !

!SVNFileTest methodsFor: 'tests restore' stamp: 'rkrk 3/20/2008 03:45'!
testReadFileProperties

	| fileName helper expected propertyKey propertyValue result |
	self willNeedRepositoryAndWorkingCopy.
	"create some file and add manually properties to it"
	fileName := 'someSVNFile'.
	helper := SVNFile 
		named: fileName
		basePath: self workingCopyPath.
	helper store.	
	propertyKey := 'schluessel'.
	propertyValue := 'wert'.
	self svnClientDo: [:svnClient |
		svnClient svnAddProperty: propertyKey WithValue: propertyValue To: helper path].
	
	sut := SVNFile 
		named: fileName
		basePath: self workingCopyPath.
	sut read.
	expected := Dictionary with: propertyKey -> propertyValue.
	result := sut properties.
	self debugExpected: expected result: result.
	self assert: result = expected.! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 5/12/2008 16:35'!
testReadFileWithUmlauts

	| filename expected svnDir |
	self willTouchFileSystem.
	expected := 'mopp:'.
	filename := (SVNPath on: expected) asEncodedString.
	self
		inFile: (self pathTo: filename inDir: self pathForTests)
		write: String new.
	svnDir := self defaultSVNDirectory.
	svnDir read.
	self assert: svnDir files size = 1.
	sut := svnDir files anyOne.
	self assert: sut theName = expected.
	self assert: sut filename = filename.! !

!SVNFileTest methodsFor: 'tests convert filename' stamp: 'rkrk 3/5/2008 18:52'!
testReadMethodWithIllegalFileName01

	| svnFile |
	self willTouchFileSystem.
	svnFile := SVNFile
		named:  'm1:'
		basePath: self pathForTests.
	svnFile store.
	sut := SVNFile
		named: svnFile theName
		basePath: svnFile basePath.
	sut read.
	self assert: sut = svnFile.! !

!SVNFileTest methodsFor: 'tests restore' stamp: 'rkrk 4/21/2008 01:20'!
testReadNonExistingFile

	| fileName |
	fileName := 'someSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	self shouldnt: [sut read] raise: Error.
	self assert: sut content isEmpty.! !

!SVNFileTest methodsFor: 'tests delete' stamp: 'rt 3/14/2008 15:51'!
testSVNRemove

	| fileName |
	self willTouchFileSystem.
	fileName := 'aLittleSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	sut remove.
	self deny: ((FileDirectory on: sut basePath) fileExists: fileName)! !

!SVNFileTest methodsFor: 'tests store' stamp: 'rkrk 3/4/2008 01:20'!
testStoreAndAddFile

	| fileName |
	self willNeedRepositoryAndWorkingCopy.
	fileName := 'testSVNFile'.
	sut := SVNFile 
		named: fileName
		basePath: self workingCopyPath.
	sut store.
	self 
		assertFile: fileName
		wasSVNAddedIn: self workingCopyPath! !

!SVNFileTest methodsFor: 'tests store' stamp: 'rkrk 3/4/2008 01:57'!
testStoreAsFile

	| fileName |
	self willTouchFileSystem.
	fileName := 'testSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	sut store.
	self
		assertThatFiles: {fileName}
		existsIn: self pathForTests.! !

!SVNFileTest methodsFor: 'tests store' stamp: 'rkrk 3/4/2008 01:21'!
testStoreContent

	| fileName content |
	self willTouchFileSystem.
	fileName := 'otherSVNFile'.
	content := 'this is content' , String cr , 'much content'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	sut store.
	self
		assertThatFile: fileName
		inPath: self pathForTests
		hasContent: content.! !

!SVNFileTest methodsFor: 'tests store' stamp: 'rkrk 3/4/2008 01:21'!
testStoreProperties

	| fileName propertyDict |
	self willNeedRepositoryAndWorkingCopy.
	fileName := 'otherSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self workingCopyPath.
	propertyDict := Dictionary new.
	propertyDict at: 'key1' put: 'value1'.
	propertyDict at: 'key2' put: 'value2'.
	sut properties: propertyDict.
	sut store.
	self
		assertThatProperties: propertyDict
		areAddedTo: sut.! !

!SVNFileTest methodsFor: 'tests svn functions' stamp: 'rkrk 3/13/2008 15:26'!
testSvnAdd

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNFile
		named: 'FileName'
		basePath: self workingCopyPath.
	sut
		store;
		svnAdd.
	self
		assertFile: sut theName
		wasSVNAddedIn: sut basePath.! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:30'!
testUnequal01

	| fileName content file1 file2 |
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content , ' Blupf'.
	file2 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	self deny: file1 = file2! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:31'!
testUnequal02

	| fileName content file1 file2 |
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file2 := SVNFile
		named: fileName , ' abc'
		basePath: self pathForTests
		content: content.
	self deny: file1 = file2! !

!SVNFileTest methodsFor: 'tests equals' stamp: 'rkrk 3/4/2008 23:33'!
testUnequal03

	| fileName content file1 file2 |
	fileName := 'test'.
	content := 'This is a file created in SVNFileTest.' , String cr , 'Enjoy :-)'.
	file1 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file2 := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	file1 properties add: 'key' -> 'value'.
	file2 properties add: 'otherKey' -> 'value'.
	self deny: file1 = file2! !

!SVNFileTest methodsFor: 'tests svn functions' stamp: 'rkrk 3/14/2008 04:19'!
testUpdateWithNoLocalChanges

	| contentForRev1 |
	self willNeedRepositoryAndWorkingCopy.
	contentForRev1 := 'abc'.
	sut content: contentForRev1.
	sut
		store;
		commit.
	"self assert: false."! !

SVNTestCase subclass: #SVNEnvironmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Environment-Test'!

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:52'!
testClassIsIncludedInEvironment

	sut := self createEnvironmentWithCurrentProjectAndSvnDummy.
	self assert: (sut includes: self svnDummy).! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:49'!
testCompiledMethodIsIncludedInEvironment

	sut := self createEnvironmentWithCurrentProjectAndSvnDummy.
	self assert: (sut includes: self svnDummy >> #m2).! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:51'!
testFindSvnMethodForCompiledMethod01

	| method result |
	"prepare"
	sut := self createEnvironmentWithCurrentProjectAndSvnDummy.
	"excercise"
	method := self svnDummy >> #onInstanceAndClassSide.
	result := sut findSvnMethodForMethod: method.
	self assert: result notNil.
	self assert: result theName = method selector asString.
	self deny: result isPartOfMetaclass.! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:49'!
testFindSvnMethodForCompiledMethod02

	| method result |
	"prepare"
	sut := self createEnvironmentWithCurrentProjectAndSvnDummy.
	"excercise"
	method := self svnDummy class >> #onInstanceAndClassSide.
	result := sut findSvnMethodForMethod: method.
	self assert: result notNil.
	self assert: result theName = method selector asString.
	self assert: result isPartOfMetaclass.! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:50'!
testFindSvnMethodForCompiledMethod03

	| method |
	"prepare"
	sut := self createEnvironmentWithEmptyProject.
	"excercise"
	method := self svnDummy class >> #onInstanceAndClassSide. 
	self assert: (sut findSvnMethodForMethod: method) isNil.! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:52'!
testFindSvnMethodInSvnClassWithinEnvironment

	| method result |
	"prepare"
	sut := self createEnvironmentWithCurrentProjectAndSvnDummy.
	method := SVNMethod forExistingMethod: self svnDummy >> #m1.
	result := sut findSvnProjectOrSvnClassForSvnMethod: method.
	self assert: result notNil.
	self assert: (result isKindOf: SVNClass).! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:49'!
testMethodRefIsIncludedInEvironment

	| methodRef |
	sut := self createEnvironmentWithCurrentProjectAndSvnDummy.
	methodRef := MethodReference class: self svnDummy selector: #m2.
	self assert: (sut includes: methodRef ).! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:51'!
testNoSvnClassForClassNotInProject

	| result |
	sut := self createEnvironmentWithEmptyProject.
	result := sut findSvnClassFor: self svnDummy.
	self assert: result isNil.! !

!SVNEnvironmentTest methodsFor: 'tests - including' stamp: 'rkrk 4/25/2008 14:48'!
testRetrieveSvnClassFromSystemClass

	| result |
	sut := self createEnvironmentWithCurrentProjectAndSvnDummy.
	result := sut findSvnClassFor: self svnDummy.
	self assert: result = (SVNClass forExistingClass: self svnDummy)! !

SVNTestCase subclass: #SVNInfoRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNInfoRequestTest methodsFor: 'helper' stamp: 'mu 4/2/2008 11:34'!
getScheduleForFile: aFile

	^ (SVNInfoRequest target: aFile) execute schedule.! !

!SVNInfoRequestTest methodsFor: 'running' stamp: 'rkrk 3/23/2008 03:24'!
setupAddedFile

	^ (self defaultSVNDirectory createFileNamed: 'fileForSvnInfo')
		store;
		yourself.! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 03:33'!
testConvertToDateFromCTimeString

	! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'rkrk 5/11/2008 01:45'!
testDefaultArrayForPrimitive

	| conditions |
	sut := SVNInfoRequest new.
	self flag: #TODO.
	conditions := {
		[:elem | elem isString and: [elem size > 200]].	"repository root url"
		[:elem | elem =
			(SVNRevision revisionKindDictionary at: #number)]. "current revision kind" 
		[:elem | elem = 0].							"current revision number"
		[:elem | elem isString and: [elem size > 200]].	"own url"
		[:elem | elem isString and: [elem size = (36 + 1)]].	"repository uuid"
		[:elem | elem =
			(SVNRevision revisionKindDictionary at: #number)]."last changed  revision kind"
		[:elem | elem = 0].							"last changed revision number"
		[:elem | elem isString and: [elem size = (25 + 1)]].	"date"
		[:elem | elem isString and: [elem size > 100]].	"author"
		[:elem | elem isString and: [elem size = (8 + 1)]].	"schedule"
	}.
	sut arrayForPrimitive with: conditions do: [:each :condition |
		self assert: (condition value: each)].! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'rkrk 5/11/2008 01:43'!
testExecuteInfoForAddedFile

	| addedFile expectedRevision expectedLastChangedRevision |
	self willNeedRepositoryAndWorkingCopy.
	addedFile := self setupAddedFile.
	sut := SVNInfoRequest target: addedFile.
	sut execute.
	self flag: #TODO. "Make author changable"
	self assert: sut author = ''.
	expectedRevision := SVNRevision number.
	self assert: sut revision = expectedRevision.
	expectedLastChangedRevision := SVNRevision number.
	expectedLastChangedRevision number: -1.
	self assert: sut lastChangedRevision = expectedLastChangedRevision.
	self assert: sut date = DateAndTime current.
	self assert: sut repositoryRootUrl , '/' = self repositoryURLPath.
	self flag: #TODO. "Manage RepositoryUUID"
	self assert: sut repositoryUUID isString.
	self assert: sut schedule = 'add'.! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'rkrk 5/5/2008 00:10'!
testGetHeadRevision

	| file request |
	self willNeedRepositoryAndWorkingCopy.
	
	file := self defaultSVNDirectory createFileNamed: 'fileInSvnInfoRequestTest'.
	file
		store;
		commit.
	request := (SVNInfoRequest target: file forRevision: (SVNRevision head)).
	request execute.
	self assert: request revision number = 1.
	file
		content: 'xyz';
		store;
		commit.
	request execute.
	self assert: request revision number = 2.
	self svnClientDo: [:client | client
		svnUpdateTargets: {file}
		toRevisionByNumber: 1].
	request execute.
	self assert: request revision number = 2.! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'rkrk 5/5/2008 00:10'!
testGetWorkingRevision

	| file request |
	self willNeedRepositoryAndWorkingCopy.
	
	file := self defaultSVNDirectory createFileNamed: 'fileInSvnInfoRequestTest'.
	file
		store;
		commit;
		content: 'xyz';
		store;
		commit.
	self svnClientDo: [:client | client
		svnUpdateTargets: {file}
		toRevisionByNumber: 1].
	request := (SVNInfoRequest target: file forRevision: (SVNRevision working)).
	request execute.
	self assert: request revision number = 1.! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'mu 4/2/2008 11:57'!
testInfoScheduleForFile

	| addedFile firstSchedule secondSchedule stream thirdSechedule |
	"setup"
	self willNeedRepositoryAndWorkingCopy.
	addedFile := self setupAddedFile.
	
	"execute"
	firstSchedule := self getScheduleForFile: addedFile.
	"self halt."
	addedFile commitWithMessage: 'not relevant'.
	secondSchedule := self getScheduleForFile: addedFile.
	self flag: #TODO. "if a element is modified - return the status modified/replace"
"	stream := FileStream fileNamed: addedFile path.
	stream
		nextPutAll: '123';
		close.
	thirdSechedule := self getScheduleForFile: addedFile."
	
	"assert"
	self assert: firstSchedule = 'add'.
	self assert: secondSchedule = 'normal'.
	"self assert: thirdSechedule = 'replace'"! !

!SVNInfoRequestTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 02:28'!
testStringForSvnPrimitive

	| string result stringForPrimitive |
	string := 'blabla'.
	result := string forSvnPrimitive. "Be a collection with one String"
	self assert: result size = 1.
	stringForPrimitive := result first.	
	self assert: stringForPrimitive last = (Character value: 0).! !

SVNTestCase subclass: #SVNListRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNListRequestTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/11/2008 05:55'!
inSvnDir: svnDir createFiles: numberOfFiles andDirectories: numberOfDirectories 
	
	1 to: numberOfFiles do: [ :i |
		(svnDir createFileNamed: 'fileNr' , i asString) store].
	1 to: numberOfDirectories do: [ :i |
		(svnDir createSubDirectoryNamed: 'dirNr' , i asString) store].
	svnDir
		store;
		commit.! !

!SVNListRequestTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 03:55'!
testCountFiles01

	| numberOfFiles svnDir dirInRepo |
	self willNeedRepositoryAndWorkingCopy.
	numberOfFiles := 5.
	svnDir := self defaultSVNDirectory.
	self 
		inSvnDir: svnDir
		createFiles: numberOfFiles
		andDirectories: 0.
	dirInRepo := SVNRepositoryDirectory
		fromUrl: svnDir svnInfo url
		forRevision: SVNRevision head.
	sut := SVNListRequest
		target: dirInRepo
		forRevision: dirInRepo revision.
	self assert: sut numberOfFiles = numberOfFiles! !

!SVNListRequestTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 03:55'!
testCountFiles02

	| numberOfFiles svnDir dirInRepo |
	self willNeedRepositoryAndWorkingCopy.
	numberOfFiles := 5.
	svnDir := self defaultSVNDirectory.
	self 
		inSvnDir: svnDir
		createFiles: numberOfFiles
		andDirectories: 7.
	dirInRepo := SVNRepositoryDirectory
		fromUrl: svnDir svnInfo url
		forRevision: SVNRevision head.
	sut := SVNListRequest
		target: dirInRepo
		forRevision: dirInRepo revision.
	self assert: sut numberOfFiles = numberOfFiles! !

!SVNListRequestTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 03:55'!
testCountSubdirectories01

	| svnDir numberOfDirs dirInRepo |
	self willNeedRepositoryAndWorkingCopy.
	numberOfDirs := 6.
	svnDir := self defaultSVNDirectory.
	self 
		inSvnDir: svnDir
		createFiles: 0
		andDirectories: numberOfDirs.
	dirInRepo := SVNRepositoryDirectory
		fromUrl: svnDir svnInfo url
		forRevision: SVNRevision head.
	sut := SVNListRequest
		target: dirInRepo
		forRevision: dirInRepo revision.
	self assert: sut numberOfSubdirectories = numberOfDirs! !

!SVNListRequestTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 03:55'!
testCountSubdirectories02

	| svnDir numberOfDirs dirInRepo |
	self willNeedRepositoryAndWorkingCopy.
	numberOfDirs := 6.
	svnDir := self defaultSVNDirectory.
	self 
		inSvnDir: svnDir
		createFiles: 4
		andDirectories: numberOfDirs.
	dirInRepo := SVNRepositoryDirectory
		fromUrl: svnDir svnInfo url
		forRevision: SVNRevision head.
	sut := SVNListRequest
		target: dirInRepo
		forRevision: dirInRepo revision.
	self assert: sut numberOfSubdirectories = numberOfDirs! !

!SVNListRequestTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 03:54'!
testListFiles

	| svnDir fileName dirName1 dirName2 dirInRepo |
	self willNeedRepositoryAndWorkingCopy.
	svnDir := self defaultSVNDirectory.
	fileName := 'fileName'.
	dirName1 := 'dirrr'.
	dirName2 := 'dirrrasdfas'.
	svnDir
		createFileNamed: fileName;
		createSubDirectoryNamed: dirName1;
		createSubDirectoryNamed: dirName2;
		store;
		commit.
	
	dirInRepo := SVNRepositoryDirectory
		fromUrl: svnDir svnInfo url
		forRevision: SVNRevision head.
	sut := SVNListRequest
		target: dirInRepo
		forRevision: dirInRepo revision.
	sut execute.
	self assert: sut fileNames size = 1.
	self assert: (sut fileNames includes: fileName).
	self assert: sut directoryNames size = 2.
	self assert: (sut directoryNames includes: dirName1).
	self assert: (sut directoryNames includes: dirName2).! !

SVNTestCase subclass: #SVNLoadFromRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing-Test'!

!SVNLoadFromRepositoryTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 17:23'!
createSVNDirectoryNamed: dirName withProperties: dict subDirectories: subDirs files: files

	| svnDir |
	svnDir := (SVNDirectory 
		named: dirName
		basePath: String new)
		properties: (dict ifNil: [Dictionary new] ifNotNil: [dict]);
		yourself.
	subDirs do: [:ea | svnDir addSubdirectory: ea].
	files do: [:ea | svnDir addFile: ea].
	^ svnDir! !

!SVNLoadFromRepositoryTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 17:23'!
createSVNFileNamed: fileName content: fileContent properties: dict

	^ (SVNFile
		named: fileName
		basePath: String new
		content: fileContent)
		properties: (dict ifNil: [Dictionary new] ifNotNil: [dict]);
		yourself.! !

!SVNLoadFromRepositoryTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 17:20'!
dictFromAssocs: collectionWithAssociations

	| properties |
	properties := Dictionary new.
	collectionWithAssociations do: [:ea |
		self assert: (ea isKindOf: Association).
		properties at: ea key put: ea value].
	^ properties.! !

!SVNLoadFromRepositoryTest methodsFor: 'as yet unclassified' stamp: 'test 5/13/2008 07:42'!
testLoadProjectFromRepository

	"(self selector: #testLoadProjectFromRepository) run"
	| svnProject sut1 sut2 |
	self willNeedRepositoryAndWorkingCopy.
	svnProject := self createSvnProjectWithSvnDummy.
	svnProject
		store;
		commit;
		removeClass: self svnDummy;
		commit.
	sut1 := SVNProject
		readFromUrl: self repositoryURLPath
		named: svnProject theName
		revision: (SVNRevision number: 1).
	self assert: (sut1 includes: (SVNClass forExistingClass: self svnDummy)).
	sut2 := SVNProject
		readFromUrl: self repositoryURLPath
		named: svnProject theName
		revision: (SVNRevision number: 2).
	self deny: (sut2 includes: (SVNClass forExistingClass: self svnDummy)).! !

!SVNLoadFromRepositoryTest methodsFor: 'tests' stamp: 'rkrk 5/12/2008 03:28'!
testRestoreDirectoryFromRepository01

	"(self selector: #testRestoreFileFromRepository) run"
	| propKey propValue url dirName svnDir |
	self willNeedRepositoryAndWorkingCopy.
	dirName := 'svnDir'.
	propKey := 'key'.
	propValue := 'value'.
	svnDir := self defaultSVNDirectory createSubDirectoryNamed: dirName.
	svnDir properties at: propKey put: propValue.
	svnDir
		store;
		commit.
	url := svnDir svnInfo url.
	sut := SVNRepositoryDirectory fromUrl: url forRevision: (SVNRevision number: 1).
	self assert: sut theName = svnDir theName.
	self assert: sut properties = svnDir properties.! !

!SVNLoadFromRepositoryTest methodsFor: 'tests' stamp: 'rkrk 5/12/2008 03:34'!
testRestoreDirectoryFromRepository02

	"Create a dir with two subdirectories. The first one also a own subdir"
	| url dirName svnDir subDirName1 subDirName2 subSubDirName subDir readSubDir1 |
	self willNeedRepositoryAndWorkingCopy.
	dirName := 'svnDir'.
	subDirName1 := 'subDir'.
	subDirName2 := 'otherSubDir'.
	subSubDirName := 'subSubDir'.
	svnDir := self defaultSVNDirectory createSubDirectoryNamed: dirName.
	subDir := svnDir createSubDirectoryNamed: subDirName1.
	subDir properties at: 'key' put: 'value'.
	subDir createSubDirectoryNamed: subSubDirName.
	svnDir createSubDirectoryNamed: subDirName2.
	svnDir
		store;
		commit.
	url := svnDir svnInfo url.
	sut := SVNRepositoryDirectory fromUrl: url forRevision: (SVNRevision number: 1).
	self assert: (sut directoryExists: subDirName1).
	self assert: (sut directoryExists: subDirName2).
	self assert: (sut directoryExists: subDirName2).
	readSubDir1 := sut getSubDirectoryNamed: subDirName1.
	self assert: (readSubDir1 directoryExists: subSubDirName).
	self assert: readSubDir1 properties notEmpty.! !

!SVNLoadFromRepositoryTest methodsFor: 'tests' stamp: 'rkrk 5/12/2008 17:26'!
testRestoreDirectoryWithSubDirectoryAndFiles

	"(self selector: #testRestoreDirectoryWithSubDirectoryAndFiles) run"
	| url svnDir svnFile1 svnFile2 subDir propertiesOfSvnFile1 |
	self willNeedRepositoryAndWorkingCopy.
	propertiesOfSvnFile1 := self dictFromAssocs: {'key' -> 'value'}.
	svnFile1 := self
		createSVNFileNamed: 'file1'
		content: ''
		properties: propertiesOfSvnFile1.
	svnFile2 := self
		createSVNFileNamed: 'file2'
		content: ''
		properties: nil.
	subDir := self
		createSVNDirectoryNamed: 'dir'
		withProperties: (self dictFromAssocs: {'key' -> 'value'})
		subDirectories: {}
		files: {}.
	svnDir := self defaultSVNDirectory createSubDirectoryNamed: 'dirName'.
	svnDir
		addFile: svnFile1;
		addFile: svnFile2;
		addSubdirectory: subDir;
		store;
		commit.
	url := svnDir svnInfo url.
	sut := SVNRepositoryDirectory fromUrl: url forRevision: (SVNRevision number: 1).
	self assert: (sut fileExists: svnFile1 theName).
	self assert: (sut fileExists: svnFile2 theName).
	self assert: (sut directoryExists: subDir theName).
	self
		assertThatProperties: propertiesOfSvnFile1
		areAddedTo: (sut getFileNamed: svnFile1 theName).
	! !

!SVNLoadFromRepositoryTest methodsFor: 'tests' stamp: 'rkrk 5/12/2008 17:14'!
testRestoreFileFromRepository

	"(self selector: #testRestoreFileFromRepository) run"
	| fileName content propKey propValue svnFile url |
	self willNeedRepositoryAndWorkingCopy.
	fileName := 'svnFile'.
	content := 'this is content for the file'.
	propKey := 'key'.
	propValue := 'value'.
	svnFile := self defaultSVNDirectory
		createFileNamed: fileName
		withContent: content.
	svnFile properties at: propKey put: propValue.
	svnFile
		store;
		commit.
	url := svnFile svnInfo url.
	sut := SVNRepositoryFile fromUrl: url forRevision: (SVNRevision number: 1).
	self assert: sut theName = svnFile theName.
	self assert: sut content = svnFile content.
	self assert: sut properties = svnFile properties.! !

SVNTestCase subclass: #SVNLoaderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNLoaderTest commentStamp: '<historical>' prior: 0!
A SVNLoaderTest is xxxxxxxxx.

Instance Variables
!

!SVNLoaderTest methodsFor: 'assertions' stamp: 'rt 3/7/2008 22:07'!
classesRecoveredCorrect: aSet

	| element setUnderTest |
	self assert: aSet size = 1.
	element := aSet someElement.
	self assert: element superclassName = 'Object'.
	self assert: element theName = 'TestClass4'.
	
	setUnderTest := element subclasses.
	self assert: setUnderTest size = 2.
	self assert: (setUnderTest collect: [:each | each theName]) = {'TestClass3'. 'TestClass5'} asSet.
	self assert: (setUnderTest detect: [:each | each theName = 'TestClass5']) subclasses isEmpty.
	
	element := setUnderTest detect: [:each | each theName = 'TestClass3'].
	setUnderTest := element subclasses.
	self assert: setUnderTest size = 1.
	
	element := setUnderTest detect: [:each | each theName = 'TestClass2'].
	setUnderTest := element subclasses.
	self assert: setUnderTest size = 2.
	self assert: (setUnderTest collect: [:each | each theName]) = {'TestClass1'. 'TestClass6'} asSet.
	
	setUnderTest do: [:each | self assert: each subclasses isEmpty].
	^true! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 10:52'!
getSVNTestClassFromClass: aClass

	^SVNClass forExistingClass: aClass! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 12:45'!
getTestClass

	| class |
	class :=(Smalltalk classNamed: self nameOfTestClass asSymbol) ifNil: [Object
		subclass: self nameOfTestClass asSymbol
		instanceVariableNames: '' 
		classVariableNames:''
		poolDictionaries: ''
		category: self class category asString].
	
	class
		compile: 'm1: obj'
		classified: 'neu'
		withStamp: nil
		notifying: nil.
	class
		compile: 'm2: obj'
		classified: 'neu'
		withStamp: nil
		notifying: nil.
	class
		compile: 'm3: obj'
		classified: 'neu'
		withStamp: nil
		notifying: nil.
	^class! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 23:21'!
nameOfTestClass

	^'ClassOfSVNLoaderTest'! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 11:21'!
removeTestClass: name

	| class |
	(class := Smalltalk classNamed: name) ifNotNil: [class removeFromSystem].! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 12:29'!
setOfDependentClasses
	^Set
		with: (SVNClass new theName: 'TestClass1'; superclassName: 'Object')
		with: (SVNClass new theName: 'TestClass2'; superclassName: 'Object')
		with: (SVNClass new theName: 'TestClass3'; superclassName: 'Object')
		with: (SVNClass new theName: 'TestClass4'; superclassName: 'SVNMethod')
		with: (SVNClass new theName: 'TestClass5'; superclassName: 'SVNClass')
		with: (SVNClass new theName: 'TestClass6'; superclassName: 'DoesNotExistingClass').! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 15:58'!
setOfDependentClassesWithCycles
	^Set
		with: (SVNClass new theName: 'TestClass1'; superclassName: 'TestClass2')
		with: (SVNClass new theName: 'TestClass2'; superclassName: 'TestClass3')
		with: (SVNClass new theName: 'TestClass3'; superclassName: 'TestClass1').! !

!SVNLoaderTest methodsFor: 'helper' stamp: 'rt 3/7/2008 21:08'!
setOfDependentClassesWithOutCycles

	^Set with: (SVNClass new theName: 'TestClass1'; superclassName: 'TestClass2')
		with: (SVNClass new theName: 'TestClass2'; superclassName: 'TestClass3')
		with: (SVNClass new theName: 'TestClass3'; superclassName: 'TestClass4')
		with: (SVNClass new theName: 'TestClass4'; superclassName: 'Object')
		with: (SVNClass new theName: 'TestClass5'; superclassName: 'TestClass4')
		with: (SVNClass new theName: 'TestClass6'; superclassName: 'TestClass2').! !

!SVNLoaderTest methodsFor: 'running' stamp: 'rt 3/8/2008 02:43'!
setUp
	super setUp.
	sut := SVNLoader new! !

!SVNLoaderTest methodsFor: 'running' stamp: 'rt 3/7/2008 11:16'!
tearDown

	self removeTestClass: self nameOfTestClass.
	
	super tearDown! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/7/2008 22:29'!
testClassSorting

	| aSVNClassSet sortedSVNClasses |
	aSVNClassSet := self setOfDependentClassesWithOutCycles.
	sut addToRequiredClassesAllDependenciesInSVNClasses: aSVNClassSet.
	
	sortedSVNClasses := sut sortSVNClasses: aSVNClassSet consider: (sut requiredClasses intersection: sut classesToLoad).
	
	self assert: (self classesRecoveredCorrect: sortedSVNClasses)! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/7/2008 12:53'!
testDetectDependenciesInSVNClasses

	| resultSet |
	resultSet := sut addToRequiredClassesAllDependenciesInSVNClasses: self setOfDependentClasses..
	self assert: resultSet = {'DoesNotExistingClass'. 'SVNClass'. 'SVNMethod'. 'Object'} asSet! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/8/2008 22:39'!
testDetectDependenciesInSVNMethods

	| svnClass resultSet |
	svnClass := self getSVNTestClassFromClass: self getTestClass.
	resultSet := sut 
				addToRequiredClassesAllDependenciesInSVNMethods: (svnClass versionedMethods).
	self assert: resultSet = (Set with: self nameOfTestClass)! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/7/2008 16:08'!
testForCycles

	sut addToRequiredClassesAllDependenciesInSVNClasses: self setOfDependentClassesWithCycles.
	self assert: (sut hasCycle: self setOfDependentClassesWithCycles).
	
	sut initialize.
	
	sut addToRequiredClassesAllDependenciesInSVNClasses: self setOfDependentClassesWithOutCycles.
	self deny: (sut hasCycle: self setOfDependentClassesWithOutCycles).! !

!SVNLoaderTest methodsFor: 'tests' stamp: 'rt 3/7/2008 15:56'!
testRequirements

	sut addToRequiredClassesAllDependenciesInSVNClasses: self setOfDependentClasses.
	
	self assert: sut classesToLoad = {'TestClass1'. 'TestClass2'. 'TestClass3'. 'TestClass4'. 'TestClass5'. 'TestClass6'} asSet.
	
	self assert: sut requiredClasses = {'DoesNotExistingClass'. 'SVNClass'. 'SVNMethod'. 'Object'} asSet.
	
	self assert: sut unknownRequiredClasses = {'DoesNotExistingClass'} asSet! !

SVNTestCase subclass: #SVNMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNMethodTest subclass: #SVNMethodExternalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNMethodExternalTest methodsFor: 'tests' stamp: 'rt 5/12/2008 19:06'!
testRevertMethodWhichWasAddedToClass

	| svnClass |
	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	
	svnClass := (SVNClass forExistingClass: self svnDummy)
		directory: (self svnDirectoryForWorkingCopy
			createSubDirectoryNamed: self svnDummy asString);
		establishSvnFilesAndDirectories;
		store;
		yourself.
	svnClass directory store.
	svnClass commitWithMessage: 'Added SVNDummy'.
	
	self svnDummy compile: self selectorForMethodWhichIsNotInSvnDummy.
	svnClass
		addCompiledMethod: self svnDummy >> self selectorForMethodWhichIsNotInSvnDummy;
		store.
	svnClass directory store.
	
	sut := (svnClass versionedMethods detect: [:me |
		me theName = self selectorForMethodWhichIsNotInSvnDummy asString]).
	sut revert.
	
	self deny: ((svnClass versionedMethods collect: [:me | me theName])
		includes: self selectorForMethodWhichIsNotInSvnDummy asString)! !

!SVNMethodExternalTest methodsFor: 'tests' stamp: 'rt 5/12/2008 19:06'!
testUpdateMethodInClassToRevisionInWhichMethodIsUnversioned

	| svnClass |
	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	
	svnClass := (SVNClass forExistingClass: self svnDummy)
		directory: (self svnDirectoryForWorkingCopy
			createSubDirectoryNamed: self svnDummy asString);
		establishSvnFilesAndDirectories;
		store;
		yourself.
	svnClass directory store.
	svnClass commitWithMessage: 'Added SVNDummy'.
	
	self svnDummy compile: self selectorForMethodWhichIsNotInSvnDummy.
	svnClass
		addCompiledMethod: self svnDummy >> self selectorForMethodWhichIsNotInSvnDummy;
		store.
	svnClass directory store.
	svnClass commitWithMessage: 'Added a method'.
	
	sut := (svnClass versionedMethods detect: [:me |
		me theName = self selectorForMethodWhichIsNotInSvnDummy asString]).
	sut updateToRevision: (SVNRevision number: (sut revisionInfos last revision) - 1).
	
	self deny: ((svnClass versionedMethods collect: [:me | me theName])
		includes: self selectorForMethodWhichIsNotInSvnDummy asString)! !

!SVNMethodTest methodsFor: 'helper' stamp: 'rkrk 4/1/2008 01:58'!
svnFileForMethodReference: methodRef

	| svnFile |
	svnFile := SVNFile 
		named: methodRef methodSymbol asString
		basePath: ''
		content: methodRef source.
	svnFile properties 
		at: 'class' put: methodRef actualClass name asString;
		at: 'category' put: methodRef category;
		at: 'timestamp' put: methodRef timeStamp.
	^ svnFile.! !

!SVNMethodTest methodsFor: 'tests' stamp: 'rkrk 3/4/2008 03:25'!
testEquals

	| methodBlock method1 method2 |
	methodBlock := [SVNMethod forExistingMethod: self svnDummy >> #m1].
	method1 := methodBlock value.
	method2 := methodBlock value.
	self assert: method1 ~~ method2.
	self assert: method1 = method2! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 2/24/2008 12:44'!
testExtractMetaClass

	| method result svnFile className |
	method := SVNMethod new.
	self flag: #TODO. "Implicitly specified mapping..."
	svnFile := SVNFile
		named: 'm99'
		basePath: '/'.
	className := 'SVNDummy class'.
	svnFile properties
		at: 'class'
		put: className.
	result := method extractClassFrom: svnFile.
	self assert: result = className.! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 3/4/2008 03:25'!
testLoadMethodIntoSystem

	| class methodSelector  |
	self willModifySVNDummy.
	class := self svnDummy.
	methodSelector := #m2.
	sut := SVNMethod forExistingMethod: class >> methodSelector.
	class removeSelector: methodSelector.
	self deny: (class methodDict includesKey: methodSelector).
	sut load.
	self assert: (class methodDict includesKey: methodSelector).! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 4/21/2008 00:46'!
testRestoreAndLoad

	
	| newSourceCode result |
	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	"prepare"
	sut := SVNMethod forExistingMethod: self svnDummy >> #m2.
	"For setting the correct path"
	self defaultSVNDirectory addFile: sut file.
	sut store.
	sut file store.
	
	newSourceCode := 'm2 ^ 1 + 2 + 3 + 4 + 5'.
	sut source: newSourceCode.
	sut store.
	sut file store.
	"exercise"
	sut restoreAndLoad.
	result := (self svnDummy >> #m2) getSource.
	self assert: result = newSourceCode.! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 4/1/2008 04:33'!
testRestoreFromSVNFile

	
	| methodSelector class methodReference svnFile expectedSVNMethod |
	"prepare"
	methodSelector := #methodWithSpecialCharacter:.
	class := self svnDummy.
	methodReference := (class >> methodSelector) methodReference.
	svnFile := self svnFileForMethodReference: methodReference.
	"exercise"
	sut := SVNMethod restoreFrom: svnFile.
	"expected"
	expectedSVNMethod := SVNMethod forExistingMethod: class >> methodSelector.
	"assertion"
	self assert: sut = expectedSVNMethod! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 4/1/2008 02:04'!
testSVNMethodComesWithCorrectlyInitializedSVNFile

	| methodSelector class methodRef expectedFile resultFile |
	"setup"
	class := self svnDummy. methodSelector := #m1.
	methodRef := (class >> methodSelector) methodReference.
	"exercise"
	sut := SVNMethod forExistingMethod: methodRef compiledMethod.
	"assert"
	expectedFile := self svnFileForMethodReference: methodRef.
	resultFile := sut file.
	self assert: expectedFile = resultFile.! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 4/2/2008 17:41'!
testStoreInSVNDirectory
	
	| methodSelector class methodReference expectedSVNFile |
	self willTouchFileSystem.
	"prepare"
	methodSelector := #methodWithSpecialCharacter:.
	class := self svnDummy.
	sut := SVNMethod forExistingMethod: class >> methodSelector.
	self defaultSVNDirectory addFile: sut file.
	"exercise"
	sut store.
	"expected"
	methodReference := (class >> methodSelector) methodReference.
	expectedSVNFile := self svnFileForMethodReference: methodReference.
	"assertion"
	expectedSVNFile basePath: sut file basePath.
	self assert: sut file notNil.
	self assert: sut file = expectedSVNFile! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 4/2/2008 18:09'!
testStoreThenRestore

	| methodSelector writtenSVNMethod methodFile readSVNMethod |
	self willTouchFileSystem.
	"prepare"
	methodSelector := #m1.
	writtenSVNMethod := SVNMethod forExistingMethod: self svnDummy >> methodSelector.
	self defaultSVNDirectory addFile: writtenSVNMethod file.
	"exercise"
	writtenSVNMethod store.
	"assertion"
	methodFile := writtenSVNMethod file.
	self assert: methodFile notNil.
	readSVNMethod := SVNMethod restoreFrom: methodFile.
	self assert: writtenSVNMethod = readSVNMethod! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 5/12/2008 16:49'!
testStoreWithSpecialCharInSVNDirectory

	| methodSelector class expectedFileName |
	"prepare"
	methodSelector := #<.
	class := self svnDummy.
	sut := SVNMethod forExistingMethod: class >> methodSelector.
	self defaultSVNDirectory addFile: sut file.
	"exercise"
	sut store.
	"expected"
	expectedFileName := (SVNPath on: sut theName) asEncodedString.
	"assertion"
	self assert: sut file notNil.
	self assert: sut file filename = expectedFileName! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 4/28/2008 00:28'!
testUpdateToPreviousRevision

	| source1 source2 |
	"Create a SVNMethod of SVNDummy>>m2. Commit rev1 of the svnMethod. Change
	svnMethod (and the svnDummy) and commit again. Update to rev1."
	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	"objects needed"
	sut := SVNMethod forExistingMethod: self svnDummy >> #m2.
	self defaultSVNDirectory addFile: sut file.
	source1 := sut source.
	"prepare"
	sut store.
	sut file store.
	sut	commit.
	source2 := 'm2 "another source of m2"'.
	self svnDummy compile: source2.
	sut source: source2. "no registry here. Manually assign new source"
	sut store.
	sut file store.
	sut commit.
	self
		assertThatFile: sut theName
		inPath: self pathForTests
		hasContent: source2.
	self assert: (self svnDummy >> #m2) getSource = source2.
	"exercise"
	sut updateToRevision: (SVNRevision number: 1).
	self assert: sut source = source1.
	self assert: (self svnDummy >> #m2) getSource = source1.! !

SVNTestCase subclass: #SVNPathTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing-Test'!

!SVNPathTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 15:43'!
testDecodePath01

	sut := SVNPath on: 'test'.
	sut asEncodedString = 'test'.! !

!SVNPathTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 15:54'!
testDecodePath02

	sut := SVNPath on: 'mp'.
	self deny: (sut asEncodedString includes: $)! !

!SVNPathTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 16:11'!
testDecodePath03

	sut := SVNPath on: 'm1:'.
	self deny: (sut asEncodedString includes: $:)! !

!SVNPathTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 16:15'!
testEncodeThenDecode

	| path result |
	path := 'm1:'.
	result := (SVNPath on: path) asEncodedString.
	result := (SVNPath on: result) asDecodedString.
	self assert: result = path.! !

!SVNPathTest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 16:27'!
testEncodeThenDecodeProblematic

	| path result |
	self flag: #TODO. "Arghhh!!
	do it: ['m:' encodeForHTTP unescapePercents = 'm:']"
	path := 'm:'.
	result := (SVNPath on: path) asEncodedString.
	result := (SVNPath on: result) asDecodedString.
	"self assert: result = path."! !

SVNTestCase subclass: #SVNProjectTest
	instanceVariableNames: 'needsTestClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNProjectTest class
	instanceVariableNames: 'sut'!

SVNProjectTest class
	instanceVariableNames: 'sut'!

SVNProjectTest subclass: #SVNProjectExternalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNProjectExternalTest methodsFor: 'assertions' stamp: 'rkrk 3/6/2008 14:41'!
assertNoSVNFileWithIllegalCharacterIn: aSVNDirectory

	aSVNDirectory files do: [:each |
		self assert: (each filename includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not.].
	aSVNDirectory subdirectories do: [:each | self assertNoSVNFileWithIllegalCharacterIn: each].! !

!SVNProjectExternalTest methodsFor: 'helper' stamp: 'rt 3/19/2008 11:15'!
createSimpleDummyClassForSVNProjectTest

	| class |
	class := Object
				subclass: self nameOfClassForTests asSymbol
				instanceVariableNames: ''
				classVariableNames: ''
				poolDictionaries: ''
				category: self class category asString.
	
	class compile: 'm1: obj' classified: 'neu' withStamp: nil notifying: nil.
	class compile: 'm2: obj' classified: 'neu' withStamp: nil notifying: nil.
	class compile: 'm3: obj' classified: 'neu' withStamp: nil notifying: nil.
	class compile: 'm4: obj' classified: 'neu' withStamp: nil notifying: nil.
	^class! !

!SVNProjectExternalTest methodsFor: 'helper' stamp: 'rt 3/13/2008 16:32'!
nameOfClassForTests

	^ 'SimpleDummyClassForSVNProjectTest'! !

!SVNProjectExternalTest methodsFor: 'helper' stamp: 'rkrk 4/1/2008 04:24'!
removeSimpleDummyClassForSVNProjectTest

	Transcript
		show: 'will remove SimpleDummyClassForSVNProjectTest in test:' , testSelector;
		cr;
		show: 'class is there:' , (Smalltalk hasClassNamed: self nameOfClassForTests) asString;
		cr.
	"testSelector = #testCheckoutProperties ifTrue: [self halt]."
	(Smalltalk hasClassNamed: self nameOfClassForTests) ifFalse: [^self].
	Transcript
		show: 'Removing...';
		cr.
	(Smalltalk classNamed: self nameOfClassForTests) removeFromSystemUnlogged.
	Transcript
		show: 'Class successfully removed';
		cr.! !

!SVNProjectExternalTest methodsFor: 'running' stamp: 'rt 3/13/2008 16:34'!
setUp

	super setUp.
	
	self deny: (Smalltalk hasClassNamed: self nameOfClassForTests).
	self createSimpleDummyClassForSVNProjectTest.! !

!SVNProjectExternalTest methodsFor: 'running' stamp: 'rt 3/13/2008 16:35'!
tearDown

	self removeSimpleDummyClassForSVNProjectTest.
	self deny: (Smalltalk hasClassNamed: self nameOfClassForTests).
	
	super tearDown.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rkrk 3/20/2008 04:58'!
testCheckoutProperties

	| svnPro destination client |
	self willNeedRepositoryAndWorkingCopy.

	svnPro := SVNProject
 		checkoutProject: 'TestPro'
		fromURL: self repositoryURLPath
		inWorkingCopy: (SVNDirectory on: self workingCopyPath).
     
	svnPro addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro store.

	destination := self workingCopyPath, self slash, svnPro theName,
				self slash, self nameOfClassForTests.
	client := SVNCommandLineClient new.
	client
		svnAddProperty: 'instanceVariables'
		WithValue: 'instVar1'
		To: destination.

	svnPro projectDirectory read.
	self assert: (svnPro projectDirectory subdirectories size = 1).! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:40'!
testCheckoutSVNDirectories

	| svnPro1 |
	self willNeedRepositoryAndWorkingCopy.
	svnPro1 := SVNProject
					checkoutProject: 'TestPro'
					fromURL: self repositoryURLPath
					inWorkingCopy: (SVNDirectory on: self workingCopyPath).
					
	svnPro1 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	self assertNoSVNFileWithIllegalCharacterIn: svnPro1 directory.
	svnPro1 commit.
	self assertNoSVNFileWithIllegalCharacterIn: svnPro1 directory.
	svnPro1 checkout.
	self assertNoSVNFileWithIllegalCharacterIn: svnPro1 directory.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rkrk 4/2/2008 16:40'!
testCountOfCommitedElements

	| svnPro1 svnPro2 |
	self willNeedRepositoryAndWorkingCopy.
	svnPro1 := SVNProject
					checkoutProject: 'TestPro'
					fromURL: self repositoryURLPath
					inWorkingCopy: (SVNDirectory on: self workingCopyPath).
					
	svnPro1 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro1 commit.
	
	svnPro2 := SVNProject
					checkoutProject: 'TestPro'
					fromURL: self repositoryURLPath
					inWorkingCopy: (SVNDirectory on: self workingCopyPath).

	
	svnPro1 commit.
	svnPro1 commit.
	self assert: svnPro1 = svnPro2.

	self assert: svnPro1 projectDirectory subdirectories size = 1.
	self assert: svnPro1 projectDirectory subdirectories size = svnPro2 projectDirectory subdirectories size.
	self assert: svnPro1 projectDirectory subdirectories anyOne files size = svnPro2 projectDirectory subdirectories anyOne files size.
	self assert: svnPro1 projectDirectory subdirectories anyOne subdirectories size = svnPro2 projectDirectory subdirectories anyOne subdirectories size.
	self assert: ((svnPro1
					projectDirectory subdirectories anyOne subdirectories
						detect: [:each | each theName = 'instance']) files size
							= (svnPro2 projectDirectory subdirectories anyOne subdirectories
								detect: [:each | each theName = 'instance']) files size)! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:42'!
testCountOfCommitedElements02

	| svnPro1 svnPro2 projectName |
	self willTouchFileSystem. self flag: #TODO. "No need to write to disk..."
	projectName := 'TestPro'.
	
	svnPro1 := SVNProject named: projectName.
	svnPro1 directory: (SVNDirectory on: self pathForTests , projectName).
					
	svnPro1 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro1 store.
	
	svnPro2 := SVNProject named: projectName.
	svnPro2 directory: (SVNDirectory on: self pathForTests , projectName).
	svnPro2 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro2 store.
	
	svnPro1 store.
	svnPro1 store.
	"self assert: svnPro1 = svnPro2."
	self assert: svnPro1 directory = svnPro2 directory.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rkrk 3/15/2008 01:48'!
testDeleteAClass

	| projectName svnProject svnClass secondWorkingCopyPath sameProject |
	"Was this test not a bit too complicated?"
	self willNeedRepositoryAndWorkingCopy.
	self flag: #TODO.
	projectName := 'TestPro'.
	svnProject := SVNProject
					checkoutProject: 'TestPro'
					fromURL: self repositoryURLPath "There was repositoryPath...?"
					inWorkingCopy: (SVNDirectory on: self workingCopyPath).
	svnClass := SVNClass forExistingClass: self createSimpleDummyClassForSVNProjectTest.
	svnProject
		addSVNClass: svnClass;
		commit;
		removeSVNClass: svnClass;	"exercise"
		commit.
	
	"Is the class really deleted?"
	secondWorkingCopyPath := self workingCopyPath, '2'.

	sameProject := SVNProject
		checkoutProject: projectName
		fromURL: self repositoryURLPath
		inWorkingCopy:  (SVNDirectory on: secondWorkingCopyPath).
	self assert: sameProject versionedClasses isEmpty.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rt 5/12/2008 18:44'!
testRevertClassWhichWasAddedToProject

	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	sut := SVNProject
		checkoutProject: 'SVNProjectExternals'
		fromRepository: (SVNRepository on: self repositoryURLPath)
		toWorkingCopy: self defaultSVNDirectory.
	sut addClass: self svnDummy.
	sut versionedClasses someElement revert.
	
	self assert: sut versionedClasses isEmpty.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rt 5/12/2008 18:44'!
testRevertMethodWhichWasAddedToProject

	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	sut := SVNProject
		checkoutProject: 'SVNProjectExternals'
		fromRepository: (SVNRepository on: self repositoryURLPath)
		toWorkingCopy: self defaultSVNDirectory.
	sut addMethod: self svnDummy >> #m2.
	self assert: sut versionedMethods size = 1.
	sut versionedMethods someElement revert.
	
	self assert: sut versionedClasses isEmpty.
	self assert: sut versionedMethods isEmpty.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rt 5/12/2008 18:44'!
testRevertProjectWithAddedClass

	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	sut := SVNProject
		checkoutProject: 'SVNProjectExternals'
		fromRepository: (SVNRepository on: self repositoryURLPath)
		toWorkingCopy: self defaultSVNDirectory.
	sut addClass: self svnDummy.
	sut revert.
	sut versionedClasses isEmpty.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rt 5/12/2008 18:56'!
testRevertProjectWithAddedMethod

	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	sut := SVNProject
		checkoutProject: 'SVNProjectExternals'
		fromRepository: (SVNRepository on: self repositoryURLPath)
		toWorkingCopy: self defaultSVNDirectory.
	sut addMethod: self svnDummy >> #m2.
	sut revert.
	sut versionedMethods isEmpty.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'test 4/1/2008 13:41'!
testStoringOfInstanceVariables

	| class svnPro1 |
	self willNeedRepositoryAndWorkingCopy.
	svnPro1 := SVNProject
		checkoutProject: 'TestPro'
		fromURL: self repositoryURLPath
		inWorkingCopy: (SVNDirectory on: self workingCopyPath).

	svnPro1 addClass: (Smalltalk classNamed: self nameOfClassForTests).
	svnPro1 commit.
	svnPro1 checkout.
	svnPro1 load.
	class := (Smalltalk classNamed:  self nameOfClassForTests).
	class addInstVarName: 'i1 i2'.
	svnPro1 commit.
	class := nil.
	"self halt."
	svnPro1 checkout.
	class := (Smalltalk classNamed:  self nameOfClassForTests).
	class addInstVarName: 'i3'.
	svnPro1 commit.
	svnPro1 checkout.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rt 5/12/2008 18:44'!
testUpdateClassInProjectToRevisionInWhichClassIsUnversioned

	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	sut := SVNProject
		checkoutProject: 'SVNProjectExternals'
		fromRepository: (SVNRepository on: self repositoryURLPath)
		toWorkingCopy: self defaultSVNDirectory.
	sut addClass: self svnDummy.
	sut commitWithMessage: 'Added SVNDummy'.
	sut versionedClasses someElement updateToRevision: (SVNRevision number: (sut
		versionedClasses someElement revisionInfos last revision - 1)).
	
	self assert: sut versionedClasses isEmpty.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rt 5/12/2008 18:41'!
testUpdateProjectWithClassToRevisionWithoutClass

	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	sut := SVNProject
		checkoutProject: 'SVNProjectExternals'
		fromRepository: (SVNRepository on: self repositoryURLPath)
		toWorkingCopy: self defaultSVNDirectory.
	sut addClass: self svnDummy.
	sut commitWithMessage: 'Added SVNDummy'.
	sut updateToRevision: (SVNRevision number: (sut versionedClasses someElement revisionInfos last revision - 1)).
	
	self assert: sut versionedClasses isEmpty.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rt 5/12/2008 18:41'!
testUpdateProjectWithVersionedMethodToRevisionWithoutVersionedMethod

	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	sut := SVNProject
		checkoutProject: 'SVNProjectExternals'
		fromRepository: (SVNRepository on: self repositoryURLPath)
		toWorkingCopy: self defaultSVNDirectory.
	sut addMethod: self svnDummy >> #m2.
	self assert: sut versionedMethods size = 1.
	sut commitWithMessage: 'Added SVNDummy>>m2'.
	sut updateToRevision: (SVNRevision number: (sut versionedMethods someElement revisionInfos last revision - 1)).
	
	self assert: sut versionedClasses isEmpty.
	self assert: sut versionedMethods isEmpty.! !

!SVNProjectExternalTest methodsFor: 'tests' stamp: 'rt 5/12/2008 18:45'!
testUpdateVersionedMethodInProjectToRevisionInWhichVersionedMethodIsUnversioned

	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
	sut := SVNProject
		checkoutProject: 'SVNProjectExternals'
		fromRepository: (SVNRepository on: self repositoryURLPath)
		toWorkingCopy: self defaultSVNDirectory.
	sut addMethod: self svnDummy >> #m2.
	self assert: sut versionedMethods size = 1.
	sut commitWithMessage: 'Added SVNDummy>>m2'.
	sut versionedMethods someElement updateToRevision: (SVNRevision number: sut
		versionedMethods someElement revisionInfos last revision - 1).
	
	self assert: sut versionedClasses isEmpty.
	self assert: sut versionedMethods isEmpty.! !

!SVNProjectTest methodsFor: 'assertion' stamp: 'rkrk 2/25/2008 02:08'!
assertExistanceOfProject: aSVNProject in: pathString

	| dir |
	dir := FileDirectory on: pathString.
	self assert: (dir directoryExists: aSVNProject theName).! !

!SVNProjectTest methodsFor: 'running' stamp: 'rt 3/17/2008 12:43'!
setUp

	super setUp.
	
	self willNeedSimpleTestClass: false! !

!SVNProjectTest methodsFor: 'helper' stamp: 'rt 3/17/2008 13:07'!
simpleTestClass

	self willNeedSimpleTestClass ifFalse: [
		self deny: (Smalltalk hasClassNamed: self simpleTestClassName).
		needsTestClass := true.
		Object
			subclass: self simpleTestClassName asSymbol
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: self class category asString].
	^ (Smalltalk classNamed: self simpleTestClassName)! !

!SVNProjectTest methodsFor: 'helper' stamp: 'rt 3/17/2008 13:02'!
simpleTestClassName

	^'SimpleTestClass'! !

!SVNProjectTest methodsFor: 'running' stamp: 'rkrk 4/15/2008 02:41'!
tearDown

	super tearDown.
	
	(Smalltalk hasClassNamed: self simpleTestClassName)
		ifTrue:[(Smalltalk classNamed: self simpleTestClassName) removeFromSystemUnlogged]! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:47'!
testAddCategory

	| classesOfCategory result |
	sut := SVNProject named: 'TestPro'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'TestPro').
	sut addCategory: 'SqueakSVN-TestCategory'.
	classesOfCategory := {
		SVNClass forExistingClass: Class1.
		SVNClass forExistingClass: Class2.
		SVNClass forExistingClass: Class3.} asSet.
	result := sut versionedClasses.
	self assert: result = classesOfCategory asSet.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:48'!
testAddClass

	| aClass methodsOfClass result |
	sut := SVNProject named: 'TestPro'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'TestPro').
	aClass := self svnDummy.
	sut addClass: aClass.
	self assert: (sut versionedClasses includes: (SVNClass forExistingClass: aClass)).
	methodsOfClass := (aClass methodDict collect: [:ea | SVNMethod forExistingMethod: ea ])
						union: (aClass class methodDict collect: [:ea | SVNMethod forExistingMethod: ea ]).
	result := sut allVersionedMethods asSet.
	self assert: result = methodsOfClass asSet.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:49'!
testAddClassWhenClassAlreadyExist

	| aClass svnClass svnMethod |
	sut := SVNProject named: 'TestPro'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'TestPro').
	aClass := self svnDummy.
	sut addClass: aClass.
	svnClass := SVNClass forExistingClass: aClass.
	svnMethod := svnClass versionedMethods detect: [:ea | (ea theName = 'm2') and: [ea nameOfClass asSymbol = svnClass theName]].
	svnClass removeSVNMethod: svnMethod.
	sut addSVNClass: svnClass.
	self assert: sut versionedClasses size = 1.
	self assert: (sut versionedClasses someElement versionedMethods noneSatisfy: [:ea | ea theName = 'm2']).! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 5/9/2008 15:04'!
testAddClassWhenClassAlreadyExistButIsUnversioned

	| aClass svnClass |
	sut := SVNProject named: 'TestPro'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'TestPro').
	aClass := self svnDummy.

	svnClass := SVNClass forExistingClass: aClass.
	svnClass isVersioned: false.
	sut addSVNClass: svnClass.
	self assert: sut versionedClasses isEmpty.
	self assert: sut allClasses size = 1.
	self assert: sut allClasses someElement = svnClass.
	
	sut addClass: aClass.
	self assert: sut versionedClasses size = 1.
	self assert: sut allClasses size = 1.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'cop 4/24/2008 15:06'!
testAddClassWhenMethodAllreadyAdded

	| aClass aMethod|
	sut := SVNProject named: 'TestPro'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'TestPro').
	aClass := self svnDummy.
	aMethod := self svnDummy >> #m1.
	sut addMethod: aMethod.
	self assert: sut versionedMethods size = 1.
	sut addClass: aClass.
	self assert: sut versionedMethods size = 0.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 5/9/2008 14:37'!
testAddMethod

	| aMethod svnMethod |
	sut := SVNProject named: 'TestPro'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'TestPro').
	aMethod := self svnDummy >> #m1.
	sut addMethod: aMethod.
	self assert: sut versionedMethods size = 1.
	svnMethod := sut versionedMethods someElement.
	self assert: svnMethod nameOfClass = aMethod methodReference actualClass name.
	self assert: svnMethod methodSelector = aMethod selector.
	
	self assert: sut versionedClasses isEmpty.
	self assert: sut allClasses size = 1.
	self assert: sut allClasses someElement theName = aMethod methodReference actualClass name! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 5/9/2008 16:17'!
testAllVersionedMethodsShouldNotModifyVersionedMethods

	sut := self createSvnProjectWithSvnDummy.
	"exercise"
	sut allVersionedMethods.
	self assert: sut versionedMethods isEmpty.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 5/9/2008 16:20'!
testClassDeleted

	self
		willNeedSimpleTestClass: true;
		willNeedRegistry.
	sut := SVNProject named: 'test'.
	self svnRegistry addSvnProject: sut.
	self defaultSVNDirectory addSubdirectory: sut directory.
	
	sut addClass: self simpleTestClass.
	self assert: (sut versionedClasses size = 1).
	
	self simpleTestClass removeFromSystem.

	self assert: (sut versionedClasses size = 0).
	self deny: (Smalltalk hasClassNamed: self simpleTestClassName)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 04:44'!
testClassLoading

	| file |
	self
		willNeedRepositoryAndWorkingCopy;
		willModifySVNDummy.
		
	sut := SVNProject
		checkoutProject: 'MyPro'
		fromURL: self repositoryURLPath
		inWorkingCopy: self defaultSVNDirectory.
	
	sut
		addClass: self svnDummy;
		commit;
		checkout;
		load.
	
	self deny: self svnDummy isNil.
	self deny: self svnDummy class isObsolete.
	self deny: sut versionedClasses size = 0.
	self deny: sut versionedClasses someElement directory isNil.
	file := sut versionedClasses someElement versionedMethods someElement file.
	self assert: ((FileDirectory on: file basePath) fileExists: file filename).! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 20:11'!
testDeleteClass

	self willNeedSimpleTestClass: true.
	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: sut theName).
	
	sut addClass: self simpleTestClass.
	self assert: (sut versionedClasses size = 1).
	sut deleteClass: self simpleTestClass.
	self deny: (sut versionedClasses size ~= 0).
	self deny: (Smalltalk hasClassNamed: self simpleTestClassName)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'pe 4/17/2008 15:35'!
testDeleteMethod

	self willNeedSimpleTestClass: true.
	self simpleTestClass compile: 'm1' classified: 'neu' withStamp: nil notifying: nil.
	
	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: sut theName).
	
	sut addMethod: (self simpleTestClass compiledMethodAt: #m1).
	self assert: (sut versionedMethods size = 1).
	sut deleteMethod: (self simpleTestClass compiledMethodAt: #m1).
	self deny: (sut versionedMethods size ~= 0).
	self deny: (self simpleTestClass selectors includes: #m1)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/1/2008 18:01'!
testDirectoryEntryWasCorrectlyInitialized

	| nameOfProject expectedDir |
	nameOfProject := 'TestPro'.
	sut := SVNProject named: nameOfProject.
	expectedDir := SVNDirectory on: nameOfProject.
	self assert: sut directory = expectedDir.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 5/9/2008 16:15'!
testExtensionMethodsShouldbeAddedToClassWhenClassIsAdded

	| numberOfClassMethods |
	sut := SVNProject named: 'TestPro'.
	sut addSvnMethod: (SVNMethod forExistingMethod: self svnDummy >> #m1).
	self assert: sut versionedMethods size = 1.
	sut addClass: self svnDummy.
	numberOfClassMethods := self svnDummy selectors size + self svnDummy class selectors size.
	self assert: sut allVersionedMethods size = numberOfClassMethods.
	self assert: sut versionedMethods isEmpty.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 20:10'!
testMappingToFileSystem01

	self willTouchFileSystem.
	sut := SVNProject named: 'SVNProjectWhichIsSerialized'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: sut theName).
	sut store.
	self 
		assertExistanceOfProject: sut
		in: self pathForTests! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/25/2008 14:37'!
testMethodDeleted

	self
		willNeedSimpleTestClass: true;
		willNeedRegistry.
	self simpleTestClass compile: 'm1' classified: 'neu' withStamp: nil notifying: nil.
	
	sut := SVNProject named: 'test'.
	self svnRegistry addSvnProject: sut.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'test').
	
	sut addMethod: (self simpleTestClass compiledMethodAt: #m1).
	self assert: (sut versionedMethods size = 1).
	
	self simpleTestClass removeSelector: #m1.
	
	self assert: (sut versionedMethods size = 0).
	self deny: (self simpleTestClass selectors includes: #m1)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/1/2008 16:50'!
testProjectDirectoryShouldBeCorrectlyInitialized

	| nameOfProject expectedDir |
	nameOfProject := 'TestPro'.
	sut := SVNProject named: nameOfProject.
	expectedDir := SVNDirectory on: nameOfProject.
	self assert: sut directory = expectedDir.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 5/9/2008 14:50'!
testProjectIsParentOfAddedClass

	sut := SVNProject named: 'TestPro'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'TestPro').
	
	sut addClass: self svnDummy.
	self assert: sut versionedClasses someElement parent = sut! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 20:03'!
testRemoveClass

	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'test').
	
	sut addClass: self svnDummy.
	self assert: (sut versionedClasses size = 1).
	sut removeClass: self svnDummy.
	self deny: (sut versionedClasses size ~= 0).
	self assert: (Smalltalk hasClassNamed: self svnDummy name asString)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:52'!
testRemoveMethod

	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'test').

	sut addMethod: (self svnDummy compiledMethodAt: #m2).
	self assert: (sut versionedMethods size = 1).
	sut removeMethod: (self svnDummy compiledMethodAt: #m2).
	self deny: (sut versionedMethods size ~= 0).
	self assert: (self svnDummy compiledMethodAt: #m2) notNil.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:52'!
testRemoveSVNClass

	| svnClass |	
	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'test').
	svnClass := SVNClass forExistingClass: self svnDummy.
	sut addSVNClass: svnClass.
	self assert: (sut versionedClasses includes: svnClass).
	sut removeSVNClass: svnClass.
	self deny: (sut versionedClasses includes: svnClass).
	self assert: (Smalltalk hasClassNamed: self svnDummy name asString)! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 03:25'!
testRemoveSVNClassAlsoRemovesClassDirectoryWhenVersioned

	| svnClass |
	"(self selector: #testRemoveSVNClassAlsoRemovesClassDirectoryWhenVersioned) run"
	self willNeedRepositoryAndWorkingCopy.
	sut := self createSvnProjectWithSvnDummy.
	svnClass := sut versionedClasses anyOne. "There is only one"
	self defaultSVNDirectory addSubdirectory: sut directory.
	sut store.
	sut removeSVNClass: svnClass.
	self denyThatFiles: {svnClass theName} existsIn: sut directory path.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 19:53'!
testRemoveSVNMethod

	| svnMethod |	
	sut := SVNProject named: 'test'.
	sut directory: (self defaultSVNDirectory createSubDirectoryNamed: 'test').
	svnMethod := SVNMethod forExistingMethod: (self svnDummy compiledMethodAt: #m2).

	sut addMethod: (self svnDummy compiledMethodAt: #m2).
	self assert: (sut versionedMethods includes: svnMethod).
	sut removeSVNMethod: svnMethod.
	self deny: (sut versionedMethods includes: svnMethod).
	self deny: (sut versionedMethods size ~= 0).
	self assert: (self svnDummy compiledMethodAt: #m2) notNil.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rt 4/13/2008 20:02'!
testRestore

	| projectName class sut2 |
	self willNeedRepositoryAndWorkingCopy.
	class := self svnDummy.
	projectName := 'SomeSVNProject'.
	sut2 := SVNProject named: projectName.
	sut2 directory: (self defaultSVNDirectory createSubDirectoryNamed: projectName).
	sut2 addClass: class.
	sut2 store.
	
	sut := SVNProject restoreFrom: (sut2 directory).
	self assert: sut theName = projectName.
	self assert: (sut versionedClasses includes: (SVNClass forExistingClass: class)).! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 04:04'!
testRestoreOfNoLongerExistingClassesWillDeleteThem

	"(self selector: #testRestoreOfNoLongerExistingClassesWillDeleteThem) run"
	self
		willModifySVNDummy;
		willNeedRepositoryAndWorkingCopy.
	sut := self createSvnProjectWithSvnDummy.
	self assert: sut versionedClasses size = 1.
	sut store.
	"Delete the directory of SVNDummy"
	(FileDirectory on: sut versionedClasses anyOne directory path) deleteRecursivelyPlatformIndependent.
	sut restore.
	self assert: sut versionedClasses size = 0.
	sut store.
	self denyThatFiles: {self svnDummy name} existsIn: sut directory path.
	"sut load.
	self assert: self svnDummy isNil."! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 01:40'!
testShouldGetProjectDirectoryfromWorkingcopyDirectory

	| projectName expectedProjectDir workingCopyDir |
	projectName := 'SVNProject123'.
	workingCopyDir := self defaultSVNDirectory.
	sut := SVNProject named: projectName.
	sut directory: (workingCopyDir createSubDirectoryNamed: projectName).
	
	"workingCopyDir read."
	expectedProjectDir := (workingCopyDir getSubDirectoryNamed: projectName).
	self assert: sut directory = expectedProjectDir.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'cop 4/23/2008 13:09'!
testStatusProjectMethods

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNProject named: 'TestPro'.
	sut directory: self defaultSVNDirectory.
	sut store.
	sut directory store.
	sut commit.
	sut addMethod: self svnDummy >> #m1.
	sut store.
	sut directory store.
	self assert: sut statusProjectMethods = #modified.! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 4/28/2008 00:49'!
testUpdateProjectToPreviousRevision

	self willNeedRepositoryAndWorkingCopy.
	sut := self createEmptySvnProject.
	sut store; commit.
	sut addClass: self svnDummy.
	sut store; commit.
	self assertThatFiles: {self svnDummy name asString} existsIn: sut directory path.
	self assert: sut versionedClasses size = 1.
	sut updateToRevision: (SVNRevision number: 1).
	self denyThatFiles: {self svnDummy name asString} existsIn: sut directory path.
	self assert: sut versionedClasses size = 0.! !

!SVNProjectTest methodsFor: 'helper' stamp: 'rt 3/17/2008 12:50'!
willNeedSimpleTestClass
	
	^ needsTestClass! !

!SVNProjectTest methodsFor: 'helper' stamp: 'rt 3/17/2008 13:03'!
willNeedSimpleTestClass: bool

	needsTestClass := false.
	bool ifTrue:	[self simpleTestClass].! !

SVNTestCase subclass: #SVNPropertiesRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNPropertiesRequestTest methodsFor: 'running' stamp: 'rt 4/17/2008 18:51'!
setUp

	super setUp.
	
	sut := SVNPropertiesRequest new.! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rt 4/17/2008 19:03'!
testConverting

	| collection dict |
	collection := (sut forPrimitiveGetArrayOfSize: 2) asOrderedCollection.
	collection at: 1 put: ( ('key' , collection first) copyFrom: 1 to: 1024 ).
	collection at: 2 put: ( ('value' , collection second) copyFrom: 1 to: 1024 ).
	
	self deny: collection first = 'key'.
	self deny: collection second = 'value'.
	
	dict := sut dictionaryFromArray: collection asArray.
	self assert: dict keys size = 1.
	self assert: (dict at: 'key') = 'value'.! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rkrk 5/11/2008 02:22'!
testCountOfPropertiesOfNonVersionedTarget

	| arrayForCount revision |
	self willTouchFileSystem.
	arrayForCount := {nil}.
	revision := SVNRevision unspecified.
	sut
		basicSvnGetCountOfPropertiesOf: self pathForTests pathForSvn
		revisionKind: revision kind
		revisionNumber: revision number
		storeCountIn: arrayForCount.
	self assert: 0 = (arrayForCount first)! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rkrk 5/11/2008 02:24'!
testCountOfPropertiesOfNotExistingTarget

	| arrayForCount revision |
	arrayForCount := {nil}.
	revision := SVNRevision unspecified.
	sut
		basicSvnGetCountOfPropertiesOf: 'neverExistingPath'
		revisionKind: revision kind
		revisionNumber: revision number
		storeCountIn: arrayForCount.
	self assert: 0 = (arrayForCount first)! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rkrk 5/11/2008 02:27'!
testCountOfPropertiesOfTargetWithProperties

	| path client arrayForCount revision |
	self willNeedRepositoryAndWorkingCopy.
	path := self workingCopyPath.
	client := SVNCApiClient new.
	arrayForCount := {nil}.
	
	client svnAddProperty: 'key' WithValue: 'value' To: path.
	client svnAddProperty: 'key2' WithValue: '' To: path.
	
	revision := SVNRevision working.
	sut
		basicSvnGetCountOfPropertiesOf: path pathForSvn
		revisionKind: revision kind
		revisionNumber: revision number
		storeCountIn: arrayForCount.
	self assert: 2 = (arrayForCount first)! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rkrk 5/11/2008 02:24'!
testCountOfPropertiesOfTargetWithoutProperties

	| arrayForCount revision |
	arrayForCount := {nil}.
	self willNeedRepositoryAndWorkingCopy.
	revision := SVNRevision head.
	sut
		basicSvnGetCountOfPropertiesOf: self workingCopyPath pathForSvn
		revisionKind: revision kind
		revisionNumber: revision number
		storeCountIn: arrayForCount.
	self assert: 0 = (arrayForCount first)! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rkrk 5/10/2008 16:58'!
testPropertiesOfNonVersionedTarget

	self willTouchFileSystem.
	sut
		target: self defaultSVNDirectory;
		execute.
	self assert: sut properties isEmpty! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rkrk 5/10/2008 16:59'!
testPropertiesOfNotExistingTarget

	sut
		target: (SVNDirectory on: 'i/do/not/exist');
		execute.
	self assert: sut properties isEmpty! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rkrk 5/10/2008 17:02'!
testPropertiesOfTargetWithProperties

	| svnDir key1 value1 key2 value2 |
	self willNeedRepositoryAndWorkingCopy.
	svnDir := self defaultSVNDirectory.
	key1 := 'key'. value1 := 'value'.
	key2 := 'key2'. value2 := ''.
	svnDir properties at: key1 put: value1.
	svnDir properties at: key2 put: value2.
	svnDir store.

	sut
		target: svnDir;
		execute.

	self assert: sut properties keys size = 2.
	self assert: (sut properties at: key1) = value1.
	self assert: (sut properties at: key2) = value2.! !

!SVNPropertiesRequestTest methodsFor: 'tests' stamp: 'rkrk 5/10/2008 17:02'!
testPropertiesOfTargetWithoutProperties

	self willNeedRepositoryAndWorkingCopy.
	sut
		target: self defaultSVNDirectory;
		execute.
	self assert: sut properties isEmpty! !

SVNTestCase subclass: #SVNRegistryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Environment-Test'!

!SVNRegistryTest methodsFor: 'helper' stamp: 'rkrk 4/24/2008 11:57'!
compileMethodNamed: methodSelector	inCategory: aString andClass: aClass
	
	aClass
		compile: methodSelector asString
		classified: aString.! !

!SVNRegistryTest methodsFor: 'helper' stamp: 'rkrk 4/25/2008 09:24'!
createRegistryWithProjectAndSvnDummy
	
	| svnProject |
	svnProject := self createEmptySvnProject .
	svnProject addClass: self svnDummy.
	^ SVNRegistry new
		addSvnProject: svnProject;
		yourself.! !

!SVNRegistryTest methodsFor: 'helper' stamp: 'rkrk 4/24/2008 11:57'!
defaultMethodSelector

	^ #methodForNotifyTest! !

!SVNRegistryTest methodsFor: 'helper' stamp: 'rkrk 4/24/2008 11:57'!
newSourceForSVNDummyM2

	^ 'm2
	^ 1984 sqrt'! !

!SVNRegistryTest methodsFor: 'running' stamp: 'rkrk 4/24/2008 11:58'!
tearDown

	super tearDown.
	sut ifNotNil: [sut notifyAboutSystemChanges: false].
	(self svnDummy methodDict anySatisfy: [:ea | ea selector = self defaultMethodSelector])
		ifTrue: [self svnDummy removeSelector: self defaultMethodSelector].! !

!SVNRegistryTest methodsFor: 'tests' stamp: 'rkrk 4/24/2008 13:07'!
testEnvironmentCreation

	| svnProject1 svnProject2 environment |
	sut := SVNRegistry new.
	svnProject1 := SVNProject named: 'pro1'.
	svnProject2 := SVNProject named: 'pro2'.
	sut
		addSvnProject: svnProject1;
		addSvnProject: svnProject2.
	
	environment := sut createSvnEnvironment.
	self assert: environment svnProjects size = 2.
	self assert: (environment svnProjects includes: svnProject1).
	self assert: (environment svnProjects includes: svnProject2).! !

!SVNRegistryTest methodsFor: 'tests - notification' stamp: 'rt 5/8/2008 18:46'!
testNotifyClassCommentModification

	| project class |
	self
		willNeedRepositoryAndWorkingCopy;
		willNeedRegistry;
		willModifySVNDummy.
		
	project := SVNProject
		checkoutProject: 'test'
		fromRepository: (SVNRepository on: self repositoryURLPath)
		toWorkingCopy: (SVNDirectory on: self workingCopyPath).
	self svnRegistry addSvnProject: project.
	
	class := self svnDummy.
	class comment: 'first comment' asText.
	project addClass: class.
	project commit.
	
	self assert: project versionedClasses someElement status = #normal.
	
	class comment: 'second comment' asText.
	
	self assert: project versionedClasses someElement status = #modified! !

!SVNRegistryTest methodsFor: 'tests - notification' stamp: 'rkrk 4/25/2008 14:27'!
testNotifyMethodModification

	"prepare"
	| svnClass svnMethod numberOfMethodsInClass numberOfMethodsInClassInSvnClass svnProject |
	self
		willModifySVNDummy;
		willNeedRegistry.

	svnProject := SVNProject named: 'ProjForRegistryTest'.
	svnProject addClass: self svnDummy.
	sut := self svnRegistry.
	sut addSvnProject: svnProject.
	
	"exercise"
	self svnDummy compile: self newSourceForSVNDummyM2.

	"assertion"	
	svnMethod := sut findSvnMethodNamed: #m2.
	self assert: svnMethod source = self newSourceForSVNDummyM2.
	
	"Are all methods of the class verioned?"
	svnClass := sut findSvnProjectOrSvnClassForSvnMethod: svnMethod.
	numberOfMethodsInClass := svnClass theClass selectors size + svnClass theClass class selectors size.
	numberOfMethodsInClassInSvnClass := svnClass versionedMethods size.
	self assert: numberOfMethodsInClass = numberOfMethodsInClassInSvnClass.! !

!SVNRegistryTest methodsFor: 'tests - notification' stamp: 'rkrk 4/25/2008 14:33'!
testNotifyMethodProtocolModification

	"prepare"
	| svnMethod numberOfMethodsInClass svnClass numberOfMethodsInClassInSvnClass |
	self
		willModifySVNDummy;
		willNeedRegistry.

	self
		compileMethodNamed: self defaultMethodSelector
		inCategory: 'notifyTest'
		andClass: self svnDummy.
		
	sut := self  svnRegistry.
	sut addSvnProject: self createSvnProjectWithSvnDummy.
	
	self
		compileMethodNamed: self defaultMethodSelector
		inCategory: 'changedMethodCategory'
		andClass: self svnDummy.
		
	"exercise"
	svnMethod := sut findSvnMethodForMethod: (self svnDummy >> self defaultMethodSelector).
	self assert: svnMethod category = 'changedMethodCategory'.
	
	svnClass := sut findSvnClassFor: self svnDummy.
	numberOfMethodsInClass := svnClass theClass selectors size + svnClass theClass class selectors size.
	numberOfMethodsInClassInSvnClass := svnClass versionedMethods size.
	self assert: numberOfMethodsInClass = numberOfMethodsInClassInSvnClass.! !

!SVNRegistryTest methodsFor: 'tests - notification' stamp: 'rkrk 4/25/2008 14:34'!
testNotifyMethodRemoving

	| method svnClass numberOfMethodsInClass numberOfMethodsInClassInSvnClass |
	self
		willNeedRegistry;
		willModifySVNDummy.

	self
		compileMethodNamed: self defaultMethodSelector
		inCategory: 'notifyTest'
		andClass: self svnDummy.
		
	sut := self svnRegistry.
	sut addSvnProject: self createSvnProjectWithSvnDummy.
	
	method := self svnDummy >> self defaultMethodSelector.
	self assert: (sut includes: method).
	self svnDummy removeSelector: self defaultMethodSelector.
	self deny: (sut includes: method).
	
	svnClass := sut findSvnClassFor: self svnDummy.
	numberOfMethodsInClass := svnClass theClass selectors size + svnClass theClass class selectors size.
	numberOfMethodsInClassInSvnClass := svnClass versionedMethods size.
	self assert: numberOfMethodsInClass = numberOfMethodsInClassInSvnClass.! !

!SVNRegistryTest methodsFor: 'tests - notification' stamp: 'rkrk 4/25/2008 14:02'!
testRegistryCreatesEnvironmentWithItsProjects

	self willNeedRegistry.
	
	self assert: self svnRegistry svnProjects isEmpty.
	self svnEnvironment addSvnProject: (SVNProject named: 'ABC').
	self assert: self svnRegistry svnProjects size = 1.! !

SVNTestCase subclass: #SVNRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNRepositoryTest subclass: #SVNRepositoryExternalTest
	instanceVariableNames: 'username password url pathOfWorkingCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNRepositoryExternalTest methodsFor: 'as yet unclassified' stamp: 'rt 4/27/2008 02:49'!
setUp

	super setUp.
	self willNeedRepositoryAndWorkingCopyWithRestrictedAccess! !

!SVNRepositoryExternalTest methodsFor: 'running' stamp: 'rt 4/24/2008 17:29'!
tearDown

	(SVNAuthenticationRequest onUsername: '' andPassword: '') execute.
	^ super tearDown! !

!SVNRepositoryExternalTest methodsFor: 'tests' stamp: 'rt 4/27/2008 02:50'!
testTryToAccessProtectedRepositoryWithUnValidKey

	self setUsername: 'validUser'.
	self setPassword: 'validKey'.
	
	(SVNAuthenticationRequest onUsername: 'invaildUser' andPassword: 'invalidKey') execute.
	
	self deny: (SVNRepository new
		primitiveProject: 'aName'
		onRepository: self repositoryURLPath
		exists: {nil}) = 0.! !

!SVNRepositoryExternalTest methodsFor: 'tests' stamp: 'rt 4/27/2008 03:45'!
testTryToAccessProtectedRepositoryWithValidKey

	(SVNAuthenticationRequest
		onUsername: self getUsername
		andPassword: self getPassword) execute.
	
	sut := SVNRepository on: self repositoryURLPath.
	sut createProject: self nameOfTestProject.
	
	self assert: (sut projectExists: self nameOfTestProject).! !

!SVNRepositoryExternalTest methodsFor: 'tests' stamp: 'rt 4/27/2008 02:52'!
testWillNeedsAPassword

	sut := SVNRepository on: self repositoryURLPath.
	self assert: sut requiresAuthentication.! !

!SVNRepositoryTest methodsFor: 'helper' stamp: 'rt 4/21/2008 19:33'!
createTestProjectNamed: aString in: anURL

	(SVNRepository on: anURL) createProject: aString! !

!SVNRepositoryTest methodsFor: 'helper' stamp: 'rt 3/30/2008 19:43'!
nameOfTestProject
	^'TestProject'! !

!SVNRepositoryTest methodsFor: 'running' stamp: 'rkrk 5/5/2008 00:12'!
tearDown

	self flag: #TODO. "Ugly"
	(self directoryManager currentDirectory notNil and:
		[self directoryManager currentDirectory isSvnAware])
			ifTrue: [(SVNCApiClient new) svnUpdateTargetsToHeadRevision: {SVNDirectory on: self workingCopyPath}].
	
	^ super tearDown! !

!SVNRepositoryTest methodsFor: 'access tests' stamp: 'rt 4/24/2008 13:07'!
testAccessingUnprotectedRepository

	self willNeedRepositoryAndWorkingCopy.
	
	(SVNAuthenticationRequest onUsername: '' andPassword: '') execute.
	
	sut := SVNRepository on: self repositoryURLPath.
	sut createProject: self nameOfTestProject.
	self assert: (sut projectExists: self nameOfTestProject).! !

!SVNRepositoryTest methodsFor: 'creating tests' stamp: 'rt 3/30/2008 19:41'!
testCheckForExistingProject

	self willNeedRepositoryAndWorkingCopy.
	self createTestProjectNamed: self nameOfTestProject in: self repositoryURLPath.
	sut := SVNRepository on: self repositoryURLPath.
	self assert: (sut projectExists: self nameOfTestProject).! !

!SVNRepositoryTest methodsFor: 'creating tests' stamp: 'rt 4/9/2008 00:55'!
testCheckForNotExistingProject

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNRepository on: self repositoryURLPath.
	self deny: (sut projectExists: self nameOfTestProject).! !

!SVNRepositoryTest methodsFor: 'creating tests' stamp: 'rt 4/9/2008 00:57'!
testCreateExistingProject

	self willNeedRepositoryAndWorkingCopy.

	sut := SVNRepository on: self repositoryURLPath.
	sut createProject: self nameOfTestProject.
	sut createProject: self nameOfTestProject.
	
	self assert: (sut projectExists: self nameOfTestProject).! !

!SVNRepositoryTest methodsFor: 'creating tests' stamp: 'rt 4/9/2008 00:21'!
testCreateNotExistingProject

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNRepository on: self repositoryURLPath.
	sut createProject: self nameOfTestProject.
	
	self assert: (sut projectExists: self nameOfTestProject).! !

!SVNRepositoryTest methodsFor: 'creating tests' stamp: 'rt 4/24/2008 15:52'!
testCreateValidRepository

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNRepository on: self repositoryURLPath.
	self assert: sut notNil.! !

!SVNRepositoryTest methodsFor: 'creating tests' stamp: 'rt 4/9/2008 00:19'!
testDoNotCreateUnvalidRepository

	sut := SVNRepository on: 'noValidUrl'.
	self assert: sut isNil.! !

!SVNRepositoryTest methodsFor: 'access tests' stamp: 'rt 4/8/2008 13:14'!
testNoPasswordRequired

	self willNeedRepositoryAndWorkingCopy.
	sut := SVNRepository on: self repositoryURLPath.
	self assert: sut requiresAuthentication not.! !

SVNTestCase subclass: #SVNRevisionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:36'!
testBase

	sut := SVNRevision base.
	self assert: sut kindSymbol = #base.
	self assert: sut kind = 5.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 5/5/2008 00:13'!
testForSvnPrimitive01

	| expected result |
	sut := SVNRevision head.
	expected := {sut kind. 0} asOrderedCollection.
	result := sut forSvnPrimitive.
	self assert: expected = result.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:52'!
testForSvnPrimitive02

	| expected |
	sut := SVNRevision number: 30.
	expected := {sut kind. 30} asOrderedCollection.
	self assert: expected = sut forSvnPrimitive.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:37'!
testHead

	sut := SVNRevision head.
	self assert: sut kindSymbol = #head.
	self assert: sut kind = 7.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:01'!
testNoNew

	self should: [SVNRevision new] raise: Error.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:09'!
testNumber

	sut := SVNRevision number: 10.
	self shouldnt: [sut number] raise: AssertionFailure.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 5/5/2008 00:14'!
testNumberOnlyWhenCorrectlyInitialized

	sut := SVNRevision unspecified.
	self assert: sut number = 0.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:27'!
testSetsShouldBeEqual

	| set1 set2 |
	set1 := {SVNRevision head. SVNRevision number: 30. SVNRevision base} asSet.
	set2 := {SVNRevision head. SVNRevision number: 30. SVNRevision base} asSet.
	self assert: set1 = set2.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:34'!
testSetsShouldNotBeEqual01

	| set1 set2 |
	set1 := {SVNRevision head. SVNRevision number: 20. SVNRevision base} asSet.
	set2 := {SVNRevision head. SVNRevision number: 30. SVNRevision base} asSet.
	self deny: set1 = set2.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:34'!
testSetsShouldNotBeEqual02

	| set1 set2 |
	set1 := {SVNRevision working. SVNRevision number: 30. SVNRevision base} asSet.
	set2 := {SVNRevision head. SVNRevision number: 30. SVNRevision base} asSet.
	self deny: set1 = set2.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 5/5/2008 10:55'!
testShouldBeEqualIfNumberIsEqual

	| sut1 sut2 |
	sut1 := SVNRevision number: 10.
	sut2 := SVNRevision head.
	sut2 number: 10.
	self deny: sut1 = sut2..! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:24'!
testShouldBeEqualIfSameKind

	| sut1 sut2 |
	sut1 := SVNRevision head.
	sut2 := SVNRevision head.
	self assert: sut1 = sut2..
	
	sut1 := SVNRevision base.
	sut2 := SVNRevision base.
	self assert: sut1 = sut2..! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:23'!
testShouldNotBeEqualIfKindIsUnequal

	| sut1 sut2 |
	sut1 := SVNRevision working.
	sut2 := SVNRevision head.
	self deny: sut1 = sut2..! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/23/2008 01:23'!
testShouldNotBeEqualIfNumberIsUnequal

	| sut1 sut2 |
	sut1 := SVNRevision head.
	sut1 number: 8.
	sut2 := SVNRevision head.
	sut2 number: 10.
	self deny: sut1 = sut2..! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:37'!
testUnspecified

	sut := SVNRevision unspecified.
	self assert: sut kindSymbol = #unspecified.
	self assert: sut kind = 0.! !

!SVNRevisionTest methodsFor: 'tests' stamp: 'rkrk 3/24/2008 11:38'!
testWorking

	sut := SVNRevision working.
	self assert: sut kindSymbol = #working.
	self assert: sut kind = 6.! !

SVNTestCase subclass: #SVNStatusRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNStatusRequestTest methodsFor: 'helper' stamp: 'mu 4/21/2008 14:21'!
addTestFile: aFile to: aDirectory
	| file |
	file := self svnDirectoryForWorkingCopy
		createFileNamed: aFile.
	aDirectory addFile: file.
	! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'cop 4/21/2008 17:41'!
testHighestStatusOfItems

	| svnFile svnDir |
	"Setup"
	self willNeedRepositoryAndWorkingCopy.
	svnDir := SVNDirectory on: 
		(self
			createDirNamed: 'testDir'
			in: self workingCopyPath).
	self addTestFile: 'testFile' to: svnDir.
	svnDir
		store;
		commit.
	svnFile := self svnDirectoryForWorkingCopy
		createFileNamed: 'testFile2'.
	svnDir addFile: svnFile.
	svnDir
		store;
		commit.
	svnFile
		content: 'abc';
		store.
	"Execute"
	sut := SVNStatusRequest target: svnDir.
	sut execute.
	"Assertion"
	self assert: sut statusKind = #modified.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'cop 4/21/2008 17:33'!
testStatusOfAddedItem

	| svnFile |
	self willNeedRepositoryAndWorkingCopy.
	svnFile := self svnDirectoryForWorkingCopy
		createFileNamed: 'addedFile'.
	svnFile store.
	sut := SVNStatusRequest target: svnFile isRecursive: false.
	sut execute.
	self assert: sut statusKind = #added.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'mu 4/21/2008 14:25'!
testStatusOfAddedItemRecursive

	| svnDir |
	"Setup"
	self willNeedRepositoryAndWorkingCopy.
	svnDir := SVNDirectory on: 
		(self
			createDirNamed: 'testDir'
			in: self workingCopyPath).
	self addTestFile: 'testFile' to: svnDir.
	svnDir
		store;
		commit.
	self addTestFile: 'testFile2' to: svnDir.
	svnDir
		store.
	"Execute"
	sut := SVNStatusRequest target: svnDir.
	sut execute.
	"Assertion"
	self assert: sut statusKind = #added.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'cop 4/21/2008 17:33'!
testStatusOfCommitedItem

	| svnFile |
	self willNeedRepositoryAndWorkingCopy.
	svnFile := self svnDirectoryForWorkingCopy
		createFileNamed: 'addedFile'.
	svnFile
		store;
		commit.
	sut := SVNStatusRequest target: svnFile isRecursive: false.
	sut execute.
	self assert: sut statusKind = #normal.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'mu 4/21/2008 14:26'!
testStatusOfCommitedItemRecursive

	| svnDir |
	"Setup"
	self willNeedRepositoryAndWorkingCopy.
	svnDir := SVNDirectory on: 
		(self
			createDirNamed: 'testDir'
			in: self workingCopyPath).
	self addTestFile: 'testFile' to: svnDir.
	svnDir
		store;
		commit.
	"Execute"
	sut := SVNStatusRequest target: svnDir.
	sut execute.
	"Assertion"
	self assert: sut statusKind = #normal.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'cop 4/21/2008 17:33'!
testStatusOfItemNotInWorkingcopy

	| svnFile |
	self willTouchFileSystem.
	svnFile := SVNFile
		named: 'fileName123456789'
		basePath: self pathForTests.
	svnFile store.
	sut := SVNStatusRequest target: svnFile isRecursive: false.
	sut execute.
	self assert: sut statusKind = #unversioned.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'test 4/21/2008 13:07'!
testStatusOfItemNotInWorkingcopyRecursive

	| svnFile svnDir path|
	self willTouchFileSystem.
	path := self
		createDirNamed: 'testDir'
		in: self pathForTests.
	svnDir := SVNDirectory on: path.
	
	svnFile := SVNFile
		named: 'fileName123456789'
		basePath: self pathForTests.
	svnDir addFile: svnFile.
	svnDir store.
	sut := SVNStatusRequest target: svnDir.
	sut execute.
	self assert: sut statusKind = #unversioned.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'rkrk 5/10/2008 18:40'!
testStatusOfMethodAfterCommit

	"(self selector: #testStatusOfMethodAfterTwoCommits) run"
	| svnMethod |
	self willNeedRepositoryAndWorkingCopy.
	svnMethod := SVNMethod forExistingMethod: (self svnDummy >> #m2).
	self defaultSVNDirectory addFile: svnMethod file.
	svnMethod store.
	svnMethod file store.
	svnMethod commit.
	self assert: svnMethod status = #normal.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'rkrk 5/10/2008 18:43'!
testStatusOfMethodAfterCommitAndModification

	"(self selector: #testStatusOfMethodAfterTwoCommits) run"
	| svnMethod |
	self willNeedRepositoryAndWorkingCopy.
	svnMethod := SVNMethod forExistingMethod: (self svnDummy >> #m2).
	self defaultSVNDirectory addFile: svnMethod file.
	svnMethod store.
	svnMethod file store.
	svnMethod commit.
	self assert: svnMethod status = #normal.
	svnMethod source: 'm2 1234567 + 123434565678'.
	svnMethod store.
	svnMethod file store.
	self assert: svnMethod status = #modified.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'cop 4/21/2008 17:33'!
testStatusOfModifiedItem

	| svnFile |
	self willNeedRepositoryAndWorkingCopy.
	svnFile := self svnDirectoryForWorkingCopy
		createFileNamed: 'addedFile'.
	svnFile
		store;
		commit;
		content: 'abc';
		store.
	sut := SVNStatusRequest target: svnFile isRecursive: false.
	sut execute.
	self assert: sut statusKind = #modified.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'mu 4/21/2008 12:59'!
testStatusOfModifiedItemRecursive

	| svnFile svnDir path|
	self willNeedRepositoryAndWorkingCopy.
	path := self
		createDirNamed: 'testDir'
		in: self workingCopyPath.
	svnDir := SVNDirectory on: path.
	
	svnFile := self svnDirectoryForWorkingCopy
		createFileNamed: 'addedFile'.
	svnDir addFile: svnFile.
	svnDir
		store;
		commit.
	svnFile
		content: 'abc';
		store.
	sut := SVNStatusRequest target: svnFile.
	sut execute.
	self assert: sut statusKind = #modified.! !

!SVNStatusRequestTest methodsFor: 'tests' stamp: 'cop 4/21/2008 17:33'!
testStatusOfUnversionedItem

	| path svnDir |
	self willNeedRepositoryAndWorkingCopy.
	"Create a directory entry. Cannot use store here
	because store automatically adds the entry to thw WC."
	path := self
		createDirNamed: 'shouldNotBeAdded'
		in: self workingCopyPath.
	svnDir := SVNDirectory on: path.
	sut := SVNStatusRequest target: svnDir isRecursive: false.
	sut execute.
	self assert: sut statusKind = #unversioned.! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 3/15/2008 05:30'!
assertFile: fileName wasSVNAddedIn: path 

	| svnDir wcEntries wcEntriesContents |
	self flag: #Todo. "Kludge. Better to use Svn Api to check if file was added."
	svnDir := FileDirectory on: path , self slash , '.svn'.
	wcEntries := svnDir readOnlyFileNamed: 'entries'.
	wcEntriesContents := wcEntries contents.
	wcEntries close.
	self assert: (wcEntriesContents includesSubString: fileName)! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 2/21/2008 20:48'!
assertThatDirectories: dirNames existsIn: path

	dirNames do: [:each |
		self assert: ((FileDirectory on: path) directoryExists: each)] .! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 2/24/2008 23:48'!
assertThatFile: fileName inPath: pathName hasContent: expectedContent 

	| fullPath actualContent |
	fullPath := self pathTo: fileName inDir: pathName.
	self assert: (FileStream isAFileNamed: fullPath).
	actualContent := (FileStream readOnlyFileNamed: fullPath) contentsOfEntireFile.
	self assert: actualContent = expectedContent! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 4/3/2008 00:45'!
assertThatFiles: fileNames existsIn: path

	| dir |
	dir := FileDirectory on: path.
	self assert: (fileNames allSatisfy: [:ea |
		(dir fileExists: ea) or: [(dir directoryExists: ea)]]).! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 5/12/2008 17:28'!
assertThatProperties: propertyDict areAddedTo: svnDirectoryEntry

	| result |
	result := (SVNPropertiesRequest target: svnDirectoryEntry) execute; properties.
	
	self debugExpected: propertyDict result: result.
	self assert: propertyDict = result.! !

!SVNTestCase methodsFor: 'helper' stamp: 'mu 4/23/2008 13:53'!
classClass
	^ 'class'! !

!SVNTestCase methodsFor: 'helper' stamp: 'mu 4/23/2008 13:53'!
classInstance
	^ 'instance'! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 4/26/2008 16:44'!
cleanupSVNDummy

	self hasModifiedSVNDummy ifFalse: [^ self].
	self flag: #TODO. "Full restore?"
	self svnDummy ifNotNil: [self svnDummy removeFromSystemUnlogged].
	self restoreSVNDummy.
	"((self svnDummy methodDict includesKey: #m2)
		and: [(self svnDummy >> #m2) getSource asString = self sourceCodeForSVNDummyM2])
			ifFalse: [self svnDummy compile: self sourceCodeForSVNDummyM2]."! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 3/15/2008 01:54'!
createDirNamed: newDirName in: existingDir 
	
	(FileDirectory on: existingDir) assureExistenceOfPath: newDirName.
	^ existingDir , FileDirectory slash , newDirName.! !

!SVNTestCase methodsFor: 'running' stamp: 'mu 4/23/2008 13:31'!
createDummyClassForTests
	^ SVNClass forExistingClass: self svnDummy! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 4/25/2008 14:31'!
createEmptySvnProject

	| proj |
	proj := SVNProject named: 'ProjectForSVNTest'.
	self defaultSVNDirectory addSubdirectory: proj directory.
	^ proj! !

!SVNTestCase methodsFor: 'svn environment' stamp: 'rkrk 5/4/2008 19:54'!
createEnvironmentWithCurrentProjectAndSvnDummy

	| env |
	env := self createEnvironmentWithEmptyProject.
	self assert: env svnProjects size = 1.
	env svnProjects anyOne addClass: self svnDummy.
	^ env! !

!SVNTestCase methodsFor: 'svn environment' stamp: 'rkrk 5/4/2008 19:55'!
createEnvironmentWithEmptyProject
	
	| svnProject environment |
	svnProject := self createEmptySvnProject.
	environment :=  self createSvnEnvironment.
	self deny: (environment svnProjects includes: svnProject).
	^ environment
		addSvnProject: svnProject;
		currentProject: svnProject;
		yourself.! !

!SVNTestCase methodsFor: 'svn environment' stamp: 'rkrk 5/4/2008 19:55'!
createSvnEnvironment

	^ self svnRegistry
		ifNil: [SVNEnvironment forSvnProjects: Set new]
		ifNotNil: [self svnRegistry createSvnEnvironment.].! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 4/25/2008 14:31'!
createSvnProjectWithSvnDummy

	^ self createEmptySvnProject
		addClass: self svnDummy;
		yourself.! !

!SVNTestCase methodsFor: 'debugging' stamp: 'rkrk 3/20/2008 03:42'!
debugExpected: expected result: result

	expected = result ifTrue: [^ self].
	Transcript
		show: 'expected: ';
		show: expected asString;
		cr;
		show: 'result';
		show: result asString;
		cr.
	self halt.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 02:30'!
defaultSVNDirectory
	
	^ SVNDirectory on: self pathForTests! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 4/3/2008 00:46'!
denyThatFiles: fileNames existsIn: path

	| dir |
	dir := FileDirectory on: path.
	self assert: (fileNames noneSatisfy: [:ea |
		(dir fileExists: ea) or: [(dir directoryExists: ea)]]).! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 01:53'!
directoryManager
	^ directoryManager! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 01:53'!
directoryManager: anObject
	directoryManager := anObject! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 03:27'!
getPassword

	^ self directoryManager getPassword! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 03:27'!
getUsername

	^ self directoryManager getUsername! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 02:31'!
hasModifiedSVNDummy
	^ hasModifiedSVNDummy! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 02:31'!
hasModifiedSVNDummy: anObject
	hasModifiedSVNDummy := anObject! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 3/15/2008 02:53'!
inFile: pathToFile write: aString

	(FileStream forceNewFileNamed: pathToFile)
		nextPutAll: aString;
		close.! !

!SVNTestCase methodsFor: 'initialization' stamp: 'rkrk 3/15/2008 04:21'!
initialize

	super initialize.
	self slash: FileDirectory slash.! !

!SVNTestCase methodsFor: 'logging' stamp: 'rt 4/15/2008 19:46'!
logCurrentTest

	SqueakSVNPluginCaller primWriteOutText: '### ' , testSelector asString , ' ###'.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 5/5/2008 11:25'!
makeRepositoryUnavailable

	 self directoryManager makeRepositoryUnavailable! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'rkrk 4/23/2008 17:14'!
methodRefOfSvnDummyM2

	^ (self svnDummy >> #m2) methodReference.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 01:53'!
pathForTests

	^ self directoryManager pathForTests.! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/24/2008 23:45'!
pathTo: filename inDir: pathToDirectory

	^ pathToDirectory , self slash , filename! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 01:54'!
repositoryURLPath

	^ self directoryManager repositoryURLPath! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'rkrk 4/26/2008 16:46'!
restoreSVNDummy

	"Read a file out of SVNDummy. If you change the class, replace this fileout. You can use
	e.g. printIt: [FileStream readOnlyFileNamed: 'SVNDummy.st' do: [:stream | stream contents]]
	after doing a fileout"
	"do it: [self new restoreSVNDummy]."
	| stream |
	stream :=  ReadWriteStream with:  '''From Squeak3.9.1 of 2 March 2008 [latest update: #7075] on 14 April 2008 at 10:36:05 pm''!!
Object subclass: #SVNDummy
	instanceVariableNames: ''i1 i2''
	classVariableNames: ''C1 C2''
	poolDictionaries: ''''
	category: ''SqueakSVN-Base-Test''!!
!!SVNDummy commentStamp: ''<historical>'' prior: 0!!
A SVNDummy is xxxxxxxxx.

Instance Variables
	i1:		<Object>
	i2:		<Object>

i1
	- xxxxx

i2
	- xxxxx
!!


!!SVNDummy methodsFor: ''dummy methods'' stamp: ''rkrk 3/14/2008 02:25''!!
< other

	^ super < other!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''test 2/23/2008 11:54''!!
m1
	^ 1!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''rkrk 4/14/2008 22:22''!!
m2
	^ 2!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''cop 2/7/2008 19:50''!!
methodWithSpecialCharacter: aString
	^ aString!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''rkrk 4/14/2008 22:35''!!
onInstanceAndClassSide

	"Methods with this name are on instance and on class side of SVNDummy."!! !!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!

SVNDummy class
	instanceVariableNames: ''IC1 IC2''!!

!!SVNDummy class methodsFor: ''dummy'' stamp: ''cop 2/7/2008 19:50''!!
m3

	^ 3!! !!

!!SVNDummy class methodsFor: ''dummy'' stamp: ''rkrk 4/14/2008 22:35''!!
onInstanceAndClassSide!! !!


!!SVNDummy class methodsFor: ''convenience'' stamp: ''cop 2/7/2008 19:50''!!
sourceCodeForM2
	^ ''m2
	^ 2''!! !!
'.
	self flag: #TODO.
	stream
		reset;
		fileInAnnouncing: 'Restoring SVNDummy';
		close.! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'rt 5/12/2008 19:04'!
selectorForMethodWhichIsNotInSvnDummy

	^ #methodWhichIsNotInSvnDummy! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 02:40'!
setPassword: aString

	self directoryManager setPassword: aString! !

!SVNTestCase methodsFor: 'running' stamp: 'rt 4/27/2008 03:59'!
setUp

	"[SVNTestDirectoryManager instance: nil]"
	super setUp.
	self hasModifiedSVNDummy: false.
	self directoryManager: SVNTestDirectoryManager getInstance.
	self directoryManager testDirectories ifEmpty: [
		self directoryManager
			basePath: (FileDirectory default directoryNamed: 'svnTests') pathName;
			createBasicTestDirs: 200 svnAwareTestDirs: 50].
	SqueakSVNPluginCaller primWriteOutText: self selector asString.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 02:40'!
setUsername: aString

	self directoryManager setUsername: aString! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 3/15/2008 04:22'!
slash

	^ slash! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:23'!
slash: string

	slash := string! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'rkrk 3/4/2008 03:01'!
sourceCodeForSVNDummyM2

	^ 'm2
	^ 2'! !

!SVNTestCase methodsFor: 'running' stamp: 'rt 4/27/2008 02:35'!
stopAccessToRepository

	(self directoryManager currentDirectory isKindOf: SVNRestrictedTestDirectory)
		ifTrue: [self directoryManager stopAccessToRepository]! !

!SVNTestCase methodsFor: 'svn helper' stamp: 'rkrk 3/4/2008 00:58'!
svnClientDo: aBlock

	aBlock value: SVNCApiClient new.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 4/3/2008 01:58'!
svnDirectoryForWorkingCopy
	
	"equals defaultSVNDirectory when registered for svnAware testDirs"
	^ SVNDirectory on: self workingCopyPath.! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 4/3/2008 01:58'!
svnDirectoryForWorkingCopy2
	
	"equals defaultSVNDirectory when registered for svnAware testDirs"
	^ SVNDirectory on: self workingCopyPath2.! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'rkrk 3/4/2008 03:07'!
svnDummy

	"For not retrieving an obsolete class"
	^ Smalltalk classNamed: 'SVNDummy'.! !

!SVNTestCase methodsFor: 'svn environment' stamp: 'rkrk 5/4/2008 19:41'!
svnEnvironment

	self flag: #TODO. "Unify this method and createEmptyEnvironment!!!!!!"
	^ self svnRegistry createSvnEnvironment.! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 4/25/2008 13:58'!
svnRegistry
	^ svnRegistry! !

!SVNTestCase methodsFor: 'accessing' stamp: 'rkrk 4/25/2008 13:58'!
svnRegistry: anObject
	svnRegistry := anObject! !

!SVNTestCase methodsFor: 'running' stamp: 'rt 4/27/2008 02:35'!
tearDown

	super tearDown.
	self
		"cleanupFileSystem;"
		cleanupSVNDummy;
		"stop external process"
		stopAccessToRepository.
	self directoryManager unregister.
	
	"Quick fix until old system notfication mechanism is fully abandoned"
	self svnRegistry ifNotNil: [
		SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self svnRegistry.
		self svnRegistry: nil].
	
	SVNRegistry allInstances do: [:ea | ea notifyAboutSystemChanges: false].! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 5/4/2008 19:42'!
willModifySVNDummy

	"SVNDummy will be restored after the test"
	self hasModifiedSVNDummy: true.! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 5/4/2008 19:41'!
willNeedRegistry

	"Every environment created after this call will belong to the registry"
	self svnRegistry: (SVNRegistry forSvnProjects: Set new).! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 4/3/2008 01:51'!
willNeedRepositoryAndTwoWorkingCopies

	self directoryManager registerForSvnAwareTestDirectoryWithTwoWorkingCopies.! !

!SVNTestCase methodsFor: 'running' stamp: 'rt 4/27/2008 02:45'!
willNeedRepositoryAndTwoWorkingCopiesWithRestrictedAccess

	self directoryManager registerForSvnRestrictedTestDirectoryWithTwoWorkingCopies.! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 3/15/2008 01:56'!
willNeedRepositoryAndWorkingCopy

	self directoryManager registerForSvnAwareTestDirectory.! !

!SVNTestCase methodsFor: 'running' stamp: 'rt 4/27/2008 02:44'!
willNeedRepositoryAndWorkingCopyWithRestrictedAccess

	self directoryManager registerForSvnRestrictedTestDirectory.! !

!SVNTestCase methodsFor: 'running' stamp: 'test 3/16/2008 03:02'!
willTouchFileSystem
	
	self flag: #TODO.
	self directoryManager registerForTestDirectory.
	"do nothing? directoryManager already has a new
	current directory because of #unregister"
	"self directoryManager registerForTestDirectory."! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'test 3/15/2008 04:34'!
workingCopyPath

	^ self directoryManager workingCopyPath! !

!SVNTestCase methodsFor: 'derived accessing' stamp: 'rkrk 4/3/2008 03:13'!
workingCopyPath2

	^ self directoryManager workingCopyPath2! !

SVNTestCase subclass: #SVNUpdateRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

SVNUpdateRequestTest subclass: #SVNConflictUpdateRequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests-Test'!

!SVNConflictUpdateRequestTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 03:35'!
testDoSimpleUpdate

	| content file |
	self willNeedRepositoryAndWorkingCopy.
	content := 'ABCabcXYZxyz'.
	file := SVNFile
		named: 'fileForUpdate'
		basePath: self pathForTests
		content: content.
	file
		store;
		commit;
		update;
		read.
	self assert: file content = content.
	! !

!SVNConflictUpdateRequestTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 00:47'!
testDoSimpleUpdateOfDeletedFile

	| content file |
	self willNeedRepositoryAndWorkingCopy.
	content := 'ABCabcXYZxyz'.
	file := SVNFile
		named: 'fileForUpdate'
		basePath: self pathForTests
		content: content.
	file
		store;
		commit;
		delete.
	self
		denyThatFiles: {file path}
		existsIn: file basePath.
	self defaultSVNDirectory update.
	self
		assertThatFiles: {file path}
		existsIn: file basePath.
	file read.
	self assert: file content = content.
	! !

!SVNConflictUpdateRequestTest methodsFor: 'tests' stamp: 'cop 4/28/2008 13:00'!
testDoUpdateWithTwoWCsAndLocalChanges

	| originalContent fileName fileInFirstWC fileInSecondWC changedContent changedContent2 |
	self willNeedRepositoryAndTwoWorkingCopies.
	originalContent := 'ABCabcXYZxyz'.
	fileName := 'fileForUpdate'.
	"Create file in first directory and commit"
	fileInFirstWC := SVNFile
		named: fileName
		basePath: self workingCopyPath
		content: originalContent.
	fileInFirstWC
		store;
		commit.
	"Access file in second WC, change and commit"
	self svnDirectoryForWorkingCopy2 update.
	fileInSecondWC := SVNFile
		named: fileName
		basePath: self workingCopyPath2.
	fileInSecondWC read.
	self assert: fileInSecondWC content = originalContent.
	changedContent := '1234ABC12343749rzcnoqixuh'.
	fileInSecondWC
		content: changedContent;
		store;
		commit.
	"Change first file and update"
	changedContent2 := 'sjk gnalkj bskjjbcsklj nv'.
	fileInFirstWC
		content: changedContent2;
		store;
		update;
		read.
	self assert: fileInFirstWC status isConflicted.
	"self assert: fileInFirstWC content = changedContent2."! !

!SVNConflictUpdateRequestTest methodsFor: 'tests' stamp: 'cop 4/28/2008 13:03'!
testDoUpdateWithTwoWCsAndWithoutLocalChanges

	| originalContent fileName fileInFirstWC fileInSecondWC changedContent |
	self willNeedRepositoryAndTwoWorkingCopies.
	originalContent := 'ABCabcXYZxyz'.
	fileName := 'fileForUpdate'.
	"Create file in first directory and commit"
	fileInFirstWC := SVNFile
		named: fileName
		basePath: self workingCopyPath
		content: originalContent.
	fileInFirstWC
		store;
		commit.
	"Access file in second WC, change and commit"
	self svnDirectoryForWorkingCopy2 update.
	fileInSecondWC := SVNFile
		named: fileName
		basePath: self workingCopyPath2.
	fileInSecondWC read.
	self assert: fileInSecondWC content = originalContent.
	changedContent := '1234ABC12343749rzcnoqixuh'.
	fileInSecondWC
		content: changedContent;
		store;
		commit.
	"check if anything is fine"
	fileInFirstWC
		update;
		read.
	self assert: fileInFirstWC content = changedContent.
	self assert: fileInFirstWC status isNormal.! !

!SVNConflictUpdateRequestTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 03:33'!
testLocalChangesShouldStayAfterUpdate

	| file originalContent newContent |
	self willNeedRepositoryAndWorkingCopy.
	originalContent := 'ABCabcXYZxyz'.
	newContent := 'Changed content'.
	file := SVNFile
		named: 'fileForUpdate'
		basePath: self workingCopyPath.
	file
		content: originalContent;
		store;
		commit;
		content: newContent;
		store;
		update;
		read.
	self assert: file content = newContent.! !

!SVNUpdateRequestTest methodsFor: 'assertion' stamp: 'rkrk 4/27/2008 16:26'!
assertSvnDirEntry: svnDirectoryEntry hasRevision: aNumber

	| svnInfo |
	svnInfo := (SVNInfoRequest
		target: svnDirectoryEntry
		forRevision: SVNRevision working).
	svnInfo execute.
	self assert: svnInfo revision number = aNumber.! !

!SVNUpdateRequestTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 22:44'!
testUpdateBeNotRecursive

	| svnDirectory svnSubDir |
	self willNeedRepositoryAndWorkingCopy.
	"Create a directory and a subDirectory. Commit so that both have revision 2.
	Update the directory to revision 1. The subdirectory should still have revision 2"
	svnDirectory := self defaultSVNDirectory createSubDirectoryNamed: 'dirCreatedInUpdateRequestTest'.
	svnSubDir := svnDirectory createSubDirectoryNamed: 'subDirCreatedInUpdateRequestTest'.
	svnDirectory
		store;
		commit.
	"Change things so that commit works"
	svnDirectory properties at: 'bla' put: 'blupf'.
	svnSubDir properties at: 'bla2' put: 'blupf2'.
	svnDirectory
		store;
		commit;
		read.
	self assertSvnDirEntry: svnDirectory hasRevision: 2.
	self assertSvnDirEntry: svnSubDir hasRevision: 2.
	sut := SVNUpdateRequest
		target: {svnDirectory}
		updateToRevision: (SVNRevision number: 1)
		beRecursive: false.
	sut execute.
	self assertSvnDirEntry: svnDirectory hasRevision: 1.
	self assertSvnDirEntry: svnSubDir hasRevision: 2.! !

!SVNUpdateRequestTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 22:44'!
testUpdateBeRecursive

	| svnDirectory svnSubDir |
	self willNeedRepositoryAndWorkingCopy.
	"Create a directory and a subDirectory. Commit so that both have revision 2.
	Update the directory to revision 1. The subdirectory should now also have revision 1"
	svnDirectory := self defaultSVNDirectory createSubDirectoryNamed: 'dirCreatedInUpdateRequestTest'.
	svnSubDir := svnDirectory createSubDirectoryNamed: 'subDirCreatedInUpdateRequestTest'.
	svnDirectory
		store;
		commit.
	"Change things so that commit works"
	svnDirectory properties at: 'bla' put: 'blupf'.
	svnSubDir properties at: 'bla2' put: 'blupf2'.
	svnDirectory
		store;
		commit;
		read.
	self assertSvnDirEntry: svnDirectory hasRevision: 2.
	self assertSvnDirEntry: svnSubDir hasRevision: 2.
	sut := SVNUpdateRequest
		target: {svnDirectory}
		updateToRevision: (SVNRevision number: 1)
		beRecursive: true.
	sut execute.
	self assertSvnDirEntry: svnDirectory hasRevision: 1.
	self assertSvnDirEntry: svnSubDir hasRevision: 1.! !

!SVNUpdateRequestTest methodsFor: 'tests' stamp: 'rkrk 5/4/2008 22:44'!
testUpdateFileOfRevision2ToRevision1

	| svnFile |
	self willNeedRepositoryAndWorkingCopy.
	svnFile := self defaultSVNDirectory
		createFileNamed: 'fileCreatedInUpdateRequestTest'
		withContent: 'rev1'.
	svnFile
		store;
		commit;
		content: 'rev2';
		store;
		commit;
		read.
	self assert: svnFile content = 'rev2'.
	sut := SVNUpdateRequest
		target: {svnFile}
		updateToRevision: (SVNRevision number: 1)
		beRecursive: false.
	sut execute.
	svnFile read.
	self assertSvnDirEntry: svnFile hasRevision: 1.
	self assert: svnFile content = 'rev1'.! !

TestCase subclass: #SVNTestDirectoryManagerTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase-Test'!

!SVNTestDirectoryManagerTest methodsFor: 'default' stamp: 'rkrk 3/15/2008 00:27'!
pathForManager

	^ (FileDirectory default directoryNamed: 'TestManagerTestDir') pathName! !

!SVNTestDirectoryManagerTest methodsFor: 'running' stamp: 'rkrk 3/16/2008 01:33'!
setUp
	super setUp.
	"SVNTestDirectoryManager is a singleton. For tests get own copy"
	sut := SVNTestDirectoryManager basicNew initialize.
	sut basePath: self pathForManager.! !

!SVNTestDirectoryManagerTest methodsFor: 'running' stamp: 'rkrk 3/16/2008 01:34'!
tearDown
	
	super tearDown.
	sut clear.
	(FileDirectory on: self pathForManager) deleteRecursivelyPlatformIndependent.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 01:42'!
testAccessingWorkingCopy2WithoutRegisteringShouldFail

	sut
		createBasicTestDirs: 0
		svnAwareTestDirs: 1.
	sut registerForSvnAwareTestDirectory.
	self should: [sut workingCopyPath2] raise: AssertionFailure.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 01:58'!
testAfterRegisterAnswerSameDirectory

	| directory |
	sut
		createBasicTestDirs: 5
		svnAwareTestDirs: 0.
	sut registerForTestDirectory.
	directory := sut currentDirectory.
	self assert: directory notNil.
	self assert: sut pathForTests = directory pathForTests.
	self assert: sut currentDirectory == directory.
	sut unregister.
	self deny: sut currentDirectory == directory.
	"self should: [sut pathForTests] raise: AssertionFailure"! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 01:59'!
testCallingSvnAwareMethods

	sut
		createBasicTestDirs: 0
		svnAwareTestDirs: 3.
	sut registerForSvnAwareTestDirectory.
	self assert: sut workingCopyPath = sut currentDirectory workingCopyPath.
	self assert: sut repositoryURLPath = sut currentDirectory repositoryURLPath.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 01:43'!
testCallingSvnAwareMethodsWithWorkingCopy2

	sut
		createBasicTestDirs: 0
		svnAwareTestDirs: 1.
	sut registerForSvnAwareTestDirectoryWithTwoWorkingCopies.
	self assert: sut workingCopyPath = sut currentDirectory workingCopyPath.
	self assert: sut workingCopyPath2 = sut currentDirectory workingCopyPath2.
	self assert: sut repositoryURLPath = sut currentDirectory repositoryURLPath.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 02:01'!
testCallingSvnAwareMethodsWithoutProperRegisteringShouldFail

	sut
		createBasicTestDirs: 2
		svnAwareTestDirs: 1.
	sut registerForTestDirectory.
	self should: [sut workingCopyPath] raise: AssertionFailure.
	self should: [sut repositoryURLPath] raise: AssertionFailure.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 06:28'!
testCreateAgainShouldUseAlreadyExistingDirectories

	| someElement |
	sut 
		createBasicTestDirs: 3
		svnAwareTestDirs: 0.
	someElement := sut testDirectories anyOne.
	sut 
		createBasicTestDirs: 5
		svnAwareTestDirs: 0.
	self assert: sut basicTestDirectories size = 5.
	self assert: (sut testDirectories includes: someElement).! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/18/2008 23:49'!
testPercent

	self assert: (sut percent: 30 of: 80) = 24.
	self assert: (sut percent: 10 of: 3) = 1. "Be at least one"! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 02:32'!
testRecreate10Percent

	sut 
		createBasicTestDirs: 10
		svnAwareTestDirs: 0.
	5 timesRepeat: [
		sut registerForTestDirectory.
		sut currentDirectory isDirty: true.
		sut unregister].
	sut reCreatePercent: 10.
	self assert: (sut testDirectories count: [:ea | ea isDirty not]) = 6.! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 02:02'!
testRegisteringMoreOftenThanTheDefaultNumberOfPreparedDirectories

	| numberOfTimesToRegister |
	sut createBasicTestDirs: 5 svnAwareTestDirs: 0.
	numberOfTimesToRegister := sut basicTestDirectories size + 3.
	numberOfTimesToRegister timesRepeat: [
		sut registerForTestDirectory.
		self deny: sut currentDirectory isDirty.
		sut currentDirectory isDirty: true.
		sut unregister].! !

!SVNTestDirectoryManagerTest methodsFor: 'tests' stamp: 'test 3/16/2008 06:16'!
testShouldClearOldDirectories

	| sutFileDirectory |
	sut 
		createBasicTestDirs: 20
		svnAwareTestDirs: 0.
	sutFileDirectory := FileDirectory on: sut basePath.
	self assert: sutFileDirectory entries size = 20.
	sut 
		createBasicTestDirs: 12
		svnAwareTestDirs: 0.
	self assert: sutFileDirectory entries size = 12.! !

TestCase subclass: #SVNTestDirectoryTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase-Test'!

SVNTestDirectoryTest subclass: #SVNAwareTestDirectoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase-Test'!

!SVNAwareTestDirectoryTest methodsFor: 'running' stamp: 'rkrk 3/14/2008 20:52'!
setUp
	super setUp.
	sut := SVNAwareTestDirectory
		theName: 'TestDir01'
		basePath: self somePath.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 17:24'!
testCheckConsistency01

	sut create.
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut isDirty: false.
	sut checkConsistency.	
	self assert: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 17:25'!
testCheckConsistency02

	sut checkConsistency.
	self assert: sut isDirty.
	sut create.
	sut checkConsistency.
	self deny: sut isDirty.
	sut isDirty: true.
	sut checkConsistency.
	self deny: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 01:28'!
testCheckConsistency03

	sut 
		create;
		createSecondWorkingCopy.
	sut isDirty: false.
	sut checkConsistency.	
	self assert: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:11'!
testClear

	sut create.
	self deny: sut isDirty.
	(sut workingCopyDirectory newFileNamed: 'file') close.
	sut clear.
	self deny: sut isDirty.
	self deny: sut repositoryDirectory exists.
	self deny: sut workingCopyDirectory exists.
	self deny: sut directory exists.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 01:22'!
testCreateDoesNotCreateAutomaticallySecondWorkingCopy

	| directory |
	sut create.
	directory := sut directory.
	self deny: (directory directoryExists: 'workingCopy2').! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:48'!
testCreateInBasepath

	| directory |
	sut create.
	directory := sut directory.
	self assert: directory exists.
	self assert: (directory directoryExists: 'repository').
	self assert: (directory directoryExists: 'workingCopy').
	self assert: (sut workingCopyDirectory directoryExists: '.svn').! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 4/3/2008 01:34'!
testCreateWorkingCopy2AndBeDirty

	sut
		create;
		createSecondWorkingCopy.
	self assert: (sut directory directoryExists: 'workingCopy2').
	self assert: (sut workingCopyDirectory2 directoryExists: '.svn').
	self assert: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 5/5/2008 11:22'!
testMakeRepositoryUnavailable

	"(self selector: #testMakeRepositoryUnavailable) run"
	sut create.
	self assert: sut repositoryDirectory exists.
	sut makeRepositoryUnavailable.
	self deny: sut repositoryDirectory exists.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:56'!
testPathForTestIsWorkingCopyPath

	self assert: sut pathForTests = sut workingCopyPath.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 22:07'!
testReCreate

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut reCreate.
	self deny: sut isDirty.! !

!SVNAwareTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:55'!
testShouldBeDirtyWhenAccessed

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	self assert: sut isDirty.! !

SVNAwareTestDirectoryTest subclass: #SVNRestrictedTestDirectoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase-Test'!

!SVNRestrictedTestDirectoryTest methodsFor: 'running' stamp: 'rt 4/26/2008 21:12'!
setUp
	super setUp.
	sut := SVNRestrictedTestDirectory
		theName: 'TestDir01'
		basePath: self somePath.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'running' stamp: 'rt 4/26/2008 21:47'!
tearDown

	sut clear.
	super tearDown! !

!SVNRestrictedTestDirectoryTest methodsFor: 'tests of new behavior' stamp: 'rt 4/26/2008 23:38'!
testChangedUsernameAndPassword

	| directory file newUsername newPassword |
	directory := FileDirectory on: sut repositoryDirectory pathName , FileDirectory slash , 'conf'.
	newUsername := 'usr'.
	newPassword := 'key'.
	
	sut create.
	self deny: sut usernameForRepository = newUsername.
	self deny: sut passwordForRepository = newPassword.
	
	file := CrLfFileStream fileNamed: directory pathName , FileDirectory slash , 'passwd'.
	self assert: file contents = sut contentOfPasswdFile.
	self deny: (file contents substrings includesAnyOf: {newUsername. newPassword}).
	file close.
	
	sut setUsername: newUsername.	
	sut setPassword: newPassword.
	
	file := CrLfFileStream fileNamed: directory pathName , FileDirectory slash , 'passwd'.
	self assert: file contents = sut contentOfPasswdFile.
	self assert: (file contents substrings includesAllOf: {newUsername. newPassword}).
	file close.
! !

!SVNRestrictedTestDirectoryTest methodsFor: 'duplicated tests' stamp: 'rt 4/26/2008 21:12'!
testCheckConsistency01

	sut create.
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut isDirty: false.
	sut checkConsistency.	
	self assert: sut isDirty.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'duplicated tests' stamp: 'rt 4/26/2008 21:13'!
testCheckConsistency02

	sut checkConsistency.
	self assert: sut isDirty.
	sut create.
	sut checkConsistency.
	self deny: sut isDirty.
	sut isDirty: true.
	sut checkConsistency.
	self deny: sut isDirty.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'duplicated tests' stamp: 'rt 4/26/2008 21:13'!
testCheckConsistency03

	sut 
		create;
		createSecondWorkingCopy.
	sut isDirty: false.
	sut checkConsistency.	
	self assert: sut isDirty.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'duplicated tests' stamp: 'rt 4/26/2008 21:13'!
testClear

	sut create.
	self deny: sut isDirty.
	(sut workingCopyDirectory newFileNamed: 'file') close.
	sut clear.
	self deny: sut isDirty.
	self deny: sut repositoryDirectory exists.
	self deny: sut workingCopyDirectory exists.
	self deny: sut directory exists.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'duplicated tests' stamp: 'rt 4/26/2008 21:13'!
testCreateDoesNotCreateAutomaticallySecondWorkingCopy

	| directory |
	sut create.
	directory := sut directory.
	self deny: (directory directoryExists: 'workingCopy2').! !

!SVNRestrictedTestDirectoryTest methodsFor: 'tests of changed behavior' stamp: 'rt 4/26/2008 21:19'!
testCreateInBasepath

	| directory |
	sut create.
	directory := sut directory.
	self assert: directory exists.
	self assert: (directory directoryExists: 'repository').
	self assert: (directory directoryExists: 'workingCopy').
	self deny: (sut workingCopyDirectory directoryExists: '.svn').! !

!SVNRestrictedTestDirectoryTest methodsFor: 'tests of new behavior' stamp: 'rt 4/26/2008 22:01'!
testCreateInBasepathAndCheckout

	| directory |
	sut
		create;
		checkoutWorkingCopy.
	directory := sut directory.
	self assert: directory exists.
	self assert: (directory directoryExists: 'repository').
	self assert: (directory directoryExists: 'workingCopy').
	self assert: (sut workingCopyDirectory directoryExists: '.svn').! !

!SVNRestrictedTestDirectoryTest methodsFor: 'tests of changed behavior' stamp: 'rt 4/26/2008 21:17'!
testCreateWorkingCopy2AndBeDirty

	sut
		create;
		createSecondWorkingCopy.
	self assert: (sut directory directoryExists: 'workingCopy2').
	self deny: (sut workingCopyDirectory2 directoryExists: '.svn').
	self assert: sut isDirty.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'tests of new behavior' stamp: 'rt 4/26/2008 22:01'!
testCreateWorkingCopy2BeDirtyAndCheckout

	sut
		create;
		createSecondWorkingCopy;
		checkoutSecondWorkingCopy.
	self assert: (sut directory directoryExists: 'workingCopy2').
	self assert: (sut workingCopyDirectory2 directoryExists: '.svn').
	self assert: sut isDirty.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'duplicated tests' stamp: 'rt 4/26/2008 21:14'!
testPathForTestIsWorkingCopyPath

	self assert: sut pathForTests = sut workingCopyPath.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'duplicated tests' stamp: 'rt 4/26/2008 21:14'!
testReCreate

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut reCreate.
	self deny: sut isDirty.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'tests of new behavior' stamp: 'rt 4/26/2008 22:28'!
testRepositoryConfiguration

	| directory file |
	sut create.
	directory := FileDirectory on: sut repositoryDirectory pathName , FileDirectory slash , 'conf'.
	self assert: directory exists.
	self assert: (directory fileExists: 'svnserve.conf').
	self assert: (directory fileExists: 'passwd').
	
	file := CrLfFileStream fileNamed: directory pathName , FileDirectory slash , 'svnserve.conf'.
	self assert: file contents = sut contentOfConfFile.
	file close.
	
	file := CrLfFileStream fileNamed: directory pathName , FileDirectory slash , 'passwd'.
	self assert: file contents = sut contentOfPasswdFile.
	file close.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'tests of changed behavior' stamp: 'rt 4/27/2008 06:35'!
testSetRepositoryUrlAndServerRoot

	| repUrl root |
	sut create.
	
	repUrl := 'svn://localhost/forSVNTestDirectoryTest/' , sut directory localName , '/' , sut nameForRepository.
	self assert: repUrl = sut repositoryURLPath.
	
	root := sut directory pathName
		copyFrom: 1
		to: (sut directory pathName size -
			sut directory localName size - 1 -
			'forSVNTestDirectoryTest' size - 1).
	self assert: root = sut serverRoot.! !

!SVNRestrictedTestDirectoryTest methodsFor: 'duplicated tests' stamp: 'rt 4/26/2008 21:14'!
testShouldBeDirtyWhenAccessed

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	self assert: sut isDirty.! !

!SVNTestDirectoryTest methodsFor: 'running' stamp: 'rkrk 3/15/2008 15:57'!
setUp

	super setUp.
	sut := SVNTestDirectory
		theName: 'TestDir01'
		basePath: self somePath.! !

!SVNTestDirectoryTest methodsFor: 'default' stamp: 'rkrk 3/14/2008 20:09'!
somePath

	| localName dir |
	localName := 'forSVNTestDirectoryTest'.
	dir := FileDirectory default.
	dir assureExistenceOfPath: localName.
	^ dir pathName , dir slash , localName.! !

!SVNTestDirectoryTest methodsFor: 'running' stamp: 'rkrk 3/16/2008 01:25'!
tearDown

	super tearDown.
	self flag: #TODO.
	(FileDirectory on: self somePath) deleteRecursivelyPlatformIndependent.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 17:25'!
testCheckConsistency01

	sut create.
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut isDirty: false.
	sut checkConsistency.	
	self assert: sut isDirty.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/16/2008 17:25'!
testCheckConsistency02

	sut checkConsistency.
	self assert: sut isDirty.
	sut create.
	sut checkConsistency.
	self deny: sut isDirty.
	sut isDirty: true.
	sut checkConsistency.
	self deny: sut isDirty.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 20:57'!
testClear

	sut create.
	self deny: sut isDirty.
	(sut directory newFileNamed: 'file') close.
	sut clear.
	self deny: sut isDirty.
	self deny: sut directory exists.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 20:57'!
testCreateInBasepath

	sut create.
	self deny: sut isDirty.
	self assert: sut directory exists.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 22:05'!
testReCreate

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	sut reCreate.
	self deny: sut isDirty.! !

!SVNTestDirectoryTest methodsFor: 'tests' stamp: 'rkrk 3/14/2008 21:54'!
testShouldBeDirtyWhenAccessed

	sut create.
	self deny: sut isDirty.
	"Create a file and use the #pathForTests accessor"
	((FileDirectory on: sut pathForTests) newFileNamed: 'file') close.
	self assert: sut isDirty.! !

TestCase subclass: #SVNUserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNUserTest methodsFor: 'as yet unclassified' stamp: 'rt 3/30/2008 21:03'!
testIfEqual

	| sut1 sut2 |
	sut1 := SVNUser user: 'User' password: 'password'.
	sut2 := SVNUser user: 'User' password: 'password'.
	
	self assert: sut1 = sut2.! !

!SVNUserTest methodsFor: 'as yet unclassified' stamp: 'rt 3/30/2008 21:04'!
testIfNotEqual

	| sut1 sut2 sut3 |
	sut1 := SVNUser user: 'User' password: 'password'.
	sut2 := SVNUser user: 'User2' password: 'password'.
	sut3 := SVNUser user: 'User' password: 'password2'.
	
	self deny: sut1 = sut2.
	self deny: sut1 = sut3.
	self deny: sut2 = sut3.! !

!MethodReference methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 22:33'!
includedInSvnEnvironment: svnEnvironment

	^ (svnEnvironment findSvnMethodForMethodRef: self) notNil! !

!Class methodsFor: '*SqueakSVN' stamp: 'rkrk 4/15/2008 05:38'!
includedInSvnEnvironment: svnEnvironment

	^ (svnEnvironment findSvnClassFor: self) notNil! !

Object subclass: #Class1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestCategory'!

!Class1 commentStamp: '<historical>' prior: 0!
A Class1 is xxxxxxxxx.

Instance Variables
!

!Class1 methodsFor: 'as yet unclassified' stamp: 'mu 3/27/2008 18:35'!
nurzumTesten
	^true! !

Object subclass: #Class2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestCategory'!

!Class2 commentStamp: '<historical>' prior: 0!
A Class2 is xxxxxxxxx.

Instance Variables
!

Object subclass: #Class3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestCategory'!

!Class3 commentStamp: '<historical>' prior: 0!
A Class3 is xxxxxxxxx.

Instance Variables
!

!Object methodsFor: '*SqueakSVN' stamp: 'rkrk 3/23/2008 01:54'!
forSvnPrimitive

	self error: 'I should not be passed down to a SVN primitive!!'! !

!Object methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 04:13'!
includedInSvnEnvironment: svnEnvironment

	^ false! !

Object subclass: #SVNClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

SVNClient subclass: #SVNCApiClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNCApiClient class methodsFor: 'unloading' stamp: 'rkrk 4/10/2008 14:43'!
buttonForUnloading

	"self buttonForUnloading"
	(SimpleButtonMorph newWithLabel: 'Unload SqueakSVNPlugin')
		target: self;
		actWhen: #buttonDown;
		actionSelector: #unloadSqueakSVN;
		openInWorld.! !

!SVNCApiClient class methodsFor: 'unloading' stamp: 'rkrk 4/10/2008 14:00'!
unloadSqueakSVN

	UIManager default inform: 'Unloading SqueakSVNPlugin'.
	SmalltalkImage current unloadModule: 'SqueakSVNPlugin'.! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 4/10/2008 12:56'!
basicSvnAdd: pathToTarget

	<primitive: 'svnAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 4/11/2008 12:41'!
basicSvnAddProperty: property WithValue:value To: target
 
	<primitive: 'svnAddPropertyWithValueTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 4/10/2008 15:43'!
basicSvnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath
 
	<primitive: 'svnCheckoutHeadRevisionFromTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 4/10/2008 13:45'!
basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath 

	<primitive: 'svnCheckoutRevisionByNumberFromTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 3/20/2008 12:18'!
basicSvnCleanupDirectory: directoryPath
	<primitive: 'svnCleanupDirectory' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 3/6/2008 11:04'!
basicSvnCommit: collectionOfPathesToTargets withMessage: aString
 
	<primitive: 'svnCommitWithMessage' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 3/10/2008 15:59'!
basicSvnDeleteTargetsFromWorkingCopy: collectionOfPathsToTargets

	<primitive: 'svnDeleteTargetsFromWorkingCopy' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'mu 5/8/2008 15:52'!
basicSvnRenamePath: pathToSource toNewPath: pathToDest

	<primitive: 'svnRenamePathToNewPath' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'cop 4/28/2008 15:18'!
basicSvnResolvedTarget: target
	<primitive: 'svnResolvedTarget' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 3/19/2008 17:18'!
basicSvnRevertTargets: targets
	<primitive: 'svnRevertTargets' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 4/27/2008 15:57'!
basicSvnUpdateTargets: collectionOfPathesToTargets toRevisionkind: revKind revisionNumber: revisionNumber beRecursive: bool
 
	<primitive: 'svnUpdateTargetsToRevisionKindRevisionNumberBeRecursive' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 4/25/2008 15:50'!
svnCommit: aCollection withMessage: aString

	| commitArray |
	commitArray := aCollection collect: [:each | each
			pathForSvn
			forSvnPrimitiveAsString].
	(SVNErrorCatcher on: [self
		basicSvnCommit: commitArray
		withMessage: aString forSvnPrimitiveAsString]) execute! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 5/4/2008 23:09'!
svnUpdateTargets: aCollection toRevisionByNumber: revisionNumber

	(SVNUpdateRequest
			target: aCollection
			updateToRevision: (SVNRevision number: revisionNumber)
			beRecursive: true) execute! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 5/5/2008 00:11'!
svnUpdateTargetsToHeadRevision: aCollectionOfSvnDirectoryEntries


	(SVNUpdateRequest
		target: aCollectionOfSvnDirectoryEntries
		updateToRevision: SVNRevision head
		beRecursive: true) execute! !

!SVNClient methodsFor: 'converting' stamp: 'test 3/26/2008 00:12'!
normalizePath: aString 

	self flag: #TODO. "Find my senders, replace method call an delete me"
	^ aString pathForSvn! !

!SVNClient methodsFor: 'svn primitives' stamp: 'pe 2/25/2008 11:54'!
svnAdd: aPath 

	^self basicSvnAdd: (self normalizePath: aPath)! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 4/17/2008 19:39'!
svnAddProperty: property WithValue:value To: target

	| propertyToAdd valueToAdd |
	self flag: #TODO. "Make conversion more clear and consider read also"
		"Check for valid key."
	propertyToAdd := property = ''
		ifTrue: ['nil']
		ifFalse: [property].
	valueToAdd := value = ''
		ifTrue: ['']
		ifFalse: [value asString].
	^self
		basicSvnAddProperty: propertyToAdd
		WithValue: valueToAdd
		To: (self normalizePath: target).! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 4/23/2008 19:31'!
svnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath

	(SVNErrorCatcher
		on: [self
			basicSvnCheckoutHeadRevisionFrom: (self normalizePath: repositoryURL)
			to: (self normalizePath: workingCopyPath)]) execute! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 4/23/2008 19:30'!
svnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath

	(SVNErrorCatcher
		on: [self
			basicSvnCheckoutRevisionByNumber: revisionNumber
			from: repositoryURL
			to: (self normalizePath: workingCopyPath)]) execute! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 3/20/2008 12:19'!
svnCleanupDirectory: directoryPath 

	^self basicSvnCleanupDirectory: (self normalizePath: directoryPath)! !

!SVNClient methodsFor: 'svn primitives' stamp: 'cop 4/28/2008 16:13'!
svnCommit: aCollection 

	^self svnCommit: aCollection withMessage: 'empty commit message'.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'cop 4/28/2008 16:13'!
svnCommit: aCollection withMessage: aString

	| commitArray |
	commitArray := aCollection collect: [:each | self normalizePath: each].
	^(SVNErrorCatcher on: [self basicSvnCommit: commitArray withMessage: aString]) execute successful! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 3/10/2008 16:00'!
svnDeleteTargetsFromWorkingCopy: collectionOfPathsToTargets 
	| deleteArray |
	deleteArray := collectionOfPathsToTargets 
				collect: [:each | self normalizePath: each].
	self basicSvnDeleteTargetsFromWorkingCopy: deleteArray! !

!SVNClient methodsFor: 'as yet unclassified' stamp: 'mu 5/8/2008 15:50'!
svnRenamePath: sourcePath toNewPath: destPath

	^ self basicSvnRenamePath: (self normalizePath: sourcePath) 
		toNewPath: (self normalizePath: destPath)! !

!SVNClient methodsFor: 'svn primitives' stamp: 'cop 4/28/2008 15:18'!
svnResolvedTarget: target 
	^ self basicSvnResolvedTarget: target! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 3/20/2008 14:17'!
svnRevertTargets: targets

	| arrayOfTargets |
	arrayOfTargets := targets collect: [:each | self normalizePath: each].
	^self basicSvnRevertTargets: arrayOfTargets! !

SVNClient subclass: #SVNCommandLineClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNCommandLineClient class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/15/2008 20:26'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Duplicated from SVNTestCase"
	"Unfortunately OSProcess is platform dependent"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [
			[p := ExternalOSProcess command: command] forkAt: Processor highIOPriority.
			[p isComplete] whileFalse: [Semaphore new waitTimeoutMSecs: 2].].! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 4/27/2008 00:59'!
basicSvnAdd: aPath 

	OSProcess waitForCommand: 'svn add ' , aPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 4/27/2008 00:59'!
basicSvnAddProperty: key WithValue: value To: path

	| command |
	command := self buildCmdPropset: key value: value for: path.
	OSProcess waitForCommand: command! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 4/27/2008 00:58'!
basicSvnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath

	OSProcess waitForCommand: 'svn co ' , repositoryURL , ' ' , workingCopyPath.
	^ 0! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 4/27/2008 00:58'!
basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath 

	OSProcess waitForCommand: 'svn co -r ' , revisionNumber asString , ' ' , repositoryURL , ' ' , workingCopyPath.
	^ 0! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 4/27/2008 00:57'!
basicSvnCommit: collectionOfTargets withMessage: aString

	| targets |
	targets := collectionOfTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	OSProcess waitForCommand: 'svn commit' , targets , ' -m "',aString,'"'.
	^ 0! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 4/27/2008 00:57'!
basicSvnUpdateTargets: collectionOfPathesToTargets toRevisionByNumber: revisionNumber

	| targets |
	targets := collectionOfPathesToTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	OSProcess waitForCommand: 'svn up -r', revisionNumber asString , targets.
	^ 0! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 4/27/2008 00:56'!
basicSvnUpdateTargetsToHeadRevision: collectionOfPathesToTargets

	| targets |
	targets := collectionOfPathesToTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	OSProcess waitForCommand: 'svn up' , targets.
	^ 0! !

!SVNCommandLineClient methodsFor: 'build commands' stamp: 'pe 2/26/2008 13:27'!
buildCmdPropset: key value: value for: path 
	
	^ 'svn propset ' , key , ' ' , value , ' ' , path.! !

!SVNCommandLineClient methodsFor: 'OSProcess' stamp: 'rt 4/27/2008 00:51'!
executeViaOSProcessSynchronously: command

	self flag: #TODO. "Duplicated from SVNTestCase"
	"Unfortunately OSProcess is platform dependent"
	
	self deprecated: 'Use the OSProcess command "waitForCommand"'.
	OSProcess waitForCommand: command! !

!SVNCommandLineClient methodsFor: 'converting' stamp: 'test 3/26/2008 00:13'!
normalizePath: aPath

	^'"' , aPath pathForSvn , '"'! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 14:21'!
svnGetHeadRevision: aPath

	self flag: #TODO. "Dirty hack. Extract headrevision from
	the output of the command line somehow."
	^ SVNCApiClient new svnGetHeadRevision: aPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rkrk 4/27/2008 16:58'!
svnUpdateTargets: aCollection toRevisionByNumber: revisionNumber

	"hack so that command line client still works. I think we could retire it soon"
	| updateArray |
	updateArray := aCollection collect: [:each | self normalizePath: each].
	
	(SVNErrorCatcher on: [self
		basicSvnUpdateTargets: updateArray
		toRevisionByNumber: revisionNumber]) execute! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rkrk 4/27/2008 16:59'!
svnUpdateTargetsToHeadRevision: aCollection 

	"hack so that command line client still works. I think we could retire it soon"
	| updateArray |
	updateArray := aCollection collect: [:each | self normalizePath: each].
	
	(SVNErrorCatcher
		on: [self basicSvnUpdateTargetsToHeadRevision: updateArray]) execute! !

Object subclass: #SVNCommand
	instanceVariableNames: 'target requestor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

SVNCommand subclass: #SVNAddToCurrentProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNAddToCurrentProjectCommand commentStamp: 'rkrk 4/23/2008 23:34' prior: 0!
For SVNSystemBrowser!

SVNAddToCurrentProjectCommand subclass: #SVNAddAllClassesInCategoryToCurrentProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNAddAllClassesInCategoryToCurrentProjectCommand methodsFor: 'execution' stamp: 'rkrk 4/24/2008 00:27'!
execute

	"Be careful. This is not tested. Not even tried..."
	| addClassCommands |
	addClassCommands := self target classes collect: [:obClassNode |
		SVNAddClassToCurrentProjectCommand
			on: obClassNode
			for: self theRequestor].
		
	addClassCommands
		select: [:ea | ea isActive]
		thenDo: [:ea | ea execute].! !

!SVNAddAllClassesInCategoryToCurrentProjectCommand methodsFor: 'testing' stamp: 'rkrk 4/24/2008 00:25'!
isActive

	^ super isActive
		and: [self target isKindOf: OBClassCategoryNode].! !

SVNAddToCurrentProjectCommand subclass: #SVNAddClassToCurrentProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNAddClassToCurrentProjectCommand methodsFor: 'executing' stamp: 'rkrk 5/5/2008 13:58'!
addTargetToCurrentProject

	self svnEnvironment currentProject addClass: self target theClass.! !

!SVNAddClassToCurrentProjectCommand methodsFor: 'testing' stamp: 'rkrk 4/23/2008 23:30'!
isActive

	^ super isActive
		and: [self target isKindOf: OBClassNode].! !

SVNAddToCurrentProjectCommand subclass: #SVNAddMethodToCurrentProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNAddMethodToCurrentProjectCommand methodsFor: 'executing' stamp: 'rt 5/8/2008 18:23'!
addTargetToCurrentProject

	| methodRef svnClass |
	methodRef := self target reference.
	(self classBelongsToCurrentProject)
		ifFalse: [self svnEnvironment currentProject addMethod: methodRef compiledMethod]
		ifTrue: [svnClass := self svnEnvironment findSvnClassFor: methodRef actualClass.
			svnClass addCompiledMethod: methodRef compiledMethod].
	self svnEnvironment currentProject store.
	! !

!SVNAddMethodToCurrentProjectCommand methodsFor: 'testing' stamp: 'rt 5/8/2008 19:27'!
classBelongsToCurrentProject

	| svnClass |

	svnClass := (self svnEnvironment findSvnClassFor:  self target theClass).
	svnClass
		ifNil: [^ false]
		ifNotNil: [^ self svnEnvironment currentProject includes: svnClass].! !

!SVNAddMethodToCurrentProjectCommand methodsFor: 'testing' stamp: 'rkrk 4/23/2008 23:31'!
isActive

	^ super isActive
		and: [self target isKindOf: OBMethodNode].! !

!SVNAddToCurrentProjectCommand methodsFor: 'execution' stamp: 'rkrk 4/23/2008 23:33'!
addTargetToCurrentProject

	self subclassResponsibility.! !

!SVNAddToCurrentProjectCommand methodsFor: 'execution' stamp: 'rkrk 5/5/2008 14:07'!
execute

	self findSvnProjectOfSVNElementOfTarget ifNotNilDo: [:project |
			self informTargetIsAlreadyVersionedIn: project. ^ self ].
	self addTargetToCurrentProject.
	self theRequestor
		announce: (OBNodeChanged node: self target);
		announce: OBRefreshRequired.

	"Wahhhhhhhhhhhhh!!!!!!!! Refactooooooooooor!!!!!!!!"
	"	| project svnClass |
	self flag: #TODO.
	project := self target svnEnvironment findSvnProjectFor: self target svnElement.
	project = self target currentSvnProject
		ifTrue: [UIManager default inform:
			'SVNElement is already a member of the project ' ,  project theName. ^ self].
	(project isNil and: [self svnElement isNil])
		ifTrue: [
			(self target isKindOf: OBClassCategoryNode)
				ifTrue: [self target classes do: [:ea| self target currentSvnProject addClass: ea theClass]].
			(self target isKindOf: OBClassNode)
				ifTrue: [self target currentSvnProject addClass: self target theClass].
			(self target isKindOf: OBMethodNode)
				ifTrue: [
					svnClass := (self target svnEnvironment findSvnClassFor: self target theNonMetaClass).
					svnClass
						ifNil: [self target currentSvnProject
								addMethod: self target reference compiledMethod]
						ifNotNil: [svnClass addMethod: (SVNMethod forExistingMethod: self target reference compiledMethod)]
					
					].
				self target currentSvnProject store.
				self theRequestor announce: (OBNodeChanged node: self target).
				^ self].
	
	(project isNil and: [self svnElement notNil])
		ifTrue: [
			(self target svnElement isKindOf: SVNMethod)
			ifTrue: [
				svnClass := self target svnEnvironment findSvnClassFor: self target theClass.
				(svnClass notNil and: [self target svnEnvironment includes: svnClass])
					ifTrue: [svnClass addMethod: self target svnElement]
					ifFalse: [self target currentSvnProject addMethod: self target svnElement]]
			ifFalse: [self target currentSvnProject addClass: self target svnElement]]
		ifFalse: [UIManager default confirm:
			'SVNElement is already a member of the project ' ,
				project theName ,
				'. Remove it and add it to the current project ' ,
				self target currentSvnProject theName , '?'].
		self target currentSvnProject store.
		self theRequestor announce: (OBNodeChanged node: self target)."! !

!SVNAddToCurrentProjectCommand methodsFor: 'ui' stamp: 'rkrk 4/23/2008 14:31'!
informTargetIsAlreadyVersionedIn: aSVNProject

	UIManager default inform:
		'You cannot add this element to the SVNProject ' ,
		self target svnEnvironment currentProject theName ,
		' because it is already versioned in the SVNProject ' ,
		aSVNProject theName.! !

!SVNAddToCurrentProjectCommand methodsFor: 'testing' stamp: 'rkrk 4/23/2008 23:30'!
isActive

	^ self target notNil 
		and: [self target currentSvnProject notNil]
		and: [self target belongsToCurrentSvnProject not]! !

!SVNAddToCurrentProjectCommand methodsFor: 'default' stamp: 'rkrk 4/12/2008 22:39'!
label

	^ 'Add to current project'! !

SVNCommand subclass: #SVNBrowseProjectInRepositoryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNBrowseProjectInRepositoryCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:20'!
execute

	| url selectedProject revision projectFromRepo environment |
	revision := self theRequestor selectedRevisionInfo revision.
	selectedProject := self svnEnvironment findSvnProjectFor: self target svnElement.
	url :=  selectedProject directory svnInfo url.
	projectFromRepo := SVNProject
		readFromUrl: url
		named: selectedProject theName
		revision: (SVNRevision number: revision).
	environment := SVNEnvironment forSvnProjects: {projectFromRepo}.
	environment currentProject: projectFromRepo.
	SVNRepositoryBrowser browseSvnEnvironment: environment.! !

!SVNBrowseProjectInRepositoryCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:18'!
isActive

	(self theRequestor isKindOf: SVNProjectBrowser) ifFalse: [^ false].
	^ self theRequestor selectedRevisionInfo notNil! !

!SVNBrowseProjectInRepositoryCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:18'!
label

	^ 'Browse revision'! !

!SVNCommand class methodsFor: 'converting' stamp: 'rkrk 4/12/2008 11:32'!
on: target for: requestor
	
	^ self new
		target: target;
		theRequestor: requestor;
		yourself.! !

!SVNCommand class methodsFor: 'testing' stamp: 'rkrk 4/12/2008 11:56'!
takesNodes

	^ true! !

!SVNCommand class methodsFor: 'testing' stamp: 'rkrk 4/12/2008 11:56'!
takesText

	^ false! !

!SVNCommand methodsFor: 'menu' stamp: 'rkrk 4/21/2008 11:24'!
addItemToMenu: aMenu

	self isActive ifFalse: [^ self].
	aMenu
		add: self label
		target: self
		action: #execute.! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 11:57'!
buttonLabel

	^ self label! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 11:49'!
cluster

	^ #SVN! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 12:35'!
createCluster
	^ OBCommandCluster label: self cluster! !

!SVNCommand methodsFor: 'execution' stamp: 'rkrk 4/6/2008 20:15'!
execute! !

!SVNCommand methodsFor: 'finding' stamp: 'rkrk 5/3/2008 18:19'!
findSvnProjectOfSVNElementOfTarget

	self svnEnvironment ifNil: [^ nil].
	^ self svnEnvironment findSvnProjectFor: self target svnElement! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 11:57'!
group

	^ #SVN! !

!SVNCommand methodsFor: 'informing' stamp: 'rkrk 5/5/2008 15:09'!
informThatRepositoryNotAccessible

	UIManager default inform: 'The repository is currently not accessible. Command cancelled.'! !

!SVNCommand methodsFor: 'testing' stamp: 'rkrk 4/7/2008 00:31'!
isActive

	^ false! !

!SVNCommand methodsFor: 'testing' stamp: 'rkrk 4/12/2008 11:20'!
isEnabled

	^ true! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 13:28'!
keystroke
	^ nil
! !

!SVNCommand methodsFor: 'default' stamp: 'rkrk 4/6/2008 20:15'!
label

	^ 'No label'! !

!SVNCommand methodsFor: 'for OB' stamp: 'rkrk 4/12/2008 11:57'!
longDescription

	"Override this and return a string or a text for the fly-by-help (tooltip)"
	^ nil! !

!SVNCommand methodsFor: 'menu' stamp: 'rkrk 4/7/2008 01:09'!
perform: aSelector orSendTo: anObject
	"needed by the menu action invocation"
	self perform: aSelector! !

!SVNCommand methodsFor: 'testing' stamp: 'rkrk 5/5/2008 15:11'!
repositoryAccessible

	| svnProject |
	svnProject := self svnEnvironment findSvnProjectFor: self svnElement.
	^ svnProject svnRepository exists.! !

!SVNCommand methodsFor: 'derived accessing' stamp: 'rkrk 5/5/2008 00:31'!
svnEnvironment

	"When a SVNSystemBrowser triggers this command than the targeted node
	does not have a meta node yet. Due to that, it is not possible for the node
	to get their svnEnvironment. Instead the browsers knows svnEnvironment,
	so ask it."
	self flag: #TODO.
	(self theRequestor isKindOf: SVNProjectBrowser orOf: OBSVNSystemBrowser)
		ifTrue: [^ self theRequestor svnEnvironment].
	^ self target svnEnvironment.! !

!SVNCommand methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:25'!
target
	^ target! !

!SVNCommand methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:25'!
target: anObject
	target := anObject! !

!SVNCommand methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:28'!
theRequestor
	^ requestor! !

!SVNCommand methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:29'!
theRequestor: anObject
	
	requestor := anObject! !

!SVNCommand methodsFor: 'testing' stamp: 'rkrk 4/7/2008 00:31'!
wantsButton

	^ false! !

SVNCommand subclass: #SVNCreateProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNCreateProjectCommand commentStamp: 'rkrk 4/23/2008 23:34' prior: 0!
For SVNProjectBrowser!

!SVNCreateProjectCommand methodsFor: 'executing' stamp: 'rt 5/7/2008 14:13'!
execute

	| svnProject |
	self flag: #TODO. "Update only the environment. ProjectNodes can be created from this"
	SVNCreateProjectDialog call ifNotNilDo: [:svnInfoGathererForProject |
		svnProject := SVNProject
			checkoutProject: svnInfoGathererForProject theName
			fromRepository: (SVNRepository on: svnInfoGathererForProject repositoryURL)
			toWorkingCopy: (SVNDirectory on: svnInfoGathererForProject workingCopyPath).
		"-------------"
		self theRequestor svnEnvironment addSvnProject: svnProject.
		self theRequestor beDependentFromProjects.
		"-------------"
		"self theRequestor projectNodes add: (SVNProjectNode
				element: svnProject
				svnEnvironment: self theRequestor svnEnvironment)."
		self theRequestor updateTree].! !

!SVNCreateProjectCommand methodsFor: 'testing' stamp: 'rkrk 4/12/2008 22:35'!
isActive

	^ self target isNil! !

!SVNCreateProjectCommand methodsFor: 'default' stamp: 'rkrk 4/6/2008 21:36'!
label

	^ 'Create Project'! !

!SVNCreateProjectCommand methodsFor: 'testing' stamp: 'rkrk 4/7/2008 00:31'!
wantsButton

	^ true! !

SVNCommand subclass: #SVNDiffBetweenRevisionsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNDiffBetweenRevisionsCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 07:14'!
execute

	| fromRevision toRevision url fromProject toProject selectedProject |
	fromRevision := self theRequestor selectedRevisionInfo revision.
	toRevision := (SVNRequestDialog
		ask: 'Diff to revision'
		template: ''
		canAcceptBlock: [:text | true]) asNumber.
	self flag: #TODO.
	selectedProject := self svnEnvironment findSvnProjectFor: self target svnElement.
	url :=  selectedProject directory svnInfo url.
	fromProject := SVNProject
		readFromUrl: url
		named: selectedProject theName
		revision: (SVNRevision number: fromRevision).
	toProject := SVNProject
		readFromUrl: url
		named: selectedProject theName
		revision: (SVNRevision number: toRevision).
	SVNDiffTool openWithNewSvnElement: toProject oldElement: fromProject.! !

!SVNDiffBetweenRevisionsCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 04:15'!
isActive

	(self theRequestor isKindOf: SVNProjectBrowser) ifFalse: [^ false].
	^ self theRequestor selectedRevisionInfo notNil! !

!SVNDiffBetweenRevisionsCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 04:16'!
label

	^ 'Diff to revision...'! !

SVNCommand subclass: #SVNElementCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

SVNElementCommand subclass: #SVNClassCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

SVNClassCommand subclass: #SVNBrowseClassCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNBrowseClassCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 4/30/2008 03:01'!
execute

	| browser class |
	class := Smalltalk classNamed: self svnClass theName.
	class ifNil: [self inform: 'This class is not loaded into the system'. ^ self].
	browser := OBSVNSystemBrowser onClass: class.
	browser svnEnvironment currentProject: self target parent svnElement.
	browser panels first currentProject: self target parent svnElement.
	browser open.
	
	! !

!SVNBrowseClassCommand methodsFor: 'as yet unclassified' stamp: 'per 4/23/2008 11:19'!
label

	^ 'Browse class'! !

!SVNClassCommand methodsFor: 'testing' stamp: 'cop 4/28/2008 11:02'!
isActive

	^ super isActive
		and: [self target hasSvnElementOfKind: SVNClass]! !

!SVNClassCommand methodsFor: 'derived accessing' stamp: 'rkrk 4/12/2008 12:45'!
svnClass

	self assert: (self svnElement isKindOf: SVNClass).
	^ self svnElement! !

SVNClassCommand subclass: #SVNDeleteClassCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNDeleteClassCommand commentStamp: 'rkrk 4/23/2008 23:35' prior: 0!
For
SVNProjectBrowser <-- not implmented yet
and
SVNSystemBrowser!

!SVNDeleteClassCommand methodsFor: 'execution' stamp: 'rkrk 4/25/2008 12:00'!
deleteClass

	(self target svnEnvironment findSvnProjectFor: self svnClass)
		ifNotNilDo: [:project | project removeSVNClass: self svnClass]! !

!SVNDeleteClassCommand methodsFor: 'execution' stamp: 'cop 4/23/2008 13:50'!
execute

	(UIManager default confirm: 'You realy want to delete this class from this project?')
		ifTrue: [ self deleteClass.]
	! !

!SVNDeleteClassCommand methodsFor: 'default' stamp: 'rkrk 5/5/2008 14:16'!
label

	^ 'Remove class from project'! !

SVNElementCommand subclass: #SVNCommitCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNCommitCommand commentStamp: 'rkrk 4/23/2008 23:35' prior: 0!
For
SVNProjectBrowser
and
SVNSystemBrowser!

!SVNCommitCommand methodsFor: 'execution' stamp: 'rkrk 5/5/2008 15:00'!
execute
	
	self svnElement isConflicted
		ifTrue: [self informAboutConflict. ^ self].
	self repositoryAccessible
		ifFalse: [self informThatRepositoryNotAccessible. ^ self].
	SVNCommitBrowser openWith: self svnElement.! !

!SVNCommitCommand methodsFor: 'execution' stamp: 'rkrk 5/5/2008 14:57'!
informAboutConflict

	UIManager default
		inform: ('This element is conflicted!!\Solve the conflict before you commit ' ,
				self svnElement theName , '.') withCRs ! !

!SVNCommitCommand methodsFor: 'testing' stamp: 'mu 4/30/2008 12:33'!
isActive

	| classOrProject |
	super isActive ifFalse: [^ false].
	(self target hasSvnElementOfKind: SVNMethod) ifFalse: [^ true].
	(self svnElement status = #added) ifFalse: [^ true].
	classOrProject := (self svnEnvironment
		findSvnProjectOrSvnClassForSvnMethod: self svnElement).
	^ (classOrProject status = #added) not
	! !

!SVNCommitCommand methodsFor: 'execution' stamp: 'rkrk 4/12/2008 12:07'!
label

	^ 'Commit SVNElement'! !

!SVNElementCommand methodsFor: 'testing' stamp: 'rkrk 4/14/2008 12:03'!
isActive

	^ self target notNil and:
		[self target belongsToCurrentSvnProject] and:
		[self target hasSvnElementOfKind: SVNElement]! !

!SVNElementCommand methodsFor: 'accessing' stamp: 'cop 4/14/2008 09:40'!
svnElement

	^ self target svnElement! !

SVNElementCommand subclass: #SVNMethodCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

SVNMethodCommand subclass: #SVNBrowseMethodCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNBrowseMethodCommand methodsFor: 'as yet unclassified' stamp: 'per 4/30/2008 12:59'!
execute

	| browser class methodSelector project |
	class := Smalltalk classNamed: self target svnElement nameOfClass.
	class ifNil: [self inform: 'This class is not loaded into the system'. ^ self].
	methodSelector := self target svnElement theName asSymbol.
	(class includesSelector: methodSelector) ifFalse: [self inform: 'This method is not loaded into the system'. ^ self].
	browser := OBSVNSystemBrowser onClass: class selector: methodSelector.
	
	project := self svnEnvironment findSvnProjectFor: self target svnElement.
	
	browser svnEnvironment currentProject: project.
	browser panels first currentProject: project.
	browser open.! !

!SVNBrowseMethodCommand methodsFor: 'as yet unclassified' stamp: 'per 4/24/2008 11:12'!
label

	^ 'Browse method'! !

SVNMethodCommand subclass: #SVNDeleteMethodCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNDeleteMethodCommand commentStamp: 'rkrk 4/23/2008 23:36' prior: 0!
For
SVNProjectBrowser <-- not implmented yet
and
SVNSystemBrowser!

!SVNDeleteMethodCommand methodsFor: 'execution' stamp: 'rkrk 4/25/2008 11:58'!
deleteMethod

	(self target svnEnvironment findSvnProjectOrSvnClassForSvnMethod: self svnMethod)
		ifNotNilDo: [:projectOrClass | projectOrClass removeSVNMethod: self svnMethod].! !

!SVNDeleteMethodCommand methodsFor: 'execution' stamp: 'cop 4/23/2008 13:50'!
execute

	(UIManager default confirm: 'You realy want to delete this method from this class?')
		ifTrue: [ self deleteMethod.]
	! !

!SVNDeleteMethodCommand methodsFor: 'default' stamp: 'rkrk 5/5/2008 14:16'!
label

	^ 'Remove method from project'! !

!SVNMethodCommand methodsFor: 'testing' stamp: 'rkrk 4/23/2008 23:49'!
isActive

	^ super isActive
		and: [self target hasSvnElementOfKind: SVNMethod]! !

!SVNMethodCommand methodsFor: 'derived accessing' stamp: 'cop 4/23/2008 10:50'!
svnMethod

	self assert: (self svnElement isKindOf: SVNMethod).
	^ self svnElement! !

SVNElementCommand subclass: #SVNProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

SVNProjectCommand subclass: #SVNCheckoutCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNCheckoutCommand commentStamp: 'rkrk 4/23/2008 23:36' prior: 0!
For
SVNProjectBrowser!

!SVNCheckoutCommand methodsFor: 'execution' stamp: 'rkrk 5/5/2008 14:39'!
execute

	self flag: #TODO. "no longer needed"
	self svnProject checkout! !

!SVNCheckoutCommand methodsFor: 'default' stamp: 'rkrk 4/7/2008 01:22'!
label

	^ 'Checkout project'! !

SVNProjectCommand subclass: #SVNChooseAndAddClassCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNChooseAndAddClassCommand commentStamp: 'rkrk 4/23/2008 23:36' prior: 0!
For
SVNProjectBrowser!

!SVNChooseAndAddClassCommand methodsFor: 'default' stamp: 'rkrk 4/21/2008 01:57'!
acceptClassBlock

	| class |
	^ [:text |
		class := (Smalltalk classNamed: text asString).
		class notNil and: [(self svnEnvironment includes: class) not]].! !

!SVNChooseAndAddClassCommand methodsFor: 'execution' stamp: 'cop 4/21/2008 17:18'!
execute

	| text |
	text := SVNRequestDialog
		ask: 'Enter class name'
		template: String new
		canAcceptBlock: self acceptClassBlock.
	text ifNil: [^ self].
	self svnProject addClass: (Smalltalk classNamed: text asString).! !

!SVNChooseAndAddClassCommand methodsFor: 'default' stamp: 'rkrk 4/7/2008 04:13'!
label

	^ 'Add class to project'! !

SVNChooseAndAddClassCommand subclass: #SVNChooseAndAddMethodCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNChooseAndAddMethodCommand commentStamp: 'rkrk 4/23/2008 23:36' prior: 0!
For
SVNProjectBrowser!

!SVNChooseAndAddMethodCommand methodsFor: 'default' stamp: 'cop 4/21/2008 17:03'!
acceptBlock: aString
	
	| class methodSelector |
	self flag: #TODO "Adding methods of a superclass... be careful!!!!!! And write a test for this!!!!!!
	What about adding the class to which the methods belongs afterwards? ...!!".
	^ [:text |
		class := Smalltalk classNamed: aString.
		methodSelector := text asString asSymbol.
		(class includesSelector: methodSelector) and:
			[(self svnEnvironment includes: class >> methodSelector) not]].! !

!SVNChooseAndAddMethodCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 4/21/2008 02:33'!
execute

	| className methodName method |
	className := SVNRequestDialog
		ask: 'Enter class name'
		template: String new
		canAcceptBlock: self acceptClassBlock.
	className ifNil: [^ self].
	
	methodName := SVNRequestDialog
		ask: 'Enter method name'
		template: String new
		canAcceptBlock: (self acceptBlock: className asString).
	methodName ifNil: [^ self].
	
	method := (Smalltalk classNamed: className) >> methodName asSymbol.
	self svnProject addMethod: method.! !

!SVNChooseAndAddMethodCommand methodsFor: 'default' stamp: 'cop 4/18/2008 12:05'!
label

	^ 'Add method to project'! !

SVNProjectCommand subclass: #SVNDeleteProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNDeleteProjectCommand methodsFor: 'execution' stamp: 'cop 4/24/2008 15:28'!
deleteProjectIn: aSVNEnv

	aSVNEnv currentProject = self svnProject ifTrue: [aSVNEnv currentProject: nil ].
	aSVNEnv svnProjects remove: self svnProject.
	self svnProject changed.! !

!SVNDeleteProjectCommand methodsFor: 'execution' stamp: 'rkrk 4/25/2008 12:00'!
execute

	(UIManager default confirm: 'You realy want to delete the ', self svnProject theName, ' project?')
		ifTrue: ["(UIManager default confirm: 'Do you want to remove ', self svnProject theName, ' project from the repository?')
			ifTrue: [self removeProjectFromRepository]".
			self deleteProjectIn: self target svnEnvironment. ]
	! !

!SVNDeleteProjectCommand methodsFor: 'default' stamp: 'cop 4/24/2008 11:31'!
label

	^ 'Delete project'! !

!SVNDeleteProjectCommand methodsFor: 'execution' stamp: 'cop 4/24/2008 14:21'!
removeProjectFromRepository
	(self svnElement 
		remove
		commitWithMessage: 'Project ', self svnElement theName, ' deleted.')
		svnDirectoryEntry delete.! !

!SVNProjectCommand methodsFor: 'testing' stamp: 'rkrk 4/23/2008 23:50'!
isActive

	^ super isActive and: [self target hasSvnElementOfKind: SVNProject]! !

!SVNProjectCommand methodsFor: 'derived accessing' stamp: 'rkrk 4/12/2008 12:44'!
svnProject

	self assert: (self svnElement isKindOf: SVNProject).
	^ self svnElement! !

SVNProjectCommand subclass: #SVNSetURLCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNSetURLCommand commentStamp: 'rkrk 4/23/2008 23:36' prior: 0!
For
SVNProjectBrowser!

!SVNSetURLCommand methodsFor: 'executing' stamp: 'pe 4/14/2008 15:17'!
execute

	| newUrl |
	newUrl := SVNRequestDialog
		ask: self label
		template: self svnProject repositoryURL asString
		canAcceptBlock: [:text | text notNil].
	newUrl ifNotNil: [self svnProject repositoryURL: newUrl asString].! !

!SVNSetURLCommand methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:24'!
label

	^ 'Edit SVNProject URL'! !

SVNProjectCommand subclass: #SVNSetWorkingCopyPathCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNSetWorkingCopyPathCommand commentStamp: 'rkrk 4/23/2008 23:36' prior: 0!
For
SVNProjectBrowser!

!SVNSetWorkingCopyPathCommand methodsFor: 'executing' stamp: 'rkrk 5/5/2008 14:20'!
execute

	| newWCPath |
	self halt. "SVNProjects no longer know their workingCopy."
	self flag: #TODO. "SVNProjects will soon have no working copy path any longer.
	They will specify their project directory instead."
	newWCPath := SVNRequestDialog
		ask: self label
		template: self svnProject workingCopyDirectory path
		canAcceptBlock: [:text | text notNil].
	self flag: #TODO. "Setting the workingcopy path is not so easy!!
	All subentries have to be updated!!"
	(UIManager default confirm: 'This operation will not work in an expected way. Continue?')
		ifTrue:[newWCPath ifNotNil: [
				self svnProject workingCopyDirectory: (SVNDirectory on: newWCPath asString)]].! !

!SVNSetWorkingCopyPathCommand methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 00:02'!
label

	^ 'Edit working copy path'! !

SVNElementCommand subclass: #SVNResolveCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNResolveCommand methodsFor: 'testing' stamp: 'cop 4/29/2008 14:30'!
isActive

	^ super isActive
		and: [self target hasSvnElementOfKind: SVNElement]
		and: [self svnElement isConflicted]! !

SVNResolveCommand subclass: #SVNResolveWithMineCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNResolveWithMineCommand methodsFor: 'execution' stamp: 'cop 4/29/2008 14:17'!
execute

	SVNConflictSolver resolveConflictWithMine: self svnElement! !

!SVNResolveWithMineCommand methodsFor: 'default' stamp: 'cop 4/29/2008 14:32'!
label

	^ 'Resolve conflict using "mine"'! !

SVNResolveCommand subclass: #SVNResolveWithTheirsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNResolveWithTheirsCommand methodsFor: 'execution' stamp: 'cop 4/29/2008 14:17'!
execute

	SVNConflictSolver resolveConflictWithTheirs: self svnElement! !

!SVNResolveWithTheirsCommand methodsFor: 'default' stamp: 'cop 4/29/2008 14:32'!
label

	^ 'Resolve conflict using "theirs"'! !

SVNElementCommand subclass: #SVNRevertCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNRevertCommand commentStamp: 'rkrk 4/23/2008 23:37' prior: 0!
For
SVNProjectBrowser
and
SVNSystemBrowser!

!SVNRevertCommand methodsFor: 'execution' stamp: 'rkrk 4/7/2008 01:55'!
execute
	
	self svnElement revert! !

!SVNRevertCommand methodsFor: 'execution' stamp: 'rkrk 4/7/2008 01:59'!
label

	^ 'Revert'! !

SVNElementCommand subclass: #SVNUpdateCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNUpdateCommand commentStamp: 'rkrk 4/23/2008 23:37' prior: 0!
For
SVNProjectBrowser
and
SVNSystemBrowser!

!SVNUpdateCommand methodsFor: 'execution' stamp: 'rkrk 5/5/2008 15:10'!
execute
	
	self repositoryAccessible
		ifFalse: [self informThatRepositoryNotAccessible. ^ self].
	self svnElement update! !

!SVNUpdateCommand methodsFor: 'execution' stamp: 'rkrk 4/7/2008 01:59'!
label

	^ 'Update'! !

SVNElementCommand subclass: #SVNUpdateToRevisionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNUpdateToRevisionCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 5/5/2008 15:10'!
execute

	| revisionNumber number |
	self repositoryAccessible
		ifFalse: [self informThatRepositoryNotAccessible. ^ self].
	revisionNumber := SVNRequestDialog
		ask: 'Please enter the revision number'
		template: ''
		canAcceptBlock: [:text |
			number := text asString asInteger.
			number notNil and: [number positive]].
	revisionNumber ifNil: [^ self].
	self svnElement updateToRevision: (SVNRevision number: revisionNumber asInteger).! !

!SVNUpdateToRevisionCommand methodsFor: 'as yet unclassified' stamp: 'cop 4/29/2008 14:19'!
label

	^ 'Update to revision...'! !

SVNCommand subclass: #SVNRefreshProjectBrowserCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!SVNRefreshProjectBrowserCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 23:32'!
execute

	| allSvnElements |
	"reset revision infos of all elements of environment
	so that commit logs and other revision infos are reloaded"
	allSvnElements := self svnEnvironment svnProjects gather: [:ea | ea allElements].
	allSvnElements do: [:ea | ea dismissRevisionInfos].
	
	"update view items"
	self theRequestor updateAll.! !

!SVNRefreshProjectBrowserCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 5/3/2008 18:34'!
isActive
	
	^ self theRequestor isKindOf: SVNProjectBrowser! !

!SVNRefreshProjectBrowserCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 5/3/2008 18:36'!
label

	^ 'Refresh'! !

!SVNRefreshProjectBrowserCommand methodsFor: 'as yet unclassified' stamp: 'rkrk 5/3/2008 18:36'!
wantsButton

	^ true! !

Object subclass: #SVNConflictSolver
	instanceVariableNames: 'svnElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNConflictSolver class methodsFor: 'initialization' stamp: 'cop 4/29/2008 14:11'!
resolveConflictWithMine: aSVNElement
	(self solveConflictFor: aSVNElement) resolveWithMine! !

!SVNConflictSolver class methodsFor: 'initialization' stamp: 'cop 4/29/2008 14:12'!
resolveConflictWithTheirs: aSVNElement
	(self solveConflictFor: aSVNElement) resolveWithTheirs! !

!SVNConflictSolver class methodsFor: 'initialization' stamp: 'cop 4/29/2008 14:48'!
solveConflictFor: svnElement
	^ self new svnElement: svnElement! !

!SVNConflictSolver methodsFor: 'file handling' stamp: 'cop 4/29/2008 10:26'!
moveContentsFrom: fromString to: toString
	
	| content |
	FileStream 
		readOnlyFileNamed: fromString
		do: [:stream | content := stream contents.].
	FileStream 
		forceNewFileNamed: toString
		do: [:stream | stream nextPutAll: content].! !

!SVNConflictSolver methodsFor: 'conflict solving' stamp: 'cop 4/29/2008 14:50'!
resolveWith: aString for: svnFile
	self 
		moveContentsFrom: svnFile path , aString
		to: svnFile path.! !

!SVNConflictSolver methodsFor: 'conflict solving' stamp: 'cop 4/29/2008 15:18'!
resolveWithMine

	self resolveWithMineForDir: self svnElement svnDirectoryEntry.
	self svnElement
		restoreAndLoad;
		resolved.! !

!SVNConflictSolver methodsFor: 'conflict solving' stamp: 'cop 4/29/2008 15:42'!
resolveWithMine: svnFile

	svnFile isConflicted ifTrue: [self resolveWith: '.mine' for: svnFile]! !

!SVNConflictSolver methodsFor: 'conflict solving' stamp: 'cop 4/29/2008 15:01'!
resolveWithMineForDir: dirEntry

	dirEntry subdirectories do: [:dir| self resolveWithMineForDir: dir].
	dirEntry files do: [:file| self resolveWithMine: file]! !

!SVNConflictSolver methodsFor: 'conflict solving' stamp: 'cop 4/29/2008 15:20'!
resolveWithTheirs
	
	self resolveWithTheirsForDir: self svnElement svnDirectoryEntry.
	self svnElement
		restoreAndLoad;
		resolved.! !

!SVNConflictSolver methodsFor: 'conflict solving' stamp: 'cop 4/29/2008 15:42'!
resolveWithTheirs: svnFile

	svnFile isConflicted ifTrue: [self resolveWith: '.r', svnFile svnInfo revision number asString for: svnFile]
	! !

!SVNConflictSolver methodsFor: 'conflict solving' stamp: 'cop 4/29/2008 15:02'!
resolveWithTheirsForDir: dirEntry
	
	dirEntry subdirectories do: [:dir| self resolveWithTheirsForDir: dir].
	dirEntry files do: [:file| self resolveWithTheirs: file]! !

!SVNConflictSolver methodsFor: 'accessing' stamp: 'cop 4/29/2008 14:47'!
svnElement
	^ svnElement! !

!SVNConflictSolver methodsFor: 'accessing' stamp: 'cop 4/29/2008 14:48'!
svnElement: aSVNElement
	svnElement := aSVNElement! !

Object subclass: #SVNCurrentProjectChanged
	instanceVariableNames: 'currentProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!SVNCurrentProjectChanged class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/11/2008 19:49'!
forProject: svnProject

	^ self new
		currentProject: svnProject;
		yourself.! !

!SVNCurrentProjectChanged methodsFor: 'accessing' stamp: 'cop 4/8/2008 19:04'!
currentProject
	^currentProject! !

!SVNCurrentProjectChanged methodsFor: 'accessing' stamp: 'cop 4/8/2008 19:04'!
currentProject: aSVNProject
	currentProject := aSVNProject! !

Object subclass: #SVNDiffCreator
	instanceVariableNames: 'differences svnProject1 svnProject2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Diffing'!

!SVNDiffCreator class methodsFor: 'instance creation' stamp: 'rkrk 5/13/2008 07:27'!
diff: aSVNProject against: aSVNProject2 
	
"	self halt.
"	^ self new
		svnProject1: aSVNProject;
		svnProject2: aSVNProject2;
		generateDifferences;
		yourself.! !

!SVNDiffCreator methodsFor: 'accessing' stamp: 'rkrk 5/13/2008 05:20'!
differences
	^ differences! !

!SVNDiffCreator methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 17:47'!
differences: anObject
	differences := anObject! !

!SVNDiffCreator methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 07:26'!
generateClassDifferencesOf: newProject and: oldProject

	| similiarClass |
	self flag: #TODO. "Refactor"
	newProject versionedClasses do: [:newClass |
		similiarClass := oldProject versionedClasses
			detect: [:oldClass | oldClass theName = newClass theName]
			ifNone: [nil].
		"Class was added/removed from one version or another or modified (notNil)"
		similiarClass
			ifNil: [self differences add: (SVNClassDifference addedElement: newClass).
				self differences addAll: (newClass versionedMethods collect: [:ea |
						SVNMethodDifference addedElement: ea])] 
			ifNotNil: [
				(newClass equals: similiarClass) ifFalse:
					[self differences add: (SVNClassDifference newElement: newClass oldElement: similiarClass)].
				self generateMethodDifferencesOf: newClass  and: similiarClass]].
	"Now test if classes were removed"
	oldProject versionedClasses do: [:oldClass |
		(newProject versionedClasses noneSatisfy: [:newClass | newClass theName = oldClass theName])
			ifTrue: [self differences add: (SVNClassDifference removedElement: oldClass).
				self differences addAll: (oldClass versionedMethods collect: [:ea |
						SVNMethodDifference removedElement: ea])]].! !

!SVNDiffCreator methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 05:26'!
generateDifferences

	"self halt."
	self generateClassDifferencesOf: self svnProject1 and: self svnProject2.
	! !

!SVNDiffCreator methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 03:48'!
generateMethodDifferencesOf: newClass and: oldClass

	|  similiarMethod |
	self flag: #TODO. "Refactor"
	newClass versionedMethods do: [:newMethod |
		similiarMethod := oldClass versionedMethods
			detect: [:oldMethod | 	oldMethod theName = newMethod theName and: [oldMethod isPartOfMetaclass = newMethod isPartOfMetaclass]]
			ifNone: [nil].
		"Class was added/removed from one version or another or modified (notNil)"
		similiarMethod
			ifNil: [self differences add: (SVNMethodDifference addedElement: newMethod)] 
			ifNotNil: [
				(newMethod equals: similiarMethod) ifFalse:
					[self differences add: (SVNMethodDifference newElement: newMethod oldElement: similiarMethod)]]].
	"Now test if methods were removed"
	oldClass versionedMethods do: [:oldMethod |
		(newClass versionedMethods noneSatisfy: [:newMethod | newMethod theName = oldMethod theName])
			ifTrue: [self differences add: (SVNMethodDifference removedElement: oldMethod)]].! !

!SVNDiffCreator methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 05:20'!
initialize

	super initialize.
	self differences: OrderedCollection new.! !

!SVNDiffCreator methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 17:49'!
svnProject1
	^ svnProject1! !

!SVNDiffCreator methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 17:49'!
svnProject1: anObject
	svnProject1 := anObject! !

!SVNDiffCreator methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 17:49'!
svnProject2
	^ svnProject2! !

!SVNDiffCreator methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 17:49'!
svnProject2: anObject
	svnProject2 := anObject! !

Object subclass: #SVNDiffSummary
	instanceVariableNames: 'target propChanged summaryKind'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Diffing'!

!SVNDiffSummary class methodsFor: 'instance creation' stamp: 'cop 5/10/2008 16:01'!
addedFor: aString

	^self new
		target: aString;
		propChanged: false;
		summaryKind: #added.! !

!SVNDiffSummary class methodsFor: 'instance creation' stamp: 'test 5/10/2008 17:31'!
deletedFor: aString

	^self new
		target: aString;
		propChanged: false;
		summaryKind: #deleted.! !

!SVNDiffSummary class methodsFor: 'instance creation' stamp: 'cop 5/10/2008 16:01'!
normalFor: aString

	^self new
		target: aString;
		propChanged: false;
		summaryKind: #normal.! !

!SVNDiffSummary class methodsFor: 'instance creation' stamp: 'test 5/10/2008 17:20'!
propChanged: prop summaryKind: kind

	^self new
		propChangedAsInt: prop;
		summaryKindAsInt: kind.! !

!SVNDiffSummary class methodsFor: 'instance creation' stamp: 'cop 5/7/2008 17:43'!
target: aString propChanged: prop summaryKind: kind

	^self new
		target: aString;
		propChangedAsInt: prop;
		summaryKindAsInt: kind.! !

!SVNDiffSummary methodsFor: 'accessing' stamp: 'cop 5/7/2008 17:31'!
propChanged

	^propChanged! !

!SVNDiffSummary methodsFor: 'accessing' stamp: 'cop 5/7/2008 17:31'!
propChanged: aBool

	propChanged := aBool! !

!SVNDiffSummary methodsFor: 'accessing' stamp: 'cop 5/8/2008 09:18'!
propChangedAsInt: anInt

	self propChanged: anInt > 0! !

!SVNDiffSummary methodsFor: 'accessing' stamp: 'cop 5/7/2008 17:31'!
summaryKind

	^summaryKind! !

!SVNDiffSummary methodsFor: 'accessing' stamp: 'cop 5/7/2008 17:31'!
summaryKind: aSelector

	summaryKind := aSelector! !

!SVNDiffSummary methodsFor: 'accessing' stamp: 'cop 5/7/2008 17:40'!
summaryKindAsInt: anInt

	self summaryKind: (SVNDiffSummaryRequest summaryKindDictionary at: anInt)! !

!SVNDiffSummary methodsFor: 'accessing' stamp: 'cop 5/7/2008 17:30'!
target

	^target! !

!SVNDiffSummary methodsFor: 'accessing' stamp: 'cop 5/7/2008 17:31'!
target: aString

	target := aString! !

Object subclass: #SVNDifference
	instanceVariableNames: 'oldSvnElement newSvnElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Diffing'!

SVNDifference subclass: #SVNClassDifference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Diffing'!

!SVNClassDifference methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 05:06'!
asString

	self newSvnElement ifNil: [
		^ 'Removed class: ' , self oldSvnElement theName].
	self oldSvnElement ifNil: [
		^ 'Added class: ' , self newSvnElement theName].
	^ 'Class modified: ' , self oldSvnElement theName.! !

!SVNClassDifference methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 01:53'!
isClassDifference

	^ true! !

!SVNDifference class methodsFor: 'instance creation' stamp: 'rkrk 5/13/2008 03:27'!
addedElement: aSVNElement
	
	^ self new
		newSvnElement: aSVNElement;
		yourself.! !

!SVNDifference class methodsFor: 'instance creation' stamp: 'rkrk 5/13/2008 03:27'!
newElement: aSVNElement oldElement: aSVNElement2 
	
	^ self new
		newSvnElement: aSVNElement;
		oldSvnElement: aSVNElement2;
		yourself.! !

!SVNDifference class methodsFor: 'instance creation' stamp: 'rkrk 5/13/2008 03:30'!
removedElement: aSVNElement 
	
	^ self new
		oldSvnElement: aSVNElement ;
		yourself.! !

!SVNDifference methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 03:18'!
asString

	^ 'Abstract diff'! !

!SVNDifference methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 03:17'!
isMethodDifference

	^ false! !

!SVNDifference methodsFor: 'accessing' stamp: 'rkrk 5/13/2008 03:17'!
newSvnElement
	^ newSvnElement! !

!SVNDifference methodsFor: 'accessing' stamp: 'rkrk 5/13/2008 03:17'!
newSvnElement: anObject
	newSvnElement := anObject! !

!SVNDifference methodsFor: 'accessing' stamp: 'rkrk 5/13/2008 03:17'!
oldSvnElement
	^ oldSvnElement! !

!SVNDifference methodsFor: 'accessing' stamp: 'rkrk 5/13/2008 03:17'!
oldSvnElement: anObject
	oldSvnElement := anObject! !

!SVNDifference methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 05:30'!
populateDiffer: diffMorph

	| fromString toString |
	fromString := self oldSvnElement
		ifNil: ['']
		ifNotNilDo: [:e | e asString].
	toString := self newSvnElement
		ifNil: ['']
		ifNotNilDo: [:e | e asString].
	diffMorph
		from: fromString
		to: toString! !

SVNDifference subclass: #SVNMethodDifference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Diffing'!

!SVNMethodDifference methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 07:13'!
asString

	self newSvnElement ifNil: [
		^ 'Removed method: ' , self oldSvnElement theName].
	self oldSvnElement ifNil: [
		^ 'Added method: ' , self newSvnElement theName].
	^ 'Method modified: ' , self oldSvnElement theName.! !

!SVNMethodDifference methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 03:18'!
isMethodDifference
	
	^ true! !

Object subclass: #SVNDirectoryEntry
	instanceVariableNames: 'theName basePath properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

SVNDirectoryEntry subclass: #SVNDirectory
	instanceVariableNames: 'subdirectories files'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

!SVNDirectory methodsFor: 'comparing' stamp: 'rkrk 4/2/2008 18:05'!
= other

	^ super = other and:
		[self files = other files] and:
			[self subdirectories = other subdirectories]! !

!SVNDirectory methodsFor: 'adding' stamp: 'rkrk 5/11/2008 03:00'!
addFile: svnFile

	| alreadyExistingFile |
	svnFile basePath: self path.
	alreadyExistingFile := self files
		detect: [:file | file theName = svnFile theName]
		ifNone: [^ self files add: svnFile].
	^ alreadyExistingFile
		properties: svnFile properties;
		content: svnFile content;
		yourself.! !

!SVNDirectory methodsFor: 'adding' stamp: 'rkrk 5/11/2008 03:01'!
addSubdirectory: svnDirectory

	| subdirectory |
	svnDirectory basePath: self path.
	subdirectory := self subdirectories
		detect: [:dir | dir theName = svnDirectory theName]
		ifNone: [self subdirectories add: svnDirectory. svnDirectory].
	
	subdirectory
		properties: svnDirectory properties;
		subdirectories: svnDirectory subdirectories;
		files: svnDirectory files.
			
	self flag: #TODO. "Ugly. How to inform subdirectories and files about new basepath?"
	svnDirectory subdirectories do: [:ea | svnDirectory addSubdirectory: ea].
	svnDirectory files do: [:ea | svnDirectory addFile: ea].
	
	^ subdirectory! !

!SVNDirectory methodsFor: 'file manipulation' stamp: 'test 3/5/2008 00:16'!
createFileNamed: filename 

	^ self
		createFileNamed: filename
		withContent: String new.! !

!SVNDirectory methodsFor: 'file manipulation' stamp: 'rkrk 3/5/2008 01:38'!
createFileNamed: filename withContent: content

	| newFile |
	newFile := SVNFile
		named: filename
		basePath: self path
		content: content.
	self addFile: newFile.
	^ newFile! !

!SVNDirectory methodsFor: 'subdirectory manipulation' stamp: 'rt 3/14/2008 15:20'!
createSubDirectoryNamed: aString 
	
	| newDirectory |
	self flag: #TODO. "Test schreiben!!!!!!!!"
	(self subdirectories anySatisfy: [:each | each theName = aString])
		ifTrue: [^ (self subdirectories detect: [:each | each theName = aString])].
	newDirectory := self class
		named: aString
		basePath: self path.
	self addSubdirectory: newDirectory.
	^ newDirectory.! !

!SVNDirectory methodsFor: 'removing' stamp: 'rkrk 3/4/2008 06:13'!
delete

	| fileDir dotSvnDir |
	fileDir := FileDirectory on: self basePath.
	
	self flag: #TODO.
	fileDir deleteFileNamed: '.DS_STORE'.
	dotSvnDir := SVNDirectory named: '.svn' basePath: self path.
	(FileDirectory on: dotSvnDir path) exists ifTrue:
		[dotSvnDir read.
		dotSvnDir recursivelyDo: [:svnDirectoryEntry |
			svnDirectoryEntry delete]].
	
	fileDir := FileDirectory on: self basePath.
	(fileDir directoryExists: self theName asString) ifFalse: [^ self].
	fileDir deleteDirectory: self theName.! !

!SVNDirectory methodsFor: 'testing' stamp: 'rkrk 2/23/2008 02:51'!
directoryExists: directoryName 

	^ self subdirectories anySatisfy: [:each |
		each theName = directoryName]! !

!SVNDirectory methodsFor: 'reading' stamp: 'rt 5/11/2008 21:56'!
existsOnDisk

	^ (FileDirectory on: self basePath) directoryExists: self filename! !

!SVNDirectory methodsFor: 'testing' stamp: 'rkrk 2/23/2008 02:35'!
fileExists: fileName

	^ self files anySatisfy: [:each | fileName = each theName].! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
files
	^ files! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
files: anObject
	files := anObject! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 02:55'!
getFileNamed: fileName 
	
	^ self files
		detect: [:each | each theName = fileName]
		ifNone: [nil].! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 02:55'!
getSubDirectoryNamed: directoryName 
	
	^ self subdirectories
		detect: [:each | each theName = directoryName]
		ifNone: [nil].! !

!SVNDirectory methodsFor: 'comparing' stamp: 'rkrk 4/2/2008 11:46'!
hash

	^ (super hash bitXor: self files hash) bitXor: self subdirectories hash! !

!SVNDirectory methodsFor: 'initialization' stamp: 'rkrk 4/2/2008 12:01'!
initialize

	super initialize.
	self
		files: OrderedCollection new;
		subdirectories: OrderedCollection new;
		theName: String new! !

!SVNDirectory methodsFor: 'testing' stamp: 'rkrk 5/11/2008 02:58'!
isConflictedFileName: fileName

	self flag: #TODO.
	^ ('*.mine*' match: fileName) or: ['*.r*' match: fileName]! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 4/2/2008 15:11'!
pathsOfAllElements

	| entries |
	entries := self files copy.
	entries addAll: self subdirectories.
	^ entries collect: [:each | each path].! !

!SVNDirectory methodsFor: 'printing' stamp: 'rkrk 4/2/2008 12:13'!
printOn: aStream

	| printBlock |
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self path;
		nextPutAll: ' - Subdirectories:'.
	printBlock := [:each |
		aStream
			nextPut: Character space;
			nextPutAll: each theName].
	self subdirectories do: printBlock.
	aStream nextPutAll: ' - Files:'.
	self files do: printBlock.
	aStream nextPut: $).! !

!SVNDirectory methodsFor: 'reading' stamp: 'rkrk 4/21/2008 00:54'!
read
	
	(FileDirectory on: self path) exists
		ifFalse: [
			Transcript show: 'Trying to load non-existing directory ' , self path; cr.
			^ self].

	super read.
	self readDirectoryEntries.! !

!SVNDirectory methodsFor: 'reading' stamp: 'rkrk 5/12/2008 03:11'!
readDirectoriesInDir: dir

	self subdirectories removeAllSuchThat: [:ea | (dir directoryNames includes: ea theName) not].
	(dir directoryNames
		reject: [:each | each = '.svn'])
		collect: [:ea | SVNDirectory named: ea basePath: self path]
		thenDo: [:ea |
			ea read.
			self addSubdirectory: ea].! !

!SVNDirectory methodsFor: 'reading' stamp: 'test 3/1/2008 02:49'!
readDirectoryEntries

	| dir |
	dir := FileDirectory on: self path.
	self
		readFilesInDir: dir;
		readDirectoriesInDir: dir.! !

!SVNDirectory methodsFor: 'reading' stamp: 'rkrk 4/29/2008 23:42'!
readFilesInDir: directory

	self flag: #TODO. "Use addSvnFile:???"
	"remove no longer existing files"
	self files removeAllSuchThat: [:ea | (directory fileNames includes: ea theName) not].
	(directory fileNames
		reject: [:name | self isConflictedFileName: name])
		collect: [:each | SVNFile named: each basePath: self path]
		thenDo: [:newFile |
			newFile read.
			self addFile: newFile.].! !

!SVNDirectory methodsFor: 'helper' stamp: 'rkrk 4/2/2008 15:13'!
recursivelyDo: aBlock

	| entries |
	self flag: #TODO. "Testen".
	entries := self files copy.
	entries addAll: self subdirectories.
	entries do: [:ea | ea recursivelyDo: aBlock].
	aBlock value: self.! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 4/2/2008 15:11'!
recursivelyGatherPathsOfAllElements

	| subElementsPaths |
	subElementsPaths := self subdirectories gather: [:each | each recursivelyGatherPathsOfAllElements].
	^ self pathsOfAllElements
		addAll: subElementsPaths;
		yourself.! !

!SVNDirectory methodsFor: 'removing' stamp: 'rkrk 4/28/2008 04:35'!
remove

	| myFileDirectory |
	myFileDirectory := FileDirectory on: self basePath.
	(myFileDirectory directoryExists: self filename) ifFalse: [^ self].
	super remove.
	"(myFileDirectory directoryExists: self filename) ifFalse: [^ self].
	myFileDirectory deleteRecursivelyPlatformIndependent.
	(myFileDirectory directoryExists: self filename) ifFalse: [^ self].
	Transcript show: 'Could not delete directory: ' , self path; cr."! !

!SVNDirectory methodsFor: 'removing' stamp: 'rkrk 4/28/2008 03:40'!
removeSVNDirectory: svnDirectory

	self subdirectories
		remove: svnDirectory
		ifAbsent: [].
	svnDirectory remove.! !

!SVNDirectory methodsFor: 'removing' stamp: 'rkrk 4/28/2008 04:00'!
removeSVNFile: svnFile

	self files
		remove: svnFile
		ifAbsent: [].
	svnFile remove. "not needed in case of method... it removes itself... hmmm"! !

!SVNDirectory methodsFor: 'storing' stamp: 'cop 4/14/2008 13:46'!
store

	| entriesToStore |
	self basePath ifEmpty: [ Transcript show: 'No base path set for ', self asString;
							cr.
							^self ].
	(FileDirectory on: self path) assureExistence.
	super store.
	entriesToStore := self files copy.
	entriesToStore addAll: self subdirectories.
	entriesToStore do: [:each | each store].! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
subdirectories
	^ subdirectories! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
subdirectories: anObject
	subdirectories := anObject! !

SVNDirectory subclass: #SVNRepositoryDirectory
	instanceVariableNames: 'revision'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

!SVNRepositoryDirectory class methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 03:12'!
fromUrl: urlString forRevision: aSVNRevision

	^ self new
		fromUrl: urlString forRevision: aSVNRevision;
		yourself.! !

!SVNRepositoryDirectory class methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 03:22'!
named: nameString basePath: path revision: svnRevision

	^ (self
		named: nameString
		basePath: path)
		revision: svnRevision;
		yourself.! !

!SVNRepositoryDirectory methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 17:33'!
createFileNamed: filename withContent: content

	"self error."! !

!SVNRepositoryDirectory methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 02:54'!
createSubDirectoryNamed: aString 

	self error.! !

!SVNRepositoryDirectory methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 02:54'!
delete

	self error.! !

!SVNRepositoryDirectory methodsFor: 'initialization' stamp: 'rkrk 5/12/2008 04:02'!
extractBasePathFromUrl: urlString

	| parts scheme |
	parts := (urlString subStrings: '/') asOrderedCollection.
	parts removeLast.
	scheme := parts removeFirst.
	scheme := scheme , '//'.
	^ scheme , (parts
		inject: String new
		into: [:result : part | result , '/' , part]).! !

!SVNRepositoryDirectory methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 17:03'!
filename

	^ (SVNPath on: self theName) asEncodedStringForRepository! !

!SVNRepositoryDirectory methodsFor: 'initialization' stamp: 'rkrk 5/12/2008 03:24'!
fromUrl: urlString forRevision: aSVNRevision 
	
	self
		theNameFromUrl: urlString;
		basePath: (self extractBasePathFromUrl: urlString);
		revision: aSVNRevision;
		read.! !

!SVNRepositoryDirectory methodsFor: 'derived accessing' stamp: 'rkrk 5/12/2008 03:20'!
path
	^ self basePath , '/' , self filename.! !

!SVNRepositoryDirectory methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 02:55'!
read

	self
		readProperties;
		readDirectoryEntries.! !

!SVNRepositoryDirectory methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 04:10'!
readDirectoryEntries

	| svnList |
	svnList := SVNListRequest target: self forRevision: self revision.
	svnList execute.
	svnList directoryNames
		collect: [:ea | SVNRepositoryDirectory named: ea basePath: self path revision: self revision]
		thenDo: [:ea | ea read .self addSubdirectory: ea].
	"----"
	svnList fileNames
		collect: [:ea | SVNRepositoryFile named: ea basePath: self path revision: self revision]
		thenDo: [:ea | ea read. self addFile: ea].! !

!SVNRepositoryDirectory methodsFor: 'reading' stamp: 'rkrk 5/12/2008 04:07'!
readProperties

	| svnPropReq |
	svnPropReq := SVNPropertiesRequest target: self forRevision: self revision.
	svnPropReq execute.
	self properties: svnPropReq properties! !

!SVNRepositoryDirectory methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 02:52'!
revision
	^ revision! !

!SVNRepositoryDirectory methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 02:52'!
revision: anObject
	revision := anObject! !

!SVNRepositoryDirectory methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 17:33'!
store! !

!SVNRepositoryDirectory methodsFor: 'initialization' stamp: 'rkrk 5/12/2008 15:39'!
theNameFromUrl: urlString

	self assert: (urlString includes: $@) not.
	self decodeName: (urlString subStrings: '/') last.! !

!SVNDirectoryEntry class methodsFor: 'illegal characters' stamp: 'rkrk 3/12/2008 14:44'!
asciiValueSeparator

	^ $%! !

!SVNDirectoryEntry class methodsFor: 'illegal characters' stamp: 'rkrk 4/21/2008 13:08'!
illegalCharacters

	^ #($/ $\ $? $* $: $| $" $< $> $ $ $)! !

!SVNDirectoryEntry class methodsFor: 'instance creation' stamp: 'rkrk 4/1/2008 17:02'!
named: aString

	^ self
		named: aString
		basePath: String new.! !

!SVNDirectoryEntry class methodsFor: 'instance creation' stamp: 'rkrk 5/12/2008 15:39'!
named: aString basePath: pathName

	"self assert: (aString includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not."
	^ self new
		decodeName: aString;
		basePath: pathName;
		yourself.! !

!SVNDirectoryEntry class methodsFor: 'instance creation' stamp: 'mu 3/31/2008 15:20'!
on: pathString
	
	FileDirectory
		splitName: pathString
		to: [:dirPath :localName |
			^ self named: localName basePath: dirPath].! !

!SVNDirectoryEntry methodsFor: 'comparing' stamp: 'rkrk 4/9/2008 19:19'!
<= other

	^ self theName <= other theName! !

!SVNDirectoryEntry methodsFor: 'comparing' stamp: 'rkrk 4/2/2008 18:05'!
= other

	self species = other species ifFalse: [^ false].
	^ self theName = other theName and:
		[self basePath = other basePath] and:
			[self properties = other properties].! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'rkrk 5/10/2008 15:49'!
addEntry

	self svnClientDo: [:client | client svnAdd: self path].! !

!SVNDirectoryEntry methodsFor: 'converting' stamp: 'rkrk 3/5/2008 19:54'!
asciiValueSeparator

	^ self class asciiValueSeparator.! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
basePath
	^ basePath! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
basePath: anObject 
	basePath := anObject! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 4/3/2008 00:26'!
checkoutFrom: url

	self svnClientDo: [:svnClient | 
		svnClient
			svnCheckoutHeadRevisionFrom: url asString
			to: self path].! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 3/13/2008 18:03'!
commit

	self commitWithMessage: String new.! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 5/4/2008 22:19'!
commitLogs
	
	^ (SVNRevisionInfosRequest target: self)
		execute;
		commitLogs.! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 4/3/2008 00:27'!
commitWithMessage: aString

	self svnClientDo: [:svnClient | 
		svnClient
			svnCommit: {self path}
			withMessage: aString.].! !

!SVNDirectoryEntry methodsFor: 'converting' stamp: 'rkrk 5/12/2008 16:37'!
decodeName: aString 

	self theName: (SVNPath on: aString) asDecodedString.
	"self assert: aString isEmpty not."
"	aString ifEmpty: [^ aString].
	(aString first = self asciiValueSeparator and: [aString size = 1]) ifTrue: [^ aString].
	
	aString isAllDigits ifTrue: [self theName: aString. ^ self].
	
	parts := aString subStrings: self asciiValueSeparator asString.
	self theName: (parts
		inject: String new
		into: [:result :each | each isAllDigits
			ifFalse: [result , each]
			ifTrue: [char := Character value: each asNumber.
				result , char asString]])."! !

!SVNDirectoryEntry methodsFor: 'removing' stamp: 'rkrk 3/4/2008 05:20'!
delete! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'cop 5/8/2008 17:18'!
diffSummaryFrom: startRev To: endRev

	^SVNDiffSummaryRequest target: self fromRevision: startRev toRevision: endRev! !

!SVNDirectoryEntry methodsFor: 'reading' stamp: 'rt 5/11/2008 21:53'!
existsOnDisk

	^ self subclassResponsibility! !

!SVNDirectoryEntry methodsFor: 'derived accessing' stamp: 'rkrk 5/12/2008 15:56'!
filename

	"print it: [self new theName: 'ab:ab'; filename]"
	^ (SVNPath on: self theName) asEncodedString
	"^ self theName encodeForHTTP."
"	(self theName includesAnyOf: self class illegalCharacters) ifFalse: [^ self theName].
	^ self class illegalCharacters 
		inject: self theName copy
		into: [:convertedName :illegalCharacter |
			convertedName
				copyReplaceAll: illegalCharacter asString
				with: (self fileNameRepresantationForIllegalCharacter: illegalCharacter)]."! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'cop 4/29/2008 15:13'!
files

	^self subclassResponsibility! !

!SVNDirectoryEntry methodsFor: 'comparing' stamp: 'rkrk 4/2/2008 11:58'!
hash

	^ ((self theName hash bitXor: self basePath hash) bitXor: self properties hash) bitXor: self species hash! !

!SVNDirectoryEntry methodsFor: 'initialization' stamp: 'rkrk 4/27/2008 05:14'!
initialize

	super initialize.
	self
		theName: String new;
		properties: Dictionary new.! !

!SVNDirectoryEntry methodsFor: 'svn state' stamp: 'cop 4/29/2008 15:43'!
isConflicted

	^self status isConflicted! !

!SVNDirectoryEntry methodsFor: 'svn state' stamp: 'cop 5/10/2008 20:20'!
isModified

	^self status isModified! !

!SVNDirectoryEntry methodsFor: 'svn state' stamp: 'rkrk 5/7/2008 00:28'!
myStatus
	
	^ (SVNStatusRequest target: self isRecursive: false)
		execute;
		yourself! !

!SVNDirectoryEntry methodsFor: 'derived accessing' stamp: 'rkrk 3/5/2008 18:03'!
path
	^ self basePath , FileDirectory slash , self filename.! !

!SVNDirectoryEntry methodsFor: 'derived accessing' stamp: 'rkrk 5/12/2008 13:32'!
pathsOfAllElements

	^ self path! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
properties
	^ properties! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
properties: anObject
	properties := anObject! !

!SVNDirectoryEntry methodsFor: 'reading' stamp: 'rkrk 5/3/2008 19:28'!
read
	
	self	readProperties.! !

!SVNDirectoryEntry methodsFor: 'reading' stamp: 'rkrk 5/10/2008 16:05'!
readProperties

	self properties: ((SVNPropertiesRequest target: self) execute; properties)! !

!SVNDirectoryEntry methodsFor: 'removing' stamp: 'rt 3/14/2008 15:09'!
remove

	self svnRemoveEntry! !

!SVNDirectoryEntry methodsFor: 'removing' stamp: 'mu 5/8/2008 16:09'!
rename

	self svnRenameEntry! !

!SVNDirectoryEntry methodsFor: 'removing' stamp: 'mu 5/8/2008 16:13'!
rename: currentName to: newName

	self svnRenameEntry: currentName to: newName! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'cop 4/29/2008 15:19'!
resolved
	
	self svnClientDo: [:svnClient|
		svnClient svnResolvedTarget: self path pathForSvn]! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'cop 4/18/2008 11:02'!
revert
	self svnClientDo: [:svnClient |
		svnClient svnRevertTargets: {self path}].
	self read.! !

!SVNDirectoryEntry methodsFor: 'svn state' stamp: 'rkrk 4/7/2008 15:42'!
status
	
	^ (SVNStatusRequest target: self)
		execute;
		yourself! !

!SVNDirectoryEntry methodsFor: 'system state' stamp: 'rt 5/11/2008 23:52'!
stillUnderVersionControl

	self existsOnDisk ifFalse: [^ false].
	^ (self status statusKind = #unversioned) not! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'pe 4/14/2008 14:36'!
store
	self assert: (FileDirectory on: self basePath) exists.
	self
		addEntry;
		storeProperties.! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'test 3/1/2008 04:14'!
storeProperties

	| client |
	client := SVNCApiClient new.
	self properties keysAndValuesDo: [:key :value |
		client svnAddProperty: key WithValue: value To: self path].! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'cop 4/29/2008 15:13'!
subdirectories

	^self subclassResponsibility! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 4/3/2008 00:28'!
svnAdd

	self svnClientDo: [:svnClient |
		svnClient svnAdd: self path].! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 4/3/2008 00:26'!
svnClientDo: aBlock

	aBlock value: SVNCApiClient new.! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 4/3/2008 03:22'!
svnInfo

	^ (SVNInfoRequest target: self)
		execute;
		yourself.! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'rt 3/13/2008 17:30'!
svnRemoveEntry

	| client |
	client := SVNCApiClient new.
	client svnDeleteTargetsFromWorkingCopy: {self path}.
	self flag: #TODO. "svn status ??? If entry isn't under version control call: entry delete ?'"! !

!SVNDirectoryEntry methodsFor: 'removing' stamp: 'mu 5/8/2008 16:12'!
svnRenameEntry: currentName to: newName

	| client |
	client := SVNCApiClient new.
	client svnRenamePath: currentName toNewPath: newName.! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
theName

	^ theName! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 3/5/2008 18:54'!
theName: aString 

	"self assert: (aString includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not."
	theName := aString asString.! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 5/4/2008 22:51'!
update
	
	self updateToRevision: SVNRevision head.
	self read.! !

!SVNDirectoryEntry methodsFor: 'svn functions' stamp: 'rkrk 5/4/2008 22:44'!
updateToRevision: svnRevision

	(SVNUpdateRequest
		target: {self}
		updateToRevision: svnRevision
		beRecursive: true) execute.
	self read.! !

SVNDirectoryEntry subclass: #SVNFile
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

!SVNFile class methodsFor: 'instance creation' stamp: 'test 3/5/2008 15:29'!
named: aString basePath: pathName content: content

	"self assert: (aString includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not."
	^ (self named: aString basePath: pathName)
		content: content;
		yourself.! !

!SVNFile methodsFor: 'comparing' stamp: 'rkrk 2/21/2008 21:44'!
= other

	^ (super = other and:
		[self content = other content])! !

!SVNFile methodsFor: 'svn functions' stamp: 'rkrk 5/10/2008 18:49'!
blame

	^ (SVNBlameLinesRequest target: self)
		execute;
		yourself! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 18:49'!
content
	^ content! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 18:49'!
content: anObject
	content := anObject! !

!SVNFile methodsFor: 'removing' stamp: 'rkrk 3/4/2008 05:13'!
delete

	(FileDirectory on: self basePath) deleteFileNamed: self theName.! !

!SVNFile methodsFor: 'reading' stamp: 'rt 5/12/2008 16:33'!
existsOnDisk

	| dir |
	dir := (FileDirectory on: self basePath).
	dir exists ifFalse: [^ false].
	^ dir fileExists: self filename! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 23:18'!
files

	"self halt. "
	self flag: #TODO.
	^OrderedCollection with: self! !

!SVNFile methodsFor: 'comparing' stamp: 'rkrk 4/2/2008 11:50'!
hash

	self flag: #TODO.
	"^ (super hash bitXor: self content hash) bitXor: self properties hash."
	
	^ super hash bitXor: self content hash! !

!SVNFile methodsFor: 'initialization' stamp: 'rkrk 4/27/2008 05:14'!
initialize

	super initialize.
	self	content: String new.! !

!SVNFile methodsFor: 'printing' stamp: 'rkrk 4/2/2008 11:27'!
printOn: aStream

	super printOn: aStream.	
	aStream
		nextPut: $(;
		nextPutAll: self path;
		nextPut: $).! !

!SVNFile methodsFor: 'reading' stamp: 'cop 4/29/2008 10:34'!
read
	
	self flag: #TODO.
	(FileStream isAFileNamed: self path)
		ifFalse: [
			Transcript show: 'Trying to load non-existing file ' , self path; cr.
			^ self].

	self assert: ('*.mine*' match: self theName) not.
	self assert: ('*.r*' match: self theName) not.
	super read.
	self	readContent.! !

!SVNFile methodsFor: 'reading' stamp: 'rt 5/12/2008 18:30'!
readContent
	FileStream 
		readOnlyFileNamed: self path
		do: [:stream | self content: stream contents.]! !

!SVNFile methodsFor: 'helper' stamp: 'rkrk 3/4/2008 05:20'!
recursivelyDo: aBlock

	self flag: #TODO. "Testen".
	aBlock value: self.! !

!SVNFile methodsFor: 'removing' stamp: 'rkrk 4/28/2008 04:35'!
remove

	| dir |
	dir := FileDirectory on: self basePath.
	dir exists ifFalse: [^ self].
	(dir fileExists: self filename) ifFalse: [^ self].
	super remove.
	"(dir fileExists: self filename) ifFalse: [^ self].
	dir deleteFileNamed: self filename.
	(dir fileExists: self filename) ifFalse: [^ self].
	Transcript show: 'Could not delete file ' , self path; cr."! !

!SVNFile methodsFor: 'conflict solving' stamp: 'rkrk 4/29/2008 23:35'!
solveConflict

	^ (SVNConflictSolver solveConflictFor: self) execute! !

!SVNFile methodsFor: 'storing' stamp: 'rkrk 4/29/2008 23:36'!
store

	"self assert: (self theName includesAnyOf: {$<. $>. $/. $\. $*. $|. $:}) not."
	FileStream 
		forceNewFileNamed: self path
		do: [:stream | stream nextPutAll: content].
	super store.! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 23:18'!
subdirectories

	"self halt."
	self flag: #TODO.
	^OrderedCollection new! !

SVNFile subclass: #SVNRepositoryFile
	instanceVariableNames: 'revision'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

!SVNRepositoryFile class methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 00:57'!
fromUrl: urlString forRevision: aSVNRevision

	^ self new
		fromUrl: urlString forRevision: aSVNRevision;
		yourself.! !

!SVNRepositoryFile class methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 03:22'!
named: nameString basePath: path revision: svnRevision

	^ (self
		named: nameString
		basePath: path)
		revision: svnRevision;
		yourself.! !

!SVNRepositoryFile methodsFor: 'removing' stamp: 'rkrk 5/12/2008 02:49'!
delete

	self error: 'Cannot delete file in repository'.! !

!SVNRepositoryFile methodsFor: 'initialization' stamp: 'rkrk 5/12/2008 04:01'!
extractBasePathFromUrl: urlString

	| parts scheme |
	parts := (urlString subStrings: '/') asOrderedCollection.
	parts removeLast.
	scheme := parts removeFirst.
	scheme := scheme , '//'.
	^ scheme , (parts
		inject: String new
		into: [:result : part | result , '/' , part]).! !

!SVNRepositoryFile methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 17:04'!
filename

	^ (SVNPath on: self theName) asEncodedStringForRepository! !

!SVNRepositoryFile methodsFor: 'initialization' stamp: 'rkrk 5/12/2008 03:24'!
fromUrl: urlString forRevision: aSVNRevision 
	
	self
		theNameFromUrl: urlString;
		basePath: (self extractBasePathFromUrl: urlString);
		revision: aSVNRevision;
		read.! !

!SVNRepositoryFile methodsFor: 'derived accessing' stamp: 'rkrk 5/12/2008 03:20'!
path
	^ self basePath , '/' , self filename.! !

!SVNRepositoryFile methodsFor: 'reading' stamp: 'rkrk 5/12/2008 02:46'!
read

	self
		readContent;
		readProperties.! !

!SVNRepositoryFile methodsFor: 'reading' stamp: 'rkrk 5/12/2008 04:06'!
readContent

	| svnCat |
	svnCat := SVNCatRequest target: self forRevision: self revision.
	svnCat execute.
	self content: svnCat contentOfTarget.! !

!SVNRepositoryFile methodsFor: 'reading' stamp: 'rkrk 5/12/2008 04:07'!
readProperties

	| svnPropReq |
	svnPropReq := SVNPropertiesRequest target: self forRevision: self revision.
	svnPropReq execute.
	self properties: svnPropReq properties! !

!SVNRepositoryFile methodsFor: 'removing' stamp: 'rkrk 5/12/2008 02:50'!
remove

	self error: 'Cannot remove file in repository'.! !

!SVNRepositoryFile methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 02:48'!
revision
	^ revision! !

!SVNRepositoryFile methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 02:48'!
revision: anObject
	revision := anObject! !

!SVNRepositoryFile methodsFor: 'conflict solving' stamp: 'rkrk 5/12/2008 02:50'!
solveConflict

	self error: 'Files in repository cannot be conflicted'.! !

!SVNRepositoryFile methodsFor: 'storing' stamp: 'rkrk 5/12/2008 17:34'!
store! !

!SVNRepositoryFile methodsFor: 'initialization' stamp: 'rkrk 5/12/2008 15:39'!
theNameFromUrl: urlString

	self assert: (urlString includes: $@) not.
	self decodeName: (urlString subStrings: '/') last.! !

Object subclass: #SVNDummy
	instanceVariableNames: 'i1 i2'
	classVariableNames: 'C1 C2'
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNDummy class
	instanceVariableNames: 'IC1 IC2'!

!SVNDummy commentStamp: '<historical>' prior: 0!
A SVNDummy is xxxxxxxxx.

Instance Variables
	i1:		<Object>
	i2:		<Object>

i1
	- xxxxx

i2
	- xxxxx
!

SVNDummy class
	instanceVariableNames: 'IC1 IC2'!

!SVNDummy class methodsFor: 'dummy' stamp: 'cop 2/7/2008 19:50'!
m3

	^ 3! !

!SVNDummy class methodsFor: 'dummy' stamp: 'rkrk 4/14/2008 22:35'!
onInstanceAndClassSide! !

!SVNDummy class methodsFor: 'convenience' stamp: 'cop 2/7/2008 19:50'!
sourceCodeForM2
	^ 'm2
	^ 2'! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'rkrk 3/14/2008 02:25'!
< other

	^ super < other! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'test 2/23/2008 11:54'!
m1
	^ 1! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'rkrk 4/14/2008 22:22'!
m2
	^ 2! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'cop 2/7/2008 19:50'!
methodWithSpecialCharacter: aString
	^ aString! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'rkrk 4/14/2008 22:35'!
onInstanceAndClassSide

	"Methods with this name are on instance and on class side of SVNDummy."! !

Object subclass: #SVNElement
	instanceVariableNames: 'theName parent svnDirectoryEntry revisionInfos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

SVNElement subclass: #SVNClass
	instanceVariableNames: 'superclassName classVariables instanceVariables classInstanceVariables comment category subclasses versionedMethods poolDictionaries isVersioned'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNClass commentStamp: 'mu 2/7/2008 16:29' prior: 0!
A SVNClass is blablabla.

Instance Variables
	class:		<Object>

class
	- xxxxx
!

!SVNClass class methodsFor: 'instance creation' stamp: 'rkrk 4/1/2008 18:28'!
forExistingClass: aClass

	^ self new
		forExistingClass: aClass;
		yourself! !

!SVNClass class methodsFor: 'instance creation' stamp: 'rt 5/9/2008 15:12'!
forExistingClassWithoutItsMethods: aClass

	^ self new
		forExistingClassWithoutItsMethods: aClass;
		yourself! !

!SVNClass class methodsFor: 'instance creation' stamp: 'rkrk 4/15/2008 00:35'!
name: className superclassName: superClassName instanceVariables: instVars classVariables: classVars classInstanceVariables: classInstVars poolDictionaries: poolDicts comment: comment category: classCategory

	^ self new
		theName: className asString;
		superclassName: superClassName;
		instanceVariables: instVars;
		classVariables: classVars;
		classInstanceVariables: classInstVars;
		poolDictionaries: poolDicts;
		comment:  comment;
		category: classCategory;
		establishSvnFilesAndDirectories;
		yourself.! !

!SVNClass methodsFor: 'comparing' stamp: 'rkrk 4/15/2008 04:24'!
= other

	^ super = other "ifFalse: [^ false].
	(self superclassName = other superclassName and:
		[self instanceVariables = other instanceVariables] and:
		[self classVariables = other classVariables] and:
		[self classInstanceVariables = other classInstanceVariables] and:
		[self comment = other comment]) ifFalse: [^ false].
	^  self category = other category and:
		[self poolDictionaries = other poolDictionaries] and:
		[self versionedMethods = other versionedMethods]"! !

!SVNClass methodsFor: 'adding' stamp: 'rkrk 4/23/2008 14:19'!
addCompiledMethod: aMethod

	"rename this in #addMethod:? and #addMethod: in #addSvnMethod:?
	Would be consisten to SVNProject>>addClass: und SVNProject>>addSvnClass:"
	self addMethod: (SVNMethod forExistingMethod: aMethod).! !

!SVNClass methodsFor: 'adding' stamp: 'rt 5/9/2008 18:27'!
addMethod: svnMethod

	^ self addSvnMethod: svnMethod! !

!SVNClass methodsFor: 'adding' stamp: 'rt 5/9/2008 18:28'!
addSvnMethod: svnMethod

	| methodDirectory |
	methodDirectory := self directory
		getSubDirectoryNamed: (svnMethod isPartOfMetaclass
			ifTrue: ['class']
			ifFalse: ['instance']).
	methodDirectory addFile: svnMethod file.
	
	svnMethod parent: self.
	self versionedMethods add: svnMethod.
	self changed.! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 5/13/2008 05:53'!
allElements

	^ (OrderedCollection with: self)
		addAll: self versionedMethods;
		yourself.! !

!SVNClass methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 02:47'!
asString

	| aStream |
	aStream := WriteStream on: (String new: 300).
	aStream
		nextPutAll: self superclassName;
		nextPutAll: ' subclass: ';
		store: self theName asSymbol;
		cr; tab;
		nextPutAll: 'instanceVariableNames: ';
		store: self instanceVariablesString;
		cr; tab;
		nextPutAll: 'classVariableNames: ';
		store: self classVariablesString;
		cr; tab;
		nextPutAll: 'classInstanceVariableNames: ';
		store: self classInstanceVariablesString;
		cr; tab;
		nextPutAll: 'poolDictionaries: ';
		store: self poolDictionariesString;
		cr; tab;
		nextPutAll: 'category: ';
		store: self category.

	^ aStream contents! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
category
	^ category! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
category: anObject
	category := anObject! !

!SVNClass methodsFor: 'storing' stamp: 'rt 5/9/2008 18:48'!
classDetailsDictionary

	^ Dictionary new
		at: self nameForSuperclassProperty 				put: self superclassName asString;
		at: self nameForCategoryProperty 				put: self category asString;
		at: self nameForPoolDictionariesProperty 		put: self poolDictionariesString;
		at: self nameForInstanceVariablesProperty 		put: self instanceVariablesString;
		at: self nameForClassVariablesProperty 			put: self classVariablesString;
		at: self nameForClassInstanceVariablesProperty 	put: self classInstanceVariablesString;
		at: self nameForCommentFile 					put: self comment;
		at: self nameForIsVersionedProperty 				put: self isVersioned asString;
		yourself.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classInstanceVariables
	^ classInstanceVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classInstanceVariables: anObject
	classInstanceVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/24/2008 00:00'!
classInstanceVariablesString

	^ self stringFromCollection: self classInstanceVariables.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classVariables
	^ classVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classVariables: anObject
	classVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/24/2008 00:00'!
classVariablesString

	^ self stringFromCollection: self classVariables.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
comment
	^ comment! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
comment: anObject
	comment := anObject! !

!SVNClass methodsFor: 'svn functions' stamp: 'rkrk 4/20/2008 22:42'!
commit

	self
		commitWithMessage: 'empty commit message';
		changed.! !

!SVNClass methodsFor: 'derived accessing' stamp: 'mu 3/31/2008 13:32'!
directory

	^ self svnDirectoryEntry! !

!SVNClass methodsFor: 'derived accessing' stamp: 'mu 3/31/2008 13:32'!
directory: aSVNDirectory

	self svnDirectoryEntry: aSVNDirectory! !

!SVNClass methodsFor: 'comparing' stamp: 'rkrk 5/13/2008 02:11'!
equals: other

	self species = other species ifFalse: [^ false].
	^ self superclassName = other superclassName
		and: [self instanceVariables = other instanceVariables]
		and: [self classVariables = other classVariables]
		and: [self classInstanceVariables = other classInstanceVariables]
		and: [self poolDictionaries = other poolDictionaries].
	"
		[self comment = other comment]) ifFalse: [^ false].
	^  self category = other category and:"
		! !

!SVNClass methodsFor: 'initialize-release' stamp: 'pe 4/14/2008 15:08'!
establishSvnFilesAndDirectories
	
	self directory ifNil: [self directory: (SVNDirectory named: self theName)].	
	self directory
		createSubDirectoryNamed: 'instance';
		createSubDirectoryNamed: 'class'.
	
	self flag: #TODO. "Is this necessary... can this be expressed better? .. see #store"
	self classDetailsDictionary keysAndValuesDo: [:fileName :content |
		self directory
			createFileNamed: fileName
			withContent: content].! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/14/2008 18:58'!
extractCategoryFrom: aSVNDirectory

	^ (aSVNDirectory getFileNamed: self nameForCategoryProperty) content asSymbol! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:02'!
extractClassVarsFrom: aSVNDirectory
	
	^ ((aSVNDirectory getFileNamed: self nameForClassVariablesProperty) content substrings collect: [:each | each asSymbol]) asSet! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:00'!
extractInstVarsFrom: aSVNDirectory

	^ (aSVNDirectory getFileNamed: self nameForInstanceVariablesProperty) content substrings! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 5/9/2008 18:56'!
extractIsVersionedFrom: aSVNDirectory
	
	(aSVNDirectory getFileNamed: self nameForIsVersionedProperty) content = 'true'
		ifTrue: [^ true]
		ifFalse: [^ false]
	! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:02'!
extractMetaInstVarsFrom: aSVNDirectory

	^ (aSVNDirectory getFileNamed: self nameForClassInstanceVariablesProperty) content substrings! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:37'!
extractPoolDictionariesFrom: aSVNDirectory
	
	^ (aSVNDirectory getFileNamed: self nameForPoolDictionariesProperty) content substrings asOrderedCollection! !

!SVNClass methodsFor: 'extracting' stamp: 'rt 3/12/2008 12:36'!
extractSuperclassFrom: aSVNDirectory
	
	^ (aSVNDirectory getFileNamed: self nameForSuperclassProperty) content! !

!SVNClass methodsFor: 'initialize-release' stamp: 'rt 5/9/2008 15:11'!
forExistingClass: aClass

	self forExistingClassWithoutItsMethods: aClass.

	"Can't use #union or #addAll here because dicts would be merged in a strange way??"
	aClass class methodDict do: [:each |
		self addMethod: (SVNMethod forExistingMethod: each)].	
	aClass methodDict do: [:each |
		self addMethod: (SVNMethod forExistingMethod: each)].
	self changed.! !

!SVNClass methodsFor: 'initialize-release' stamp: 'rt 5/9/2008 15:11'!
forExistingClassWithoutItsMethods: aClass

	self
		theName: aClass name asString;
		superclassName: aClass superclass name asString;
		instanceVariables: aClass instVarNames;
		classVariables: aClass classVarNames;
		classInstanceVariables: aClass class instVarNames;
		poolDictionaries: aClass poolDictionaryNames;
		comment: aClass comment;
		category: aClass category;
		isVersioned: true.

	self establishSvnFilesAndDirectories.
	self changed.! !

!SVNClass methodsFor: 'comparing' stamp: 'rkrk 2/24/2008 13:29'!
hash

	^ self theName hash! !

!SVNClass methodsFor: 'initialize-release' stamp: 'rkrk 4/20/2008 22:44'!
initialize

	super initialize.
	self
		versionedMethods: Set new;
		subclasses: Set new.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
instanceVariables
	^ instanceVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
instanceVariables: anObject
	instanceVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 23:59'!
instanceVariablesString

	^ self stringFromCollection: self instanceVariables.! !

!SVNClass methodsFor: 'testing' stamp: 'rkrk 4/20/2008 22:58'!
isIncludedInEnvironment: svnEnvironment

	^ (svnEnvironment findSvnClassFor: self) notNil! !

!SVNClass methodsFor: 'testing' stamp: 'rkrk 4/15/2008 04:25'!
isIncludedInProject: svnProject


	^ svnProject versionedClasses includes: self! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 5/9/2008 15:00'!
isVersioned

	^ isVersioned! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 5/9/2008 15:01'!
isVersioned: aBool

	isVersioned := aBool! !

!SVNClass methodsFor: 'modifying the system' stamp: 'rkrk 5/13/2008 06:44'!
load
	
	self poolDictionaries do: [:each | Smalltalk at: each asSymbol ifAbsentPut: Dictionary new].
	(Smalltalk classNamed: self theName asSymbol)
		ifNotNil: [self reloadClass]
		ifNil: [self loadAsNewClass].
			
	self versionedMethods do: [:each | each load].
	self removeUnversionedMethods.
	self subclasses do: [:each | each load].
	self changed.! !

!SVNClass methodsFor: 'modifying the system' stamp: 'rkrk 3/31/2008 23:37'!
loadAsNewClass

	| superclass |
	self assert: self theClass isNil.	
	superclass := Smalltalk classNamed: self superclassName.
	self assert: superclass notNil.
	superclass
		subclass: self theName asSymbol
		instanceVariableNames: self instanceVariablesString
		classVariableNames: self classVariablesString
		poolDictionaries: self poolDictionariesString
		category: self category.
	self theClass classSide instanceVariableNames: self classInstanceVariablesString.
	self theClass comment: self comment.
! !

!SVNClass methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 06:11'!
localRevisionNumber

	| dirEntries |
	self flag: #TODO.
	dirEntries := self directory files union: self directory subdirectories.
	dirEntries add: self directory.
	^ dirEntries collect: [:ea | ea svnInfo lastChangedRevision number]! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rkrk 4/1/2008 18:12'!
nameForCategoryProperty

	^ 'category'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 2/29/2008 02:16'!
nameForClassInstanceVariablesProperty
	^ 'classInstanceVariables'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 2/29/2008 02:17'!
nameForClassVariablesProperty
	^ 'classVariables'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rkrk 2/23/2008 12:03'!
nameForCommentFile

	^ 'comment'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 2/29/2008 02:17'!
nameForInstanceVariablesProperty
	^ 'instanceVariables'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 5/9/2008 18:46'!
nameForIsVersionedProperty

	^ 'isVersioned'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 3/9/2008 16:45'!
nameForPoolDictionariesProperty
	^'poolDictionaries'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rt 2/29/2008 02:05'!
nameForSuperclassProperty
	^'superclass'! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/9/2008 16:40'!
poolDictionaries

	^poolDictionaries! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/9/2008 16:40'!
poolDictionaries: anObject

	poolDictionaries := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rt 3/9/2008 16:46'!
poolDictionariesString

	^ self stringFromCollection: self poolDictionaries.! !

!SVNClass methodsFor: 'printing' stamp: 'rkrk 2/23/2008 23:52'!
printOn: aStream

	super printOn: aStream.
	aStream	nextPut: $(.
	self theName printOn: aStream.
	aStream nextPut: $).! !

!SVNClass methodsFor: 'modifying the system' stamp: 'rkrk 5/13/2008 06:53'!
reloadClass

	| class newVars varsToRemove |		
	class := Smalltalk classNamed: self theName asSymbol.
	self assert: class notNil.
	
	"superclass"
	class superclass: (Smalltalk classNamed: self superclassName).
	
	"instVars"
	newVars := self instanceVariables asOrderedCollection copy.
	newVars removeAllFoundIn: class instVarNames.
	newVars do: [:newInstVar |
		class addInstVarName: newInstVar].
	varsToRemove := class instVarNames asOrderedCollection copy.
	varsToRemove removeAllFoundIn: self instanceVariables asOrderedCollection.
	varsToRemove do: [:removeInstVar |
		class removeInstVarName: removeInstVar].
	
	"classVars"
	newVars := self classVariables asOrderedCollection copy.
	newVars removeAllFoundIn: class classVarNames.
	newVars do: [:newClassVar |
		class addClassVarName: newClassVar].
	varsToRemove := class classVarNames asOrderedCollection copy.
	varsToRemove removeAllFoundIn: self classVariables asOrderedCollection.
	varsToRemove do: [:removeClassVar |
		class removeClassVarName: removeClassVar].
	
	"pools"
	newVars := self poolDictionaries asOrderedCollection copy.
	newVars removeAllFoundIn: class poolDictionaryNames.
	newVars do: [:newPoolDictionary |
		class addSharedPool: (Smalltalk at: newPoolDictionary asSymbol)].
	"varsToRemove := class poolDictionaryNames copy.
	varsToRemove removeAllFoundIn: self poolDictionaries asOrderedCollection.
	varsToRemove do: [:removeClassVar |
		class removeClassVarName: removeClassVar]."
	
	"classInstVars"
	newVars := self classInstanceVariables asOrderedCollection copy.
	newVars removeAllFoundIn: class class instVarNames.
	newVars do: [:newClassInstVar |
		class class addInstVarName: newClassInstVar].
	varsToRemove := class class instVarNames asOrderedCollection copy.
	varsToRemove removeAllFoundIn: self classInstanceVariables asOrderedCollection.
	varsToRemove do: [:removeClassInstVar |
		class class removeInstVarName: removeClassInstVar].

	"category"
	class category: self category.
	
	"comment"
	class comment: self comment.! !

!SVNClass methodsFor: 'removing' stamp: 'rt 5/12/2008 16:28'!
removeAllUnversionedItems

	self versionedMethods
		select: [:method | method stillUnderVersionControl not]
		thenDo: [:unversionedMethod | self removeSVNMethod: unversionedMethod].! !

!SVNClass methodsFor: 'removing' stamp: 'rt 5/11/2008 23:35'!
removeFromParent

	self parent ifNotNil: [self parent removeSVNClass: self].! !

!SVNClass methodsFor: 'removing' stamp: 'rt 5/12/2008 16:52'!
removeSVNMethod: svnMethod

	| methodDirectory |
	svnMethod remove.
	self versionedMethods remove: svnMethod.
	self flag: #TODO. "..."
	methodDirectory := self directory getSubDirectoryNamed: (svnMethod isPartOfMetaclass
			ifTrue: ['class']
			ifFalse: ['instance']).
	methodDirectory ifNotNil: [methodDirectory removeSVNFile: svnMethod file].
	(self isVersioned not and: [self versionedMethods isEmpty]) ifTrue: [self removeFromParent].
	self changed.! !

!SVNClass methodsFor: 'removing' stamp: 'rt 3/25/2008 19:34'!
removeUnversionedMethods

	| class methodsToRemove metaClass |
	self flag: #TODO. "just for testLoadingAExistingClassWithoutAMethodShouldRemoveTheMethod"
	self flag: #TODO. "if we need this put it to reloadClass"
	
	class := (Smalltalk classNamed: self theName asSymbol).
	methodsToRemove := class methodDict keys.
	methodsToRemove removeAll: ((self versionedMethods
		select: [:instanceMethod | instanceMethod isPartOfMetaclass not])
			collect: [:versionedMethod | versionedMethod methodSelector asSymbol]).
	methodsToRemove do: [:removeMeMethod | class removeSelectorSilently: removeMeMethod asSymbol].
	
	metaClass := class class.
	methodsToRemove := metaClass methodDict keys.
	methodsToRemove removeAll: ((self versionedMethods
		select: [:classMethod | classMethod isPartOfMetaclass])
			collect: [:versionedMethod | versionedMethod methodSelector asSymbol]).
	methodsToRemove do: [:removeMeMethod | metaClass removeSelectorSilently: removeMeMethod asSymbol].! !

!SVNClass methodsFor: 'as yet unclassified' stamp: 'mu 4/23/2008 15:04'!
renameSVNClass: aString! !

!SVNClass methodsFor: 'restoring' stamp: 'rkrk 4/21/2008 01:06'!
restore

	super restore.
	self
		theName: self directory theName;
		restoreClassDetails;
		restoreMethods;
		comment: (self directory getFileNamed: self nameForCommentFile) content.! !

!SVNClass methodsFor: 'restoring' stamp: 'rt 5/9/2008 18:49'!
restoreClassDetails

	self
		superclassName: (self extractSuperclassFrom: self directory);
		instanceVariables: (self extractInstVarsFrom: self directory);
		classVariables: (self extractClassVarsFrom: self directory);
		classInstanceVariables: (self extractMetaInstVarsFrom: self directory);
		poolDictionaries: (self extractPoolDictionariesFrom: self directory);
		category: (self extractCategoryFrom: self directory);
		isVersioned: (self extractIsVersionedFrom: self directory).! !

!SVNClass methodsFor: 'restoring' stamp: 'rkrk 4/28/2008 03:59'!
restoreMethods

	| allMethodFiles |
	allMethodFiles := self directory subdirectories gather: [:subDir | subDir files].
	 self versionedMethods
		select: [:ea | (allMethodFiles includes: ea file) not]
		thenDo: [:ea | self removeSVNMethod: ea].
	allMethodFiles do: [:file |
		self addMethod: (SVNMethod restoreFrom: file)].
	self changed.! !

!SVNClass methodsFor: 'svn state' stamp: 'cop 4/22/2008 13:44'!
statusClassMethods
	^self statusMethodsFor: 'class'! !

!SVNClass methodsFor: 'svn state' stamp: 'rkrk 4/22/2008 17:24'!
statusComment

	^ (self directory getFileNamed: 'comment')
		ifNil: [#none]
		ifNotNilDo: [:commentFile | commentFile status statusKind].! !

!SVNClass methodsFor: 'svn state' stamp: 'cop 4/22/2008 13:44'!
statusInstanceMethods
	^self statusMethodsFor: 'instance'! !

!SVNClass methodsFor: 'svn state' stamp: 'cop 4/29/2008 14:43'!
statusMethodsFor: aString 
	| statusKind myStatus |
	statusKind := (svnDirectoryEntry subdirectories 
		detect: [ :ea | ea theName = aString ]
		ifNone: [ ^ #none ]) status statusKind.
	statusKind = #conflicted ifTrue: [^#conflicted].
	myStatus := svnDirectoryEntry myStatus statusKind.
	(self keyForStatus: statusKind) > (self keyForStatus: myStatus) ifTrue: [ ^ #modified ].
	^ statusKind! !

!SVNClass methodsFor: 'storing' stamp: 'cop 4/22/2008 14:54'!
store

	self versionedMethods do: [:each | each store].
	self classDetailsDictionary keysAndValuesDo: [:fileName :content |
		self directory
			createFileNamed: fileName
			withContent: content].! !

!SVNClass methodsFor: 'convenience' stamp: 'rkrk 2/23/2008 23:59'!
stringFromCollection: aCol

	^ String streamContents: [:s | aCol asStringOn: s delimiter: ' ']! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/7/2008 17:16'!
subclasses

	^subclasses! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/7/2008 17:14'!
subclasses: anObject

	subclasses := anObject asSet! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
superclassName
	^ superclassName! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
superclassName: anObject
	superclassName := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 3/31/2008 23:36'!
theClass

	^ Smalltalk classNamed: self theName! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/9/2008 01:13'!
versionedMethods
	
	^ versionedMethods! !

!SVNClass methodsFor: 'accessing' stamp: 'rt 3/8/2008 22:08'!
versionedMethods: anObject

	versionedMethods := anObject asSet! !

!SVNElement class methodsFor: 'instance creation' stamp: 'rkrk 4/21/2008 00:18'!
restoreFrom: aSVNDirectoryEntry
	
	^ self new
		svnDirectoryEntry: aSVNDirectoryEntry;
		restore;
		yourself.! !

!SVNElement methodsFor: 'comparing' stamp: 'rkrk 3/1/2008 01:40'!
= other

	self species = other species ifFalse: [^ false].
	^ self theName = other theName
! !

!SVNElement methodsFor: 'converting' stamp: 'rkrk 5/13/2008 02:36'!
asString

	self subclassResponsibility! !

!SVNElement methodsFor: 'svn functions' stamp: 'rkrk 4/27/2008 22:47'!
commit

	self commitWithMessage: 'No commit message'.! !

!SVNElement methodsFor: 'svn functions' stamp: 'rkrk 4/20/2008 22:40'!
commitWithMessage: aString

	self store.
	self svnDirectoryEntry commitWithMessage:aString.
	self changed.
	self flag: #TODO.! !

!SVNElement methodsFor: 'svn functions' stamp: 'cop 5/8/2008 17:21'!
diffSummary

	^self diffSummaryFrom: SVNRevision working To: SVNRevision head! !

!SVNElement methodsFor: 'svn functions' stamp: 'cop 5/10/2008 18:34'!
diffSummaryFrom: startRev

	^self svnDirectoryEntry diffSummaryFrom: startRev To: SVNRevision head! !

!SVNElement methodsFor: 'svn functions' stamp: 'cop 5/8/2008 17:19'!
diffSummaryFrom: startRev To: endRev

	^self svnDirectoryEntry diffSummaryFrom: startRev To: endRev! !

!SVNElement methodsFor: 'svn functions' stamp: 'rkrk 5/5/2008 00:30'!
dismissRevisionInfos

	self revisionInfos: nil! !

!SVNElement methodsFor: 'initialization' stamp: 'rkrk 4/1/2008 17:00'!
establishSvnFilesAndDirectories

	self subclassResponsibility.! !

!SVNElement methodsFor: 'comparing' stamp: 'rkrk 3/31/2008 23:35'!
hash

	^ self theName hash! !

!SVNElement methodsFor: 'initialization' stamp: 'rkrk 4/1/2008 17:44'!
initialize

	super initialize.
	self theName: String new.! !

!SVNElement methodsFor: 'svn state' stamp: 'cop 4/29/2008 15:43'!
isConflicted
	
	^self svnDirectoryEntry isConflicted! !

!SVNElement methodsFor: 'testing' stamp: 'rkrk 4/14/2008 04:04'!
isIncludedInEnvironment: svnEnvironment

	^ false! !

!SVNElement methodsFor: 'testing' stamp: 'rt 5/12/2008 18:11'!
isIncludedInProject: svnProject

	^ false! !

!SVNElement methodsFor: 'svn state' stamp: 'cop 5/10/2008 20:20'!
isModified
	
	^self svnDirectoryEntry isModified! !

!SVNElement methodsFor: 'svn state' stamp: 'rt 5/9/2008 13:39'!
keyForStatus: aSelector

	^ SVNStatusRequest statusKindDictionary keyForIdentity: aSelector! !

!SVNElement methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 06:10'!
localRevisionNumber

	^ {self svnDirectoryEntry svnInfo lastChangedRevision number}! !

!SVNElement methodsFor: 'accessing' stamp: 'rt 5/9/2008 14:30'!
parent

	^ parent! !

!SVNElement methodsFor: 'accessing' stamp: 'rt 5/9/2008 14:30'!
parent: svnElement

	parent := svnElement! !

!SVNElement methodsFor: 'removing' stamp: 'rkrk 4/20/2008 22:40'!
remove

	(self svnDirectoryEntry) ifNil: [^ self].
	self svnDirectoryEntry remove.
	self changed.! !

!SVNElement methodsFor: 'removing' stamp: 'rt 5/12/2008 17:41'!
removeAllUnversionedItems
	"Remove all unversioned SVNMethods and SVNClasses from the SVNElement.
	A SVNMethod hasn't any SVNClass or SVNMethod."! !

!SVNElement methodsFor: 'removing' stamp: 'rt 5/12/2008 17:41'!
removeFromParent
	"Remove the SVNElement from it's parent. SVNProjects haven't any parent."! !

!SVNElement methodsFor: 'conflict solving' stamp: 'cop 4/29/2008 15:18'!
resolved

	self svnDirectoryEntry resolved! !

!SVNElement methodsFor: 'restoring' stamp: 'rkrk 4/21/2008 00:56'!
restore

	"Hmm... is that good? If we do that than we have to be consistent
	regarding #store. So move serializing into filesystem	into SVNElements?"
	self svnDirectoryEntry read.
	! !

!SVNElement methodsFor: 'convenience' stamp: 'rt 5/12/2008 16:24'!
restoreAndLoad

	self stillUnderVersionControl
		ifTrue: [self isConflicted ifFalse: [
			self
				removeAllUnversionedItems;
				restore;
				load]]
		ifFalse: [self removeFromParent].
	self changed.
	! !

!SVNElement methodsFor: 'svn functions' stamp: 'rkrk 4/20/2008 22:40'!
revert

	self svnDirectoryEntry revert.
	self restoreAndLoad.! !

!SVNElement methodsFor: 'svn functions' stamp: 'rkrk 5/4/2008 21:51'!
revisionInfos

	revisionInfos ifNil: [
		revisionInfos := (SVNRevisionInfosRequest target: self svnDirectoryEntry)
			execute;
			commitLogs].
	^ revisionInfos! !

!SVNElement methodsFor: 'accessing' stamp: 'rkrk 5/4/2008 21:45'!
revisionInfos: aCollectionOfSVNRevisionInfos

	revisionInfos := aCollectionOfSVNRevisionInfos! !

!SVNElement methodsFor: 'svn state' stamp: 'rt 5/9/2008 18:17'!
status
	| statusKind myStatus |
	myStatus := self svnDirectoryEntry myStatus statusKind.
	( {#added. #missing. #deleted} includes: myStatus ) ifTrue: [^ myStatus].
	
	statusKind := self svnDirectoryEntry status statusKind.
	statusKind = #conflicted ifTrue: [^#conflicted].
	
	(SVNStatusRequest highestStatusOf: {statusKind. myStatus}) = myStatus
		ifFalse: [^ #modified]
		ifTrue: [^ statusKind].! !

!SVNElement methodsFor: 'system state' stamp: 'rt 5/11/2008 21:45'!
stillUnderVersionControl

	^ self svnDirectoryEntry stillUnderVersionControl! !

!SVNElement methodsFor: 'storing' stamp: 'rkrk 4/21/2008 00:56'!
store! !

!SVNElement methodsFor: 'accessing' stamp: 'rt 3/14/2008 14:10'!
svnDirectoryEntry

	^ svnDirectoryEntry! !

!SVNElement methodsFor: 'accessing' stamp: 'rt 3/14/2008 14:10'!
svnDirectoryEntry: aSVNDirectoryEntry

	svnDirectoryEntry := aSVNDirectoryEntry! !

!SVNElement methodsFor: 'svn functions' stamp: 'rkrk 5/4/2008 20:35'!
svnInfo

	^ self svnDirectoryEntry svnInfo.! !

!SVNElement methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 00:36'!
theName

	self assert: theName isString.
	^ theName asString! !

!SVNElement methodsFor: 'accessing' stamp: 'rkrk 3/5/2008 20:43'!
theName: anObject
	theName := anObject asString! !

!SVNElement methodsFor: 'svn functions' stamp: 'rkrk 4/21/2008 00:16'!
update

	self svnDirectoryEntry update.
	self restoreAndLoad.	! !

!SVNElement methodsFor: 'svn functions' stamp: 'rkrk 5/13/2008 06:54'!
updateToRevision: svnRevision

	self svnDirectoryEntry updateToRevision: svnRevision.
	self restoreAndLoad.	! !

SVNElement subclass: #SVNMethod
	instanceVariableNames: 'nameOfClass category source timeStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNMethod class methodsFor: 'instance creation' stamp: 'rkrk 4/1/2008 17:50'!
forExistingMethod: aCompiledMethod 
	
	^ self new
		forExistingMethod: aCompiledMethod;
		establishSvnFilesAndDirectories;
		yourself! !

!SVNMethod methodsFor: 'comparing' stamp: 'pe 4/14/2008 14:14'!
= otherMethod

	self species = otherMethod species ifFalse: [^ false].
	^ self methodSelector = otherMethod methodSelector and: 
		[self nameOfClass = otherMethod nameOfClass]! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'rkrk 5/13/2008 05:53'!
allElements

	^ (OrderedCollection with: self)! !

!SVNMethod methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 02:37'!
asString

	^ self source! !

!SVNMethod methodsFor: 'svn functions' stamp: 'rkrk 5/10/2008 18:23'!
blame

	^ self file blame.! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
category
	^ category! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
category: anObject
	category := anObject! !

!SVNMethod methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 03:33'!
equals: other

	self species = other species ifFalse: [^ false].
	^ self source = other source
		and: [self timeStamp = other timeStamp]! !

!SVNMethod methodsFor: 'initialization' stamp: 'rkrk 4/21/2008 00:39'!
establishSvnFilesAndDirectories

	"create"
	self file: (SVNFile
		named: self theName
		basePath: '').
	"synch. Put synch in own method? Two way?"
	self flag: #TODO. "This is a store. So call it!!"
	self file content: self source.
	self file properties
		at: self nameForClassProperty put: self nameOfClass;
		at: self nameForCategoryProperty put: self category;
		at: self nameForTimeStampProperty put: self timeStamp.! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:00'!
extractCategoryFrom: svnFile

	^ svnFile properties at: self nameForCategoryProperty! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:01'!
extractClassFrom: svnFile

	^ svnFile properties at: self nameForClassProperty! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 01:58'!
extractSourceCodeFrom: svnFile

	^ svnFile content! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:01'!
extractTimeStampFrom: svnFile

	^ svnFile properties at: self nameForTimeStampProperty! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'rt 3/14/2008 14:18'!
file

	^ self svnDirectoryEntry! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'rt 3/14/2008 14:18'!
file: aSVNFile

	self svnDirectoryEntry: aSVNFile! !

!SVNMethod methodsFor: 'initialization' stamp: 'rkrk 4/20/2008 23:01'!
forExistingMethod: aCompiledMethod

	| methodReference |
	methodReference := aCompiledMethod methodReference.
	self
		methodSelector: methodReference methodSymbol;
		nameOfClass: methodReference actualClass name;
		category: methodReference category;
		source: methodReference source;
		timeStamp: methodReference timeStamp.! !

!SVNMethod methodsFor: 'comparing' stamp: 'pe 4/14/2008 14:15'!
hash

	^ self methodSelector hash bitXor: self nameOfClass hash.! !

!SVNMethod methodsFor: 'initialization' stamp: 'rkrk 4/27/2008 05:18'!
initialize
	
	super initialize.
	self
		theName: String new; "hmm SVNProject tests fail when theName is not set here... although it is done in super.."
		nameOfClass: String new;
		timeStamp: String new;
		methodSelector: String new;
		source: String new;
		category: String new;
		establishSvnFilesAndDirectories.! !

!SVNMethod methodsFor: 'testing' stamp: 'rkrk 4/15/2008 04:51'!
isIncludedInProject: svnProject


	^ svnProject allVersionedMethods includes: self! !

!SVNMethod methodsFor: 'testing' stamp: 'rkrk 4/1/2008 04:14'!
isPartOfMetaclass

	self flag: #TODO.
	^ (Smalltalk hasClassNamed: self nameOfClass)
		ifTrue: [(Smalltalk classNamed: self nameOfClass) isMeta]
		ifFalse: [self nameOfClass endsWith: ' class'].! !

!SVNMethod methodsFor: 'modifying the system' stamp: 'rkrk 4/20/2008 23:01'!
load
	
	| class relatedSystemEntry |
	"find the correct class"
	relatedSystemEntry := Smalltalk at: self nameOfClass substrings first asSymbol.
	
	class := self isPartOfMetaclass
		ifTrue: [relatedSystemEntry class]
		ifFalse: [relatedSystemEntry].
		
	class
		compile: self source
		classified: self category
		withStamp: self timeStamp
		notifying: nil.
		
	self changed.! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:28'!
methodSelector

	^ self theName! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:28'!
methodSelector: aString

	self theName: aString! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:00'!
nameForCategoryProperty
	^ 'category'! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:01'!
nameForClassProperty
	^ 'class'! !

!SVNMethod methodsFor: 'file system mapping' stamp: 'rkrk 2/24/2008 02:01'!
nameForTimeStampProperty
	^ 'timestamp'! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:27'!
nameOfClass
	^ nameOfClass! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:27'!
nameOfClass: anObject
	nameOfClass := anObject! !

!SVNMethod methodsFor: 'printing' stamp: 'rkrk 2/24/2008 02:29'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self nameOfClass;
		nextPutAll: '>>';
		nextPutAll: self methodSelector;
		nextPut: $).! !

!SVNMethod methodsFor: 'removing' stamp: 'rt 5/11/2008 23:35'!
removeFromParent

	self parent ifNotNil: [self parent removeSVNMethod: self].! !

!SVNMethod methodsFor: 'restoring' stamp: 'rkrk 4/21/2008 00:37'!
restore

	super restore.
	self
		methodSelector: self file theName asString;
		category: (self extractCategoryFrom: self file);
		source: (self extractSourceCodeFrom: self file);
		nameOfClass: (self extractClassFrom: self file);
		timeStamp: (self extractTimeStampFrom: self file).! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
source
	^ source! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
source: anObject
	source := anObject! !

!SVNMethod methodsFor: 'svn state' stamp: 'rt 5/12/2008 18:06'!
status

	^ self svnDirectoryEntry status statusKind! !

!SVNMethod methodsFor: 'storing' stamp: 'rkrk 4/1/2008 02:26'!
store
	
	self file content: self source.
	self file properties
		at: self nameForClassProperty put: self nameOfClass;
		at: self nameForCategoryProperty put: self category;
		at: self nameForTimeStampProperty put: self timeStamp.! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
timeStamp
	^ timeStamp! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/24/2008 01:25'!
timeStamp: anObject
	timeStamp := anObject! !

SVNElement subclass: #SVNProject
	instanceVariableNames: 'repository allSvnClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNProject class methodsFor: 'instance creation' stamp: 'rkrk 5/5/2008 15:01'!
checkoutProject: aName fromRepository: svnRepository toWorkingCopy: aSVNDirectory 

	| projectDir |
	self assert: svnRepository exists.
	projectDir := aSVNDirectory createSubDirectoryNamed: aName.
	svnRepository createProject: aName.
	self assert: (svnRepository projectExists: aName).
	
	^ self new
		svnRepository: svnRepository;
		directory: projectDir;
		theName: aName;
		checkout;
		yourself.! !

!SVNProject class methodsFor: 'instance creation' stamp: 'rt 4/29/2008 10:34'!
checkoutProject: aName fromURL: url inWorkingCopy: aSVNDirectory 
	
	| repository |
	repository := SVNRepository on: url.
	repository ifNil: [^ SVNErrorCatcher new onRepositoryDoesNotExists].
	^ self checkoutProject: aName fromRepository: repository toWorkingCopy: aSVNDirectory! !

!SVNProject class methodsFor: 'instance creation' stamp: 'rkrk 4/1/2008 17:44'!
named: aString 
	
	^ self new
		theName: aString;
		establishSvnFilesAndDirectories;
		yourself.! !

!SVNProject class methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 05:06'!
readFromUrl: urlString named: aName revision: svnRevision

	| projectDir url |
	self flag: #TODO. "This does not belong here"
	url := urlString.
	(urlString endsWith: '/') ifTrue: [url := urlString first: urlString size - 1].
	(url endsWith: aName) ifTrue: [url := urlString first: urlString size - (aName size + 1)].
	projectDir := SVNRepositoryDirectory
		named: aName
		basePath: url pathForSvn
		revision: svnRevision.
	projectDir read.
	^ self new
		svnRepository: (SVNRepository on: url);
		directory: projectDir;
		restore;
		yourself.! !

!SVNProject methodsFor: 'comparing' stamp: 'rkrk 3/1/2008 01:50'!
= other

	super = other ifFalse: [^ false].
	^ self versionedClasses = other versionedClasses and:
		[self versionedMethods = other versionedMethods].! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 4/27/2008 04:49'!
addCategory: categoryString

	(Smalltalk organization listAtCategoryNamed: categoryString)
		collect: [:classSymbol | Smalltalk at: classSymbol] 
		thenDo: [:class | self addClass: class].! !

!SVNProject methodsFor: 'adding' stamp: 'cop 4/24/2008 10:17'!
addClass: aClass

	self addSVNClass: (SVNClass forExistingClass: aClass).! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 4/29/2008 21:15'!
addMethod: aMethod 
	
	self flag: #TODO.
	self projectDirectory ifNil: [self error: 'No working copy path specified.'].
	self addSvnMethod: (SVNMethod forExistingMethod: aMethod).! !

!SVNProject methodsFor: 'adding' stamp: 'rt 5/9/2008 17:51'!
addSVNClass: svnClass

	self flag: #TODO. "Refactor. Code below is hard to read"
	self projectDirectory ifNil: [self error: 'No working copy path specified.'].
	svnClass parent: self.
	
	self allClasses copy
		select: [:ea | ea theName asString = svnClass theName asString]
		thenDo: [:alreadyExistingClass | self allClasses remove: alreadyExistingClass].
	self projectDirectory addSubdirectory: svnClass directory.
	self allClasses add: svnClass.
	self store.
	self changed.! !

!SVNProject methodsFor: 'adding' stamp: 'rt 5/12/2008 17:46'!
addSvnMethod: svnMethod 

	| svnClass |
	svnClass := self allClasses
		detect: [:cl | cl theName = svnMethod nameOfClass asString]
		ifNone: [(SVNClass forExistingClassWithoutItsMethods: (Smalltalk
			classNamed: svnMethod nameOfClass asSymbol))
				isVersioned: false;
				yourself].
	svnClass addMethod: svnMethod.
	self addSVNClass: svnClass.
	self store.
	self changed.! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 5/9/2008 14:54'!
allClasses
	
	^ allSvnClasses! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 5/9/2008 14:53'!
allClasses: anObject

	allSvnClasses := anObject! !

!SVNProject methodsFor: 'derived accessing' stamp: 'rkrk 5/12/2008 23:32'!
allElements

	^ (OrderedCollection with: self)
		addAll: self allVersionedMethods;
		addAll: self versionedClasses;
		yourself.! !

!SVNProject methodsFor: 'derived accessing' stamp: 'rkrk 4/27/2008 05:20'!
allVersionedMethods
	
	^ self versionedClasses
		inject: self versionedMethods copy
		into: [:allMethods :class |
			allMethods
				addAll: class versionedMethods;
				yourself].! !

!SVNProject methodsFor: 'svn functions' stamp: 'rkrk 4/21/2008 00:20'!
checkout

	self projectDirectory checkoutFrom: self repositoryURL , '/' , self theName.
	self projectDirectory read.
	self restore.
	self changed.! !

!SVNProject methodsFor: 'svn functions' stamp: 'rkrk 4/21/2008 00:14'!
commit

	self commitWithMessage: 'empty commit message'.! !

!SVNProject methodsFor: 'removing' stamp: 'pe 4/17/2008 15:36'!
deleteClass: aClass
	
	self removeClass: aClass.
	(Smalltalk classNamed: aClass name asString) removeFromSystem.
	^aClass! !

!SVNProject methodsFor: 'removing' stamp: 'pe 4/17/2008 15:36'!
deleteMethod: aMethod

	self removeMethod: aMethod.
	(Smalltalk classNamed: aMethod sourceClass name) removeSelector: aMethod sourceSelector.
	^aMethod! !

!SVNProject methodsFor: 'derived accessing' stamp: 'cop 4/14/2008 11:18'!
directory

	self svnDirectoryEntry ifNil: [self svnDirectoryEntry: (SVNDirectory on: '')].
	^ self svnDirectoryEntry! !

!SVNProject methodsFor: 'derived accessing' stamp: 'rkrk 4/1/2008 16:41'!
directory: svnDirectory

	self svnDirectoryEntry: svnDirectory! !

!SVNProject methodsFor: 'initialization' stamp: 'rkrk 4/1/2008 17:01'!
establishSvnFilesAndDirectories

	self directory: (SVNDirectory named: self theName).! !

!SVNProject methodsFor: 'notifying' stamp: 'rkrk 4/15/2008 01:02'!
event: anEvent

	| method |
	self halt.
	(anEvent isRemoved and:
	[anEvent itemKind = #class])
		ifTrue: [(self versionedClasses includes: (SVNClass forExistingClass: anEvent itemClass))
				ifTrue: [self removeClass: anEvent itemClass]].

	(anEvent isRemoved and:
	[anEvent itemKind = #method])
		ifTrue: [method := self versionedMethods
							detect: [:each |
								(each methodSelector = anEvent itemSelector) and:
								[each nameOfClass = anEvent itemClass name]]
							ifNone: [nil].
				method ifNotNil: [self removeSVNMethod: method]]! !

!SVNProject methodsFor: 'finding' stamp: 'cop 4/18/2008 12:13'!
findClass: aString
	^self versionedClasses detect: [:class| class theName = aString] ifNone: [nil]! !

!SVNProject methodsFor: 'testing' stamp: 'rkrk 4/14/2008 11:57'!
includes: svnElement

	^ svnElement isIncludedInProject: self.! !

!SVNProject methodsFor: 'initialization' stamp: 'rt 5/9/2008 15:36'!
initialize

	super initialize.
	self
		allClasses: Set new;
		repositoryURL: nil.! !

!SVNProject methodsFor: 'modifying the system' stamp: 'cop 4/14/2008 21:10'!
load
	SVNLoader
		loadSVNClasses: self versionedClasses copy
		andSVNMethods: self versionedMethods copy! !

!SVNProject methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 06:11'!
localRevisionNumber

	| dirEntries |
	self flag: #TODO.
	dirEntries := self directory files union: self directory subdirectories.
	dirEntries add: self directory.
	^ dirEntries collect: [:ea | ea svnInfo lastChangedRevision number]! !

!SVNProject methodsFor: 'notifying' stamp: 'rkrk 4/17/2008 09:01'!
notifyAboutSystemModifications: aBoolean

	| notifier |
	notifier := SystemChangeNotifier uniqueInstance.
	aBoolean ifTrue: [self halt].
	aBoolean
		ifFalse: [notifier noMoreNotificationsFor: self]
		ifTrue: [
			notifier
				notify: self
				ofSystemChangesOfItem: #class
				using: #event:.
			notifier
				notify: self
				ofSystemChangesOfItem: #method
				using: #event:].! !

!SVNProject methodsFor: 'printing' stamp: 'rkrk 3/3/2008 20:30'!
printOn: aStream

	super printOn: aStream.
	aStream	nextPut: $(.
	self theName printOn: aStream.
	aStream nextPut: $).! !

!SVNProject methodsFor: 'derived accessing' stamp: 'rt 4/13/2008 18:35'!
projectDirectory

"	^ self workingCopyDirectory createSubDirectoryNamed: self theName."
	^ self directory! !

!SVNProject methodsFor: 'removing' stamp: 'rt 5/12/2008 17:42'!
removeAllUnversionedItems

	self versionedMethods
		select: [:method | method stillUnderVersionControl not]
		thenDo: [:unversionedMethod | self removeSVNMethod: unversionedMethod].
	self versionedClasses
		select: [:class | class stillUnderVersionControl not]
		thenDo: [:unversionedClass | self removeSVNClass: unversionedClass].! !

!SVNProject methodsFor: 'removing' stamp: 'rt 3/13/2008 13:27'!
removeClass: aClass

	| svnClass |
	svnClass := SVNClass forExistingClass: aClass.
	self removeSVNClass: svnClass.
	^aClass! !

!SVNProject methodsFor: 'removing' stamp: 'rt 3/17/2008 11:15'!
removeMethod: aMethod

	| svnMethod |
	svnMethod := SVNMethod forExistingMethod: aMethod.
	self removeSVNMethod: svnMethod.
	^aMethod! !

!SVNProject methodsFor: 'removing' stamp: 'rt 5/9/2008 16:23'!
removeSVNClass: aSVNClass

	self allClasses remove: aSVNClass.
	self projectDirectory removeSVNDirectory: aSVNClass directory.
	aSVNClass remove. " Remove from filesystem"
	self changed.! !

!SVNProject methodsFor: 'removing' stamp: 'rt 5/12/2008 17:52'!
removeSVNMethod: aSVNMethod

	| svnClass |	
	svnClass := self allClasses
		detect: [:cl | cl theName = aSVNMethod nameOfClass]
		ifNone: [^ self].
	"This line remove the method from the class and, if necessary, the class from the project."
	svnClass removeSVNMethod: aSVNMethod.
	self changed.! !

!SVNProject methodsFor: 'testing' stamp: 'rkrk 5/3/2008 19:44'!
repositoryIsAvailable

	^ self svnRepository exists! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 4/13/2008 21:49'!
repositoryURL
	
	self svnRepository ifNil: [^''].
	^ self svnRepository url! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 4/29/2008 10:35'!
repositoryURL: anUrl

	anUrl ifNil: [^ self].
	(SVNRepository repositoryExistsOn: anUrl)
		ifFalse: [^ SVNErrorCatcher new onRepositoryDoesNotExists].
		
	self svnRepository: (SVNRepository on: anUrl).
	self svnRepository createProject: self theName.! !

!SVNProject methodsFor: 'restoring' stamp: 'rkrk 4/28/2008 03:38'!
restore
	
	super restore.
	self theName: self directory theName.
	"If I have classes which are not included in the directory from which
	I restore now, I will remove those classes."
	self versionedClasses
		select: [:ea | (self directory subdirectories includes: ea directory) not]
		thenDo: [:ea | self removeSVNClass: ea].
	self directory subdirectories do: [:each |
		self addSVNClass: (SVNClass restoreFrom: each)].
	self flag: #TODO. "Load methods of project"! !

!SVNProject methodsFor: 'svn state' stamp: 'rt 5/9/2008 18:16'!
statusProjectMethods

	| highestStatus statusKinds myStatus |
	self flag: #TODO. "Refactor!! find something better"
	myStatus := self directory myStatus statusKind.
	( {#added. #missing. #deleted} includes: myStatus ) ifTrue: [^ myStatus].
	
	statusKinds := self versionedMethods collect: [:method | method status].
	highestStatus := SVNStatusRequest highestStatusOf: statusKinds.
	
	(SVNStatusRequest highestStatusOf: {highestStatus. myStatus}) = myStatus
		ifFalse: [^ #modified]
		ifTrue: [^ highestStatus]! !

!SVNProject methodsFor: 'storing' stamp: 'rt 5/9/2008 15:29'!
store

	"self versionedMethods do: [:each | each store.].
	self versionedClasses do: [:each | each store]."
	self allClasses do: [:each | each store].

	"Now write files and directories"
	self projectDirectory store.! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 4/13/2008 17:47'!
svnRepository

	^ repository! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 4/13/2008 17:46'!
svnRepository: aSVNRepository

	repository := aSVNRepository! !

!SVNProject methodsFor: 'accessing' stamp: 'cop 4/14/2008 11:14'!
theName: aString
	super theName: aString.
	self directory theName: aString.! !

!SVNProject methodsFor: 'modifying the system' stamp: 'rkrk 2/25/2008 01:48'!
unload
	self flag: #TODO.! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 5/9/2008 14:54'!
versionedClasses
	
	^ self allClasses select: [:ea | ea isVersioned]! !

!SVNProject methodsFor: 'accessing' stamp: 'rt 5/12/2008 17:57'!
versionedMethods
	
	| methods |
	methods := Set new.
	self allClasses
		select: [:class | class isVersioned not]
		thenDo: [:unversionedClass | methods addAll: unversionedClass versionedMethods].
	^ methods! !

Object subclass: #SVNEnvironment
	instanceVariableNames: 'svnProjects currentProject'
	classVariableNames: 'CurrentSVNEnvironment'
	poolDictionaries: ''
	category: 'SqueakSVN-Environment'!

!SVNEnvironment class methodsFor: 'instance creation' stamp: 'rkrk 4/15/2008 01:57'!
forSvnProjects: collection

	^ self new
		svnProjects: collection;
		yourself.! !

!SVNEnvironment methodsFor: 'adding' stamp: 'rkrk 4/14/2008 21:38'!
addSvnProject: svnProject

	self svnProjects add: svnProject.! !

!SVNEnvironment methodsFor: 'derived accessing' stamp: 'rkrk 4/15/2008 02:01'!
allSvnClasses

	^ self svnProjects gather: [:ea | ea versionedClasses].! !

!SVNEnvironment methodsFor: 'derived accessing' stamp: 'rkrk 4/24/2008 12:02'!
allSvnMethods

	^ self svnProjects gather: [:ea | ea allVersionedMethods].! !

!SVNEnvironment methodsFor: 'for OB' stamp: 'rkrk 4/21/2008 09:49'!
currentProject
	^ currentProject! !

!SVNEnvironment methodsFor: 'for OB' stamp: 'rkrk 4/21/2008 09:49'!
currentProject: anObject
	currentProject := anObject! !

!SVNEnvironment methodsFor: 'for OB' stamp: 'rkrk 4/21/2008 09:50'!
currentSvnProjectChanged: aSVNCurrentProjectChangedAnn

	self currentProject: aSVNCurrentProjectChangedAnn currentProject! !

!SVNEnvironment methodsFor: 'finding' stamp: 'cop 4/22/2008 14:17'!
findSvnClassFor: aClass

	^ self allSvnClasses
		detect: [:ea | (ea theName = aClass name) or: [ea theName, ' class' = aClass name]]
		ifNone: [nil].! !

!SVNEnvironment methodsFor: 'finding' stamp: 'rkrk 4/14/2008 22:53'!
findSvnMethodForMethod: compiledMethod

	^ self findSvnMethodForMethodRef: compiledMethod methodReference.! !

!SVNEnvironment methodsFor: 'finding' stamp: 'rkrk 4/24/2008 12:03'!
findSvnMethodForMethodRef: methodRef

	^ self allSvnMethods
		detect: [:ea |
			ea nameOfClass asString = methodRef actualClass asString and:
				[ea theName = methodRef methodSymbol asString] and:
				[ea isPartOfMetaclass = methodRef classIsMeta]]
		ifNone: [nil].! !

!SVNEnvironment methodsFor: 'finding' stamp: 'rkrk 4/24/2008 13:00'!
findSvnMethodNamed: aStringOrSymbol

	^ self allSvnMethods
		detect: [:ea | ea theName = aStringOrSymbol asSymbol]
		ifNone: [nil].! !

!SVNEnvironment methodsFor: 'finding' stamp: 'rkrk 4/25/2008 15:48'!
findSvnProjectFor: svnElement

	"Kludge. Use double dispatch"
	self flag: #TODO.
	svnElement ifNil: [^ nil].
	(svnElement isKindOf: SVNProject) ifTrue: [^ svnElement].
	^ (svnElement isKindOf: SVNMethod)
		ifTrue: [
			self svnProjects
				detect: [:ea | ea allVersionedMethods includes: svnElement]
				ifNone: [nil]]
		ifFalse: [
			self svnProjects
				detect: [:ea | ea versionedClasses includes: svnElement]
				ifNone: [nil]].! !

!SVNEnvironment methodsFor: 'finding' stamp: 'rkrk 4/21/2008 10:43'!
findSvnProjectNamed: aString

	^ self svnProjects
		detect: [:ea | ea theName = aString]
		ifNone: [nil].! !

!SVNEnvironment methodsFor: 'finding' stamp: 'rkrk 4/15/2008 02:03'!
findSvnProjectOrSvnClassForSvnMethod: method

	| result |
	result := self svnProjects
		detect: [:ea | ea versionedMethods includes: method]
		ifNone: [nil].
	result ifNotNil: [^ result].
	^ self allSvnClasses
		detect: [:ea | ea versionedMethods includes: method]
		ifNone: [nil].! !

!SVNEnvironment methodsFor: 'testing' stamp: 'rkrk 4/14/2008 22:14'!
includes: anObject

	^ anObject includedInSvnEnvironment: self.! !

!SVNEnvironment methodsFor: 'initialization' stamp: 'rkrk 4/14/2008 21:40'!
initialize

	super initialize.
	self svnProjects: Set new.! !

!SVNEnvironment methodsFor: 'for OB' stamp: 'rkrk 4/21/2008 09:50'!
subscribeWithAnnouncer: anOBAnnouncer

	anOBAnnouncer
		observe: SVNCurrentProjectChanged
		send: #currentSvnProjectChanged:
		to: self.! !

!SVNEnvironment methodsFor: 'accessing' stamp: 'rkrk 4/14/2008 21:39'!
svnProjects
	^ svnProjects! !

!SVNEnvironment methodsFor: 'accessing' stamp: 'rkrk 4/14/2008 21:39'!
svnProjects: anObject
	svnProjects := anObject! !

SVNEnvironment subclass: #SVNRegistry
	instanceVariableNames: ''
	classVariableNames: 'Current CurrentSVNRegistry'
	poolDictionaries: ''
	category: 'SqueakSVN-Environment'!

!SVNRegistry class methodsFor: 'accessing' stamp: 'rkrk 4/25/2008 15:16'!
current

	CurrentSVNRegistry ifNil: [self initialize].
	^ CurrentSVNRegistry! !

!SVNRegistry class methodsFor: 'initialization' stamp: 'rkrk 4/25/2008 15:15'!
initialize

	"self initialize"
	CurrentSVNRegistry := self forSvnProjects: Set new.! !

!SVNRegistry class methodsFor: 'initialization' stamp: 'rkrk 4/26/2008 19:48'!
restart

	"self restart"
	| svnProjects |
	svnProjects := self current svnProjects.
	self initialize.
	self current svnProjects: svnProjects.! !

!SVNRegistry methodsFor: 'system change notification' stamp: 'rkrk 4/26/2008 19:49'!
classChanged: anEvent

	| svnClass |
	svnClass := self findSvnClassFor: anEvent oldItem.
	svnClass ifNil: [^ self].
	svnClass forExistingClass: anEvent item.
	(self findSvnProjectFor: svnClass)
		ifNotNilDo: [:project | project store. project changed.].
	svnClass changed.
! !

!SVNRegistry methodsFor: 'system change notification' stamp: 'rt 5/7/2008 18:11'!
classCommentChanged: anEvent

	| svnClass |
	svnClass := self findSvnClassFor: anEvent item.
	svnClass ifNil: [^ self].
	svnClass comment: anEvent item comment.
	(self findSvnProjectFor: svnClass)
		ifNotNilDo: [:project | project store. project changed.].
	svnClass changed.
! !

!SVNRegistry methodsFor: 'system change notification' stamp: 'rt 5/9/2008 16:23'!
classRemoved: anEvent

	| class container |
	self flag: #TODO. "under construction"
	class := self findSvnClassFor: anEvent item.
	class ifNil: [^ self].
	container := self findSvnProjectFor: class.
	container removeSVNClass: class.
	class remove.
	container changed.! !

!SVNRegistry methodsFor: 'svn environment' stamp: 'rkrk 4/24/2008 13:10'!
createSvnEnvironment

	^ SVNEnvironment forSvnProjects: self svnProjects! !

!SVNRegistry methodsFor: 'system change notification' stamp: 'rkrk 4/25/2008 09:27'!
extractMethodFromEvent: anEvent

	self flag: #TODO. "..."
	(anEvent class canPerform: #oldItem)
		ifTrue: [^ anEvent oldItem].
	^ anEvent item! !

!SVNRegistry methodsFor: 'initialization' stamp: 'rkrk 4/25/2008 14:01'!
initialize
	
	super initialize.
	self notifyAboutSystemChanges: true.! !

!SVNRegistry methodsFor: 'system change notification' stamp: 'rkrk 5/10/2008 18:46'!
methodChanged: anEvent

	| method |
	method := self findSvnMethodForMethod: (self extractMethodFromEvent: anEvent).
	method ifNil: [^ self].
	method forExistingMethod: anEvent item.
	(self findSvnProjectFor: method)
		ifNotNilDo: [:project | project store. project changed.].
	method changed.
	(self findSvnProjectFor: method) changed.! !

!SVNRegistry methodsFor: 'system change notification' stamp: 'rkrk 4/25/2008 15:49'!
methodRemoved: anEvent

	| method container |
	method := self findSvnMethodForMethod: anEvent item.
	method ifNil: [^ self].
	container := self findSvnProjectOrSvnClassForSvnMethod: method.
	container removeSVNMethod: method.
	method remove.
	(self findSvnProjectFor: container) changed.! !

!SVNRegistry methodsFor: 'system change notification' stamp: 'rt 5/7/2008 18:28'!
notifyAboutSystemChanges: aBoolean

	| notifier |
	"self restart"
	self flag: #TODO. "What about #category, #protocol?"
	notifier := SystemChangeNotifier uniqueInstance.
	aBoolean
		ifFalse: [notifier noMoreNotificationsFor: self]
		ifTrue: [
			notifier
				notify: self
				ofSystemChangesOfItem: #class
				change: #Removed
				using: #classRemoved:.
			notifier
				notify: self
				ofSystemChangesOfItem: #class
				change: #Modified
				using: #classChanged:.
			notifier
				notify: self
				ofSystemChangesOfItem: #class
				change: #Commented
				using: #classCommentChanged:.
			"Subscribe methods"
			#(#Modified #Recategorized #Reorganized #Renamed #Commented) do: [:ea |
				notifier
					notify: self
					ofSystemChangesOfItem: #method
					change: ea
					using: #methodChanged:.].
				notifier
					notify: self
					ofSystemChangesOfItem: #method
					change: #Removed
					using: #methodRemoved:.].! !

Object subclass: #SVNErrorCatcher
	instanceVariableNames: 'block successful error'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNErrorCatcher class methodsFor: 'svn constants' stamp: 'rt 5/7/2008 11:44'!
errorDictionary

	^ Dictionary new
		at: 0		put: #onSuccess;
		at: 155000	put: #onWorkingCopyForDifferentURL;
		at: 150002	put: #onAlreadyUnderVersionControl;
		at: 150004	put: #onHasNoUrl;
		at: 155007	put: #onIsNotAWorkingCopy;
		at: 160013	put: #onFileNotFound;
		at: 160017	put: #onNotAFile;
		at: 170000	put: #onNonExistentInRevision;
		at: 170001	put: #onAuthenticationFailure;
		at: 200005	put: #onNotUnderVersionControl;
		at: 210005	put: #onRepositoryDoesNotExists;
		at: 730061	put: #onCanNotConnectToHost;
		yourself! !

!SVNErrorCatcher class methodsFor: 'instance creation' stamp: 'rt 4/22/2008 15:42'!
on: aBlock

	^ self new
		onBlock: aBlock;
		yourself! !

!SVNErrorCatcher methodsFor: 'accessing' stamp: 'rt 4/22/2008 15:42'!
block

	^ block! !

!SVNErrorCatcher methodsFor: 'accessing' stamp: 'test 5/10/2008 17:25'!
error

	^error! !

!SVNErrorCatcher methodsFor: 'accessing' stamp: 'test 5/10/2008 17:25'!
error: aSelector

	error := aSelector! !

!SVNErrorCatcher methodsFor: 'accessing' stamp: 'test 5/10/2008 17:29'!
execute

	| result |
	"self halt."
	successful := false.
	"Transcript show: 'Calling SVN: ' , self block asString; cr."
	Cursor wait showWhile: [result := self block value].
	
	self error: (self class errorDictionary
		at: result
		ifAbsent: ["#unsupportedErrorCode"
			Transcript show: 'Unsupported error code: ' , result asString; cr. ^ self]).
	self perform: self error.! !

!SVNErrorCatcher methodsFor: 'initialize' stamp: 'rt 4/22/2008 16:10'!
initialize

	super initialize.
	successful := false.
	block := [0]! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/23/2008 20:39'!
onAlreadyUnderVersionControl! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/22/2008 18:44'!
onAuthenticationFailure

	| svnUser |
	svnUser :=(SVNAuthenticationRequestDialog
		withUsernameTemplate: ''
		andPasswordTemplate: '').
	svnUser ifNil: [^ self].
	
	(SVNAuthenticationRequest
		onUsername: svnUser user
		andPassword: svnUser password) execute.
		
	self execute.
	
	"reset to default"
	"(SVNAuthenticationRequest
		onUsername: ''
		andPassword: '') execute."! !

!SVNErrorCatcher methodsFor: 'accessing' stamp: 'rt 4/22/2008 15:03'!
onBlock: aBlock

	block := aBlock! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/26/2008 16:02'!
onCanNotConnectToHost! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/23/2008 20:41'!
onFileNotFound! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/23/2008 18:29'!
onHasNoUrl
	"nothing"! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rkrk 5/7/2008 00:23'!
onIsNotAWorkingCopy
	"nothing"
	"self halt."! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/23/2008 20:40'!
onNonExistentInRevision! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/24/2008 11:31'!
onNotAFile! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/23/2008 20:38'!
onNotUnderVersionControl! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/29/2008 10:36'!
onRepositoryDoesNotExists

	SVNMessageBox openWith: 'Repository does not exists.'! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/22/2008 15:48'!
onSuccess

	successful := true! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'rt 4/22/2008 16:51'!
onWorkingCopyForDifferentURL

	SVNMessageBox
		openWith: 'The working copy is already a working copy for a different URL.'! !

!SVNErrorCatcher methodsFor: 'accessing' stamp: 'rt 4/22/2008 15:06'!
successful

	^ successful! !

!SVNErrorCatcher methodsFor: 'error handling' stamp: 'test 5/10/2008 17:40'!
unsupportedErrorCode

	"send me an eMail"
	"SVNMessageBox openWith: 'Please contact the application support team.'"! !

Object subclass: #SVNInformationGathererForSVNProject
	instanceVariableNames: 'repositoryURL theName workingCopyPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNInformationGathererForSVNProject methodsFor: 'initialize-release' stamp: 'rt 5/7/2008 12:50'!
initialize

	super initialize.
	repositoryURL := ''.
	workingCopyPath := ''.
	theName := ''! !

!SVNInformationGathererForSVNProject methodsFor: 'accessing' stamp: 'rt 5/7/2008 13:24'!
repositoryExists

	^ SVNRepository repositoryExistsOn: self repositoryURL.! !

!SVNInformationGathererForSVNProject methodsFor: 'accessing' stamp: 'rt 5/7/2008 12:56'!
repositoryURL
	
	^ repositoryURL! !

!SVNInformationGathererForSVNProject methodsFor: 'accessing' stamp: 'rt 5/7/2008 13:42'!
repositoryURL: anUrl

	repositoryURL := anUrl withoutAnyClosingSlashs.
	self repositoryExists ifFalse: [SVNErrorCatcher new onRepositoryDoesNotExists].! !

!SVNInformationGathererForSVNProject methodsFor: 'accessing' stamp: 'rt 5/7/2008 12:08'!
theName

	^ theName! !

!SVNInformationGathererForSVNProject methodsFor: 'accessing' stamp: 'rt 5/7/2008 12:48'!
theName: aString

	theName := aString! !

!SVNInformationGathererForSVNProject methodsFor: 'accessing' stamp: 'rt 5/7/2008 12:48'!
workingCopyPath

	^ workingCopyPath! !

!SVNInformationGathererForSVNProject methodsFor: 'accessing' stamp: 'rt 5/7/2008 13:41'!
workingCopyPath: aString

	workingCopyPath := aString withoutAnyClosingSlashs! !

Object subclass: #SVNLoader
	instanceVariableNames: 'requiredClasses classesToLoad unknownRequiredClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNLoader class methodsFor: 'loading' stamp: 'rt 3/7/2008 00:27'!
loadSVNClasses: aSet
"superclasses"
	^self loadSVNClasses: aSet andSVNMethods: (Set new)! !

!SVNLoader class methodsFor: 'loading' stamp: 'rkrk 4/1/2008 12:12'!
loadSVNClasses: aSVNClassSet andSVNMethods: aSVNMethodSet

	self flag: #TODO. "implement unload..., reload (unload->load)"
	^ self new
		loadSVNClasses: aSVNClassSet
		andSVNMethods: aSVNMethodSet;
		yourself.! !

!SVNLoader class methodsFor: 'loading' stamp: 'rt 3/7/2008 00:26'!
loadSVNMethods: aSet
"Classes"
	^self loadSVNClasses: (Set new) andSVNMethods: aSet! !

!SVNLoader methodsFor: 'setters' stamp: 'rt 3/8/2008 16:44'!
addToRequiredClassesAllDependenciesInSVNClasses: aSVNClassSet 

	| newDependencies |
	self classesToLoad addAll: (aSVNClassSet collect: [:each | each theName]).
	newDependencies := aSVNClassSet collect: [:each | each superclassName asString].
	self requiredClasses addAll: newDependencies.
	^newDependencies! !

!SVNLoader methodsFor: 'setters' stamp: 'rt 3/10/2008 13:12'!
addToRequiredClassesAllDependenciesInSVNMethods: aSVNMethodSet 

	| newDependencies |
	newDependencies := aSVNMethodSet collect: [:each | each nameOfClass substrings first].
	self requiredClasses addAll: newDependencies.
	^newDependencies! !

!SVNLoader methodsFor: 'getters' stamp: 'rt 3/7/2008 12:01'!
classesToLoad
	^classesToLoad! !

!SVNLoader methodsFor: 'getters' stamp: 'rt 3/7/2008 23:05'!
findOriginInSystemFor: aSVNClass superclassCanNotBe: aString superclassMustBeInSystemOr: aSVNClassSet consider: aSet

	| ownSuperclassName svnSuperClass |
	ownSuperclassName := aSVNClass superclassName.
	ownSuperclassName = aString ifTrue: [^nil].
	(aSet includes: ownSuperclassName) ifFalse: [^ownSuperclassName].
			
	svnSuperClass := (aSVNClassSet select: [:aClass | aClass theName = ownSuperclassName]) someElement.
	
	^self findOriginInSystemFor: svnSuperClass superclassCanNotBe: aString superclassMustBeInSystemOr: aSVNClassSet consider: aSet.! !

!SVNLoader methodsFor: 'private' stamp: 'rt 3/7/2008 23:05'!
hasCycle: aSVNClassSet.
	"Answer if there is a cycle in the set of svnClasses.
	Needs that addToRequiredClassesAllDependenciesInSVNClasses: had running."

	aSVNClassSet do: [:eachClass |
			(self
				findOriginInSystemFor: eachClass
				superclassCanNotBe: eachClass theName
				superclassMustBeInSystemOr: aSVNClassSet
				consider: (self requiredClasses intersection: (self classesToLoad))) ifNil: [^true]].
	^false! !

!SVNLoader methodsFor: 'initialization' stamp: 'rt 3/7/2008 12:09'!
initialize
	super initialize.
	requiredClasses := Set new.
	classesToLoad := Set new.
	unknownRequiredClasses := Set new! !

!SVNLoader methodsFor: 'loading' stamp: 'rt 3/10/2008 13:14'!
loadSVNClasses: aSVNClassSet andSVNMethods: aSVNMethodSet 

	self addToRequiredClassesAllDependenciesInSVNClasses: aSVNClassSet.
	self addToRequiredClassesAllDependenciesInSVNMethods: aSVNMethodSet.
	
	self flag: #TODO. "abort, if some required classes are unknown or there are cycles"
	self unknownRequiredClasses ifNotEmpty: [^self].
	(self hasCycle: aSVNClassSet) ifTrue: [^self].
	
	self loadSVNClassesSorted: aSVNClassSet.
	aSVNMethodSet do: [:each | each load]! !

!SVNLoader methodsFor: 'private' stamp: 'rt 3/10/2008 13:14'!
loadSVNClassesSorted: aSVNClassSet

	| sortedClasses |
	sortedClasses := self sortSVNClasses: aSVNClassSet consider: (self requiredClasses intersection: self classesToLoad).
	
	sortedClasses do: [:each | each load]! !

!SVNLoader methodsFor: 'getters' stamp: 'rt 3/7/2008 00:37'!
requiredClasses
	^requiredClasses! !

!SVNLoader methodsFor: 'sorting' stamp: 'rt 3/7/2008 22:29'!
sortSVNClasses: aSVNClassSet consider: aSet

	| allSubclasses subclasses |
	aSet ifEmpty: [^aSVNClassSet].
	allSubclasses := Set new.
	aSVNClassSet do: [:each |
		(aSet includes: each theName)
			ifTrue: [subclasses := aSVNClassSet select: [:subClass |
												(subClass superclassName = each theName)].
					each subclasses addAll: subclasses.
					allSubclasses addAll: subclasses]].
	
	aSVNClassSet removeAll: allSubclasses.
	^aSVNClassSet! !

!SVNLoader methodsFor: 'getters' stamp: 'rt 3/8/2008 16:49'!
unknownRequiredClasses
	"all required classes, which are not in classesToLoad and unknown in the system"
	| unknownClasses realyUnknownClasses class |
	unknownClasses := self requiredClasses copy.
	unknownClasses removeAllFoundIn: self classesToLoad.
	realyUnknownClasses := Set new.
	unknownClasses do: [:each | 
		class := Smalltalk classNamed: each.
		(class isNil or: [class isObsolete]) ifTrue: [realyUnknownClasses add: each]].
	^realyUnknownClasses
	! !

Object subclass: #SVNNode
	instanceVariableNames: 'svnElement svnEnvironment parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

SVNNode subclass: #SVNClassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNClassNode methodsFor: 'functionality' stamp: 'rkrk 4/21/2008 02:06'!
getChildren

	^ {SVNInstanceSideOfClassNode
		element: self svnElement
		parent: self
		svnEnvironment: self svnEnvironment.
	SVNClassSideOfClassNode
		element: self svnElement
		parent: self
		svnEnvironment: self svnEnvironment.
	SVNCommentNode
		element: self svnElement
		parent: self
		svnEnvironment: self svnEnvironment.}.! !

SVNNode subclass: #SVNClassSideOfClassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNClassSideOfClassNode methodsFor: 'functionality' stamp: 'mu 4/21/2008 12:36'!
getChildren

	^ self sortChildren: (self svnElement versionedMethods
		select: [:each | each isPartOfMetaclass]
		thenCollect: [:each | SVNMethodNode
				element: each
				parent: self
				svnEnvironment: self svnEnvironment]).! !

!SVNClassSideOfClassNode methodsFor: 'functionality' stamp: 'rkrk 4/7/2008 04:17'!
getLabel

	^ 'class'! !

!SVNClassSideOfClassNode methodsFor: 'svn functions' stamp: 'mu 4/21/2008 11:40'!
status
	^self svnElement statusClassMethods! !

SVNNode subclass: #SVNCommentNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNCommentNode methodsFor: 'functionality' stamp: 'rkrk 4/6/2008 03:44'!
getLabel

	^ 'comment'! !

!SVNCommentNode methodsFor: 'as yet unclassified' stamp: 'mu 4/21/2008 11:40'!
status
	^self svnElement statusComment! !

SVNNode subclass: #SVNInstanceSideOfClassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNInstanceSideOfClassNode methodsFor: 'functionality' stamp: 'mu 4/21/2008 12:37'!
getChildren
	^ self sortChildren: (self svnElement versionedMethods
		select: [:each | each isPartOfMetaclass not]
		thenCollect: [:each |
			SVNMethodNode
				element: each
				parent: self
				svnEnvironment: self svnEnvironment.]).! !

!SVNInstanceSideOfClassNode methodsFor: 'functionality' stamp: 'cop 2/27/2008 10:52'!
getLabel
	^'instance'! !

!SVNInstanceSideOfClassNode methodsFor: 'svn functions' stamp: 'rkrk 4/25/2008 15:20'!
status

	^ self svnElement statusInstanceMethods! !

SVNNode subclass: #SVNMethodNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNNode class methodsFor: 'instance creation' stamp: 'rkrk 4/21/2008 02:03'!
element: aSVNElement parent: aSVNNode svnEnvironment: svnEnvironment
	
	^ (self element: aSVNElement svnEnvironment: svnEnvironment)
		parent: aSVNNode;
		yourself.! !

!SVNNode class methodsFor: 'instance creation' stamp: 'rkrk 4/21/2008 02:03'!
element: aSVNElement svnEnvironment: svnEnvironment
	
	^self new
		svnElement: aSVNElement;
		svnEnvironment: svnEnvironment;
		yourself.! !

!SVNNode methodsFor: 'comparing' stamp: 'cop 5/10/2008 19:39'!
= aNode

	^self svnElement = aNode svnElement! !

!SVNNode methodsFor: 'testing' stamp: 'rkrk 4/14/2008 12:13'!
belongsToCurrentSvnProject

	"Kludge. Needed becaus of compatibility for OBSystemBrowser"
	^ true! !

!SVNNode methodsFor: 'derived accessing' stamp: 'rkrk 4/23/2008 09:32'!
currentSvnProject

	"Actually this method is not needed here yet. It has to be implemented from
	OBCodeNodes, But SVNNodes are only used in SVNProjects and there is no current
	Project there..."
	self svnEnvironment ifNil: [^ nil].
	^ self svnEnvironment currentProject.! !

!SVNNode methodsFor: 'svn functions' stamp: 'cop 5/10/2008 18:47'!
diffSummary
	^self svnElement diffSummary! !

!SVNNode methodsFor: 'svn functions' stamp: 'cop 5/10/2008 18:47'!
diffSummaryFrom: svnRevision
	^self svnElement diffSummaryFrom: svnRevision! !

!SVNNode methodsFor: 'functionality' stamp: 'rkrk 4/7/2008 04:18'!
getChildren

	^ OrderedCollection new! !

!SVNNode methodsFor: 'functionality' stamp: 'rkrk 4/12/2008 11:43'!
getLabel

	^ self svnElement theName! !

!SVNNode methodsFor: 'testing' stamp: 'rkrk 4/12/2008 11:35'!
hasSvnElementOfKind: aClass

	^ self svnElement isKindOf: aClass! !

!SVNNode methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 04:18'!
parent

	^ parent! !

!SVNNode methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 04:18'!
parent: aSVNNode

	parent := aSVNNode! !

!SVNNode methodsFor: 'message handling' stamp: 'rkrk 4/6/2008 03:41'!
perform: selector orSendTo: otherTarget

	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!SVNNode methodsFor: 'functionality' stamp: 'mu 4/21/2008 12:36'!
sortChildren: aCol
	^aCol asSortedCollection: [:a :b| a svnElement theName < b svnElement theName ]! !

!SVNNode methodsFor: 'svn functions' stamp: 'mu 4/21/2008 11:38'!
status
	^self svnElement status! !

!SVNNode methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:44'!
svnElement

	^ svnElement! !

!SVNNode methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 11:44'!
svnElement: aSVNElement

	svnElement := aSVNElement! !

!SVNNode methodsFor: 'accessing' stamp: 'rkrk 4/21/2008 02:04'!
svnEnvironment
	^ svnEnvironment! !

!SVNNode methodsFor: 'accessing' stamp: 'rkrk 4/21/2008 02:04'!
svnEnvironment: anObject
	svnEnvironment := anObject! !

SVNNode subclass: #SVNNodeMock
	instanceVariableNames: 'kindOfClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands-Test'!

!SVNNodeMock class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/23/2008 09:56'!
shouldBeKindOfClass: aClass

	^ self new
		shouldBeKindOfClass: aClass;
		yourself.! !

!SVNNodeMock methodsFor: 'initialization' stamp: 'rkrk 4/23/2008 09:58'!
initialize

	super initialize.
	self kindOfClasses: Set new.! !

!SVNNodeMock methodsFor: 'testing' stamp: 'rkrk 4/23/2008 09:51'!
isKindOf: class

	(self kindOfClasses includes: class) ifTrue: [^ true].
	^ super isKindOf: class.! !

!SVNNodeMock methodsFor: 'accessing' stamp: 'rkrk 4/23/2008 09:52'!
kindOfClasses
	^ kindOfClasses! !

!SVNNodeMock methodsFor: 'accessing' stamp: 'rkrk 4/23/2008 09:52'!
kindOfClasses: anObject
	kindOfClasses := anObject! !

!SVNNodeMock methodsFor: 'as yet unclassified' stamp: 'rkrk 4/23/2008 09:58'!
shouldBeKindOfClass: aClass

	| class |
	class := aClass.
	[class = ProtoObject] whileFalse: [
		self kindOfClasses add: class.
		class := class superclass].! !

SVNNode subclass: #SVNProjectMethodNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNProjectMethodNode methodsFor: 'functionality' stamp: 'mu 4/21/2008 12:37'!
getChildren

	^ self sortChildren: (self svnElement versionedMethods
		collect: [:each | SVNMethodNode
			element: each
			parent: self
			svnEnvironment: self svnEnvironment]).! !

!SVNProjectMethodNode methodsFor: 'functionality' stamp: 'rkrk 4/15/2008 06:52'!
getLabel

	^ 'methods'! !

!SVNProjectMethodNode methodsFor: 'svn functions' stamp: 'mu 4/21/2008 12:04'!
status
	^self svnElement statusProjectMethods! !

SVNNode subclass: #SVNProjectNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools-Nodes'!

!SVNProjectNode methodsFor: 'functionality' stamp: 'mu 4/21/2008 12:45'!
getChildren

	| children |
	children := self svnElement versionedClasses
		collect: [:each | SVNClassNode
						element: each
						parent: self
						svnEnvironment: self svnEnvironment].
	children := self sortChildren: children.
	self svnElement versionedMethods ifNotEmpty: [
		children add: (SVNProjectMethodNode
						element: self svnElement
						parent: self
						svnEnvironment: self svnEnvironment)].
	^ children! !

Object subclass: #SVNRepository
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNRepository class methodsFor: 'instance creation' stamp: 'rkrk 5/5/2008 14:49'!
on: anURL

	(self repositoryExistsOn: anURL) ifFalse: [^ nil].
	^ self new
		setUrl: anURL;
		yourself! !

!SVNRepository class methodsFor: 'primitives' stamp: 'rt 4/8/2008 13:02'!
primitiveSvnExistsRepositoryOnUrl: anUrl
	<primitive: 'svnExistsRepositoryOnUrl' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNRepository class methodsFor: 'primitives' stamp: 'rt 4/8/2008 12:41'!
primitiveSvnRequireAuthenticationAtRepositoryOnUrl: anUrl
	<primitive: 'svnRequireAuthenticationAtRepositoryOnUrl' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNRepository class methodsFor: 'evaluating' stamp: 'rt 4/8/2008 13:01'!
repositoryExistsOn: anUrl

	^ self primitiveSvnExistsRepositoryOnUrl: anUrl pathForSvn! !

!SVNRepository class methodsFor: 'evaluating' stamp: 'rt 4/8/2008 12:58'!
requireAuthenticationAtRepositoryOnUrl: anUrl

	^ self primitiveSvnRequireAuthenticationAtRepositoryOnUrl: anUrl pathForSvn! !

!SVNRepository methodsFor: 'project creating' stamp: 'rt 4/23/2008 19:38'!
createProject: aName

	(self projectExists: aName)
		ifFalse: [(SVNErrorCatcher on: [self
					primitiveCreateProject: aName
					onUrl: self url pathForSvn]) execute].
	^ aName! !

!SVNRepository methodsFor: 'evaluating' stamp: 'rkrk 5/5/2008 15:01'!
exists

	^ self class repositoryExistsOn: self url! !

!SVNRepository methodsFor: 'primitives' stamp: 'rt 4/8/2008 13:24'!
primitiveCreateProject: aName onUrl: anUrl

	<primitive: 'svnCreateProjectOnRepository' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNRepository methodsFor: 'primitives' stamp: 'rt 4/23/2008 15:40'!
primitiveProject: aName onRepository: anUrl exists: aBoolInAnArray

	<primitive: 'svnProjectOnExists' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNRepository methodsFor: 'printing' stamp: 'rt 4/21/2008 13:06'!
printOn: aStream

	super printOn: aStream.
	aStream	nextPut: $(.
	aStream nextPutAll: '''', self url , ''''.
	aStream nextPut: $).! !

!SVNRepository methodsFor: 'project creating' stamp: 'rt 4/23/2008 15:41'!
projectExists: aName

	| arrayOfBool |
	arrayOfBool := {nil}.
	(SVNErrorCatcher on: [self
		primitiveProject: aName
		onRepository: self url pathForSvn
		exists: arrayOfBool]) execute.
	^ arrayOfBool at: 1! !

!SVNRepository methodsFor: 'evaluating' stamp: 'rt 4/8/2008 13:13'!
requiresAuthentication

	^ self class requireAuthenticationAtRepositoryOnUrl: self url! !

!SVNRepository methodsFor: 'accessing' stamp: 'rt 4/8/2008 12:41'!
setUrl: anUrl
	url := anUrl! !

!SVNRepository methodsFor: 'accessing' stamp: 'rt 3/30/2008 23:45'!
url
	^url! !

Object subclass: #SVNRequest
	instanceVariableNames: 'target errorCatcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

SVNRequest subclass: #SVNAuthenticationRequest
	instanceVariableNames: 'username password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNAuthenticationRequest class methodsFor: 'instance creation' stamp: 'rt 4/21/2008 18:07'!
onUsername: aUsername andPassword: aPassword

	^ self new
		onUsername: aUsername andPassword: aPassword;
		yourself! !

!SVNAuthenticationRequest methodsFor: 'primitive' stamp: 'rt 4/21/2008 18:10'!
basicSetUsernameTo: aUsername andPasswordTo: aPassword

	<primitive: 'authenticateWithNameAndPassword' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNAuthenticationRequest methodsFor: 'execution' stamp: 'rt 4/21/2008 18:14'!
execute

	self basicSetUsernameTo: self username andPasswordTo: self password.! !

!SVNAuthenticationRequest methodsFor: 'initialization' stamp: 'rt 4/21/2008 18:13'!
initialize

	super initialize.
	username := ''.
	password := ''.! !

!SVNAuthenticationRequest methodsFor: 'accessing' stamp: 'rt 4/21/2008 18:07'!
onUsername: aUsername andPassword: aPassword

	username := aUsername.
	password := aPassword! !

!SVNAuthenticationRequest methodsFor: 'accessing' stamp: 'rt 4/21/2008 18:14'!
password

	^ password! !

!SVNAuthenticationRequest methodsFor: 'accessing' stamp: 'rt 4/21/2008 18:14'!
username

	^ username! !

SVNRequest subclass: #SVNBlameLinesRequest
	instanceVariableNames: 'blameLines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNBlameLinesRequest class methodsFor: 'default' stamp: 'rkrk 5/10/2008 17:34'!
arrayForPrimitive
	"Pass this array down and fill in the elements the result of svn blame"
	^ { 
		self stringForNumber.	"Revision of the current line"
		self stringForAuthor.
		self stringForTime.
		self stringForNumber.	"Number of the current line"
		self stringForCodeLine.
	 }! !

!SVNBlameLinesRequest class methodsFor: 'default' stamp: 'rkrk 5/10/2008 17:35'!
positionForAuthor

	^ 2! !

!SVNBlameLinesRequest class methodsFor: 'default' stamp: 'rkrk 5/10/2008 17:36'!
positionForContent

	^ 5! !

!SVNBlameLinesRequest class methodsFor: 'default' stamp: 'rkrk 5/10/2008 17:36'!
positionForLineNumber

	^ 4! !

!SVNBlameLinesRequest class methodsFor: 'default' stamp: 'rkrk 5/10/2008 17:35'!
positionForRevisionNumber

	^ 1! !

!SVNBlameLinesRequest class methodsFor: 'default' stamp: 'rkrk 5/10/2008 17:36'!
positionForTime

	^ 3! !

!SVNBlameLinesRequest class methodsFor: 'default' stamp: 'cop 5/5/2008 12:20'!
stringForAuthor

	^ String new: 125! !

!SVNBlameLinesRequest class methodsFor: 'default' stamp: 'cop 5/5/2008 12:24'!
stringForCodeLine
	^ String new: 255! !

!SVNBlameLinesRequest class methodsFor: 'default' stamp: 'cop 5/5/2008 12:23'!
stringForNumber
	^ String new: 25! !

!SVNBlameLinesRequest class methodsFor: 'default' stamp: 'cop 5/5/2008 12:22'!
stringForTime

	^ String new: 44! !

!SVNBlameLinesRequest methodsFor: 'primitives' stamp: 'rkrk 5/10/2008 16:42'!
arrayForPrimitive: anInt

	"anInt specifies the number of lines. For each line an array is added
	in which author, date, code and so on can be stored"
	| newCol |
	self flag: #TODO. "Make this more meaningful"
	newCol := OrderedCollection new.
	1 to: anInt do: [:i | (self class arrayForPrimitive
		do: [:each | newCol addAll: each forSvnPrimitive])].
	^ newCol asArray.! !

!SVNBlameLinesRequest methodsFor: 'accessing' stamp: 'rkrk 5/10/2008 17:39'!
authorForLine: lineNumber

	^ self line: lineNumber at: self class positionForAuthor.! !

!SVNBlameLinesRequest methodsFor: 'primitives' stamp: 'rt 4/23/2008 17:53'!
basicSvnGetBlameLinesFrom: aTarget storeLinesIn: lineArray
	<primitive: 'svnGetBlameLinesFromStoreLinesIn' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNBlameLinesRequest methodsFor: 'primitives' stamp: 'rkrk 5/10/2008 16:25'!
basicSvnGetCountOfBlameLinesFrom: aTarget storeCountIn: arrayForNumber
	<primitive: 'svnGetCountOfBlameLinesFromStoreCountIn' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNBlameLinesRequest methodsFor: 'accessing' stamp: 'rt 4/23/2008 17:44'!
blameLines

	^ blameLines! !

!SVNBlameLinesRequest methodsFor: 'accessing' stamp: 'rt 4/23/2008 17:44'!
blameLines: anObject

	blameLines := anObject! !

!SVNBlameLinesRequest methodsFor: 'accessing' stamp: 'rkrk 5/10/2008 17:41'!
contentForLine: lineNumber

	^ self line: lineNumber at: self class positionForContent.! !

!SVNBlameLinesRequest methodsFor: 'execution' stamp: 'rkrk 5/10/2008 16:54'!
execute

	| linesArray |
	linesArray := self arrayForPrimitive: self numberOfLines.
	self flag: #TODO. "Why 5???"
	self assert: linesArray size = (5 * self numberOfLines).

	"get lines"
	self errorCatcherDo: 
		[self 
			basicSvnGetBlameLinesFrom: self target path pathForSvn
			storeLinesIn: linesArray].
	self primitiveWasSuccessful ifFalse: [^ self].
	self processResult: linesArray! !

!SVNBlameLinesRequest methodsFor: 'initialization' stamp: 'rkrk 5/10/2008 16:22'!
initialize
	super initialize.
	self blameLines: Array new.! !

!SVNBlameLinesRequest methodsFor: 'accessing' stamp: 'rkrk 5/10/2008 18:01'!
line: numberOfLine at: positionOfItem

	| index |
	index := (numberOfLine - 1) * self numberOfItemsInLine + positionOfItem.
	^ self blameLines at: index! !

!SVNBlameLinesRequest methodsFor: 'accessing' stamp: 'rkrk 5/10/2008 18:13'!
numberOfItemsInLine

	"In a line are stored:
	Revision number, author, timestamp, lineNr, content - 5 items"
	"^ self class arrayForPrimitive size"
	^ 5! !

!SVNBlameLinesRequest methodsFor: 'accessing' stamp: 'rt 5/11/2008 15:59'!
numberOfLines
	
	^ self target content lineCount.! !

!SVNBlameLinesRequest methodsFor: 'accessing' stamp: 'rkrk 5/10/2008 18:14'!
numberOfLinesRead
	
	^ self blameLines size // self numberOfItemsInLine! !

!SVNBlameLinesRequest methodsFor: 'execution' stamp: 'rkrk 5/10/2008 16:57'!
processResult: anArray

	self blameLines: (anArray collect: [:ea |
		self prepareStringForSqueak: ea]).! !

!SVNBlameLinesRequest methodsFor: 'accessing' stamp: 'rkrk 5/10/2008 17:40'!
revisionForLine: lineNumber

	^ self line: lineNumber at: self class positionForRevisionNumber.! !

!SVNBlameLinesRequest methodsFor: 'accessing' stamp: 'rkrk 5/10/2008 19:09'!
tableCollection

	| revisionCollection authorCollection lineCollection codeCollection |
	revisionCollection := OrderedCollection with: 'Revision'.
	authorCollection := OrderedCollection with: 'Author'.
	lineCollection := OrderedCollection with: 'Line'.
	codeCollection := OrderedCollection with: 'Code'.
	
	1 to: self numberOfLinesRead do: [:line |
		revisionCollection add: (self revisionForLine: line).
		authorCollection add: (self authorForLine: line).
		lineCollection add: line - 1.
		codeCollection add: (self contentForLine: line)].

	^ Array
		with: revisionCollection
		with: authorCollection
		with: lineCollection
		with: codeCollection.! !

!SVNBlameLinesRequest methodsFor: 'accessing' stamp: 'rkrk 5/10/2008 17:40'!
timeForLine: lineNumber

	^ self line: lineNumber at: self class positionForTime.! !

!SVNBlameLinesRequest methodsFor: 'accessing' stamp: 'rkrk 5/10/2008 17:39'!
timeStampForLine: lineNumber

	^ self line: lineNumber at: self class positionForTime.! !

SVNRequest subclass: #SVNCatRequest
	instanceVariableNames: 'targetRevision contentOfTarget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNCatRequest class methodsFor: 'instance creation' stamp: 'rkrk 5/7/2008 10:50'!
target: svnDirectoryEntry forRevision: svnRevision

	^ self new
		target: svnDirectoryEntry;
		targetRevision: svnRevision;
		yourself.! !

!SVNCatRequest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/8/2008 01:58'!
arrayForPrimitive

	"^ 'Hallo, hallo, dies is ein Test :-)' forSvnPrimitive asArray"
	^ {nil. (String new: 15) forSvnPrimitiveAsString}! !

!SVNCatRequest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/8/2008 10:06'!
basicSvnCatFor: targetPath revisionKind: revkind revisionNumber: revNumber storeInArray: array

	<primitive: 'svnCatForTargetRevisionKindRevisionNumberStoreInArray' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCatRequest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/12/2008 02:59'!
callSvnWith: arrayForPrimitive

	self errorCatcherDo:  [
		self
			basicSvnCatFor: self target path pathForSvn
			revisionKind: self targetRevision kind
			revisionNumber: self targetRevision number
			storeInArray: arrayForPrimitive].! !

!SVNCatRequest methodsFor: 'accessing' stamp: 'rkrk 5/7/2008 11:09'!
contentOfTarget
	^ contentOfTarget! !

!SVNCatRequest methodsFor: 'accessing' stamp: 'rkrk 5/7/2008 11:09'!
contentOfTarget: anObject
	contentOfTarget := anObject! !

!SVNCatRequest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/8/2008 02:06'!
execute

	| arrayForPrimitive length |
	arrayForPrimitive := self arrayForPrimitive.
	self assert: arrayForPrimitive size = 2.
	
	"Make a first call. If the string in arrayForPrimitive is too small (primitive fails)
	allocate a bigger string (array first is the necessary size) and call the primitive again"
	[self callSvnWith: arrayForPrimitive]
		on: Error
		do: [
			length := arrayForPrimitive first.
			arrayForPrimitive at: 2 put: (String new: length) forSvnPrimitiveAsString.
			self callSvnWith: arrayForPrimitive].
	
	self processResult: arrayForPrimitive.! !

!SVNCatRequest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/8/2008 02:07'!
processResult: arrayForPrimitive

	self contentOfTarget: (self prepareStringForSqueak: arrayForPrimitive second).! !

!SVNCatRequest methodsFor: 'accessing' stamp: 'rkrk 5/7/2008 10:50'!
targetRevision
	^ targetRevision! !

!SVNCatRequest methodsFor: 'accessing' stamp: 'rkrk 5/7/2008 10:50'!
targetRevision: anObject
	targetRevision := anObject! !

SVNRequest subclass: #SVNDiffSummaryRequest
	instanceVariableNames: 'startRevision endRevision'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNDiffSummaryRequest class methodsFor: 'svn constants' stamp: 'cop 5/7/2008 17:34'!
summaryKindDictionary

"enum svn_client_diff_summarize_kind_t"

	^ Dictionary new
		at: 0 	put: #normal;		"An item with no text modifications"
		at: 1 	put: #added;			"An added item"
		at: 2 	put: #modified;		"An item with text modifications"
		at: 3 	put: #deleted;		"A deleted item"
		yourself.! !

!SVNDiffSummaryRequest class methodsFor: 'convenience' stamp: 'cop 5/7/2008 13:12'!
target: svnDirectoryEntry fromRevision: startRevision toRevision: endRevision

	^ (self new
		target: svnDirectoryEntry;
		startRevision: startRevision;
		endRevision: endRevision) execute! !

!SVNDiffSummaryRequest methodsFor: 'primitives' stamp: 'cop 5/8/2008 15:41'!
basicSvnDiffSummerize: aPath Kind: startRevKind From: startRevNum Kind: endRevKind To: endRevNum Into: array

	<primitive: 'svnDiffSummerizeKindFromKindTo' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNDiffSummaryRequest methodsFor: 'primitives' stamp: 'cop 5/10/2008 16:27'!
basicSvnDiffSummerizeCount: aPath Kind: startRevKind From: startRevNum Kind: endRevKind To: endRevNum Into: anInt

	<primitive: 'svnDiffSummerizeCountKindFromKindToInto' module: 'SqueakSVNPlugin'>
	^self primitiveFailed! !

!SVNDiffSummaryRequest methodsFor: 'accessing' stamp: 'cop 5/7/2008 13:02'!
endRevision

	^endRevision! !

!SVNDiffSummaryRequest methodsFor: 'accessing' stamp: 'cop 5/7/2008 13:02'!
endRevision: svnRevision

	endRevision := svnRevision! !

!SVNDiffSummaryRequest methodsFor: 'execution' stamp: 'test 5/10/2008 17:33'!
execute

	| numOfSummaries numArray orderedCol returnArray |
	numArray := Array with: 0.
	self errorCatcherDo:  [
		self
			basicSvnDiffSummerizeCount: self target path pathForSvn
			Kind: self startRevision kind
			From: self startRevision number
			Kind: self endRevision kind
			To: self endRevision number
			Into: numArray].
		
	numOfSummaries := numArray first.	
	
	self errorCatcher error = #onFileNotFound ifTrue: [^SVNDiffSummary addedFor: self target theName].
	self errorCatcher error = #onNotUnderVersionControl ifTrue: [^SVNDiffSummary deletedFor: self target theName].
	numOfSummaries = 0 ifTrue: [^SVNDiffSummary normalFor: self target theName].
	
	orderedCol := OrderedCollection new.
	
	1 to: numOfSummaries do: [:ea|
		orderedCol add: (String new: 255).
		orderedCol add: -1.
		orderedCol add: -1].
	
	returnArray := orderedCol asArray.

	self errorCatcherDo:  [
		self
			basicSvnDiffSummerize: self target path pathForSvn
			Kind: self startRevision kind
			From: self startRevision number
			Kind: self endRevision kind
			To: self endRevision number
			Into: returnArray].

	"check for success ?"
	
	^self processResult: returnArray.! !

!SVNDiffSummaryRequest methodsFor: 'execution' stamp: 'test 5/10/2008 17:21'!
processResult: resultArray

	^SVNDiffSummary propChanged: (resultArray at: 2 ) summaryKind: (resultArray at: 3 )! !

!SVNDiffSummaryRequest methodsFor: 'accessing' stamp: 'cop 5/7/2008 13:02'!
startRevision

	^startRevision! !

!SVNDiffSummaryRequest methodsFor: 'accessing' stamp: 'cop 5/7/2008 13:03'!
startRevision: svnRevision

	startRevision := svnRevision! !

SVNRequest subclass: #SVNInfoRequest
	instanceVariableNames: 'targetRevision author revision lastChangedRevision date repositoryRootUrl url repositoryUUID schedule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 5/11/2008 01:32'!
arrayForPrimitive

	"Pass this array down and fill in the elements the result of svn info"
	^ {
		self stringForUrl.				"repository root url"
		self elementForRevision.			"Current revision"
		self stringForUrl.				"own url"
		self stringForRepositoryUUID.
		self elementForRevision.			"Last changed revision"
		self stringForDate.
		self stringForAuthor.
		self stringForSchedule
	}! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'test 5/10/2008 16:46'!
elementForRevision

	^ SVNRevision number! !

!SVNInfoRequest class methodsFor: 'convenience' stamp: 'cop 5/7/2008 13:24'!
headRevisionOf: svnDirectoryEntry

	^ ((self target: svnDirectoryEntry forRevision: SVNRevision head) execute) revision! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 02:05'!
stringForAuthor

	^ String new: 125! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 02:05'!
stringForDate

	"apr_ctime returns a string of size 25"
	^ String new: 25! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 02:20'!
stringForRepositoryUUID

	^ String new: 36! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 3/23/2008 02:05'!
stringForSchedule

	^ String new: 8! !

!SVNInfoRequest class methodsFor: 'default' stamp: 'rkrk 5/11/2008 01:31'!
stringForUrl

	^ String new: 255! !

!SVNInfoRequest class methodsFor: 'instance creation' stamp: 'rkrk 4/26/2008 02:31'!
target: svnDirectoryEntry forRevision: svnRevision

	^ self new
		target: svnDirectoryEntry;
		targetRevision: svnRevision;
		yourself.! !

!SVNInfoRequest methodsFor: 'primitive' stamp: 'rkrk 5/11/2008 01:35'!
arrayForPrimitive

	"Some objects are mapped to more than one object for their
	representation in the primitive. E.g. a SVNRevision is mapped
	to: <KindString>. NumberOrNil"
	^ (self class arrayForPrimitive
		inject: OrderedCollection new
		into: [:preparedCol :each |
			preparedCol
				addAll: each forSvnPrimitive;
				yourself]) asArray.! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:15'!
author
	^ author! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:15'!
author: anObject
	author := anObject! !

!SVNInfoRequest methodsFor: 'primitive' stamp: 'rkrk 3/24/2008 11:24'!
basicSvnGetInfoFrom: targetPath revisionKind: revKind revisionNumber: revNumber storeInArray: array

	<primitive: 'svnInfoForTargetRevisionKindRevisionNumberStoreInArray' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNInfoRequest methodsFor: 'service' stamp: 'rkrk 3/23/2008 03:35'!
convertToDateFromCTimeString: aString

	self flag: #TODO. "Implement the thing"
	^ DateAndTime current! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:15'!
date
	^ date! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:15'!
date: anObject
	date := anObject! !

!SVNInfoRequest methodsFor: 'execution' stamp: 'rkrk 5/11/2008 01:32'!
execute

	| arrayForPrimitive |
	arrayForPrimitive := self arrayForPrimitive.
	self assert: arrayForPrimitive size = 10.
	
	self errorCatcherDo:  [
		self
			basicSvnGetInfoFrom: self target path pathForSvn
			revisionKind: self targetRevision kind
			revisionNumber: self targetRevision number
			storeInArray: arrayForPrimitive].

	"check for success ?"
	
	self processResult: arrayForPrimitive.! !

!SVNInfoRequest methodsFor: 'initialization' stamp: 'rkrk 4/26/2008 03:23'!
initialize

	super initialize.
	self targetRevision: SVNRevision unspecified.! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
lastChangedRevision
	^ lastChangedRevision! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
lastChangedRevision: anObject
	lastChangedRevision := anObject! !

!SVNInfoRequest methodsFor: 'execution' stamp: 'rkrk 5/11/2008 01:33'!
processResult: resultArray

	| preparedArray |
	self flag: #TODO. "Implicit mapping. Where should the indices be stored?"
	preparedArray := resultArray collect: [:each | each isString
		ifTrue: [self prepareStringForSqueak: each]
		ifFalse: [each]].
	self repositoryRootUrl: (preparedArray at: 1).
	self revision: (SVNRevision
		fromKind: (preparedArray at: 2)
		number: (preparedArray at: 3)).
	self url: (preparedArray at: 4).
	self repositoryUUID: (preparedArray at: 5).
	self lastChangedRevision: (SVNRevision
		fromKind: (preparedArray at: 6)
		number: (preparedArray at: 7)).
	self date: (self convertToDateFromCTimeString: (preparedArray at: 8)).
	self author: (preparedArray at: 9).
	self schedule: (preparedArray at: 10).! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
repositoryRootUrl
	^ repositoryRootUrl! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
repositoryRootUrl: anObject
	repositoryRootUrl := anObject! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
repositoryUUID
	^ repositoryUUID! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
repositoryUUID: anObject
	repositoryUUID := anObject! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
revision
	^ revision! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:16'!
revision: anObject
	revision := anObject! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:36'!
schedule
	^ schedule! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 03:36'!
schedule: anObject
	schedule := anObject! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 4/26/2008 02:31'!
targetRevision
	^ targetRevision! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 4/26/2008 02:31'!
targetRevision: anObject
	targetRevision := anObject! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 5/11/2008 01:34'!
url
	^ url! !

!SVNInfoRequest methodsFor: 'accessing' stamp: 'rkrk 5/11/2008 01:34'!
url: anObject
	url := anObject! !

SVNRequest subclass: #SVNListRequest
	instanceVariableNames: 'targetRevision fileNames directoryNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNListRequest class methodsFor: 'as yet unclassified' stamp: 'rkrk 5/11/2008 16:53'!
arrayForCount

	"^ #(countVar direntKind)" 
	| array |
	array := Array new: 2.
	array at: self positionForCount put: 0.
	array at: self positionForNodeKind put: nil.
	^ array! !

!SVNListRequest class methodsFor: 'as yet unclassified' stamp: 'rkrk 5/11/2008 05:21'!
positionForCount

	^ 1! !

!SVNListRequest class methodsFor: 'as yet unclassified' stamp: 'rkrk 5/11/2008 05:22'!
positionForNodeKind

	^ 2! !

!SVNListRequest class methodsFor: 'as yet unclassified' stamp: 'rkrk 5/11/2008 16:51'!
stringForPath

	^ String new: 255! !

!SVNListRequest class methodsFor: 'as yet unclassified' stamp: 'rkrk 5/11/2008 05:38'!
target: svnDirectoryEntry forRevision: svnRevision

	^ self new
		target: svnDirectoryEntry;
		targetRevision: svnRevision;
		yourself.! !

!SVNListRequest methodsFor: 'execution' stamp: 'rkrk 5/11/2008 17:03'!
arrayForReading: number

	"^ #(countVar direntKind stringForPath_1 stringForPath_2 ... stringForPath_number)"
	| stringCollection |
	stringCollection := (1 to: number) collect: [:i |
		"better to use #prepareStringForPrimitive:!!!!!! --> but be careful, make the the same"
		self class stringForPath forSvnPrimitiveAsString].
	^ (self class arrayForCount asOrderedCollection
		addAll: stringCollection;
		yourself) asArray.! !

!SVNListRequest methodsFor: 'primitive' stamp: 'rkrk 5/11/2008 05:27'!
basicSvnListCountDirEntriesForTarget: targetOop revisionKind: revisionKindOop revisionNumber: revisionNumberOop recursive: recursiveBoolOop storeInArray: resultArrayOop

	<primitive: 'svnListCountDirEntriesForTargetForTargetRevisionKindRevisionNumberRecursiveStoreInArray' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNListRequest methodsFor: 'primitive' stamp: 'rkrk 5/11/2008 16:35'!
basicSvnListReadDirEntriesForTarget: targetOop revisionKind: revisionKindOop revisionNumber: revisionNumberOop recursive: recursiveBoolOop storeInArray: resultArrayOop

	<primitive: 'svnListReadDirEntriesForTargetForTargetRevisionKindRevisionNumberRecursiveStoreInArray' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNListRequest methodsFor: 'primitive' stamp: 'rkrk 5/11/2008 05:27'!
basicSvnNodeKindDir

	<primitive: 'svnNodeKindDir' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNListRequest methodsFor: 'primitive' stamp: 'rkrk 5/11/2008 05:27'!
basicSvnNodeKindFile

	<primitive: 'svnNodeKindFile' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNListRequest methodsFor: 'execution' stamp: 'rkrk 5/12/2008 03:56'!
countDirEntriesOfKind: nodeKind

	| array |
	array := self class arrayForCount.
	array at: self class positionForNodeKind put: nodeKind.
	self assert: array size = 2.
	self assert: (array includes: nil) not.
	self assert: self target path notEmpty.
	
	self errorCatcherDo: [
		self
			basicSvnListCountDirEntriesForTarget: self target path pathForSvn
			revisionKind: self targetRevision kind
			revisionNumber: self targetRevision number
			recursive: false
			storeInArray: array].
	
	^ array at: self class positionForCount.! !

!SVNListRequest methodsFor: 'accessing' stamp: 'rkrk 5/11/2008 05:20'!
directoryNames
	^ directoryNames! !

!SVNListRequest methodsFor: 'accessing' stamp: 'rkrk 5/11/2008 05:20'!
directoryNames: anObject
	directoryNames := anObject! !

!SVNListRequest methodsFor: 'execution' stamp: 'rkrk 5/11/2008 16:58'!
execute

	| fileArray dirArray |
	fileArray := self readFiles: self numberOfFiles.
	self processFileArray: fileArray.
	
	dirArray := self readDirectories: self numberOfSubdirectories.
	self processDirectoryArray: dirArray.! !

!SVNListRequest methodsFor: 'accessing' stamp: 'rkrk 5/11/2008 05:20'!
fileNames
	^ fileNames! !

!SVNListRequest methodsFor: 'accessing' stamp: 'rkrk 5/11/2008 05:20'!
fileNames: anObject
	fileNames := anObject! !

!SVNListRequest methodsFor: 'as yet unclassified' stamp: 'rkrk 5/11/2008 06:04'!
initialize
	super initialize.
	self
		fileNames: OrderedCollection new;
		directoryNames: OrderedCollection new.! !

!SVNListRequest methodsFor: 'execution' stamp: 'rkrk 5/11/2008 05:33'!
numberOfFiles


	^ self countDirEntriesOfKind: self basicSvnNodeKindFile.! !

!SVNListRequest methodsFor: 'execution' stamp: 'rkrk 5/11/2008 05:32'!
numberOfSubdirectories

	^ self countDirEntriesOfKind: self basicSvnNodeKindDir.! !

!SVNListRequest methodsFor: 'execution' stamp: 'rkrk 5/11/2008 17:01'!
processDirectoryArray: anArray

	self directoryNames: (anArray collect: [:ea | self prepareStringForSqueak: ea]).! !

!SVNListRequest methodsFor: 'execution' stamp: 'rkrk 5/11/2008 17:01'!
processFileArray: anArray

	self fileNames: (anArray collect: [:ea | self prepareStringForSqueak: ea]).! !

!SVNListRequest methodsFor: 'execution' stamp: 'rkrk 5/12/2008 03:57'!
readDirEntries: number ofKind: nodeKind

	| array offset |
	array := self arrayForReading: number.
	array at: self class positionForNodeKind put: nodeKind.
	"array first = count variable. array second = nodeKind
	The count variable determines the index in the array where the path
	should be stored. The first two positions are occupied, so set count to two."
	offset := 2.
	array at: self class positionForCount put: offset.
	self assert: array size = (number + offset).
	self assert: (array includes: nil) not.
	self assert: self target path notEmpty.
	
	self errorCatcherDo: [
		self
			basicSvnListReadDirEntriesForTarget: self target path pathForSvn
			revisionKind: self targetRevision kind
			revisionNumber: self targetRevision number
			recursive: false
			storeInArray: array].
	
	^ array last: array size - offset.! !

!SVNListRequest methodsFor: 'execution' stamp: 'rkrk 5/11/2008 16:59'!
readDirectories: number

	^ self
		readDirEntries: number
		ofKind: self basicSvnNodeKindDir.! !

!SVNListRequest methodsFor: 'execution' stamp: 'rkrk 5/11/2008 16:59'!
readFiles: number

	^ self
		readDirEntries: number
		ofKind: self basicSvnNodeKindFile.! !

!SVNListRequest methodsFor: 'derived accessing' stamp: 'rkrk 5/11/2008 05:21'!
svnNodeKindDir

	<primitive: 'svnNodeKindDir' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNListRequest methodsFor: 'derived accessing' stamp: 'rkrk 5/11/2008 05:21'!
svnNodeKindFile

	<primitive: 'svnNodeKindFile' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNListRequest methodsFor: 'accessing' stamp: 'rkrk 5/11/2008 05:20'!
targetRevision
	^ targetRevision! !

!SVNListRequest methodsFor: 'accessing' stamp: 'rkrk 5/11/2008 05:20'!
targetRevision: anObject
	targetRevision := anObject! !

SVNRequest subclass: #SVNPath
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

!SVNPath class methodsFor: 'instance creation' stamp: 'rkrk 5/12/2008 15:42'!
on: pathString

	^ self new
		path: pathString;
		yourself.! !

!SVNPath methodsFor: 'conversion' stamp: 'rkrk 5/12/2008 17:00'!
asDecodedString

	"Encode 2 times:
	1 - svn_path_uri_decode
	2 - #unescapePercents"
	^ self squeakHTTPDecode: (self svnHTTPDecode: self path)! !

!SVNPath methodsFor: 'conversion' stamp: 'rkrk 5/12/2008 17:00'!
asEncodedString

	"Encode 2 times:
	1 - #encodeForHTTP
	2 - svn_path_uri_encode
	Reason: #encodeForHTTP alone does not create valid encoded svn paths.
	svn_path_uri_encode alone does not convert colons. Hence, combine them"
	^ self svnHTTPEncode: (self squeakHTTPEncode: self path)! !

!SVNPath methodsFor: 'conversion' stamp: 'rkrk 5/12/2008 17:03'!
asEncodedStringForRepository

	self flag: #TODO. "Quick hack. When directly accessing the repository
	the % is once again encoded."
	^ self svnHTTPEncode: self asEncodedString ! !

!SVNPath methodsFor: 'primitive' stamp: 'rkrk 5/12/2008 15:54'!
basicDecodePath: pathToDecode storeIn: result

	<primitive: 'svnDecodePathStoreIn' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNPath methodsFor: 'primitive' stamp: 'rkrk 5/12/2008 14:33'!
basicEncodePath: pathToEncode storeIn: result

	<primitive: 'svnEncodePathStoreIn' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNPath methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 15:45'!
path
	^ path! !

!SVNPath methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 15:45'!
path: anObject
	path := anObject! !

!SVNPath methodsFor: 'decoding' stamp: 'rkrk 5/12/2008 16:57'!
squeakHTTPDecode: aString

	^ aString unescapePercents! !

!SVNPath methodsFor: 'encoding' stamp: 'rkrk 5/12/2008 16:58'!
squeakHTTPEncode: aString

	^ aString encodeForHTTP! !

!SVNPath methodsFor: 'decoding' stamp: 'rkrk 5/12/2008 16:58'!
svnHTTPDecode: aString

	| result |
	result := String new: 255.
	self
		basicDecodePath: aString forSvnPrimitiveAsString
		storeIn: result.
	^ self prepareStringForSqueak: result! !

!SVNPath methodsFor: 'encoding' stamp: 'rkrk 5/12/2008 16:59'!
svnHTTPEncode: aString

	| result |
	result := String new: 255.
	self
		basicEncodePath: aString forSvnPrimitiveAsString
		storeIn: result.
	^ self prepareStringForSqueak: result ! !

SVNRequest subclass: #SVNPropertiesRequest
	instanceVariableNames: 'properties targetRevision'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNPropertiesRequest class methodsFor: 'as yet unclassified' stamp: 'rkrk 5/11/2008 02:29'!
target: svnDirectoryEntry forRevision: svnRevision

	^ self new
		target: svnDirectoryEntry;
		targetRevision: svnRevision;
		yourself.! !

!SVNPropertiesRequest methodsFor: 'primitives' stamp: 'rkrk 5/11/2008 02:21'!
basicSvnGetCountOfPropertiesOf: pathForPrimitives revisionKind: revkind revisionNumber: revNumber storeCountIn: arrayForCount
	<primitive: 'svnGetCountOfPropertiesOnRevisionKindRevisionNumberStoreCountIn' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNPropertiesRequest methodsFor: 'primitives' stamp: 'rkrk 5/11/2008 02:15'!
basicSvnGetPropertiesOf: pathOop revisionKind: revkind revisionNumber: revNumber storeInArray: resultArray 
	<primitive: 'svnGetPropertiesOfRevisionKindRevisionNumberStoreInArray' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNPropertiesRequest methodsFor: 'converting' stamp: 'rkrk 5/10/2008 16:10'!
dictionaryFromArray: anArray

	| resultDict realArray |
	resultDict := Dictionary new.
	realArray := (anArray collect: [:ea | ea copyUpTo: self null]) asArray.
	
	realArray ifNil: [^ resultDict].
	realArray pairsDo: [:key :value |
		resultDict at: key put: value].
	^ resultDict.! !

!SVNPropertiesRequest methodsFor: 'execution' stamp: 'rkrk 5/12/2008 02:59'!
execute

	| count resultArray arrayForCount |
	arrayForCount := {nil}.
	self errorCatcherDo: 
		[self 
			basicSvnGetCountOfPropertiesOf: self target path pathForSvn
			revisionKind: self targetRevision kind
			revisionNumber: self targetRevision number
			storeCountIn: arrayForCount].
	count := arrayForCount first.
	count isZero ifTrue: [^ self].

	"keys and values are returned, so we need twice the size of all properties"
	resultArray := self forPrimitiveGetArrayOfSize: 2 * count.
	self errorCatcherDo: 
		[self 
			basicSvnGetPropertiesOf: self target path pathForSvn
			revisionKind: self targetRevision kind
			revisionNumber: self targetRevision number
			storeInArray: resultArray].
	self primitiveWasSuccessful ifFalse: [^ self].
	self processResult: resultArray! !

!SVNPropertiesRequest methodsFor: 'initialization' stamp: 'rkrk 5/11/2008 02:27'!
initialize
	super initialize.
	self
		properties: Dictionary new;
		targetRevision: SVNRevision unspecified.! !

!SVNPropertiesRequest methodsFor: 'execution' stamp: 'rkrk 5/10/2008 16:19'!
processResult: anArray

	
	self properties: (self dictionaryFromArray: anArray).! !

!SVNPropertiesRequest methodsFor: 'accessing' stamp: 'rt 4/17/2008 17:30'!
properties

	^ properties
! !

!SVNPropertiesRequest methodsFor: 'accessing' stamp: 'rt 4/17/2008 17:30'!
properties: anObject

	properties := anObject
! !

!SVNPropertiesRequest methodsFor: 'accessing' stamp: 'rkrk 5/11/2008 02:27'!
targetRevision
	^ targetRevision! !

!SVNPropertiesRequest methodsFor: 'accessing' stamp: 'rkrk 5/11/2008 02:27'!
targetRevision: anObject
	targetRevision := anObject! !

!SVNRequest class methodsFor: 'instance creation' stamp: 'rkrk 4/3/2008 16:43'!
target: svnDirectoryElement

	^ self new
		target: svnDirectoryElement;
		yourself.! !

!SVNRequest methodsFor: 'accessing' stamp: 'rkrk 5/4/2008 19:20'!
errorCatcher
	^ errorCatcher! !

!SVNRequest methodsFor: 'accessing' stamp: 'rkrk 5/4/2008 19:20'!
errorCatcher: anObject
	errorCatcher := anObject! !

!SVNRequest methodsFor: 'execution' stamp: 'rkrk 5/4/2008 19:19'!
errorCatcherDo: aBlock

	(self errorCatcher onBlock: aBlock) execute.! !

!SVNRequest methodsFor: 'execution' stamp: 'cop 4/10/2008 08:14'!
execute
	^self subclassResponsibility! !

!SVNRequest methodsFor: 'primitives' stamp: 'rt 4/23/2008 17:41'!
forPrimitiveGetArrayOfSize: aNumber

	^ ( (1 to: aNumber) collect: [:ea | String ofSize: 1024])  asArray! !

!SVNRequest methodsFor: 'initialization' stamp: 'rkrk 5/4/2008 19:20'!
initialize

	super initialize.
	self errorCatcher: SVNErrorCatcher new.! !

!SVNRequest methodsFor: 'string converting' stamp: 'rkrk 5/4/2008 18:03'!
null

	^ Character value: 0! !

!SVNRequest methodsFor: 'string converting' stamp: 'rkrk 5/7/2008 11:11'!
prepareStringForPrimitive: string

	"self assert: (string includes: self null) not."
	string at: string size put: self null.
	^ string convertToSystemString.! !

!SVNRequest methodsFor: 'string converting' stamp: 'rkrk 5/10/2008 16:25'!
prepareStringForSqueak: string

	^ string asDefaultDecodedString copyUpTo: self null.! !

!SVNRequest methodsFor: 'execution' stamp: 'rkrk 5/10/2008 16:15'!
primitiveWasSuccessful
	^ self errorCatcher successful! !

!SVNRequest methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 17:08'!
target
	^ target! !

!SVNRequest methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 17:08'!
target: anObject
	target := anObject! !

SVNRequest subclass: #SVNRevisionInfosRequest
	instanceVariableNames: 'commitLogs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNRevisionInfosRequest methodsFor: 'primitives' stamp: 'rkrk 5/4/2008 19:15'!
basicSvnGetCommitLogs: count from: targetStringForSvnPrimitive	to: revisionNumberOop storeInArray: resultArray
	
	<primitive: 'svnGetCommitLogsFromToStoreInArray' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNRevisionInfosRequest methodsFor: 'primitives' stamp: 'rkrk 5/4/2008 19:15'!
basicSvnGetCountOfCommitLogsFrom: aTarget to: headRevisionNumber storeCountIn: arrayForCount
	
	<primitive: 'svnGetCountOfCommitLogsFromToStoreCountIn' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SVNRevisionInfosRequest methodsFor: 'accessing' stamp: 'rt 4/23/2008 20:06'!
commitLogs

	^ commitLogs! !

!SVNRevisionInfosRequest methodsFor: 'accessing' stamp: 'rt 4/23/2008 20:06'!
commitLogs: anObject

	commitLogs := anObject! !

!SVNRevisionInfosRequest methodsFor: 'execution' stamp: 'rkrk 5/4/2008 20:25'!
execute

	| resultArray |
	resultArray := self getCommitLogs: self numberOfCommitLogs.
	self processResult: resultArray.! !

!SVNRevisionInfosRequest methodsFor: 'execution' stamp: 'rkrk 5/10/2008 16:17'!
getCommitLogs: numberOfCommitLogs 

	| resultArray |
	self flag: #TODO. "Why 4???"
	resultArray := self forPrimitiveGetArrayOfSize: 4 * numberOfCommitLogs.
	self errorCatcherDo: 
		[self 
			basicSvnGetCommitLogs: numberOfCommitLogs
			from: self target path pathForSvn
			to: self headRevisionNumber
			storeInArray: resultArray].
	^ self primitiveWasSuccessful 
		ifTrue: [resultArray]
		ifFalse: [Array new]! !

!SVNRevisionInfosRequest methodsFor: 'accessing' stamp: 'rkrk 5/4/2008 20:25'!
headRevisionNumber

	| request |
	self flag: #TODO.
	request := SVNInfoRequest target: self target forRevision: (SVNRevision head).
	request execute.
	^ request revision number
		ifNil: [0]
		ifNotNilDo: [:number | number].! !

!SVNRevisionInfosRequest methodsFor: 'execution' stamp: 'rkrk 5/4/2008 20:02'!
numberOfCommitLogs

	| array |
	array := {nil}. "the number will be put in the array"
	self errorCatcherDo: [
		self
			basicSvnGetCountOfCommitLogsFrom: self target path pathForSvn
			to: self headRevisionNumber
			storeCountIn: array].
	^ array first.! !

!SVNRevisionInfosRequest methodsFor: 'execution' stamp: 'rkrk 5/4/2008 19:15'!
processResult: anArray
	"anArray looks like:
	<RevisionNumber(int), Author(string), Date(String)?, Comment(Sring), ...>"
	| logs |
	logs := OrderedCollection new.
	anArray ifEmpty: [self commitLogs: logs. ^ self].
	self flag: #TODO.	"refactor to group:by:???!!!!!!!!"
	1 
		to: anArray size
		by: 4
		do:  [:index | 
			logs add: (SVNRevisionInfo 
					withRevision: (anArray at: index) asInteger
					author: ((anArray at: index + 1) copyUpTo: self null)
					date: ((anArray at: index + 2) copyUpTo: self null)
					comment: ((anArray at: index + 3) copyUpTo: self null)) ].
	self commitLogs: logs.! !

SVNRequest subclass: #SVNStatusRequest
	instanceVariableNames: 'isRecursive statusKind contactRepository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNStatusRequest class methodsFor: 'svn constants' stamp: 'rt 5/9/2008 17:38'!
highestStatusOf: aCollection

	^ aCollection detectMax: [:statusValue | self statusKindDictionary keyAtValue: statusValue]! !

!SVNStatusRequest class methodsFor: 'svn constants' stamp: 'mu 4/21/2008 11:18'!
statusKindDictionary

"enum svn_wc_status_kind:"

	^ Dictionary new
		at: 0 	put: #unversioned;
		at: 1 	put: #none;			"does not exist"
		at: 2 	put: #unversioned;	"is not a versioned thing in this wc"
		at: 3 	put: #normal;		"exists, but uninteresting"
		at: 4 	put: #added;			"is scheduled for addition"
		at: 5 	put: #missing;		"under v.c., but is missing"
		at: 6 	put: #deleted;		"scheduled for deletion"
		at: 7 	put: #replaced;		"was deleted and then re-added"
		at: 8 	put: #modified;		"text or props have been modified"
		at: 9 	put: #merged;		"local mods received repos mods"
		at: 10 	put: #conflicted;	"local mods received conflicting repos mods"
		at: 11 	put: #ignored;		"is unversioned but configured to be ignored"
		at: 12 	put: #obstructed;	"an unversioned resource is in the way of the versioned resource"
		at: 13 	put: #external;		"an unversioned path populated by an svn:externals property"
		at: 14 	put: #incomplete;	"a directory doesn't contain a complete entries list"
		yourself.! !

!SVNStatusRequest class methodsFor: 'instance creation' stamp: 'cop 4/21/2008 17:33'!
target: svnDirectoryElement isRecursive: aBool

	^ self new
		target: svnDirectoryElement;
		isRecursive: aBool;
		yourself.! !

!SVNStatusRequest class methodsFor: 'instance creation' stamp: 'rkrk 5/6/2008 09:31'!
target: svnDirectoryElement isRecursive: aBool contactRepository: anotherBool

	^ self new
		target: svnDirectoryElement;
		isRecursive: aBool;
		contactRepository: anotherBool;
		yourself.! !

!SVNStatusRequest methodsFor: 'primitive' stamp: 'rkrk 4/12/2008 14:04'!
arrayForPrimitive

	"Put only an enum value (int) into the array.
	It is created in the primitive, so pass nil."
	^ {nil}.! !

!SVNStatusRequest methodsFor: 'accessing' stamp: 'rkrk 5/6/2008 09:31'!
contactRepository
	^ contactRepository! !

!SVNStatusRequest methodsFor: 'accessing' stamp: 'rkrk 5/6/2008 09:31'!
contactRepository: anObject
	contactRepository := anObject! !

!SVNStatusRequest methodsFor: 'execution' stamp: 'rkrk 5/6/2008 09:32'!
execute

	| arrayForPrimitive |
	
	arrayForPrimitive := self arrayForPrimitive.
	self assert: arrayForPrimitive size = 1.
	
	self errorCatcherDo: [
		self
			primSvnStatus: self target path pathForSvn
			revisionKind: nil revisionNumber: nil
			storeInArray: arrayForPrimitive
			recursive: self isRecursive
			contactRepository: self contactRepository].
	
	self processResult: arrayForPrimitive.! !

!SVNStatusRequest methodsFor: 'initialization' stamp: 'rkrk 5/6/2008 09:32'!
initialize
	super initialize.
	self
		isRecursive: true;
		contactRepository: false.! !

!SVNStatusRequest methodsFor: 'testing' stamp: 'test 4/30/2008 10:59'!
isAdded

	^ self statusKind = #added! !

!SVNStatusRequest methodsFor: 'testing' stamp: 'rkrk 4/7/2008 15:27'!
isConflicted

	^ self statusKind = #conflicted! !

!SVNStatusRequest methodsFor: 'testing' stamp: 'cop 5/10/2008 20:21'!
isModified

	^ self statusKind = #modified! !

!SVNStatusRequest methodsFor: 'testing' stamp: 'cop 4/28/2008 13:03'!
isNormal

	^ self statusKind = #normal! !

!SVNStatusRequest methodsFor: 'accessing' stamp: 'cop 4/21/2008 17:29'!
isRecursive
	^isRecursive! !

!SVNStatusRequest methodsFor: 'accessing' stamp: 'cop 4/21/2008 17:29'!
isRecursive: aBool
	isRecursive := aBool! !

!SVNStatusRequest methodsFor: 'primitive' stamp: 'rkrk 5/4/2008 23:50'!
primSvnStatus: targetString revisionKind: revKind revisionNumber: revNum storeInArray: arr recursive: bool contactRepository: otherBool

	<primitive: 'svnStatusForTargetRevisionKindRevisionNumberStoreInArrayRecursiveCheckRepositoryForChanges' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNStatusRequest methodsFor: 'execution' stamp: 'rkrk 4/3/2008 17:15'!
processResult: resultArray

	self statusKind: (self class statusKindDictionary at: (resultArray at: 1)).! !

!SVNStatusRequest methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 16:58'!
statusKind
	^ statusKind! !

!SVNStatusRequest methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 16:58'!
statusKind: anObject
	statusKind := anObject! !

SVNRequest subclass: #SVNUpdateRequest
	instanceVariableNames: 'revisionToUpdate beRecursive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

!SVNUpdateRequest class methodsFor: 'instance creation' stamp: 'rkrk 4/27/2008 13:42'!
target: svnElement updateToRevision: revisionToUpdate beRecursive: boolean

	^ self new
		target: svnElement;
		revisionToUpdate: revisionToUpdate;
		beRecursive: boolean;
		yourself.! !

!SVNUpdateRequest methodsFor: 'accessing' stamp: 'rkrk 4/27/2008 13:42'!
beRecursive
	^ beRecursive! !

!SVNUpdateRequest methodsFor: 'accessing' stamp: 'rkrk 4/27/2008 13:42'!
beRecursive: anObject
	beRecursive := anObject! !

!SVNUpdateRequest methodsFor: 'execution' stamp: 'rkrk 5/4/2008 22:45'!
execute

	self errorCatcherDo: [
		self
			primSvnUpdateTargets: (self target collect: [:ea | ea path pathForSvn])
			toRevisionkind: self revisionToUpdate kind
			revisionNumber: self revisionToUpdate number
			beRecursive: self beRecursive].! !

!SVNUpdateRequest methodsFor: 'primitive' stamp: 'rkrk 4/27/2008 15:56'!
primSvnUpdateTargets: collectionOfPathesToTargets toRevisionkind: revKind revisionNumber: revisionNumber beRecursive: bool
 
	<primitive: 'svnUpdateTargetsToRevisionKindRevisionNumberBeRecursive' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNUpdateRequest methodsFor: 'accessing' stamp: 'rkrk 4/27/2008 13:39'!
revisionToUpdate
	^ revisionToUpdate! !

!SVNUpdateRequest methodsFor: 'accessing' stamp: 'rkrk 4/27/2008 13:39'!
revisionToUpdate: anObject
	revisionToUpdate := anObject! !

Object subclass: #SVNRevision
	instanceVariableNames: 'number kind'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 5/4/2008 22:53'!
base
	".svn/entries current revision"

	^ self
		fromKindSymbol: #base
		number: 0.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/24/2008 12:05'!
fromKind: enumKindNumber number: number

	"Not for public use"
	^ self basicNew
		initialize;
		kind: enumKindNumber;
		number: number;
		yourself.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/24/2008 12:06'!
fromKindSymbol: symbol number: number

	"Not for public use"
	^ self
		fromKind: (self revisionKindDictionary at: symbol)
		number: number.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/25/2008 04:13'!
halloWelt

	self teilnehmerListe do: [: teilnehmer |
		Transcript
			show: 'Hallo ';
			show: teilnehmer;
			show: ' - Willkommen zum Etoys Workshop';
			cr.]! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 5/4/2008 22:53'!
head
	".svn/entries current revision"

	^ self
		fromKindSymbol: #head
		number: 0.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/23/2008 01:02'!
new

	self error: 'No new!! Use specific revisions!!'! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'test 5/10/2008 17:03'!
number
	"Use it only internal, The number should change soon."

	^ self
		fromKindSymbol: #number
		number: 0.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 3/24/2008 11:40'!
number: aNumber

	^ self
		fromKindSymbol: #number
		number: aNumber.! !

!SVNRevision class methodsFor: 'svn constants' stamp: 'rkrk 3/24/2008 11:48'!
revisionKindDictionary

	"enum svn_opt_revision_kind
		0 svn_opt_revision_unspecified - No revision information given.
		1 svn_opt_revision_number- revision given as number
		2 svn_opt_revision_date- revision given as date
		3 svn_opt_revision_committed- rev of most recent change
		4 svn_opt_revision_previous- (rev of most recent change) - 1
		5 svn_opt_revision_base- .svn/entries current revision
		6 svn_opt_revision_working - current, plus local mods
		7 svn_opt_revision_head- repository youngest"
	^ Dictionary new
		add: #unspecified 	-> 0;
		add: #number 		-> 1;
		add: #date 			-> 2;
		add: #committed 	-> 3;
		add: #previous 		-> 4;
		add: #base 			-> 5;
		add: #working 		-> 6;
		add: #head 			-> 7;
		yourself.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 5/4/2008 22:54'!
unspecified
	
	^ self
		fromKindSymbol: #unspecified
		number: 0.! !

!SVNRevision class methodsFor: 'instance creation' stamp: 'rkrk 5/4/2008 22:54'!
working
	"current, plus local mods"

	^ self
		fromKindSymbol: #working
		number: 0.! !

!SVNRevision methodsFor: 'comparing' stamp: 'rkrk 5/5/2008 00:16'!
= other

	super = other.
	^ self kind = other kind and: [self number = other number].! !

!SVNRevision methodsFor: 'converting' stamp: 'rkrk 3/24/2008 11:51'!
forSvnPrimitive

	self flag: #TODO.
	^ {self kind. self number} asOrderedCollection.! !

!SVNRevision methodsFor: 'testing' stamp: 'rkrk 3/24/2008 11:52'!
hash

	^ self number
		ifNil: [self kind hash]
		ifNotNil: [self number hash].! !

!SVNRevision methodsFor: 'accessing' stamp: 'rkrk 3/24/2008 11:44'!
kind
	^ kind! !

!SVNRevision methodsFor: 'accessing' stamp: 'rkrk 3/24/2008 11:44'!
kind: anObject
	kind := anObject! !

!SVNRevision methodsFor: 'accessing' stamp: 'rkrk 3/24/2008 11:45'!
kindSymbol
	^ self class revisionKindDictionary keyAtValue: self kind! !

!SVNRevision methodsFor: 'accessing' stamp: 'test 3/23/2008 02:43'!
number

	^ number! !

!SVNRevision methodsFor: 'accessing' stamp: 'rkrk 3/23/2008 00:59'!
number: anObject
	number := anObject! !

!SVNRevision methodsFor: 'printing' stamp: 'rkrk 3/25/2008 23:55'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self kindSymbol asString;
		nextPutAll: ' - ';
		nextPutAll: self number asString;
		nextPut: $).! !

Object subclass: #SVNRevisionInfo
	instanceVariableNames: 'revision author date comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Requests'!

SVNRevisionInfo class
	instanceVariableNames: 'revision author date comment'!

SVNRevisionInfo class
	instanceVariableNames: 'revision author date comment'!

!SVNRevisionInfo class methodsFor: 'instance creation' stamp: 'rkrk 5/4/2008 18:58'!
withRevision: aRevision author: anAuthor date: aDate comment: aComment

	^ self new
		revision: aRevision;
		author: anAuthor;
		date: aDate;
		comment: aComment;
		yourself.! !

!SVNRevisionInfo methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:16'!
author
	^ author! !

!SVNRevisionInfo methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:17'!
author: anAuthor
	author := anAuthor! !

!SVNRevisionInfo methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:15'!
comment
	^ comment! !

!SVNRevisionInfo methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:17'!
comment: aComment
	comment := aComment! !

!SVNRevisionInfo methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:16'!
date
	^ date! !

!SVNRevisionInfo methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:18'!
date: aDate
	date := aDate! !

!SVNRevisionInfo methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:16'!
revision
	^ revision! !

!SVNRevisionInfo methodsFor: 'accessing' stamp: 'mu 3/18/2008 16:18'!
revision: aRevision
	revision := aRevision! !

!SVNRevisionInfo methodsFor: 'printing' stamp: 'rkrk 4/3/2008 15:36'!
revisionAuthorDateString

	^ self revision asString, ' - ', self author , ' ' , self date asDateAndTime asTimeStamp asString! !

Object subclass: #SVNTestDirectory
	instanceVariableNames: 'directory isDirty number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

SVNTestDirectory subclass: #SVNAwareTestDirectory
	instanceVariableNames: 'workingCopyDirectory workingCopyDirectory2 repositoryDirectory'
	classVariableNames: 'UseTestEnvPlg'
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

!SVNAwareTestDirectory class methodsFor: 'testEnvPlg' stamp: 'rt 4/14/2008 00:08'!
testEnvPlgInUse

	UseTestEnvPlg ifNil: [^ false].
	^ UseTestEnvPlg! !

!SVNAwareTestDirectory class methodsFor: 'testEnvPlg' stamp: 'rt 4/13/2008 23:58'!
useOSProcess: bool

	UseTestEnvPlg := bool not! !

!SVNAwareTestDirectory class methodsFor: 'testEnvPlg' stamp: 'rt 4/13/2008 23:58'!
useTestEnvPlg: bool

	UseTestEnvPlg := bool! !

!SVNAwareTestDirectory methodsFor: 'consistency' stamp: 'rkrk 4/3/2008 03:09'!
checkConsistency
	
	| workingCopyIsDirty workingCopy2IsDirty |
	workingCopyIsDirty := (self workingCopyDirectory exists and:
					[self workingCopyDirectory entries size = 1]) not.
	"SVNAwareTestDirectories which were created before the addition of
	the second working copy have no workingCopyDirectory2. Declare them
	as dirty. this can be removed after everyone has fresh test directories"
	workingCopy2IsDirty := self workingCopyDirectory2 isNil.
	self directory: self directory.
	"Really test if wc2 is dirty"
	workingCopy2IsDirty ifFalse:
		[workingCopy2IsDirty := self workingCopyDirectory2 exists].
	
	self isDirty: (workingCopyIsDirty or: [workingCopy2IsDirty]).! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rkrk 4/3/2008 03:09'!
create

	super create.
	self
		createRepository;
		createWorkingCopy.! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rt 4/27/2008 00:55'!
createRepository
	
	self assert: (FileDirectory on: self repositoryPath) exists not.
	
	self class testEnvPlgInUse
		ifTrue: [TestEnvAcs svnCreateRepositoryOn: self repositoryPath]
		ifFalse: [OSProcess waitForCommand: 'svnadmin create "' , self repositoryPath ,'"'.]
	! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rkrk 4/3/2008 01:35'!
createSecondWorkingCopy

	self isDirty: true.
	self createWorkingCopyInPath: self workingCopyDirectory2 pathName.! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rkrk 4/3/2008 01:26'!
createWorkingCopy

	self createWorkingCopyInPath: self workingCopyDirectory pathName.! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rt 4/27/2008 00:55'!
createWorkingCopyInPath: path

	self assert: self repositoryDirectory exists.
	self assert: (FileDirectory on: path) exists not.
	
	self class testEnvPlgInUse
		ifTrue: [TestEnvAcs svnCheckoutHeadRevisionFrom: self repositoryURLPath to: path]
		ifFalse: [OSProcess waitForCommand:
		'svn co ' , self repositoryURLPath , ' "' , path , '"'.]
	! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 01:24'!
directory: aFileDirectory
	super directory: aFileDirectory.
	
	self
		workingCopyDirectory: (aFileDirectory directoryNamed: self nameForWorkingCopy);
		workingCopyDirectory2: (aFileDirectory directoryNamed: self nameForWorkingCopy2);
		repositoryDirectory: (aFileDirectory directoryNamed: self nameForRepository)! !

!SVNAwareTestDirectory methodsFor: 'OSProcess' stamp: 'rt 4/27/2008 00:49'!
executeViaOSProcessSynchronously: command

	OSProcess waitForCommand: command! !

!SVNAwareTestDirectory methodsFor: 'testing' stamp: 'rkrk 3/14/2008 22:39'!
isSvnAware

	^ true! !

!SVNAwareTestDirectory methodsFor: 'creating' stamp: 'rkrk 5/5/2008 11:22'!
makeRepositoryUnavailable

	self repositoryDirectory deleteRecursivelyPlatformIndependent.! !

!SVNAwareTestDirectory methodsFor: 'default' stamp: 'rkrk 3/14/2008 20:56'!
nameForRepository

	^ 'repository'! !

!SVNAwareTestDirectory methodsFor: 'default' stamp: 'rkrk 3/14/2008 20:56'!
nameForWorkingCopy

	^ 'workingCopy'! !

!SVNAwareTestDirectory methodsFor: 'default' stamp: 'rkrk 4/3/2008 01:24'!
nameForWorkingCopy2

	^ 'workingCopy2'! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 3/14/2008 22:02'!
pathForTests

	^ self workingCopyPath! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:10'!
repositoryDirectory

	^ repositoryDirectory! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:10'!
repositoryDirectory: aFileDirectory

	repositoryDirectory := aFileDirectory! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 3/14/2008 21:31'!
repositoryPath

	^ self repositoryDirectory pathName! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 3/14/2008 21:49'!
repositoryURLPath

	^ self repositoryDirectory asUrl asString! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:11'!
workingCopyDirectory

	^ workingCopyDirectory! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 01:24'!
workingCopyDirectory2
	^ workingCopyDirectory2! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 4/3/2008 01:24'!
workingCopyDirectory2: anObject
	workingCopyDirectory2 := anObject! !

!SVNAwareTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 04:08'!
workingCopyDirectory: aFileDirectory

	workingCopyDirectory := aFileDirectory! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 3/14/2008 22:03'!
workingCopyPath

	"Assume that when the path i accessed (should only be done by tests)
	the directory is dirty"
	self isDirty: true.
	^ self workingCopyDirectory pathName! !

!SVNAwareTestDirectory methodsFor: 'derived accessing' stamp: 'rkrk 4/3/2008 01:46'!
workingCopyPath2

	"Assume that when the path i accessed (should only be done by tests)
	the directory is dirty"
	self isDirty: true.
	^ self workingCopyDirectory2 pathName! !

SVNAwareTestDirectory subclass: #SVNRestrictedTestDirectory
	instanceVariableNames: 'accessible username password'
	classVariableNames: 'Daemon'
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

!SVNRestrictedTestDirectory class methodsFor: 'as yet unclassified' stamp: 'rt 4/27/2008 05:10'!
startDaemonOnRoot: aPath

	(Daemon isNil or: [Daemon isRunning not])
		ifTrue: [Daemon := OSProcess command: 'svnserve -r "' , aPath , '" -d'].
	[Daemon isRunning] whileFalse: [(Delay forMilliseconds: 100) wait]! !

!SVNRestrictedTestDirectory methodsFor: 'testing' stamp: 'rt 4/26/2008 20:47'!
accessRestricted

	^ true! !

!SVNRestrictedTestDirectory methodsFor: 'repository access' stamp: 'rt 4/27/2008 06:06'!
accessible

	"^ accessible"
	^ Daemon notNil and: [Daemon isRunning]! !

!SVNRestrictedTestDirectory methodsFor: 'repository access' stamp: 'rt 4/26/2008 17:01'!
accessible: anObject

	accessible := anObject! !

!SVNRestrictedTestDirectory methodsFor: 'consistency' stamp: 'rt 4/27/2008 05:55'!
checkConsistency

	| workingCopyIsDirty workingCopy2IsDirty usernameChanged passwordChanged hasRevisions revsDir |
	workingCopyIsDirty := (self workingCopyDirectory exists and:
					[self workingCopyDirectory entries size = 0]) not.
	
	workingCopy2IsDirty := self workingCopyDirectory2 notNil.
	workingCopy2IsDirty :=workingCopy2IsDirty ifTrue: [(self workingCopyDirectory2 exists" and:
					[self workingCopyDirectory2 entries size ~= 0]")].
			
	usernameChanged := self usernameForRepository ~= self defaultUsername.
	passwordChanged := self passwordForRepository ~= self defaultPassword.
	
	revsDir := (self repositoryDirectory directoryNamed: 'db') directoryNamed: 'revs'.
	hasRevisions := revsDir exists and: [revsDir entries size > 1].
	
	self isDirty: (workingCopyIsDirty or:
		[workingCopy2IsDirty] or:
		[usernameChanged] or:
		[passwordChanged] or:
		[hasRevisions]).! !

!SVNRestrictedTestDirectory methodsFor: 'accessing' stamp: 'rt 4/25/2008 10:56'!
checkoutSecondWorkingCopy

	self isDirty: true.
	self checkoutWorkingCopyInPath: self workingCopyDirectory2 pathName.! !

!SVNRestrictedTestDirectory methodsFor: 'accessing' stamp: 'rt 4/25/2008 10:55'!
checkoutWorkingCopy

	self isDirty: true.
	self checkoutWorkingCopyInPath: self workingCopyDirectory pathName.! !

!SVNRestrictedTestDirectory methodsFor: 'accessing' stamp: 'rt 4/27/2008 00:54'!
checkoutWorkingCopyInPath: path

	self flag: #TODO.
	self assert: self repositoryDirectory exists.
	self assert: (FileDirectory on: path) exists.
	
	"TestEnvPlg doesn't support any authentication"
	OSProcess waitForCommand:
		'svn co ' , self repositoryURLPath , ' "' , path , '"',
		' --username ' , self usernameForRepository , 
		' --password ' , self passwordForRepository.
	! !

!SVNRestrictedTestDirectory methodsFor: 'clearing' stamp: 'rt 4/26/2008 21:31'!
clear

	self makeRepositoryNonAccessible.
	super clear.! !

!SVNRestrictedTestDirectory methodsFor: 'repository configuration' stamp: 'rt 4/26/2008 19:00'!
configureRepository

	self writeConfigurationFile.
	self writePasswordFile.! !

!SVNRestrictedTestDirectory methodsFor: 'repository configuration' stamp: 'rt 4/26/2008 19:11'!
contentOfConfFile

	^ '### Visit http://subversion.tigris.org/ for more information.' , Character cr asString ,
	Character cr asString ,
	'[general]' , Character cr asString ,
	'anon-access = none' , Character cr asString ,
	'auth-access = write' , Character cr asString ,
	'password-db = passwd'.! !

!SVNRestrictedTestDirectory methodsFor: 'repository configuration' stamp: 'rt 4/26/2008 19:21'!
contentOfPasswdFile

	^ '[users]' , Character cr asString ,
	self usernameForRepository , ' = ' , self passwordForRepository! !

!SVNRestrictedTestDirectory methodsFor: 'creating' stamp: 'rt 4/26/2008 18:59'!
createRepository

	super createRepository.
	self configureRepository.! !

!SVNRestrictedTestDirectory methodsFor: 'creating' stamp: 'rt 4/25/2008 10:39'!
createWorkingCopyInPath: path

	self assert: self repositoryDirectory exists.
	self assert: (FileDirectory on: path) exists not.
	
	(FileDirectory on: path) assureExistence.
	
	self assert: (FileDirectory on: path) exists.! !

!SVNRestrictedTestDirectory methodsFor: 'default' stamp: 'rt 4/27/2008 05:25'!
defaultPassword

	^ 'password'! !

!SVNRestrictedTestDirectory methodsFor: 'default' stamp: 'rt 4/27/2008 05:25'!
defaultUsername

	^ 'username'! !

!SVNRestrictedTestDirectory methodsFor: 'initialization' stamp: 'rt 4/26/2008 19:46'!
initialize

	super initialize.
	accessible := false! !

!SVNRestrictedTestDirectory methodsFor: 'repository access' stamp: 'rt 4/27/2008 06:05'!
makeRepositoryAccessible

	self accessible ifTrue: [^ self].
	"self accessible: true."
	"[self runSvnServe] fork."
	self class startDaemonOnRoot: self serverRoot! !

!SVNRestrictedTestDirectory methodsFor: 'repository access' stamp: 'rt 4/27/2008 00:53'!
makeRepositoryNonAccessible

	self accessible ifFalse: [^ self].
	self accessible: false.
	
	"final call to stop last instances of svnserve"
	OSProcess waitForCommand: 'svn info svn://localhost/stop'.! !

!SVNRestrictedTestDirectory methodsFor: 'accessing' stamp: 'rt 4/27/2008 05:26'!
passwordForRepository

	password
		ifNil: [^ self defaultPassword]
		ifNotNil: [^ password]! !

!SVNRestrictedTestDirectory methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 06:31'!
repositoryURLPath

	| dir topDirName |
	self isDirty: true.
	self makeRepositoryAccessible.
	(Delay forMilliseconds: 50) wait.
	dir := self directory.
	topDirName := ( FileDirectory on: (dir pathName
		copyFrom: 1
		to: (dir pathName size - dir localName size - 1)) ) localName.
	^ 'svn://localhost/' , topDirName , '/' , dir localName , '/' , self nameForRepository! !

!SVNRestrictedTestDirectory methodsFor: 'repository access' stamp: 'rt 4/27/2008 05:11'!
runSvnServe
"that will not work"
"	[self accessible] whileTrue: [self
		executeViaOSProcessSynchronously: 'svnserve -r ' , self serverRoot , ' -X']"
	[self accessible] whileTrue: [OSProcess waitForCommand: 'svnserve -r ' , self serverRoot , ' -X']! !

!SVNRestrictedTestDirectory methodsFor: 'repository configuration' stamp: 'rt 4/27/2008 06:33'!
serverRoot

	| dir topDir |
	dir := self directory.
	topDir := FileDirectory on: (dir pathName
		copyFrom: 1
		to: (dir pathName size - dir localName size - 1)).
	^ topDir pathName
		copyFrom: 1
		to: ( topDir pathName size - topDir localName size - 1 )! !

!SVNRestrictedTestDirectory methodsFor: 'accessing' stamp: 'rt 4/26/2008 19:36'!
setPassword: aString

	password := aString.
	(self repositoryDirectory directoryExists: 'conf') ifTrue: [self writePasswordFile]! !

!SVNRestrictedTestDirectory methodsFor: 'accessing' stamp: 'rt 4/26/2008 19:36'!
setUsername: aString

	username := aString.
	(self repositoryDirectory directoryExists: 'conf') ifTrue: [self writePasswordFile]! !

!SVNRestrictedTestDirectory methodsFor: 'accessing' stamp: 'rt 4/27/2008 05:25'!
usernameForRepository

	username
		ifNil: [^ self defaultUsername]
		ifNotNil: [^ username]! !

!SVNRestrictedTestDirectory methodsFor: 'repository configuration' stamp: 'rt 4/26/2008 19:19'!
writeConfigurationFile

	| confDir |
	confDir := self repositoryDirectory directoryNamed: 'conf'.
	confDir deleteFileNamed: 'svnserve.conf'.
	
	(CrLfFileStream fileNamed: confDir pathName , FileDirectory slash , 'svnserve.conf')
		nextPutAll: self contentOfConfFile;
		close.! !

!SVNRestrictedTestDirectory methodsFor: 'repository configuration' stamp: 'rt 4/26/2008 19:19'!
writePasswordFile

	| confDir |
	confDir := self repositoryDirectory directoryNamed: 'conf'.
	confDir deleteFileNamed: 'passwd'.
	
	(CrLfFileStream fileNamed: confDir pathName , FileDirectory slash , 'passwd')
		nextPutAll: self contentOfPasswdFile;
		close.! !

!SVNTestDirectory class methodsFor: 'instance creation' stamp: 'rkrk 3/14/2008 20:39'!
theName: aName basePath: basePath

	^ self new
		directory: (FileDirectory on: basePath , FileDirectory slash , aName);
		yourself.! !

!SVNTestDirectory methodsFor: 'testing' stamp: 'rt 4/26/2008 20:48'!
accessRestricted

	^ false! !

!SVNTestDirectory methodsFor: 'consistency' stamp: 'rkrk 3/16/2008 17:17'!
checkConsistency
	
	self isDirty: (self directory exists and: [self directory entries size = 0]) not.
! !

!SVNTestDirectory methodsFor: 'clearing' stamp: 'rkrk 3/16/2008 01:24'!
clear

	self directory deleteRecursivelyPlatformIndependent! !

!SVNTestDirectory methodsFor: 'creating' stamp: 'rkrk 3/16/2008 05:21'!
create

	self directory exists ifTrue: [self reCreate. ^ self].
	self directory assureExistence.
	self isDirty: false.! !

!SVNTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 20:40'!
directory
	^ directory! !

!SVNTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 20:40'!
directory: anObject
	directory := anObject! !

!SVNTestDirectory methodsFor: 'initialization' stamp: 'test 3/16/2008 06:25'!
initialize

	super initialize.
	self isDirty: true.
	number := 1000 atRandom.! !

!SVNTestDirectory methodsFor: 'testing' stamp: 'rkrk 3/14/2008 21:58'!
isDirty

	^ isDirty! !

!SVNTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 22:00'!
isDirty: anObject
	isDirty := anObject! !

!SVNTestDirectory methodsFor: 'testing' stamp: 'rkrk 3/14/2008 22:39'!
isSvnAware

	"I cannot create repositories and stuff"
	^ false! !

!SVNTestDirectory methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 21:59'!
pathForTests

	"Assume that when the path i accessed (should only be done by tests)
	the directory is dirty"
	self isDirty: true.
	^ self directory pathName! !

!SVNTestDirectory methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 06:26'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: (self isDirty ifTrue: [''] ifFalse: ['not ']);
		nextPutAll: 'dirty';
		nextPutAll: ' ' , number asString;
		nextPut: $).! !

!SVNTestDirectory methodsFor: 'creating' stamp: 'rkrk 3/16/2008 05:25'!
reCreate

	self
		clear;
		create! !

Object subclass: #SVNTestDirectoryManager
	instanceVariableNames: 'currentDirectory basicTestDirectories svnAwareTestDirectories basePath svnRestrictedTestDirectories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

SVNTestDirectoryManager class
	instanceVariableNames: 'instance observingMorph'!

SVNTestDirectoryManager class
	instanceVariableNames: 'instance observingMorph'!

!SVNTestDirectoryManager class methodsFor: 'consistency' stamp: 'rkrk 3/16/2008 17:10'!
checkConsistency

	self getInstance checkConsistency.! !

!SVNTestDirectoryManager class methodsFor: 'convenience' stamp: 'rkrk 3/16/2008 04:09'!
createObservingMorph

	"SVNTestDirectoryManager createObservingMorph"
	observingMorph := SVNObservingMorph new.
	observingMorph
		openInWorld;
		start.! !

!SVNTestDirectoryManager class methodsFor: 'instance creation' stamp: 'rkrk 3/15/2008 03:05'!
getInstance

	"[SVNTestDirectoryManager getInstance]
	[SVNTestDirectoryManager instance: nil]"
	^ self instance
		ifNil: [instance := self basicNew initialize]
		ifNotNil: [self instance]! !

!SVNTestDirectoryManager class methodsFor: 'class initialization' stamp: 'rkrk 3/16/2008 17:10'!
initialize

	"self initialize"
	super initialize.
	World 
		when: #aboutToEnterWorld
		send: #checkConsistency to: self.! !

!SVNTestDirectoryManager class methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 02:57'!
instance

	^ instance! !

!SVNTestDirectoryManager class methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 02:58'!
instance: instanceOfSelf

	instance := instanceOfSelf! !

!SVNTestDirectoryManager class methodsFor: 'convenience' stamp: 'rkrk 3/16/2008 04:10'!
killObservingMorph

	"SVNTestDirectoryManager killObservingMorph"
	observingMorph
		stop;
		delete.! !

!SVNTestDirectoryManager class methodsFor: 'instance creation' stamp: 'rkrk 3/15/2008 01:45'!
new

	self error: 'Singleton. Call getInstance'.! !

!SVNTestDirectoryManager class methodsFor: 'convenience' stamp: 'rkrk 3/16/2008 07:02'!
reCreate

	"SVNTestDirectoryManager reCreate"
	[self getInstance reCreateTestDirectories. self beep] fork.! !

!SVNTestDirectoryManager class methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 01:19'!
uninstall

	self getInstance clear.
	self instance: nil.! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rt 4/12/2008 21:49'!
basePath
	basePath
		ifNil: [^ self basePath: FileDirectory default fullName , FileDirectory slash , 'svnTests'].
	^ basePath! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/15/2008 00:25'!
basePath: anObject
	basePath := anObject! !

!SVNTestDirectoryManager methodsFor: 'recreating' stamp: 'rkrk 3/18/2008 23:55'!
basicReCreateDirectories: directories howMany: number
"Recreate all or only the given number of directories.
Ignore if number > directories size"

	| dirtyDirs |
	dirtyDirs := directories select: [:ea | ea isDirty].
	dirtyDirs size > number ifTrue: [dirtyDirs := dirtyDirs first: number].
	dirtyDirs
		do: [:each | each reCreate]
		displayingProgress: 'Recreating dirty test directories'.! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 01:49'!
basicTestDirectories
	^ basicTestDirectories! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'test 3/16/2008 06:03'!
basicTestDirectories: anObject

	self assert: (anObject isKindOf: Set) not.
	"self assert: (anObject isKindOf: Array) not."
	basicTestDirectories := anObject! !

!SVNTestDirectoryManager methodsFor: 'consistency' stamp: 'rkrk 3/16/2008 17:28'!
checkConsistency

	self testDirectories
		do: [:ea | ea checkConsistency]
		displayingProgress: 'SVNTestDirectoryManager conistency check'.! !

!SVNTestDirectoryManager methodsFor: 'removing' stamp: 'rkrk 3/16/2008 01:27'!
clear

	self testDirectories do: [:ea | ea clear].
	(FileDirectory on: self basePath) deleteRecursivelyPlatformIndependent.! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 06:29'!
create: number fromClass: SVNDirectoryClass named: partOfName considerExisting: directories
"Create only as many new directories as needed. Reuse old ones"

	| newDirectories |
	^ directories size >= number
		ifTrue: [self reuse: number of: directories]
		ifFalse: [
			newDirectories := (directories size to: number - 1) collect: [:i |
				SVNDirectoryClass
					theName: partOfName , i asString
					basePath: self basePath].
				directories addAll: newDirectories asOrderedCollection.
				directories].! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 05:39'!
createBasicTestDirectories: number

	self basicTestDirectories: (self
		create: number
		fromClass: SVNTestDirectory
		named: 'SVNTestDirectory_'
		considerExisting: self basicTestDirectories).! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/19/2008 00:00'!
createBasicTestDirs: numberForBasic svnAwareTestDirs: numberForSvnAware
"This method should be called by a user for setting up the state
og the manager"

	self assert: self basePath notNil.
	self
		createBasicTestDirectories: numberForBasic;
		createSvnAwareTestDirectories: numberForSvnAware.
	self reCreateTestDirectories.! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 05:38'!
createSvnAwareTestDirectories: number

	self svnAwareTestDirectories: (self
		create: number
		fromClass: SVNAwareTestDirectory
		named: 'SVNAwareTestDirectory_'
		considerExisting: self svnAwareTestDirectories).! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rt 4/27/2008 03:12'!
createSvnRestrictedTestDirectories: number

	self svnRestrictedTestDirectories: (self
		create: number
		fromClass: SVNRestrictedTestDirectory
		named: 'SVNRestrictedTestDirectory_'
		considerExisting: self svnRestrictedTestDirectories).! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 22:26'!
currentDirectory
	^ currentDirectory! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/14/2008 22:26'!
currentDirectory: anObject
	currentDirectory := anObject! !

!SVNTestDirectoryManager methodsFor: 'finding' stamp: 'rt 4/26/2008 20:49'!
findCleanSvnAwareTestDirectory

	self assert: self svnAwareTestDirectories notEmpty.
	^ self findTestDirectoryWhichSatisfies: [:directory |
		directory isSvnAware and:
		[directory isDirty not] and:
		[directory accessRestricted not]].! !

!SVNTestDirectoryManager methodsFor: 'finding' stamp: 'rt 4/27/2008 18:29'!
findCleanSvnRestrictedTestDirectory

	self svnRestrictedTestDirectories ifEmpty: [self createSvnRestrictedTestDirectories: 20].
	^ self findTestDirectoryWhichSatisfies: [:directory |
		directory isSvnAware and:
		[directory isDirty not] and:
		[directory accessRestricted]].! !

!SVNTestDirectoryManager methodsFor: 'finding' stamp: 'rkrk 3/16/2008 02:06'!
findCleanTestDirectory

	self assert: self basicTestDirectories notEmpty.
	^ self findTestDirectoryWhichSatisfies: [:directory |
		directory isSvnAware not and: [directory isDirty not]].! !

!SVNTestDirectoryManager methodsFor: 'finding' stamp: 'rkrk 3/16/2008 03:04'!
findTestDirectoryWhichSatisfies: conditionBlock

	^ self testDirectories
		detect: conditionBlock
		ifNone: [self reCreatePercent: 10.
			self testDirectories detect: conditionBlock].! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 02:03'!
getPassword

	self
		assert: (self currentDirectory notNil and: [self currentDirectory accessRestricted])
		description: 'The calling test has not registered for SVN restricted directory support'.
	^ self currentDirectory passwordForRepository.! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 02:03'!
getUsername

	self
		assert: (self currentDirectory notNil and: [self currentDirectory accessRestricted])
		description: 'The calling test has not registered for SVN restricted directory support'.
	^ self currentDirectory usernameForRepository.! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rt 4/27/2008 01:52'!
initialize

	super initialize.
	self
		basicTestDirectories: OrderedCollection new;
		svnAwareTestDirectories: OrderedCollection new;
		svnRestrictedTestDirectories: OrderedCollection new.! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rkrk 5/5/2008 11:24'!
makeRepositoryUnavailable

	self currentDirectory makeRepositoryUnavailable! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 03:57'!
numberOfCleanBasicTestDirectories

	^ self basicTestDirectories count: [:each | each isDirty not]! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 03:57'!
numberOfCleanSvnAwareTestDirectories

	^ self svnAwareTestDirectories count: [:each | each isDirty not]! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rt 4/27/2008 01:52'!
numberOfCleanSvnRestrictedTestDirectories

	^ self svnRestrictedTestDirectories count: [:each | each isDirty not]! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 00:36'!
pathForTests

	self
		assert: self currentDirectory notNil
		description: 'The calling test has not registered for directory support'.
	^ self currentDirectory pathForTests! !

!SVNTestDirectoryManager methodsFor: 'helper' stamp: 'rkrk 3/16/2008 05:18'!
percent: percent of: total

	| result |
	result := (total * (percent / 100)) asInteger.
	result = 0 ifTrue: [^ 1]. "should at least be one"
	^ result! !

!SVNTestDirectoryManager methodsFor: 'printing' stamp: 'rt 4/27/2008 01:58'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: 'svn restricted ';
		nextPutAll: self svnRestrictedTestDirectories size asString;
		nextPut: $/;
		nextPutAll: self numberOfCleanSvnRestrictedTestDirectories asString;
		nextPutAll: ' svn aware: ';
		nextPutAll: self svnAwareTestDirectories size asString;
		nextPut: $/;
		nextPutAll: self numberOfCleanSvnAwareTestDirectories asString;
		nextPutAll: ' basic: ';
		nextPutAll: self basicTestDirectories size asString;
		nextPut: $/;
		nextPutAll: self numberOfCleanBasicTestDirectories asString;
		nextPut: $).! !

!SVNTestDirectoryManager methodsFor: 'recreating' stamp: 'rt 4/27/2008 01:50'!
reCreatePercent: percent

	self
		basicReCreateDirectories: self basicTestDirectories
	 	howMany: (self	percent: percent of: self basicTestDirectories size).
	self
		basicReCreateDirectories: self svnAwareTestDirectories
	 	howMany: (self	percent: percent of: self svnAwareTestDirectories size).
	self
		basicReCreateDirectories: self svnRestrictedTestDirectories
	 	howMany: (self	percent: percent of: self svnRestrictedTestDirectories size).! !

!SVNTestDirectoryManager methodsFor: 'recreating' stamp: 'rkrk 3/16/2008 02:41'!
reCreateTestDirectories

	self reCreatePercent: 100.! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rkrk 3/15/2008 01:22'!
registerForSvnAwareTestDirectory
	
	self currentDirectory: self findCleanSvnAwareTestDirectory! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rkrk 4/3/2008 01:48'!
registerForSvnAwareTestDirectoryWithTwoWorkingCopies

	self registerForSvnAwareTestDirectory.
	self currentDirectory createSecondWorkingCopy.! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rt 4/27/2008 01:47'!
registerForSvnRestrictedTestDirectory
	
	self currentDirectory: self findCleanSvnRestrictedTestDirectory! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rt 4/27/2008 01:47'!
registerForSvnRestrictedTestDirectoryWithTwoWorkingCopies

	self registerForSvnRestrictedTestDirectory.
	self currentDirectory createSecondWorkingCopy.! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rkrk 3/15/2008 01:22'!
registerForTestDirectory
	
	self currentDirectory: self findCleanTestDirectory! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 01:32'!
repositoryURLPath

	self
		assert: (self currentDirectory notNil and: [self currentDirectory isSvnAware])
		description: 'The calling test has not registered for SVN aware directory support'.
	^ self currentDirectory repositoryURLPath.! !

!SVNTestDirectoryManager methodsFor: 'initialization' stamp: 'rkrk 3/16/2008 06:15'!
reuse: number of: directories

	| directoriesNotNeeded |
	directoriesNotNeeded := (directories last: directories size - number).
	directoriesNotNeeded do: [:ea | ea clear].
	^ (directories first: number) asOrderedCollection! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 02:04'!
setPassword: aString

	self
		assert: (self currentDirectory notNil and: [self currentDirectory accessRestricted])
		description: 'The calling test has not registered for SVN restricted directory support'.
	^ self currentDirectory setPassword: aString.! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 02:04'!
setUsername: aString

	self
		assert: (self currentDirectory notNil and: [self currentDirectory accessRestricted])
		description: 'The calling test has not registered for SVN restricted directory support'.
	^ self currentDirectory setUsername: aString.! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rt 4/27/2008 02:31'!
stopAccessToRepository

	self
		assert: (self currentDirectory notNil and: [self currentDirectory isSvnAware])
		description: 'The calling test has not registered for SVN aware directory support'.
	self currentDirectory accessRestricted ifTrue: [self currentDirectory makeRepositoryNonAccessible]! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 01:49'!
svnAwareTestDirectories
	^ svnAwareTestDirectories! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rkrk 3/16/2008 06:00'!
svnAwareTestDirectories: anObject

	self assert: (anObject isKindOf: Set) not.
	self assert: (anObject isKindOf: Array) not.
	svnAwareTestDirectories := anObject! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rt 4/27/2008 02:06'!
svnRestrictedTestDirectories

	svnRestrictedTestDirectories ifNil: [self svnRestrictedTestDirectories: OrderedCollection new].
	^ svnRestrictedTestDirectories! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rt 4/27/2008 01:44'!
svnRestrictedTestDirectories: anObject

	self assert: (anObject isKindOf: Set) not.
	self assert: (anObject isKindOf: Array) not.
	svnRestrictedTestDirectories := anObject! !

!SVNTestDirectoryManager methodsFor: 'accessing' stamp: 'rt 4/27/2008 01:45'!
testDirectories

	^ self basicTestDirectories
		union: (self svnAwareTestDirectories
		union: self svnRestrictedTestDirectories)! !

!SVNTestDirectoryManager methodsFor: 'registering' stamp: 'rkrk 3/15/2008 02:38'!
unregister

	self flag: #TODO. "self currentDirectory: nil"
	self currentDirectory: self findCleanTestDirectory.! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rkrk 3/15/2008 01:32'!
workingCopyPath

	self
		assert: (self currentDirectory notNil and: [self currentDirectory isSvnAware])
		description: 'The calling test has not registered for SVN aware directory support'.
	^ self currentDirectory workingCopyPath.! !

!SVNTestDirectoryManager methodsFor: 'derived accessing' stamp: 'rkrk 4/3/2008 01:45'!
workingCopyPath2

	self assert: (self currentDirectory notNil
		and: [self currentDirectory isSvnAware]
		and: [self currentDirectory workingCopyDirectory2 exists]).
	^ self currentDirectory workingCopyPath2.! !

Object subclass: #SVNTool
	instanceVariableNames: 'builder window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

SVNTool subclass: #SVNCommitBrowser
	instanceVariableNames: 'svnElement comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNCommitBrowser class methodsFor: 'instance creation' stamp: 'rkrk 4/6/2008 02:21'!
openWith: svnElement

	^ self new
		svnElement: svnElement;
		open;
		yourself.
! !

!SVNCommitBrowser methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:22'!
buildCommentField

	^ (self builder pluggableInputFieldSpec new)
		model: self;
		getText: #comment;
		setText: #setComment:;
		frame: (0 @ 0 corner: 1 @ 0.3);
		yourself.! !

!SVNCommitBrowser methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:23'!
buildCommitButton
	
	^ (self builder pluggableButtonSpec new)
		model: self;
		label: self commitButtonLabel;
		action: #commit;
		color: #grayColor;
		frame: (0.4 @ 0.9 corner: 0.6 @ 1);
		yourself.! !

!SVNCommitBrowser methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:23'!
buildCommitSelectionTree

	^ (self builder pluggableTreeSpec new)
		frame: (0 @ 0.3 corner: 1 @ 0.9);
		yourself.! !

!SVNCommitBrowser methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:25'!
buildWidgets

	^ {self buildCommentField.
	self buildCommitSelectionTree.
	self buildCommitButton}! !

!SVNCommitBrowser methodsFor: 'accessing' stamp: 'rkrk 4/5/2008 23:18'!
comment

	^ comment ifNil: ['Enter a comment'].! !

!SVNCommitBrowser methodsFor: 'accessing' stamp: 'rkrk 4/5/2008 23:18'!
comment: aString

	comment := aString.! !

!SVNCommitBrowser methodsFor: 'commiting' stamp: 'mu 4/30/2008 09:50'!
commit
	| revisionNumber newRevisionNumber |
	self readAllInputs.
	revisionNumber := self getHeadRevisionNumber.
	self svnElement commitWithMessage: self comment.
	newRevisionNumber := self getHeadRevisionNumber.
	newRevisionNumber > revisionNumber 
		ifTrue: [ SVNCommitMessage openWith: self comment ]
		ifFalse: [ SVNMessageBox openWith: self noCommitString ].
	self close! !

!SVNCommitBrowser methodsFor: 'default' stamp: 'rkrk 4/5/2008 23:19'!
commitButtonLabel

	^ 'Commit'! !

!SVNCommitBrowser methodsFor: 'commiting' stamp: 'mu 4/30/2008 09:53'!
executeInfoRequest
	| request |
	request := SVNInfoRequest 
		target: self svnElement svnDirectoryEntry
		forRevision: SVNRevision head.
	request execute.
	^ request! !

!SVNCommitBrowser methodsFor: 'default' stamp: 'rkrk 4/6/2008 00:27'!
extent

	^ 400 @ 300! !

!SVNCommitBrowser methodsFor: 'commiting' stamp: 'mu 4/30/2008 09:54'!
getHeadRevisionNumber
	| request revisionNumber |
	request := self executeInfoRequest.
	revisionNumber := request revision number ifNil: [ revisionNumber := 0 ].
	^ revisionNumber! !

!SVNCommitBrowser methodsFor: 'default' stamp: 'rkrk 4/6/2008 00:27'!
label

	^ 'SqueakSVN Commit Browser'! !

!SVNCommitBrowser methodsFor: 'default' stamp: 'rkrk 5/4/2008 23:54'!
noCommitString
	
	^ 'Commit failure. No changes to the previous version?'! !

!SVNCommitBrowser methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 02:07'!
setComment: aText

	self comment: aText asString.
	^ true.! !

!SVNCommitBrowser methodsFor: 'accessing' stamp: 'rkrk 4/5/2008 23:17'!
svnElement
	^ svnElement! !

!SVNCommitBrowser methodsFor: 'accessing' stamp: 'rkrk 4/5/2008 23:17'!
svnElement: anObject
	svnElement := anObject! !

SVNTool subclass: #SVNCommitMessage
	instanceVariableNames: 'comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNCommitMessage class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/6/2008 02:22'!
openWith: aString

	^ self new
		comment: aString;
		open;
		yourself.! !

!SVNCommitMessage methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:49'!
buildLogMessageField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #logMessage;
		frame: (0 @ 0 corner: 1 @ 0.85);
		yourself.! !

!SVNCommitMessage methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:49'!
buildOKButton

	^ self builder pluggableButtonSpec new
		model: self;
		label: #okButtonLabel;
		action: #close;
		color: #grayColor;
		frame: (0.4 @ 0.85 corner: 0.6 @ 1);
		yourself.! !

!SVNCommitMessage methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:41'!
buildWidgets

	^ {self buildLogMessageField.
	self buildOKButton}.! !

!SVNCommitMessage methodsFor: 'accessing' stamp: 'mu 3/13/2008 14:26'!
comment
	^ comment! !

!SVNCommitMessage methodsFor: 'accessing' stamp: 'mu 3/13/2008 14:26'!
comment: aString
	comment := aString! !

!SVNCommitMessage methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:45'!
extent

	^ 300@200! !

!SVNCommitMessage methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:45'!
label

	^ 'Commit successful'! !

!SVNCommitMessage methodsFor: 'log message creation' stamp: 'rkrk 4/6/2008 01:46'!
logMessage

	| logMessage |
	logMessage := 
		('Comment:' asText) allBold,
		String tab,
		self comment,
		String cr,
		String cr,
		('Timestamp:' asText) allBold,
		String tab,
		"nicht schn, da nicht die Zeit von der Version sondern aktuelle Zeit"
		TimeStamp current asString.
	^ logMessage! !

!SVNCommitMessage methodsFor: 'default' stamp: 'mu 3/13/2008 14:32'!
okButtonLabel
	^ 'Ok'! !

SVNTool subclass: #SVNCreateRepositoryTool
	instanceVariableNames: 'repositoryName repositoryUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNCreateRepositoryTool class methodsFor: 'instance creation' stamp: 'rkrk 4/15/2008 20:32'!
initialize

	"self initialize"
	self registerInOpenMenu.
! !

!SVNCreateRepositoryTool class methodsFor: 'instance creation' stamp: 'rkrk 4/15/2008 16:35'!
open

	^ self new
		open;
		yourself.
! !

!SVNCreateRepositoryTool class methodsFor: 'instance creation' stamp: 'rkrk 4/15/2008 20:31'!
registerInOpenMenu

	TheWorldMenu registerOpenCommand: {'SVNCreateRepositoryTool'. {self. #open}}.! !

!SVNCreateRepositoryTool methodsFor: 'building' stamp: 'rkrk 4/15/2008 16:36'!
buildGenerateRepositoryButton
	
	^ (self builder pluggableButtonSpec new)
		model: self;
		label: self generateRepositoryButtonLabel;
		action: #generate;
		color: #grayColor;
		frame: (0.2 @ 0.8 corner: 0.8 @ 1);
		yourself.! !

!SVNCreateRepositoryTool methodsFor: 'building' stamp: 'rkrk 4/21/2008 01:41'!
buildRepositoryNameField

	^ (self builder pluggableInputFieldSpec new)
		model: self;
		getText: #repositoryName;
		setText: #setRepositoryName:;
		frame: (0 @ 0 corner: 1 @ 0.3);
		yourself.! !

!SVNCreateRepositoryTool methodsFor: 'building' stamp: 'rkrk 4/15/2008 20:23'!
buildRepositoryPathField

	^ (self builder pluggableInputFieldSpec new)
		model: self;
		getText: #repositoryUrl;
		frame: (0 @ 0.3 corner: 1 @ 0.8);
		yourself.! !

!SVNCreateRepositoryTool methodsFor: 'building' stamp: 'rkrk 4/15/2008 16:29'!
buildWidgets

	^ {self buildRepositoryNameField.
	self buildRepositoryPathField.
	self buildGenerateRepositoryButton}! !

!SVNCreateRepositoryTool methodsFor: 'default' stamp: 'rkrk 4/15/2008 16:42'!
defaultRepositoryNameInfo

	^ 'Please type in a name for the repository.'! !

!SVNCreateRepositoryTool methodsFor: 'default' stamp: 'rkrk 4/15/2008 16:36'!
extent

	^ 400 @ 200! !

!SVNCreateRepositoryTool methodsFor: 'generating' stamp: 'rt 4/27/2008 00:52'!
generate

	| repositoryDir |
	self repositoryName = self defaultRepositoryNameInfo ifTrue: [
		UIManager default inform: 'Please specify a local repository name'. ^ self].
	repositoryDir := (FileDirectory default directoryNamed: self repositoryName).
	OSProcess waitForCommand: 'svnadmin create "' , repositoryDir pathName , '"'.
	self assert: repositoryDir exists.
	self repositoryUrl: repositoryDir asUrl asString.
	self changed: #repositoryUrl.! !

!SVNCreateRepositoryTool methodsFor: 'default' stamp: 'rkrk 4/15/2008 16:31'!
generateRepositoryButtonLabel

	^ 'Generate Repository'! !

!SVNCreateRepositoryTool methodsFor: 'default' stamp: 'rkrk 4/15/2008 16:31'!
label

	^ 'SqueakSVN Create Repository Tool'! !

!SVNCreateRepositoryTool methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 16:42'!
repositoryName
	^ repositoryName ifNil: [self defaultRepositoryNameInfo]! !

!SVNCreateRepositoryTool methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 16:35'!
repositoryName: anObject
	repositoryName := anObject! !

!SVNCreateRepositoryTool methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 20:23'!
repositoryUrl
	^ repositoryUrl! !

!SVNCreateRepositoryTool methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 20:23'!
repositoryUrl: anObject
	repositoryUrl := anObject! !

!SVNCreateRepositoryTool methodsFor: 'accessing' stamp: 'rkrk 4/15/2008 20:10'!
setRepositoryName: aText

	(aText asString includes: Character space) ifTrue: [^ false].
	self repositoryName: aText asString.
	^ true.! !

SVNTool subclass: #SVNMergeTool
	instanceVariableNames: 'selectedDifference differences newElement oldElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

SVNMergeTool subclass: #SVNDiffTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNDiffTool methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 02:51'!
diffMorph

	^ self window allMorphs detect: [:ea | ea isKindOf: DiffMorph]! !

!SVNMergeTool class methodsFor: 'user interface' stamp: 'rkrk 5/13/2008 03:52'!
openWithNewSvnElement: newElement oldElement: oldElement

	"self open"
	^ self new
		newElement: newElement;
		oldElement: oldElement;
		generateDifferences;
		open;
		yourself.
! !

!SVNMergeTool methodsFor: 'building' stamp: 'mu 5/6/2008 17:01'!
buildCommitButton
	^ (self builder pluggableButtonSpec new)
		model: self;
		label: self commitButtonLabel;
		action: #commitDifferences;
		color: #grayColor;
		frame: (0.75 @ 0.4 corner: 1 @ 0.5);
		yourself.
	! !

!SVNMergeTool methodsFor: 'building' stamp: 'rkrk 5/13/2008 01:24'!
buildDiffPanel

	^ self builder diffSpec new
		name: 'DiffMorph';
		frame: (0 @ 0.5 corner: 1 @ 1);
		yourself! !

!SVNMergeTool methodsFor: 'building' stamp: 'rkrk 5/13/2008 02:53'!
buildDifferenceList
	
	^ (self builder pluggableListSpec new)
		model: self;
		list: #listDifferences;
		getIndex: #differencesIndex;
		setIndex: #differencesIndex:;
		frame: (0 @ 0 corner: 1 @ 0.4);
		yourself.! !

!SVNMergeTool methodsFor: 'building' stamp: 'mu 5/6/2008 17:07'!
buildFirstVersionPanel
	^ self builder pluggableTextSpec new
		model: self;
		frame: (0 @ 0.5 corner: 0.3 @ 1);
		yourself! !

!SVNMergeTool methodsFor: 'building' stamp: 'mu 5/6/2008 16:06'!
buildNextDiffButton
	^ (self builder pluggableButtonSpec new)
		model: self;
		label: self nextDiffButtonLabel;
		action: #nextDiff;
		color: #grayColor;
		frame: (0 @ 0.4 corner: 0.25 @ 0.5);
		yourself.
	! !

!SVNMergeTool methodsFor: 'building' stamp: 'mu 5/6/2008 17:05'!
buildSaveButton
	^ (self builder pluggableButtonSpec new)
		model: self;
		label: self saveButtonLabel;
		action: #saveDifferences;
		color: #grayColor;
		frame: (0.5 @ 0.4 corner: 0.75 @ 0.5);
		yourself.
	! !

!SVNMergeTool methodsFor: 'building' stamp: 'mu 5/6/2008 17:07'!
buildSecondVersionPanel
	^ self builder pluggableTextSpec new
		frame: (0.7 @ 0.5 corner: 1 @ 1);
		yourself! !

!SVNMergeTool methodsFor: 'building' stamp: 'rkrk 5/13/2008 02:58'!
buildWidgets
	
	^ { self buildDifferenceList.
		self	buildNextDiffButton.
		self	buildCommitButton.
		self	buildSaveButton.
		self	buildDiffPanel.
"		self	buildFirstVersionPanel.
		self	buildSecondVersionPanel.
		self	buildDiffPanel ."
	 }! !

!SVNMergeTool methodsFor: 'buttons' stamp: 'mu 5/6/2008 16:59'!
commitButtonLabel
	
	^ 'Commit Differences'! !

!SVNMergeTool methodsFor: 'buttons' stamp: 'mu 5/6/2008 16:59'!
commitDifferences

	^ ''! !

!SVNMergeTool methodsFor: 'accessing' stamp: 'rkrk 5/13/2008 02:59'!
differences
	^ differences! !

!SVNMergeTool methodsFor: 'accessing' stamp: 'rkrk 5/13/2008 02:59'!
differences: anObject
	differences := anObject! !

!SVNMergeTool methodsFor: 'building' stamp: 'rkrk 5/13/2008 02:59'!
differencesIndex

	self selectedDifference ifNil: [^ 0].
	^ self differences indexOf: self selectedDifference.! !

!SVNMergeTool methodsFor: 'building' stamp: 'rkrk 5/13/2008 03:02'!
differencesIndex: index

	self selectedDifference: (self differences at: index ifAbsent: [nil]).
	self
		changed: #differencesIndex;
		updateDiffMorph.
! !

!SVNMergeTool methodsFor: 'default' stamp: 'mu 5/6/2008 15:58'!
extent

	^ 700 @ 500! !

!SVNMergeTool methodsFor: 'initialization' stamp: 'rkrk 5/13/2008 05:26'!
generateDifferences

	| differ |
	differ := SVNDiffCreator
		diff: self newElement 
		against: self oldElement.
	self differences: differ differences! !

!SVNMergeTool methodsFor: 'default' stamp: 'rkrk 5/13/2008 01:27'!
label

	"^ 'Commit- and Mergetool'"
	^ 'SVNDiffViewer'! !

!SVNMergeTool methodsFor: 'building' stamp: 'rkrk 5/13/2008 02:54'!
listDifferences

	^ self differences collect: [:ea | ea asString].! !

!SVNMergeTool methodsFor: 'accessing' stamp: 'rkrk 5/13/2008 03:51'!
newElement
	^ newElement! !

!SVNMergeTool methodsFor: 'accessing' stamp: 'rkrk 5/13/2008 03:51'!
newElement: anObject
	newElement := anObject! !

!SVNMergeTool methodsFor: 'buttons' stamp: 'mu 5/6/2008 17:06'!
nextDiff

	^ ''! !

!SVNMergeTool methodsFor: 'buttons' stamp: 'mu 5/6/2008 16:01'!
nextDiffButtonLabel
	
	^ 'Next Difference'! !

!SVNMergeTool methodsFor: 'accessing' stamp: 'rkrk 5/13/2008 03:51'!
oldElement
	^ oldElement! !

!SVNMergeTool methodsFor: 'accessing' stamp: 'rkrk 5/13/2008 03:51'!
oldElement: anObject
	oldElement := anObject! !

!SVNMergeTool methodsFor: 'buttons' stamp: 'mu 5/6/2008 16:59'!
saveButtonLabel
	
	^ 'Save Differences'! !

!SVNMergeTool methodsFor: 'buttons' stamp: 'mu 5/6/2008 17:00'!
saveDifferences

	^ ''! !

!SVNMergeTool methodsFor: 'accessing' stamp: 'rkrk 5/13/2008 02:59'!
selectedDifference
	^ selectedDifference! !

!SVNMergeTool methodsFor: 'accessing' stamp: 'rkrk 5/13/2008 02:59'!
selectedDifference: anObject
	selectedDifference := anObject! !

!SVNMergeTool methodsFor: 'updating' stamp: 'rkrk 5/13/2008 05:22'!
updateDiffMorph

	self selectedDifference ifNil: [^ self].
	self selectedDifference populateDiffer: self diffMorph.! !

SVNTool subclass: #SVNMessageBox
	instanceVariableNames: 'comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNMessageBox class methodsFor: 'instance creation' stamp: 'rt 4/22/2008 16:37'!
openWith: aString

	^ self new
		comment: aString;
		open;
		yourself.! !

!SVNMessageBox methodsFor: 'building' stamp: 'rt 4/22/2008 16:47'!
buildMessageField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #comment;
		frame: (0 @ 0 corner: 1 @ 0.65);
		yourself.! !

!SVNMessageBox methodsFor: 'building' stamp: 'rt 4/22/2008 16:47'!
buildOKButton

	^ self builder pluggableButtonSpec new
		model: self;
		label: #okButtonLabel;
		action: #close;
		color: #grayColor;
		frame: (0.4 @ 0.65 corner: 0.6 @ 1);
		yourself.! !

!SVNMessageBox methodsFor: 'building' stamp: 'rt 4/22/2008 16:44'!
buildWidgets

	^ {self buildMessageField.
	self buildOKButton}.! !

!SVNMessageBox methodsFor: 'accessing' stamp: 'rt 4/22/2008 16:37'!
comment
	^ comment! !

!SVNMessageBox methodsFor: 'accessing' stamp: 'rt 4/22/2008 16:37'!
comment: aString
	comment := aString! !

!SVNMessageBox methodsFor: 'default' stamp: 'rt 4/22/2008 16:50'!
extent

	^ 270@100! !

!SVNMessageBox methodsFor: 'default' stamp: 'rt 4/22/2008 16:42'!
label

	^ 'SVN Notification'! !

!SVNMessageBox methodsFor: 'default' stamp: 'rt 4/22/2008 16:37'!
okButtonLabel
	^ 'Ok'! !

SVNTool subclass: #SVNModalTool
	instanceVariableNames: 'done response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

SVNModalTool subclass: #SVNCreateProjectDialog
	instanceVariableNames: 'svnProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNCreateProjectDialog class methodsFor: 'as yet unclassified' stamp: 'rt 5/7/2008 13:58'!
call
	^ (self new)
		svnProject: SVNInformationGathererForSVNProject new;
		open;
		call! !

!SVNCreateProjectDialog methodsFor: 'building' stamp: 'mu 4/7/2008 13:42'!
buildCreateProjectButton

	^ self builder pluggableButtonSpec new
		model: self;
		label: self projectButtonLabel;
		action: #finished;
		color: #greenColor;
		state: #canAccept;
		frame: (0.3 @ 0.8 corner: 0.7 @ 1);
		yourself.! !

!SVNCreateProjectDialog methodsFor: 'building' stamp: 'rkrk 4/6/2008 02:23'!
buildProjectNameField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #projectName;
		setText: #setProjectName:;
		frame: (0 @ 0 corner: 1 @ 0.266);
		yourself.! !

!SVNCreateProjectDialog methodsFor: 'building' stamp: 'rkrk 4/6/2008 02:23'!
buildUrlField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #projectUrl;
		setText: #setProjectUrl:;
		frame: (0 @ 0.266 corner: 1 @ 0.533);
		yourself.! !

!SVNCreateProjectDialog methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:59'!
buildWidgets

	^ {self buildProjectNameField.
	self buildUrlField.
	self buildWorkingCopyPathField.
	self buildCreateProjectButton}.! !

!SVNCreateProjectDialog methodsFor: 'building' stamp: 'rkrk 4/6/2008 02:24'!
buildWorkingCopyPathField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #projectWorkingCopyPath;
		setText: #setProjectWorkingCopyPath:;
		frame: (0 @ 0.533 corner: 1 @ 0.8);
		yourself.! !

!SVNCreateProjectDialog methodsFor: 'testing' stamp: 'rt 5/7/2008 14:42'!
canAccept
	^ self projectName ~= self projectButtonLabel and:
		[self projectUrl ~= self defaultURL] and:
		[self projectUrlAvailable] and:
		[self projectWorkingCopyPath ~= self defaultWCPath] and:
		[self projectWorkingCopyPath ~= (FileUrl absoluteFromText: self projectUrl) path first].! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:53'!
defaultProjectName

	^ 'Insert the project name here.'! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:53'!
defaultURL

	^ 'Insert the repository URL here'! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rt 5/7/2008 14:38'!
defaultWCPath

	^ '(optional) Insert the working copy path here'! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:55'!
extent

	^ 300 @ 180! !

!SVNCreateProjectDialog methodsFor: 'accepting' stamp: 'rt 5/7/2008 14:32'!
finished

	self readAllInputs.
	self setProjectWorkingCopyPathIfReqiured.
	self canAccept ifFalse: [^ self].
	self answer: self svnProject.
	self closeIfOpen.! !

!SVNCreateProjectDialog methodsFor: 'converting' stamp: 'rkrk 4/6/2008 02:42'!
getFullPathFor: aString

	aString asURI isAbsolute ifTrue: [^ aString].
	^ FileDirectory fullPathForURI: aString! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:55'!
label

	^ 'Create a SVNProject'.! !

!SVNCreateProjectDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 02:02'!
projectButtonLabel

	^ 'Create project'! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rkrk 4/6/2008 02:55'!
projectName

	^ self svnProject theName
		ifEmpty: [self defaultProjectName]
		ifNotEmptyDo: [:name | name].! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rt 5/7/2008 12:55'!
projectUrl

	^ self svnProject repositoryURL
		ifEmpty: [self defaultURL]
		ifNotEmpty: [:url | url asString].! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rt 5/7/2008 14:42'!
projectUrlAvailable

	^ self svnProject repositoryExists! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rt 5/7/2008 12:56'!
projectWorkingCopyPath

	^ self svnProject workingCopyPath
		ifEmpty: [self defaultWCPath]
		ifNotEmpty: [:dir | dir asString].! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'cop 4/18/2008 13:02'!
setProjectName: stringOrText
	self svnProject theName: stringOrText asString.
	^ true! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rkrk 4/21/2008 01:31'!
setProjectUrl: stringOrText
	
	self svnProject repositoryURL: stringOrText asString.
	^ true! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rt 5/7/2008 12:55'!
setProjectWorkingCopyPath: stringOrText

	| path |
	path := self getFullPathFor: stringOrText asString.
	self svnProject workingCopyPath: path.
	^ true! !

!SVNCreateProjectDialog methodsFor: 'derived accessing' stamp: 'rt 5/7/2008 14:40'!
setProjectWorkingCopyPathIfReqiured

	self projectWorkingCopyPath = self defaultWCPath
		ifTrue: [self setProjectWorkingCopyPath: '.'].! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 02:18'!
svnProject
	^ svnProject! !

!SVNCreateProjectDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 02:18'!
svnProject: anObject
	svnProject := anObject! !

!SVNModalTool methodsFor: 'modal actions' stamp: 'rkrk 4/6/2008 21:30'!
answer: object

	response := object.
	self endModalState.! !

!SVNModalTool methodsFor: 'building' stamp: 'rkrk 4/6/2008 21:18'!
buildMainWindow
	
	^ super buildMainWindow
		closeAction: #endModalState;
		yourself.! !

!SVNModalTool methodsFor: 'modal actions' stamp: 'rkrk 4/6/2008 22:20'!
call
	
	"Pattern taken from FillInTheBlankMorph"
	"Answers nil if canceled"
	| world |
	world := World.
	done := false.
	[done] whileFalse: [world doOneCycle].
	self closeIfOpen.
	world doOneCycle.
	^ response! !

!SVNModalTool methodsFor: 'modal actions' stamp: 'rkrk 4/6/2008 21:24'!
closeIfOpen

	"Dirty hack. If the close (X) button is clicked then #close is called two times.
	The second time the widget is already closed, so the delete call results in an error."
	[self close] on: MessageNotUnderstood do: [].! !

!SVNModalTool methodsFor: 'modal actions' stamp: 'rkrk 4/6/2008 21:30'!
endModalState

	done := true.! !

SVNModalTool subclass: #SVNRequestDialog
	instanceVariableNames: 'label text canAccepBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

SVNRequestDialog subclass: #SVNAuthenticationRequestDialog
	instanceVariableNames: 'username password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNAuthenticationRequestDialog class methodsFor: 'instance creation' stamp: 'rt 4/22/2008 17:48'!
ask: questionString template: templateString canAcceptBlock: aBlock

	^ superclass ask: questionString template: templateString canAcceptBlock: aBlock! !

!SVNAuthenticationRequestDialog class methodsFor: 'instance creation' stamp: 'rkrk 4/30/2008 14:29'!
withUsernameTemplate: usernameString andPasswordTemplate: passwordString

	^ self new
		canAccepBlock: [:ea | true];
		username: usernameString;
		password: passwordString;
		open;
		call.! !

!SVNAuthenticationRequestDialog methodsFor: 'building' stamp: 'rt 4/22/2008 18:21'!
buildPasswordField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #password;
		setText: #password:;
		frame: (0.26 @ 0.3 corner: 1 @ 0.6);
		yourself.! !

!SVNAuthenticationRequestDialog methodsFor: 'building' stamp: 'rt 4/22/2008 18:20'!
buildPasswordFieldDescriptionField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #passwordDescriptionText;
		frame: (0 @ 0.3 corner: 0.25 @ 0.6);
		yourself.! !

!SVNAuthenticationRequestDialog methodsFor: 'building' stamp: 'rt 4/22/2008 18:21'!
buildUsernameField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #username;
		setText: #username:;
		frame: (0.26 @ 0 corner: 1 @ 0.25);
		yourself.! !

!SVNAuthenticationRequestDialog methodsFor: 'building' stamp: 'rt 4/22/2008 18:21'!
buildUsernameFieldDescriptionField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #usernameDescriptionText;
		frame: (0 @ 0 corner: 0.25 @ 0.25);
		yourself.! !

!SVNAuthenticationRequestDialog methodsFor: 'building' stamp: 'rt 4/22/2008 18:19'!
buildWidgets
	
	^ {self buildUsernameFieldDescriptionField.
	self buildPasswordFieldDescriptionField.
	self buildUsernameField.
	self buildPasswordField.
	self buildOKButton}.! !

!SVNAuthenticationRequestDialog methodsFor: 'confirming' stamp: 'rt 4/22/2008 17:50'!
confirm

	self readAllInputs.
	self canAccept ifFalse: [^ self].
	self answer: (SVNUser
		user: self username asString
		password: self password asString).
	self closeIfOpen.! !

!SVNAuthenticationRequestDialog methodsFor: 'default' stamp: 'rt 4/22/2008 17:41'!
extent

	^ 300@100! !

!SVNAuthenticationRequestDialog methodsFor: 'default' stamp: 'rt 4/22/2008 17:39'!
label

	^ 'SVN Authentication Request'! !

!SVNAuthenticationRequestDialog methodsFor: 'accessing' stamp: 'rt 4/22/2008 17:13'!
password

	^ password! !

!SVNAuthenticationRequestDialog methodsFor: 'accessing' stamp: 'rt 4/22/2008 17:47'!
password: aStringOrText

	password := aStringOrText.
	^ self canAccept! !

!SVNAuthenticationRequestDialog methodsFor: 'accessing' stamp: 'rt 4/22/2008 18:18'!
passwordDescriptionText

	^ 'Password:' asText allBold! !

!SVNAuthenticationRequestDialog methodsFor: 'accessing' stamp: 'rt 4/22/2008 17:12'!
username

	^ username! !

!SVNAuthenticationRequestDialog methodsFor: 'accessing' stamp: 'rt 4/22/2008 17:47'!
username: aStringOrText

	username := aStringOrText.
	^ self canAccept! !

!SVNAuthenticationRequestDialog methodsFor: 'accessing' stamp: 'rt 4/22/2008 18:18'!
usernameDescriptionText

	^ 'Username:' asText allBold! !

!SVNRequestDialog class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/7/2008 03:55'!
ask: questionString template: templateString canAcceptBlock: aBlock

	^ self new
		canAccepBlock: aBlock;
		label: questionString;
		text: templateString;
		open;
		call.! !

!SVNRequestDialog methodsFor: 'building' stamp: 'rkrk 4/7/2008 03:49'!
buildOKButton
	
	^ self builder pluggableButtonSpec new
		model: self;
		label: self okButtonLabel;
		action: #confirm;
		color: #greenColor;
		state: #canAccept;
		frame: (0.3 @ 0.6 corner: 0.7 @ 1);
		yourself.! !

!SVNRequestDialog methodsFor: 'building' stamp: 'rkrk 4/7/2008 03:49'!
buildTextField

	^ self builder pluggableInputFieldSpec new
		model: self;
		getText: #text;
		setText: #text:;
		frame: (0 @ 0 corner: 1 @ 0.6);
		yourself.! !

!SVNRequestDialog methodsFor: 'building' stamp: 'rkrk 4/6/2008 22:04'!
buildWidgets
	
	^ {self buildTextField.
	self buildOKButton}.! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:15'!
canAccepBlock
	^ canAccepBlock! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:15'!
canAccepBlock: anObject
	canAccepBlock := anObject! !

!SVNRequestDialog methodsFor: 'testing' stamp: 'rkrk 4/6/2008 22:10'!
canAccept

	^ self canAccepBlock value: self text.! !

!SVNRequestDialog methodsFor: 'confirming' stamp: 'rkrk 4/21/2008 12:38'!
confirm

	self readAllInputs.
	self canAccept ifFalse: [^ self].
	self answer: self text asString.
	self closeIfOpen.! !

!SVNRequestDialog methodsFor: 'default' stamp: 'rkrk 4/7/2008 03:50'!
extent

	^ 220@100! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:10'!
label

	^ label! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:14'!
label: aString

	label := aString! !

!SVNRequestDialog methodsFor: 'default' stamp: 'rkrk 4/6/2008 22:11'!
okButtonLabel

	^ 'Confirm'! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 22:14'!
text
	^ text! !

!SVNRequestDialog methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 03:54'!
text: anObject

	text := anObject.
	^ self canAccept! !

SVNTool subclass: #SVNProjectBrowser
	instanceVariableNames: 'svnEnvironment projectNodes selectedNode summaryNode selectedRevisionInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Tools'!

!SVNProjectBrowser class methodsFor: 'initialization' stamp: 'rkrk 4/15/2008 20:35'!
initialize

	"self initialize"
	self registerInOpenMenu.! !

!SVNProjectBrowser class methodsFor: 'instance creation' stamp: 'rkrk 4/25/2008 14:45'!
open

	self flag: #TODO.
	^ self openWithSvnEnvironment: SVNRegistry current createSvnEnvironment.! !

!SVNProjectBrowser class methodsFor: 'instance creation' stamp: 'cop 4/24/2008 12:55'!
openWithSvnEnvironment: svnEnvironment

	^ self new
		svnEnvironment: svnEnvironment;
		beDependentFromProjects;
		open;
		yourself.! !

!SVNProjectBrowser class methodsFor: 'initialization' stamp: 'rkrk 4/15/2008 20:35'!
registerInOpenMenu

	TheWorldMenu registerOpenCommand: {'SVNProjectBrowser'. {self. #open}}.! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'cop 4/22/2008 14:56'!
beDependentFromClassesOfProject: aSVNProject

	aSVNProject versionedClasses do: [:each |
			each addDependent: self.
			self beDependentFromMethodsOfClass: each ].! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'cop 4/22/2008 14:56'!
beDependentFromMethodsOfClass: aSVNClass

	aSVNClass versionedMethods do: [:each |
			each addDependent: self].! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'rkrk 5/6/2008 00:26'!
beDependentFromProjects

	self svnEnvironment svnProjects do: [:project |
		project allElements do: [:each |
			each addDependent: self ].
		self flag: #TODO. "why #beDependentFromClassesOfProject:???
		#allElements includes classes already!!!!!!"
		self beDependentFromClassesOfProject: project].! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'rkrk 4/20/2008 15:08'!
beIndependentFromSvnProjects

	self svnEnvironment svnProjects do: [:project |
		project allElements do: [:each |
			each removeDependent: self]].! !

!SVNProjectBrowser methodsFor: 'building' stamp: 'rkrk 5/13/2008 07:56'!
buildButtonsFromCommands
"This methods creates commands from #commandClasses. For each command a button
is created and inserted at the bottom of the browser"
	| buttonHeight commands numberOfButtons buttonWidth buttonX buttonSpec |
	self flag: #TODO. "Refactor"
	buttonHeight := 0.9.
	commands := self commands select: [:ea | ea wantsButton].
	numberOfButtons := commands size.
	buttonWidth := 1 / numberOfButtons.
	buttonX := 0.
	^ commands collect: [:ea |
		buttonSpec := self builder pluggableButtonSpec new
			model: ea;
			label: ea label;
			action: #execute;
			frame: (buttonX@buttonHeight corner: (buttonX + buttonWidth)@1);
			"color: #grayColor;"
			yourself.
		buttonX := buttonX + buttonWidth.
		buttonSpec].
	! !

!SVNProjectBrowser methodsFor: 'building' stamp: 'cop 5/10/2008 19:41'!
buildDiffSummerizeTree

	^ self builder pluggableTreeSpec new
		model: self;
		roots: #updateDiffSummerizeNodes;
		hasChildren: #nodeHasChildren:;
		getChildren: #getChildrenOfNode:;
		label: #labelOfNode:;
		menu: #menuOn:;
		getSelectedPath: #getPathToSelectedSummaryNode;
		icon: #getSummeryIcon:;
		setSelected: #summaryNode:;
		frame: (0.66 @ 0 corner: 1 @ 0.9);
		yourself.! !

!SVNProjectBrowser methodsFor: 'building' stamp: 'test 5/10/2008 18:03'!
buildLogMessageText

	^ self builder pluggableTextSpec new
		model: self;
		getText: #logMessage;
		frame: (0.33 @  0.5 corner: 0.66 @ 0.9);
		yourself.! !

!SVNProjectBrowser methodsFor: 'building' stamp: 'rkrk 5/13/2008 04:25'!
buildRevisionInfoList

	^ self builder pluggableListSpec new
		model: self;
		list: #listRevisionInfos;
		getIndex: #selectedRevisionInfoIndex;
		setIndex: #selectedRevisionInfoIndex:;
		menu: #menuOn:;
		"getSelected: #selectedRevisionInfo;
		setSelected: #selectedRevisionInfo:;"
		frame: (0.33 @ 0 corner: 0.66 @ 0.5);
		yourself.! !

!SVNProjectBrowser methodsFor: 'building' stamp: 'cop 5/10/2008 18:07'!
buildSvnElementTree

	^ self builder pluggableTreeSpec new
		model: self;
		roots: #updateProjectNodes;
		hasChildren: #nodeHasChildren:;
		getChildren: #getChildrenOfNode:;
		label: #labelOfNode:;
		menu: #menuOn:;
		getSelectedPath: #getPathToSelectedNode;
		icon: #getIcon:;
		setSelected: #setSelectedNode:;
		frame: (0 @ 0 corner: 0.33 @ 0.9);
		yourself.! !

!SVNProjectBrowser methodsFor: 'building' stamp: 'cop 5/10/2008 18:13'!
buildWidgets

	| result |
	result := {self buildSvnElementTree.
	self buildRevisionInfoList.
	self buildLogMessageText.
	self buildDiffSummerizeTree} asOrderedCollection.
	result addAll: self buildButtonsFromCommands.
	^ result! !

!SVNProjectBrowser methodsFor: 'ui actions' stamp: 'rkrk 4/20/2008 15:07'!
close

	super close.
	self beIndependentFromSvnProjects.! !

!SVNProjectBrowser methodsFor: 'commands' stamp: 'rkrk 5/13/2008 09:21'!
commandClasses

	^ { 
		SVNBrowseClassCommand.
		SVNBrowseMethodCommand.
		SVNCreateProjectCommand.
		SVNCommitCommand.
		SVNUpdateCommand.
		SVNUpdateToRevisionCommand.
		SVNResolveWithMineCommand.
		SVNResolveWithTheirsCommand.
		SVNRevertCommand.
		SVNSetURLCommand.
		SVNDeleteProjectCommand.
		SVNDeleteClassCommand.
		SVNDeleteMethodCommand.
		SVNChooseAndAddClassCommand.
		SVNChooseAndAddMethodCommand.
		SVNRefreshProjectBrowserCommand.
		SVNDiffBetweenRevisionsCommand.
		SVNBrowseProjectInRepositoryCommand
	 }! !

!SVNProjectBrowser methodsFor: 'commands' stamp: 'rkrk 4/12/2008 11:32'!
commands
	
	^ self commandClasses collect: [:ea |
		ea
			on: self selectedNode
			for: self].! !

!SVNProjectBrowser methodsFor: 'log message window' stamp: 'rkrk 5/5/2008 23:49'!
commentFor: svnRevisionInfo

	svnRevisionInfo ifNil: [^ 'Select a versioned class or method'].
	^ svnRevisionInfo comment.! !

!SVNProjectBrowser methodsFor: 'default' stamp: 'cop 5/10/2008 19:46'!
extent

	^ 800 @ 500! !

!SVNProjectBrowser methodsFor: 'elment tree window' stamp: 'rkrk 4/7/2008 02:39'!
getChildrenOfNode: aNode

	^ aNode getChildren! !

!SVNProjectBrowser methodsFor: 'ui actions' stamp: 'mu 4/21/2008 11:59'!
getIcon: node
	^ OBMorphicIcons iconNamed: node status! !

!SVNProjectBrowser methodsFor: 'elment tree window' stamp: 'cop 5/10/2008 19:42'!
getPathToNode: aNode

	| aCollection iterNode |
	iterNode := aNode.
	aCollection := OrderedCollection new.
	[iterNode notNil] whileTrue: [
		aCollection addLast: iterNode.
		iterNode := iterNode parent].
	^ aCollection! !

!SVNProjectBrowser methodsFor: 'elment tree window' stamp: 'cop 5/10/2008 19:43'!
getPathToSelectedNode

	^self getPathToNode: self selectedNode.! !

!SVNProjectBrowser methodsFor: 'elment tree window' stamp: 'cop 5/10/2008 19:45'!
getPathToSelectedSummaryNode

	^self getPathToNode: self summaryNode.! !

!SVNProjectBrowser methodsFor: 'diff summary' stamp: 'rkrk 5/13/2008 06:27'!
getSummarySelector: node

	"self halt."
	self selectedRevisionInfo ifNil: [^(node diffSummary summaryKind)].
	^((node diffSummaryFrom: (SVNRevision number: self selectedRevisionInfo revision)) summaryKind)! !

!SVNProjectBrowser methodsFor: 'diff summary' stamp: 'cop 5/10/2008 19:50'!
getSummeryIcon: node 

	^ OBMorphicIcons iconNamed: (self getSummarySelector: node)! !

!SVNProjectBrowser methodsFor: 'default' stamp: 'rkrk 4/6/2008 03:13'!
label

	^ 'SqueakSVN Project Browser'! !

!SVNProjectBrowser methodsFor: 'elment tree window' stamp: 'rkrk 4/7/2008 02:40'!
labelOfNode: aNode 

	^ aNode getLabel! !

!SVNProjectBrowser methodsFor: 'derived accessing' stamp: 'rkrk 4/21/2008 02:02'!
listOfProjectNodes: svnProjects

	self projectNodes: (svnProjects collect: [:each |
		SVNProjectNode
			element: each
			svnEnvironment: self svnEnvironment]).
! !

!SVNProjectBrowser methodsFor: 'revision list window' stamp: 'rkrk 5/13/2008 06:02'!
listRevisionInfos

	| svnElement revisionNumbers currentRevisionNumber sortedRevInfos |
	self flag: #TODO.
	self selectedNode ifNil: [^ #('No SVNElement selected')].
	svnElement := self selectedNode svnElement.

	svnElement revisionInfos ifEmpty: [^ #('No Commit-Logs available')].
	self flag: #TODO.
	revisionNumbers := svnElement allElements gather: [:ea | ea localRevisionNumber].
	"currentRevisionNumber := svnElement localRevisionNumber.
	sortedRevInfos := svnElement revisionInfos asSortedCollection: [:a :b |
		a revision < b revision].
	currentRevisionNumber := (sortedRevInfos select: [:ea | ea revision <= currentRevisionNumber]) last revision.
	revisionNumbers add: currentRevisionNumber."
	^ svnElement revisionInfos collect: [:each | 
		(revisionNumbers includes: each revision)
			ifTrue: [each revisionAuthorDateString asText allBold]
			ifFalse: [each revisionAuthorDateString]].! !

!SVNProjectBrowser methodsFor: 'log message window' stamp: 'rkrk 5/6/2008 00:02'!
logMessage

	^ self logMessageHeader append: (self commentFor: self selectedRevisionInfo).! !

!SVNProjectBrowser methodsFor: 'log message window' stamp: 'rkrk 5/6/2008 00:02'!
logMessageHeader

	^ 'Log-Message:' asText allBold ,
		String cr.
! !

!SVNProjectBrowser methodsFor: 'menus' stamp: 'rkrk 4/12/2008 11:19'!
menuOn: aMenu 
	
	self commands do: [:ea | ea addItemToMenu: aMenu].
	^ aMenu! !

!SVNProjectBrowser methodsFor: 'elment tree window' stamp: 'rkrk 4/7/2008 02:40'!
nodeHasChildren: aNode

	^ (self getChildrenOfNode: aNode) notEmpty! !

!SVNProjectBrowser methodsFor: 'message handling' stamp: 'cop 2/26/2008 12:41'!
perform: selector orSendTo: otherTarget
	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'cop 4/24/2008 12:59'!
projectNodes
	^ projectNodes! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 3/4/2008 03:48'!
projectNodes: anObject
	projectNodes := anObject asOrderedCollection! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'mu 3/18/2008 17:51'!
selectedNode
	^ selectedNode! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 4/7/2008 02:27'!
selectedNode: aNode 

	selectedNode := aNode! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 5/5/2008 23:43'!
selectedRevisionInfo

	^ selectedRevisionInfo! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 5/6/2008 00:15'!
selectedRevisionInfo: svnRevisionInfo

	selectedRevisionInfo := svnRevisionInfo.! !

!SVNProjectBrowser methodsFor: 'revision list window' stamp: 'rkrk 5/6/2008 00:15'!
selectedRevisionInfoIndex

	self selectedNode ifNil: [^ 0].
	^ self selectedNode svnElement revisionInfos indexOf: self selectedRevisionInfo.! !

!SVNProjectBrowser methodsFor: 'revision list window' stamp: 'cop 5/10/2008 20:04'!
selectedRevisionInfoIndex: index
	
	| revisionInfosOfElem |
	self selectedNode ifNil: [^ self].
	revisionInfosOfElem := self selectedNode svnElement revisionInfos.
	self
		selectedRevisionInfo: (revisionInfosOfElem at: index ifAbsent: [nil]);
		changed: #selectedRevisionInfoIndex;
		changed: #logMessage;
		changed: #updateDiffSummerizeNodes.! !

!SVNProjectBrowser methodsFor: 'elment tree window' stamp: 'cop 5/10/2008 18:57'!
setSelectedNode: aNode 

	"callback for elementTree"
	self
		selectedNode: aNode;
		selectedRevisionInfo: nil;
		updateRevisionInfoList;
		changed: #updateDiffSummerizeNodes.! !

!SVNProjectBrowser methodsFor: 'diff summary' stamp: 'rkrk 5/13/2008 06:21'!
summaryNode

	^summaryNode! !

!SVNProjectBrowser methodsFor: 'diff summary' stamp: 'cop 5/10/2008 19:41'!
summaryNode: aNode

	summaryNode := aNode! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 4/20/2008 15:05'!
svnEnvironment
	^ svnEnvironment! !

!SVNProjectBrowser methodsFor: 'accessing' stamp: 'rkrk 4/20/2008 15:05'!
svnEnvironment: anObject
	svnEnvironment := anObject! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'cop 5/10/2008 18:42'!
update: anObject

	self
		updateTree;
		updateDiffSummerizeNodes! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'cop 5/10/2008 18:42'!
updateAll

	self
		updateTree;
		updateRevisionInfoList;
		updateLogMessageWindow;
		updateDiffSummerizeNodes .! !

!SVNProjectBrowser methodsFor: 'diff summary' stamp: 'rkrk 5/13/2008 06:21'!
updateDiffSummerizeNodes

	self selectedNode ifNil: [^#()].
	^{self selectedNode}! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'rkrk 5/5/2008 23:49'!
updateLogMessageWindow

	self changed: #logMessage.! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'rkrk 5/3/2008 19:29'!
updateProjectNodes

	self projectNodes
		ifNil: [self listOfProjectNodes: self svnEnvironment svnProjects]
		ifNotNil: [self updateProjectNodesList].
	^ self projectNodes! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'rkrk 5/5/2008 23:27'!
updateProjectNodesList

	"Determine those projects who are not already have node
	in the list and delete those nodes which do not have a corresponding
	svnProject -- refactor in two methods...??!!!!!!"
	| copyedSet |
	copyedSet := self svnEnvironment svnProjects copy.
	self projectNodes copy do: [:node |
		(copyedSet includes: node svnElement)
			ifTrue: [copyedSet remove: node svnElement]
			ifFalse: [self projectNodes remove: node]].
	self projectNodes addAll: (copyedSet collect: [:ea |
		SVNProjectNode
			element: ea
			svnEnvironment: self svnEnvironment]).! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'rkrk 5/6/2008 00:36'!
updateRevisionInfoList

	"call the revision list's '#list: selector"
	self changed: #listRevisionInfos.
	self updateLogMessageWindow.! !

!SVNProjectBrowser methodsFor: 'updating' stamp: 'cop 4/24/2008 13:15'!
updateTree

	self changed: #updateProjectNodes.
	self changed: #getPathToSelectedNode.! !

!SVNTool methodsFor: 'derived accessing' stamp: 'rkrk 4/21/2008 11:58'!
allTextMorphs

	"hack for accepting text contents of windows"
	^ self window allMorphs select: [:ea | ea isKindOf: PluggableTextMorph].! !

!SVNTool methodsFor: 'colors' stamp: 'rkrk 4/6/2008 01:54'!
blueColor
	^ Color blue lighter lighter  ! !

!SVNTool methodsFor: 'building' stamp: 'rkrk 5/12/2008 23:09'!
buildMainWindow

	^ self builder pluggableWindowSpec new
		model: self;
		extent: self extent;
		label: self label;
		children: self buildWidgets;
		yourself.! !

!SVNTool methodsFor: 'building' stamp: 'rkrk 4/6/2008 01:34'!
buildWidgets

	^ #()! !

!SVNTool methodsFor: 'building' stamp: 'rkrk 5/12/2008 23:11'!
buildWith: aBuilder
"This method is expected by the ToolBuilder. It creates the main widget specification.
Subclasses of SVNTool should create their sub widgets in the #buildWidgets"

	self builder: aBuilder.
	self	window: (self builder build: (self buildMainWindow)).
	^ self window! !

!SVNTool methodsFor: 'accessing' stamp: 'rkrk 5/12/2008 23:13'!
builder

	^ builder ifNil: [builder := ToolBuilder default].! !

!SVNTool methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 01:36'!
builder: anObject
	builder := anObject! !

!SVNTool methodsFor: 'ui actions' stamp: 'rkrk 4/6/2008 00:59'!
close

	self builder close: self window.! !

!SVNTool methodsFor: 'default' stamp: 'rkrk 4/6/2008 21:59'!
extent

	^ 300 @ 300! !

!SVNTool methodsFor: 'colors' stamp: 'rkrk 4/6/2008 01:54'!
grayColor
	^ Color gray  ! !

!SVNTool methodsFor: 'colors' stamp: 'rkrk 4/6/2008 01:54'!
greenColor

	^ Color green! !

!SVNTool methodsFor: 'default' stamp: 'rkrk 4/6/2008 01:19'!
label

	^ 'I have no label'! !

!SVNTool methodsFor: 'ui actions' stamp: 'rkrk 5/12/2008 23:13'!
open

	self builder open: self.
	self flag: #TODO. "Quick hack for changing the color. pluggableWindowSpec has no
	option for changing it???!!!!!!"
	"self window color: Color gray lighter."! !

!SVNTool methodsFor: 'ui actions' stamp: 'rkrk 4/21/2008 12:38'!
readAllInputs

	self allTextMorphs do: [:ea | ea accept].! !

!SVNTool methodsFor: 'colors' stamp: 'rkrk 4/6/2008 01:54'!
redColor

	^ Color red! !

!SVNTool methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 01:37'!
window
	^ window! !

!SVNTool methodsFor: 'accessing' stamp: 'rkrk 4/6/2008 01:37'!
window: anObject
	window := anObject! !

Object subclass: #SVNUser
	instanceVariableNames: 'user password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNUser class methodsFor: 'instance creating' stamp: 'rt 3/30/2008 20:55'!
user: aString password: aSecString

	^self new
		user: aString password: aSecString! !

!SVNUser methodsFor: 'comparing' stamp: 'rt 3/30/2008 20:58'!
= obj
	^self species = obj species
		and: [self user = obj user]
		and: [self password = obj password]! !

!SVNUser methodsFor: 'comparing' stamp: 'rt 4/21/2008 11:22'!
hash

	^ self user hash bitXor: self password hash! !

!SVNUser methodsFor: 'accessing' stamp: 'rt 3/30/2008 20:53'!
password
	^ password! !

!SVNUser methodsFor: 'accessing' stamp: 'rt 3/30/2008 20:52'!
password: aSecString
	password := aSecString.! !

!SVNUser methodsFor: 'printing' stamp: 'rt 4/8/2008 14:54'!
printOn: aStream

	super printOn: aStream.
	aStream	nextPut: $(.
	aStream nextPutAll: '''', self user , ''', ''' , self password , ''''.
	aStream nextPut: $).! !

!SVNUser methodsFor: 'accessing' stamp: 'rt 3/30/2008 20:53'!
user
	^ user! !

!SVNUser methodsFor: 'accessing' stamp: 'rt 3/30/2008 20:52'!
user: aString
	user := aString.! !

!SVNUser methodsFor: 'accessing' stamp: 'rt 3/30/2008 20:52'!
user: aString password: aSecString
	self user: aString.
	self password: aSecString.! !

Object subclass: #SqueakSVNPluginCaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SqueakSVNPluginCaller commentStamp: 'rkrk 1/7/2008 02:27' prior: 0!
Only for testing purposes!!!

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 3/13/2008 15:37'!
callStringTest01

	<primitive: 'stringTest01' module: 'SqueakSVNPlugin'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'test 3/20/2008 04:00'!
callStringTest02

	<primitive: 'stringTest02' module: 'SqueakSVNPlugin'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 3/13/2008 22:38'!
onlyATest

	<primitive: 'onlyATest' module: 'SqueakSVNPlugin'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/6/2008 16:29'!
primSvnModifiedAdd: target

	<primitive: 'svnModifiedAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/3/2008 14:56'!
primSvnStatus: target revisionKind: revKind revisionNumber: revNum storeInArray: arr

	<primitive: 'svnStatusForTargetRevisionKindRevisionNumberStoreInArray' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rt 4/15/2008 19:43'!
primWriteOutText: aString

	<primitive: 'writeToOutputFileText' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 5/11/2008 05:12'!
svnListForTarget: targetOop revisionKind: revisionKindOop revisionNumber: revisionNumberOop recursive: recursiveBoolOop storeInArray: resultArrayOop

	<primitive: 'svnListCountFilesForTargetForTargetRevisionKindRevisionNumberRecursiveStoreInArray' module: 'SqueakSVNPlugin'>
	^ self primitiveFailed! !

Object subclass: #TestEnvAcs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-TestBase'!

!TestEnvAcs commentStamp: 'rt 4/14/2008 00:18' prior: 0!
A TestEnvAcs is an accessor to the TestEnvPlg. You can use the TestEnvPlg to create and checkout a subversion repository.!

!TestEnvAcs class methodsFor: 'as yet unclassified' stamp: 'rt 4/13/2008 00:36'!
svnCheckoutHeadRevisionFrom: aURLOop to: aPathOop

	<primitive: 'svnCheckoutHeadRevisionFromTo' module: 'TestEnvPlg'>
	^ self primitiveFailed! !

!TestEnvAcs class methodsFor: 'as yet unclassified' stamp: 'rt 4/13/2008 15:41'!
svnCreateRepositoryOn: path

	<primitive: 'svnAdminCreateRepositoryOn' module: 'TestEnvPlg'>
	^ self primitiveFailed! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 3/6/2008 17:18'!
added
^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 2341178251 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295 4294967295 2341178251 4294967295)
	offset: 0@0)
	colorsFromArray: #(#( ) #(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.5 0.5 0.5) #(1.0 0.0 0.0) #(0.0 1.0 0.0) #(0.0 0.0 1.0) #(0.0 1.0 1.0) #(1.0 1.0 0.0) #(1.0 0.0 1.0) #(0.125 0.125 0.125) #(0.25 0.25 0.25) #(0.375 0.375 0.375) #(0.625 0.625 0.625) #(0.75 0.75 0.75) #(0.875 0.875 0.875) #(0.031 0.031 0.031) #(0.063 0.063 0.063) #(0.094 0.094 0.094) #(0.156 0.156 0.156) #(0.188 0.188 0.188) #(0.219 0.219 0.219) #(0.282 0.282 0.282) #(0.313 0.313 0.313) #(0.344 0.344 0.344) #(0.407 0.407 0.407) #(0.438 0.438 0.438) #(0.469 0.469 0.469) #(0.531 0.531 0.531) #(0.562 0.562 0.562) #(0.593 0.593 0.593) #(0.656 0.656 0.656) #(0.687 0.687 0.687) #(0.718 0.718 0.718) #(0.781 0.781 0.781) #(0.812 0.812 0.812) #(0.844 0.844 0.844) #(0.906 0.906 0.906) #(0.937 0.937 0.937) #(0.969 0.969 0.969) #(0.0 0.0 0.0) #(0.0 0.199 0.0) #(0.0 0.4 0.0) #(0.0 0.599 0.0) #(0.0 0.8 0.0) #(0.0 1.0 0.0) #(0.0 0.0 0.199) #(0.0 0.199 0.199) #(0.0 0.4 0.199) #(0.0 0.599 0.199) #(0.0 0.8 0.199) #(0.0 1.0 0.199) #(0.0 0.0 0.4) #(0.0 0.199 0.4) #(0.0 0.4 0.4) #(0.0 0.599 0.4) #(0.0 0.8 0.4) #(0.0 1.0 0.4) #(0.0 0.0 0.599) #(0.0 0.199 0.599) #(0.0 0.4 0.599) #(0.0 0.599 0.599) #(0.0 0.8 0.599) #(0.0 1.0 0.599) #(0.0 0.0 0.8) #(0.0 0.199 0.8) #(0.0 0.4 0.8) #(0.0 0.599 0.8) #(0.0 0.8 0.8) #(0.0 1.0 0.8) #(0.0 0.0 1.0) #(0.0 0.199 1.0) #(0.0 0.4 1.0) #(0.0 0.599 1.0) #(0.0 0.8 1.0) #(0.0 1.0 1.0) #(0.199 0.0 0.0) #(0.199 0.199 0.0) #(0.199 0.4 0.0) #(0.199 0.599 0.0) #(0.199 0.8 0.0) #(0.199 1.0 0.0) #(0.199 0.0 0.199) #(0.199 0.199 0.199) #(0.199 0.4 0.199) #(0.199 0.599 0.199) #(0.199 0.8 0.199) #(0.199 1.0 0.199) #(0.199 0.0 0.4) #(0.199 0.199 0.4) #(0.199 0.4 0.4) #(0.199 0.599 0.4) #(0.199 0.8 0.4) #(0.199 1.0 0.4) #(0.199 0.0 0.599) #(0.199 0.199 0.599) #(0.199 0.4 0.599) #(0.199 0.599 0.599) #(0.199 0.8 0.599) #(0.199 1.0 0.599) #(0.199 0.0 0.8) #(0.199 0.199 0.8) #(0.199 0.4 0.8) #(0.199 0.599 0.8) #(0.199 0.8 0.8) #(0.199 1.0 0.8) #(0.199 0.0 1.0) #(0.199 0.199 1.0) #(0.199 0.4 1.0) #(0.199 0.599 1.0) #(0.199 0.8 1.0) #(0.199 1.0 1.0) #(0.4 0.0 0.0) #(0.4 0.199 0.0) #(0.4 0.4 0.0) #(0.4 0.599 0.0) #(0.4 0.8 0.0) #(0.4 1.0 0.0) #(0.4 0.0 0.199) #(0.4 0.199 0.199) #(0.4 0.4 0.199) #(0.4 0.599 0.199) #(0.4 0.8 0.199) #(0.4 1.0 0.199) #(0.4 0.0 0.4) #(0.4 0.199 0.4) #(0.4 0.4 0.4) #(0.4 0.599 0.4) #(0.4 0.8 0.4) #(0.4 1.0 0.4) #(0.4 0.0 0.599) #(0.4 0.199 0.599) #(0.4 0.4 0.599) #(0.4 0.599 0.599) #(0.4 0.8 0.599) #(0.4 1.0 0.599) #(0.4 0.0 0.8) #(0.4 0.199 0.8) #(0.4 0.4 0.8) #(0.4 0.599 0.8) #(0.4 0.8 0.8) #(0.4 1.0 0.8) #(0.4 0.0 1.0) #(0.4 0.199 1.0) #(0.4 0.4 1.0) #(0.4 0.599 1.0) #(0.4 0.8 1.0) #(0.4 1.0 1.0) #(0.599 0.0 0.0) #(0.599 0.199 0.0) #(0.599 0.4 0.0) #(0.599 0.599 0.0) #(0.599 0.8 0.0) #(0.599 1.0 0.0) #(0.599 0.0 0.199) #(0.599 0.199 0.199) #(0.599 0.4 0.199) #(0.599 0.599 0.199) #(0.599 0.8 0.199) #(0.599 1.0 0.199) #(0.599 0.0 0.4) #(0.599 0.199 0.4) #(0.599 0.4 0.4) #(0.599 0.599 0.4) #(0.599 0.8 0.4) #(0.599 1.0 0.4) #(0.599 0.0 0.599) #(0.599 0.199 0.599) #(0.599 0.4 0.599) #(0.599 0.599 0.599) #(0.599 0.8 0.599) #(0.599 1.0 0.599) #(0.599 0.0 0.8) #(0.599 0.199 0.8) #(0.599 0.4 0.8) #(0.599 0.599 0.8) #(0.599 0.8 0.8) #(0.599 1.0 0.8) #(0.599 0.0 1.0) #(0.599 0.199 1.0) #(0.599 0.4 1.0) #(0.599 0.599 1.0) #(0.599 0.8 1.0) #(0.599 1.0 1.0) #(0.8 0.0 0.0) #(0.8 0.199 0.0) #(0.8 0.4 0.0) #(0.8 0.599 0.0) #(0.8 0.8 0.0) #(0.8 1.0 0.0) #(0.8 0.0 0.199) #(0.8 0.199 0.199) #(0.8 0.4 0.199) #(0.8 0.599 0.199) #(0.8 0.8 0.199) #(0.8 1.0 0.199) #(0.8 0.0 0.4) #(0.8 0.199 0.4) #(0.8 0.4 0.4) #(0.8 0.599 0.4) #(0.8 0.8 0.4) #(0.8 1.0 0.4) #(0.8 0.0 0.599) #(0.8 0.199 0.599) #(0.8 0.4 0.599) #(0.8 0.599 0.599) #(0.8 0.8 0.599) #(0.8 1.0 0.599) #(0.8 0.0 0.8) #(0.8 0.199 0.8) #(0.8 0.4 0.8) #(0.8 0.599 0.8) #(0.8 0.8 0.8) #(0.8 1.0 0.8) #(0.8 0.0 1.0) #(0.8 0.199 1.0) #(0.8 0.4 1.0) #(0.8 0.599 1.0) #(0.8 0.8 1.0) #(0.8 1.0 1.0) #(1.0 0.0 0.0) #(1.0 0.199 0.0) #(1.0 0.4 0.0) #(1.0 0.599 0.0) #(1.0 0.8 0.0) #(1.0 1.0 0.0) #(1.0 0.0 0.199) #(1.0 0.199 0.199) #(1.0 0.4 0.199) #(1.0 0.599 0.199) #(1.0 0.8 0.199) #(1.0 1.0 0.199) #(1.0 0.0 0.4) #(1.0 0.199 0.4) #(1.0 0.4 0.4) #(1.0 0.599 0.4) #(1.0 0.8 0.4) #(1.0 1.0 0.4) #(1.0 0.0 0.599) #(1.0 0.199 0.599) #(1.0 0.4 0.599) #(1.0 0.599 0.599) #(1.0 0.8 0.599) #(1.0 1.0 0.599) #(1.0 0.0 0.8) #(1.0 0.199 0.8) #(1.0 0.4 0.8) #(1.0 0.599 0.8) #(1.0 0.8 0.8) #(1.0 1.0 0.8) #(1.0 0.0 1.0) #(1.0 0.199 1.0) #(1.0 0.4 1.0) #(1.0 0.599 1.0) #(1.0 0.8 1.0) #(1.0 1.0 1.0)  ))! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'mu 3/31/2008 15:28'!
conflicted

	"do it: [self new conflicted asMorph openInHand]"
^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 4294967295 3789677025 4294967295 4292993505 4294967295 3789684735 4292993535 4294967295 4292993535 4293001215 4294967295 4294959615 3791650815 3789677025 4294959585 3791650815 3789677025 3789677025 3791650815 3789677025 3789677025 3791650815 3789677055 4294959585 4293001215 4294967295 4294959615 4292993535 4294967295 4292993535 4294959585 3789677025 3789684735 4294967295 3789677025 4294967295)
	offset: 0@0)
	colorsFromArray: #(#( ) #(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.5 0.5 0.5) #(1.0 0.0 0.0) #(0.0 1.0 0.0) #(0.0 0.0 1.0) #(0.0 1.0 1.0) #(1.0 1.0 0.0) #(1.0 0.0 1.0) #(0.125 0.125 0.125) #(0.25 0.25 0.25) #(0.375 0.375 0.375) #(0.625 0.625 0.625) #(0.75 0.75 0.75) #(0.875 0.875 0.875) #(0.031 0.031 0.031) #(0.063 0.063 0.063) #(0.094 0.094 0.094) #(0.156 0.156 0.156) #(0.188 0.188 0.188) #(0.219 0.219 0.219) #(0.282 0.282 0.282) #(0.313 0.313 0.313) #(0.344 0.344 0.344) #(0.407 0.407 0.407) #(0.438 0.438 0.438) #(0.469 0.469 0.469) #(0.531 0.531 0.531) #(0.562 0.562 0.562) #(0.593 0.593 0.593) #(0.656 0.656 0.656) #(0.687 0.687 0.687) #(0.718 0.718 0.718) #(0.781 0.781 0.781) #(0.812 0.812 0.812) #(0.844 0.844 0.844) #(0.906 0.906 0.906) #(0.937 0.937 0.937) #(0.969 0.969 0.969) #(0.0 0.0 0.0) #(0.0 0.199 0.0) #(0.0 0.4 0.0) #(0.0 0.599 0.0) #(0.0 0.8 0.0) #(0.0 1.0 0.0) #(0.0 0.0 0.199) #(0.0 0.199 0.199) #(0.0 0.4 0.199) #(0.0 0.599 0.199) #(0.0 0.8 0.199) #(0.0 1.0 0.199) #(0.0 0.0 0.4) #(0.0 0.199 0.4) #(0.0 0.4 0.4) #(0.0 0.599 0.4) #(0.0 0.8 0.4) #(0.0 1.0 0.4) #(0.0 0.0 0.599) #(0.0 0.199 0.599) #(0.0 0.4 0.599) #(0.0 0.599 0.599) #(0.0 0.8 0.599) #(0.0 1.0 0.599) #(0.0 0.0 0.8) #(0.0 0.199 0.8) #(0.0 0.4 0.8) #(0.0 0.599 0.8) #(0.0 0.8 0.8) #(0.0 1.0 0.8) #(0.0 0.0 1.0) #(0.0 0.199 1.0) #(0.0 0.4 1.0) #(0.0 0.599 1.0) #(0.0 0.8 1.0) #(0.0 1.0 1.0) #(0.199 0.0 0.0) #(0.199 0.199 0.0) #(0.199 0.4 0.0) #(0.199 0.599 0.0) #(0.199 0.8 0.0) #(0.199 1.0 0.0) #(0.199 0.0 0.199) #(0.199 0.199 0.199) #(0.199 0.4 0.199) #(0.199 0.599 0.199) #(0.199 0.8 0.199) #(0.199 1.0 0.199) #(0.199 0.0 0.4) #(0.199 0.199 0.4) #(0.199 0.4 0.4) #(0.199 0.599 0.4) #(0.199 0.8 0.4) #(0.199 1.0 0.4) #(0.199 0.0 0.599) #(0.199 0.199 0.599) #(0.199 0.4 0.599) #(0.199 0.599 0.599) #(0.199 0.8 0.599) #(0.199 1.0 0.599) #(0.199 0.0 0.8) #(0.199 0.199 0.8) #(0.199 0.4 0.8) #(0.199 0.599 0.8) #(0.199 0.8 0.8) #(0.199 1.0 0.8) #(0.199 0.0 1.0) #(0.199 0.199 1.0) #(0.199 0.4 1.0) #(0.199 0.599 1.0) #(0.199 0.8 1.0) #(0.199 1.0 1.0) #(0.4 0.0 0.0) #(0.4 0.199 0.0) #(0.4 0.4 0.0) #(0.4 0.599 0.0) #(0.4 0.8 0.0) #(0.4 1.0 0.0) #(0.4 0.0 0.199) #(0.4 0.199 0.199) #(0.4 0.4 0.199) #(0.4 0.599 0.199) #(0.4 0.8 0.199) #(0.4 1.0 0.199) #(0.4 0.0 0.4) #(0.4 0.199 0.4) #(0.4 0.4 0.4) #(0.4 0.599 0.4) #(0.4 0.8 0.4) #(0.4 1.0 0.4) #(0.4 0.0 0.599) #(0.4 0.199 0.599) #(0.4 0.4 0.599) #(0.4 0.599 0.599) #(0.4 0.8 0.599) #(0.4 1.0 0.599) #(0.4 0.0 0.8) #(0.4 0.199 0.8) #(0.4 0.4 0.8) #(0.4 0.599 0.8) #(0.4 0.8 0.8) #(0.4 1.0 0.8) #(0.4 0.0 1.0) #(0.4 0.199 1.0) #(0.4 0.4 1.0) #(0.4 0.599 1.0) #(0.4 0.8 1.0) #(0.4 1.0 1.0) #(0.599 0.0 0.0) #(0.599 0.199 0.0) #(0.599 0.4 0.0) #(0.599 0.599 0.0) #(0.599 0.8 0.0) #(0.599 1.0 0.0) #(0.599 0.0 0.199) #(0.599 0.199 0.199) #(0.599 0.4 0.199) #(0.599 0.599 0.199) #(0.599 0.8 0.199) #(0.599 1.0 0.199) #(0.599 0.0 0.4) #(0.599 0.199 0.4) #(0.599 0.4 0.4) #(0.599 0.599 0.4) #(0.599 0.8 0.4) #(0.599 1.0 0.4) #(0.599 0.0 0.599) #(0.599 0.199 0.599) #(0.599 0.4 0.599) #(0.599 0.599 0.599) #(0.599 0.8 0.599) #(0.599 1.0 0.599) #(0.599 0.0 0.8) #(0.599 0.199 0.8) #(0.599 0.4 0.8) #(0.599 0.599 0.8) #(0.599 0.8 0.8) #(0.599 1.0 0.8) #(0.599 0.0 1.0) #(0.599 0.199 1.0) #(0.599 0.4 1.0) #(0.599 0.599 1.0) #(0.599 0.8 1.0) #(0.599 1.0 1.0) #(0.8 0.0 0.0) #(0.8 0.199 0.0) #(0.8 0.4 0.0) #(0.8 0.599 0.0) #(0.8 0.8 0.0) #(0.8 1.0 0.0) #(0.8 0.0 0.199) #(0.8 0.199 0.199) #(0.8 0.4 0.199) #(0.8 0.599 0.199) #(0.8 0.8 0.199) #(0.8 1.0 0.199) #(0.8 0.0 0.4) #(0.8 0.199 0.4) #(0.8 0.4 0.4) #(0.8 0.599 0.4) #(0.8 0.8 0.4) #(0.8 1.0 0.4) #(0.8 0.0 0.599) #(0.8 0.199 0.599) #(0.8 0.4 0.599) #(0.8 0.599 0.599) #(0.8 0.8 0.599) #(0.8 1.0 0.599) #(0.8 0.0 0.8) #(0.8 0.199 0.8) #(0.8 0.4 0.8) #(0.8 0.599 0.8) #(0.8 0.8 0.8) #(0.8 1.0 0.8) #(0.8 0.0 1.0) #(0.8 0.199 1.0) #(0.8 0.4 1.0) #(0.8 0.599 1.0) #(0.8 0.8 1.0) #(0.8 1.0 1.0) #(1.0 0.0 0.0) #(1.0 0.199 0.0) #(1.0 0.4 0.0) #(1.0 0.599 0.0) #(1.0 0.8 0.0) #(1.0 1.0 0.0) #(1.0 0.0 0.199) #(1.0 0.199 0.199) #(1.0 0.4 0.199) #(1.0 0.599 0.199) #(1.0 0.8 0.199) #(1.0 1.0 0.199) #(1.0 0.0 0.4) #(1.0 0.199 0.4) #(1.0 0.4 0.4) #(1.0 0.599 0.4) #(1.0 0.8 0.4) #(1.0 1.0 0.4) #(1.0 0.0 0.599) #(1.0 0.199 0.599) #(1.0 0.4 0.599) #(1.0 0.599 0.599) #(1.0 0.8 0.599) #(1.0 1.0 0.599) #(1.0 0.0 0.8) #(1.0 0.199 0.8) #(1.0 0.4 0.8) #(1.0 0.599 0.8) #(1.0 0.8 0.8) #(1.0 1.0 0.8) #(1.0 0.0 1.0) #(1.0 0.199 1.0) #(1.0 0.4 1.0) #(1.0 0.599 1.0) #(1.0 0.8 1.0) #(1.0 1.0 1.0)  ))! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 4/12/2008 19:42'!
doesNotUnderstand: selector

	^ self unknown! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 4/12/2008 19:00'!
errorIcon

	"do it: [self new errorIcon asMorph openInHand]"
	^((ColorForm
	extent: 11@18
	depth: 8
	fromArray: #( 6974136 1785358954 1785358848 6994104 3099113656 3099093504 6994104 3099113656 3099113472 1785379000 3099113656 3099093504 1785379000 3093981802 1785358848 1785379000 3099113656 1785358848 1785379000 3099113656 3093981696 1785379000 3099113656 1785358848 1785379000 3093981802 1785358848 1785379000 3093981802 1785358848 1785379000 3099113656 1785358848 1785379000 3099113656 3093981696 1785379000 3099113656 1785358848 1785379000 3093981802 1785358848 1790490808 3093981802 1785358848 1785379000 1785358954 1785358848)
	offset: 697@527)
	colorsFromArray: #(#( ) #(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.5 0.5 0.5) #(1.0 0.0 0.0) #(0.0 1.0 0.0) #(0.0 0.0 1.0) #(0.0 1.0 1.0) #(1.0 1.0 0.0) #(1.0 0.0 1.0) #(0.125 0.125 0.125) #(0.25 0.25 0.25) #(0.375 0.375 0.375) #(0.625 0.625 0.625) #(0.75 0.75 0.75) #(0.875 0.875 0.875) #(0.031 0.031 0.031) #(0.063 0.063 0.063) #(0.094 0.094 0.094) #(0.156 0.156 0.156) #(0.188 0.188 0.188) #(0.219 0.219 0.219) #(0.282 0.282 0.282) #(0.313 0.313 0.313) #(0.344 0.344 0.344) #(0.407 0.407 0.407) #(0.438 0.438 0.438) #(0.469 0.469 0.469) #(0.531 0.531 0.531) #(0.562 0.562 0.562) #(0.593 0.593 0.593) #(0.656 0.656 0.656) #(0.687 0.687 0.687) #(0.718 0.718 0.718) #(0.781 0.781 0.781) #(0.812 0.812 0.812) #(0.844 0.844 0.844) #(0.906 0.906 0.906) #(0.937 0.937 0.937) #(0.969 0.969 0.969) #(0.0 0.0 0.0) #(0.0 0.199 0.0) #(0.0 0.4 0.0) #(0.0 0.599 0.0) #(0.0 0.8 0.0) #(0.0 1.0 0.0) #(0.0 0.0 0.199) #(0.0 0.199 0.199) #(0.0 0.4 0.199) #(0.0 0.599 0.199) #(0.0 0.8 0.199) #(0.0 1.0 0.199) #(0.0 0.0 0.4) #(0.0 0.199 0.4) #(0.0 0.4 0.4) #(0.0 0.599 0.4) #(0.0 0.8 0.4) #(0.0 1.0 0.4) #(0.0 0.0 0.599) #(0.0 0.199 0.599) #(0.0 0.4 0.599) #(0.0 0.599 0.599) #(0.0 0.8 0.599) #(0.0 1.0 0.599) #(0.0 0.0 0.8) #(0.0 0.199 0.8) #(0.0 0.4 0.8) #(0.0 0.599 0.8) #(0.0 0.8 0.8) #(0.0 1.0 0.8) #(0.0 0.0 1.0) #(0.0 0.199 1.0) #(0.0 0.4 1.0) #(0.0 0.599 1.0) #(0.0 0.8 1.0) #(0.0 1.0 1.0) #(0.199 0.0 0.0) #(0.199 0.199 0.0) #(0.199 0.4 0.0) #(0.199 0.599 0.0) #(0.199 0.8 0.0) #(0.199 1.0 0.0) #(0.199 0.0 0.199) #(0.199 0.199 0.199) #(0.199 0.4 0.199) #(0.199 0.599 0.199) #(0.199 0.8 0.199) #(0.199 1.0 0.199) #(0.199 0.0 0.4) #(0.199 0.199 0.4) #(0.199 0.4 0.4) #(0.199 0.599 0.4) #(0.199 0.8 0.4) #(0.199 1.0 0.4) #(0.199 0.0 0.599) #(0.199 0.199 0.599) #(0.199 0.4 0.599) #(0.199 0.599 0.599) #(0.199 0.8 0.599) #(0.199 1.0 0.599) #(0.199 0.0 0.8) #(0.199 0.199 0.8) #(0.199 0.4 0.8) #(0.199 0.599 0.8) #(0.199 0.8 0.8) #(0.199 1.0 0.8) #(0.199 0.0 1.0) #(0.199 0.199 1.0) #(0.199 0.4 1.0) #(0.199 0.599 1.0) #(0.199 0.8 1.0) #(0.199 1.0 1.0) #(0.4 0.0 0.0) #(0.4 0.199 0.0) #(0.4 0.4 0.0) #(0.4 0.599 0.0) #(0.4 0.8 0.0) #(0.4 1.0 0.0) #(0.4 0.0 0.199) #(0.4 0.199 0.199) #(0.4 0.4 0.199) #(0.4 0.599 0.199) #(0.4 0.8 0.199) #(0.4 1.0 0.199) #(0.4 0.0 0.4) #(0.4 0.199 0.4) #(0.4 0.4 0.4) #(0.4 0.599 0.4) #(0.4 0.8 0.4) #(0.4 1.0 0.4) #(0.4 0.0 0.599) #(0.4 0.199 0.599) #(0.4 0.4 0.599) #(0.4 0.599 0.599) #(0.4 0.8 0.599) #(0.4 1.0 0.599) #(0.4 0.0 0.8) #(0.4 0.199 0.8) #(0.4 0.4 0.8) #(0.4 0.599 0.8) #(0.4 0.8 0.8) #(0.4 1.0 0.8) #(0.4 0.0 1.0) #(0.4 0.199 1.0) #(0.4 0.4 1.0) #(0.4 0.599 1.0) #(0.4 0.8 1.0) #(0.4 1.0 1.0) #(0.599 0.0 0.0) #(0.599 0.199 0.0) #(0.599 0.4 0.0) #(0.599 0.599 0.0) #(0.599 0.8 0.0) #(0.599 1.0 0.0) #(0.599 0.0 0.199) #(0.599 0.199 0.199) #(0.599 0.4 0.199) #(0.599 0.599 0.199) #(0.599 0.8 0.199) #(0.599 1.0 0.199) #(0.599 0.0 0.4) #(0.599 0.199 0.4) #(0.599 0.4 0.4) #(0.599 0.599 0.4) #(0.599 0.8 0.4) #(0.599 1.0 0.4) #(0.599 0.0 0.599) #(0.599 0.199 0.599) #(0.599 0.4 0.599) #(0.599 0.599 0.599) #(0.599 0.8 0.599) #(0.599 1.0 0.599) #(0.599 0.0 0.8) #(0.599 0.199 0.8) #(0.599 0.4 0.8) #(0.599 0.599 0.8) #(0.599 0.8 0.8) #(0.599 1.0 0.8) #(0.599 0.0 1.0) #(0.599 0.199 1.0) #(0.599 0.4 1.0) #(0.599 0.599 1.0) #(0.599 0.8 1.0) #(0.599 1.0 1.0) #(0.8 0.0 0.0) #(0.8 0.199 0.0) #(0.8 0.4 0.0) #(0.8 0.599 0.0) #(0.8 0.8 0.0) #(0.8 1.0 0.0) #(0.8 0.0 0.199) #(0.8 0.199 0.199) #(0.8 0.4 0.199) #(0.8 0.599 0.199) #(0.8 0.8 0.199) #(0.8 1.0 0.199) #(0.8 0.0 0.4) #(0.8 0.199 0.4) #(0.8 0.4 0.4) #(0.8 0.599 0.4) #(0.8 0.8 0.4) #(0.8 1.0 0.4) #(0.8 0.0 0.599) #(0.8 0.199 0.599) #(0.8 0.4 0.599) #(0.8 0.599 0.599) #(0.8 0.8 0.599) #(0.8 1.0 0.599) #(0.8 0.0 0.8) #(0.8 0.199 0.8) #(0.8 0.4 0.8) #(0.8 0.599 0.8) #(0.8 0.8 0.8) #(0.8 1.0 0.8) #(0.8 0.0 1.0) #(0.8 0.199 1.0) #(0.8 0.4 1.0) #(0.8 0.599 1.0) #(0.8 0.8 1.0) #(0.8 1.0 1.0) #(1.0 0.0 0.0) #(1.0 0.199 0.0) #(1.0 0.4 0.0) #(1.0 0.599 0.0) #(1.0 0.8 0.0) #(1.0 1.0 0.0) #(1.0 0.0 0.199) #(1.0 0.199 0.199) #(1.0 0.4 0.199) #(1.0 0.599 0.199) #(1.0 0.8 0.199) #(1.0 1.0 0.199) #(1.0 0.0 0.4) #(1.0 0.199 0.4) #(1.0 0.4 0.4) #(1.0 0.599 0.4) #(1.0 0.8 0.4) #(1.0 1.0 0.4) #(1.0 0.0 0.599) #(1.0 0.199 0.599) #(1.0 0.4 0.599) #(1.0 0.599 0.599) #(1.0 0.8 0.599) #(1.0 1.0 0.599) #(1.0 0.0 0.8) #(1.0 0.199 0.8) #(1.0 0.4 0.8) #(1.0 0.599 0.8) #(1.0 0.8 0.8) #(1.0 1.0 0.8) #(1.0 0.0 1.0) #(1.0 0.199 1.0) #(1.0 0.4 1.0) #(1.0 0.599 1.0) #(1.0 0.8 1.0) #(1.0 1.0 1.0)  ))! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 3/6/2008 17:18'!
modified
^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 4294967295 3941264106 4294967295 4294961898 3942645738 3941269503 4293585642 4294967295 3941264127 4293585642 4294967295 3941264127 3941264106 4294967295 3941264106 3941264106 4294967295 3941264106 3941264106 3942645738 3941264106 3941264106 3941264106 3941264106 4293585642 3942645738 3941264127 4293585642 4294967295 3941264127 4294961898 3942645738 3941269503 4294967295 3941264106 4294967295)
	offset: 0@0)
	colorsFromArray: #(#( ) #(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.5 0.5 0.5) #(1.0 0.0 0.0) #(0.0 1.0 0.0) #(0.0 0.0 1.0) #(0.0 1.0 1.0) #(1.0 1.0 0.0) #(1.0 0.0 1.0) #(0.125 0.125 0.125) #(0.25 0.25 0.25) #(0.375 0.375 0.375) #(0.625 0.625 0.625) #(0.75 0.75 0.75) #(0.875 0.875 0.875) #(0.031 0.031 0.031) #(0.063 0.063 0.063) #(0.094 0.094 0.094) #(0.156 0.156 0.156) #(0.188 0.188 0.188) #(0.219 0.219 0.219) #(0.282 0.282 0.282) #(0.313 0.313 0.313) #(0.344 0.344 0.344) #(0.407 0.407 0.407) #(0.438 0.438 0.438) #(0.469 0.469 0.469) #(0.531 0.531 0.531) #(0.562 0.562 0.562) #(0.593 0.593 0.593) #(0.656 0.656 0.656) #(0.687 0.687 0.687) #(0.718 0.718 0.718) #(0.781 0.781 0.781) #(0.812 0.812 0.812) #(0.844 0.844 0.844) #(0.906 0.906 0.906) #(0.937 0.937 0.937) #(0.969 0.969 0.969) #(0.0 0.0 0.0) #(0.0 0.199 0.0) #(0.0 0.4 0.0) #(0.0 0.599 0.0) #(0.0 0.8 0.0) #(0.0 1.0 0.0) #(0.0 0.0 0.199) #(0.0 0.199 0.199) #(0.0 0.4 0.199) #(0.0 0.599 0.199) #(0.0 0.8 0.199) #(0.0 1.0 0.199) #(0.0 0.0 0.4) #(0.0 0.199 0.4) #(0.0 0.4 0.4) #(0.0 0.599 0.4) #(0.0 0.8 0.4) #(0.0 1.0 0.4) #(0.0 0.0 0.599) #(0.0 0.199 0.599) #(0.0 0.4 0.599) #(0.0 0.599 0.599) #(0.0 0.8 0.599) #(0.0 1.0 0.599) #(0.0 0.0 0.8) #(0.0 0.199 0.8) #(0.0 0.4 0.8) #(0.0 0.599 0.8) #(0.0 0.8 0.8) #(0.0 1.0 0.8) #(0.0 0.0 1.0) #(0.0 0.199 1.0) #(0.0 0.4 1.0) #(0.0 0.599 1.0) #(0.0 0.8 1.0) #(0.0 1.0 1.0) #(0.199 0.0 0.0) #(0.199 0.199 0.0) #(0.199 0.4 0.0) #(0.199 0.599 0.0) #(0.199 0.8 0.0) #(0.199 1.0 0.0) #(0.199 0.0 0.199) #(0.199 0.199 0.199) #(0.199 0.4 0.199) #(0.199 0.599 0.199) #(0.199 0.8 0.199) #(0.199 1.0 0.199) #(0.199 0.0 0.4) #(0.199 0.199 0.4) #(0.199 0.4 0.4) #(0.199 0.599 0.4) #(0.199 0.8 0.4) #(0.199 1.0 0.4) #(0.199 0.0 0.599) #(0.199 0.199 0.599) #(0.199 0.4 0.599) #(0.199 0.599 0.599) #(0.199 0.8 0.599) #(0.199 1.0 0.599) #(0.199 0.0 0.8) #(0.199 0.199 0.8) #(0.199 0.4 0.8) #(0.199 0.599 0.8) #(0.199 0.8 0.8) #(0.199 1.0 0.8) #(0.199 0.0 1.0) #(0.199 0.199 1.0) #(0.199 0.4 1.0) #(0.199 0.599 1.0) #(0.199 0.8 1.0) #(0.199 1.0 1.0) #(0.4 0.0 0.0) #(0.4 0.199 0.0) #(0.4 0.4 0.0) #(0.4 0.599 0.0) #(0.4 0.8 0.0) #(0.4 1.0 0.0) #(0.4 0.0 0.199) #(0.4 0.199 0.199) #(0.4 0.4 0.199) #(0.4 0.599 0.199) #(0.4 0.8 0.199) #(0.4 1.0 0.199) #(0.4 0.0 0.4) #(0.4 0.199 0.4) #(0.4 0.4 0.4) #(0.4 0.599 0.4) #(0.4 0.8 0.4) #(0.4 1.0 0.4) #(0.4 0.0 0.599) #(0.4 0.199 0.599) #(0.4 0.4 0.599) #(0.4 0.599 0.599) #(0.4 0.8 0.599) #(0.4 1.0 0.599) #(0.4 0.0 0.8) #(0.4 0.199 0.8) #(0.4 0.4 0.8) #(0.4 0.599 0.8) #(0.4 0.8 0.8) #(0.4 1.0 0.8) #(0.4 0.0 1.0) #(0.4 0.199 1.0) #(0.4 0.4 1.0) #(0.4 0.599 1.0) #(0.4 0.8 1.0) #(0.4 1.0 1.0) #(0.599 0.0 0.0) #(0.599 0.199 0.0) #(0.599 0.4 0.0) #(0.599 0.599 0.0) #(0.599 0.8 0.0) #(0.599 1.0 0.0) #(0.599 0.0 0.199) #(0.599 0.199 0.199) #(0.599 0.4 0.199) #(0.599 0.599 0.199) #(0.599 0.8 0.199) #(0.599 1.0 0.199) #(0.599 0.0 0.4) #(0.599 0.199 0.4) #(0.599 0.4 0.4) #(0.599 0.599 0.4) #(0.599 0.8 0.4) #(0.599 1.0 0.4) #(0.599 0.0 0.599) #(0.599 0.199 0.599) #(0.599 0.4 0.599) #(0.599 0.599 0.599) #(0.599 0.8 0.599) #(0.599 1.0 0.599) #(0.599 0.0 0.8) #(0.599 0.199 0.8) #(0.599 0.4 0.8) #(0.599 0.599 0.8) #(0.599 0.8 0.8) #(0.599 1.0 0.8) #(0.599 0.0 1.0) #(0.599 0.199 1.0) #(0.599 0.4 1.0) #(0.599 0.599 1.0) #(0.599 0.8 1.0) #(0.599 1.0 1.0) #(0.8 0.0 0.0) #(0.8 0.199 0.0) #(0.8 0.4 0.0) #(0.8 0.599 0.0) #(0.8 0.8 0.0) #(0.8 1.0 0.0) #(0.8 0.0 0.199) #(0.8 0.199 0.199) #(0.8 0.4 0.199) #(0.8 0.599 0.199) #(0.8 0.8 0.199) #(0.8 1.0 0.199) #(0.8 0.0 0.4) #(0.8 0.199 0.4) #(0.8 0.4 0.4) #(0.8 0.599 0.4) #(0.8 0.8 0.4) #(0.8 1.0 0.4) #(0.8 0.0 0.599) #(0.8 0.199 0.599) #(0.8 0.4 0.599) #(0.8 0.599 0.599) #(0.8 0.8 0.599) #(0.8 1.0 0.599) #(0.8 0.0 0.8) #(0.8 0.199 0.8) #(0.8 0.4 0.8) #(0.8 0.599 0.8) #(0.8 0.8 0.8) #(0.8 1.0 0.8) #(0.8 0.0 1.0) #(0.8 0.199 1.0) #(0.8 0.4 1.0) #(0.8 0.599 1.0) #(0.8 0.8 1.0) #(0.8 1.0 1.0) #(1.0 0.0 0.0) #(1.0 0.199 0.0) #(1.0 0.4 0.0) #(1.0 0.599 0.0) #(1.0 0.8 0.0) #(1.0 1.0 0.0) #(1.0 0.0 0.199) #(1.0 0.199 0.199) #(1.0 0.4 0.199) #(1.0 0.599 0.199) #(1.0 0.8 0.199) #(1.0 1.0 0.199) #(1.0 0.0 0.4) #(1.0 0.199 0.4) #(1.0 0.4 0.4) #(1.0 0.599 0.4) #(1.0 0.8 0.4) #(1.0 1.0 0.4) #(1.0 0.0 0.599) #(1.0 0.199 0.599) #(1.0 0.4 0.599) #(1.0 0.599 0.599) #(1.0 0.8 0.599) #(1.0 1.0 0.599) #(1.0 0.0 0.8) #(1.0 0.199 0.8) #(1.0 0.4 0.8) #(1.0 0.599 0.8) #(1.0 0.8 0.8) #(1.0 1.0 0.8) #(1.0 0.0 1.0) #(1.0 0.199 1.0) #(1.0 0.4 1.0) #(1.0 0.599 1.0) #(1.0 0.8 1.0) #(1.0 1.0 1.0)  ))! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'cop 4/8/2008 19:21'!
normal
	^ (ColorForm 
		extent: 12 @ 12
		depth: 8
		fromArray: #(
				4294967295
				2038004089
				4294967295
				4286151033
				2038004089
				2038038527
				4286151033
				2038004089
				2038004223
				4286151033
				2038004089
				2046786047
				2038004089
				2038004223
				4286151033
				2038004089
				2038038527
				2038004089
				2046820217
				4294967161
				2038004089
				2046820351
				4294932857
				2038004089
				4286185471
				4286151033
				2038004223
				4286151167
				2038004089
				2038004223
				4294932857
				2038004089
				2038038527
				4294967295
				2038004089
				4294967295
			)
		offset: 0 @ 0) colorsFromArray: #(
			#()
			#(0.0 0.0 0.0 )
			#(1.0 1.0 1.0 )
			#(0.5 0.5 0.5 )
			#(1.0 0.0 0.0 )
			#(0.0 1.0 0.0 )
			#(0.0 0.0 1.0 )
			#(0.0 1.0 1.0 )
			#(1.0 1.0 0.0 )
			#(1.0 0.0 1.0 )
			#(0.125 0.125 0.125 )
			#(0.25 0.25 0.25 )
			#(0.375 0.375 0.375 )
			#(0.625 0.625 0.625 )
			#(0.75 0.75 0.75 )
			#(0.875 0.875 0.875 )
			#(0.031 0.031 0.031 )
			#(0.063 0.063 0.063 )
			#(0.094 0.094 0.094 )
			#(0.156 0.156 0.156 )
			#(0.188 0.188 0.188 )
			#(0.219 0.219 0.219 )
			#(0.282 0.282 0.282 )
			#(0.313 0.313 0.313 )
			#(0.344 0.344 0.344 )
			#(0.407 0.407 0.407 )
			#(0.438 0.438 0.438 )
			#(0.469 0.469 0.469 )
			#(0.531 0.531 0.531 )
			#(0.562 0.562 0.562 )
			#(0.593 0.593 0.593 )
			#(0.656 0.656 0.656 )
			#(0.687 0.687 0.687 )
			#(0.718 0.718 0.718 )
			#(0.781 0.781 0.781 )
			#(0.812 0.812 0.812 )
			#(0.844 0.844 0.844 )
			#(0.906 0.906 0.906 )
			#(0.937 0.937 0.937 )
			#(0.969 0.969 0.969 )
			#(0.0 0.0 0.0 )
			#(0.0 0.199 0.0 )
			#(0.0 0.4 0.0 )
			#(0.0 0.599 0.0 )
			#(0.0 0.8 0.0 )
			#(0.0 1.0 0.0 )
			#(0.0 0.0 0.199 )
			#(0.0 0.199 0.199 )
			#(0.0 0.4 0.199 )
			#(0.0 0.599 0.199 )
			#(0.0 0.8 0.199 )
			#(0.0 1.0 0.199 )
			#(0.0 0.0 0.4 )
			#(0.0 0.199 0.4 )
			#(0.0 0.4 0.4 )
			#(0.0 0.599 0.4 )
			#(0.0 0.8 0.4 )
			#(0.0 1.0 0.4 )
			#(0.0 0.0 0.599 )
			#(0.0 0.199 0.599 )
			#(0.0 0.4 0.599 )
			#(0.0 0.599 0.599 )
			#(0.0 0.8 0.599 )
			#(0.0 1.0 0.599 )
			#(0.0 0.0 0.8 )
			#(0.0 0.199 0.8 )
			#(0.0 0.4 0.8 )
			#(0.0 0.599 0.8 )
			#(0.0 0.8 0.8 )
			#(0.0 1.0 0.8 )
			#(0.0 0.0 1.0 )
			#(0.0 0.199 1.0 )
			#(0.0 0.4 1.0 )
			#(0.0 0.599 1.0 )
			#(0.0 0.8 1.0 )
			#(0.0 1.0 1.0 )
			#(0.199 0.0 0.0 )
			#(0.199 0.199 0.0 )
			#(0.199 0.4 0.0 )
			#(0.199 0.599 0.0 )
			#(0.199 0.8 0.0 )
			#(0.199 1.0 0.0 )
			#(0.199 0.0 0.199 )
			#(0.199 0.199 0.199 )
			#(0.199 0.4 0.199 )
			#(0.199 0.599 0.199 )
			#(0.199 0.8 0.199 )
			#(0.199 1.0 0.199 )
			#(0.199 0.0 0.4 )
			#(0.199 0.199 0.4 )
			#(0.199 0.4 0.4 )
			#(0.199 0.599 0.4 )
			#(0.199 0.8 0.4 )
			#(0.199 1.0 0.4 )
			#(0.199 0.0 0.599 )
			#(0.199 0.199 0.599 )
			#(0.199 0.4 0.599 )
			#(0.199 0.599 0.599 )
			#(0.199 0.8 0.599 )
			#(0.199 1.0 0.599 )
			#(0.199 0.0 0.8 )
			#(0.199 0.199 0.8 )
			#(0.199 0.4 0.8 )
			#(0.199 0.599 0.8 )
			#(0.199 0.8 0.8 )
			#(0.199 1.0 0.8 )
			#(0.199 0.0 1.0 )
			#(0.199 0.199 1.0 )
			#(0.199 0.4 1.0 )
			#(0.199 0.599 1.0 )
			#(0.199 0.8 1.0 )
			#(0.199 1.0 1.0 )
			#(0.4 0.0 0.0 )
			#(0.4 0.199 0.0 )
			#(0.4 0.4 0.0 )
			#(0.4 0.599 0.0 )
			#(0.4 0.8 0.0 )
			#(0.4 1.0 0.0 )
			#(0.4 0.0 0.199 )
			#(0.4 0.199 0.199 )
			#(0.4 0.4 0.199 )
			#(0.4 0.599 0.199 )
			#(0.4 0.8 0.199 )
			#(0.4 1.0 0.199 )
			#(0.4 0.0 0.4 )
			#(0.4 0.199 0.4 )
			#(0.4 0.4 0.4 )
			#(0.4 0.599 0.4 )
			#(0.4 0.8 0.4 )
			#(0.4 1.0 0.4 )
			#(0.4 0.0 0.599 )
			#(0.4 0.199 0.599 )
			#(0.4 0.4 0.599 )
			#(0.4 0.599 0.599 )
			#(0.4 0.8 0.599 )
			#(0.4 1.0 0.599 )
			#(0.4 0.0 0.8 )
			#(0.4 0.199 0.8 )
			#(0.4 0.4 0.8 )
			#(0.4 0.599 0.8 )
			#(0.4 0.8 0.8 )
			#(0.4 1.0 0.8 )
			#(0.4 0.0 1.0 )
			#(0.4 0.199 1.0 )
			#(0.4 0.4 1.0 )
			#(0.4 0.599 1.0 )
			#(0.4 0.8 1.0 )
			#(0.4 1.0 1.0 )
			#(0.599 0.0 0.0 )
			#(0.599 0.199 0.0 )
			#(0.599 0.4 0.0 )
			#(0.599 0.599 0.0 )
			#(0.599 0.8 0.0 )
			#(0.599 1.0 0.0 )
			#(0.599 0.0 0.199 )
			#(0.599 0.199 0.199 )
			#(0.599 0.4 0.199 )
			#(0.599 0.599 0.199 )
			#(0.599 0.8 0.199 )
			#(0.599 1.0 0.199 )
			#(0.599 0.0 0.4 )
			#(0.599 0.199 0.4 )
			#(0.599 0.4 0.4 )
			#(0.599 0.599 0.4 )
			#(0.599 0.8 0.4 )
			#(0.599 1.0 0.4 )
			#(0.599 0.0 0.599 )
			#(0.599 0.199 0.599 )
			#(0.599 0.4 0.599 )
			#(0.599 0.599 0.599 )
			#(0.599 0.8 0.599 )
			#(0.599 1.0 0.599 )
			#(0.599 0.0 0.8 )
			#(0.599 0.199 0.8 )
			#(0.599 0.4 0.8 )
			#(0.599 0.599 0.8 )
			#(0.599 0.8 0.8 )
			#(0.599 1.0 0.8 )
			#(0.599 0.0 1.0 )
			#(0.599 0.199 1.0 )
			#(0.599 0.4 1.0 )
			#(0.599 0.599 1.0 )
			#(0.599 0.8 1.0 )
			#(0.599 1.0 1.0 )
			#(0.8 0.0 0.0 )
			#(0.8 0.199 0.0 )
			#(0.8 0.4 0.0 )
			#(0.8 0.599 0.0 )
			#(0.8 0.8 0.0 )
			#(0.8 1.0 0.0 )
			#(0.8 0.0 0.199 )
			#(0.8 0.199 0.199 )
			#(0.8 0.4 0.199 )
			#(0.8 0.599 0.199 )
			#(0.8 0.8 0.199 )
			#(0.8 1.0 0.199 )
			#(0.8 0.0 0.4 )
			#(0.8 0.199 0.4 )
			#(0.8 0.4 0.4 )
			#(0.8 0.599 0.4 )
			#(0.8 0.8 0.4 )
			#(0.8 1.0 0.4 )
			#(0.8 0.0 0.599 )
			#(0.8 0.199 0.599 )
			#(0.8 0.4 0.599 )
			#(0.8 0.599 0.599 )
			#(0.8 0.8 0.599 )
			#(0.8 1.0 0.599 )
			#(0.8 0.0 0.8 )
			#(0.8 0.199 0.8 )
			#(0.8 0.4 0.8 )
			#(0.8 0.599 0.8 )
			#(0.8 0.8 0.8 )
			#(0.8 1.0 0.8 )
			#(0.8 0.0 1.0 )
			#(0.8 0.199 1.0 )
			#(0.8 0.4 1.0 )
			#(0.8 0.599 1.0 )
			#(0.8 0.8 1.0 )
			#(0.8 1.0 1.0 )
			#(1.0 0.0 0.0 )
			#(1.0 0.199 0.0 )
			#(1.0 0.4 0.0 )
			#(1.0 0.599 0.0 )
			#(1.0 0.8 0.0 )
			#(1.0 1.0 0.0 )
			#(1.0 0.0 0.199 )
			#(1.0 0.199 0.199 )
			#(1.0 0.4 0.199 )
			#(1.0 0.599 0.199 )
			#(1.0 0.8 0.199 )
			#(1.0 1.0 0.199 )
			#(1.0 0.0 0.4 )
			#(1.0 0.199 0.4 )
			#(1.0 0.4 0.4 )
			#(1.0 0.599 0.4 )
			#(1.0 0.8 0.4 )
			#(1.0 1.0 0.4 )
			#(1.0 0.0 0.599 )
			#(1.0 0.199 0.599 )
			#(1.0 0.4 0.599 )
			#(1.0 0.599 0.599 )
			#(1.0 0.8 0.599 )
			#(1.0 1.0 0.599 )
			#(1.0 0.0 0.8 )
			#(1.0 0.199 0.8 )
			#(1.0 0.4 0.8 )
			#(1.0 0.599 0.8 )
			#(1.0 0.8 0.8 )
			#(1.0 1.0 0.8 )
			#(1.0 0.0 1.0 )
			#(1.0 0.199 1.0 )
			#(1.0 0.4 1.0 )
			#(1.0 0.599 1.0 )
			#(1.0 0.8 1.0 )
			#(1.0 1.0 1.0 )
		)! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 4/12/2008 19:42'!
unknown

	^  self unversioned! !

!OBMorphicIcons methodsFor: '*SqueakSVN' stamp: 'rkrk 4/12/2008 19:41'!
unversioned

	^  (Form
	extent: 12@12
	depth: 32
	fromArray: #( 0 0 4294967295 4294967295 4278190080 4278190080 4278190080 4278190080 4294967295 4294967295 0 0 0 4294967295 4294967295 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4294967295 4294967295 0 0 4294967295 4278190080 4278190080 4278190080 4294967295 4294967295 4278190080 4278190080 4278190080 4294967295 0 0 4294967295 4278190080 4278190080 4294967295 4294967295 4294967295 4294967295 4278190080 4278190080 4294967295 0 0 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190080 4278190080 4294967295 0 0 0 0 0 0 4294967295 4294967295 4278190080 4278190080 4278190080 4294967295 0 0 0 0 0 4294967295 4294967295 4278190080 4278190080 4278190080 4294967295 4294967295 0 0 0 0 0 4294967295 4278190080 4278190080 4278190080 4294967295 4294967295 0 0 0 0 0 0 4294967295 4278190080 4278190080 4294967295 4294967295 0 0 0 0 0 0 0 4294967295 4294967295 4294967295 4294967295 0 0 0 0 0 0 0 0 4294967295 4278190080 4278190080 4294967295 0 0 0 0 0 0 0 0 4294967295 4278190080 4278190080 4294967295 0 0 0 0)
	offset: 819@706)! !

PluggableWidgetSpec subclass: #DiffSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Diffing'!

!DiffSpec methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:47'!
buildWith: aBuilder
	^ aBuilder buildDiffSpec: self! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 04:24'!
belongsToCurrentSvnProject

	^ false! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 02:51'!
commentsOfUsedTraits

	"MetaNode>>allChildrenForNode: gives a dnu if this method is not implemented"
	^ #()! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 11:54'!
currentSvnProject

	self svnEnvironment ifNil: [^ nil].
	^ self svnEnvironment currentProject.! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 5/3/2008 17:14'!
hasSvnElementOfKind: aClass

	^ self svnElement isKindOf: aClass! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 02:53'!
metaclassesOfUsedTraits

	"MetaNode>>allChildrenForNode: gives a dnu if this method is not implemented"
	^ #()! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 03:58'!
svnElement

	^ nil! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 5/3/2008 18:18'!
svnEnvironment

	"Ugly solution. Somehow nodes have to know their svnEnvironment.
	In the moment there is a filter added to all OBMetaNodes which are build in
	an OBSVNSystemBrowser."
	| environmentFilter |
	self metaNode ifNil: [^ nil].
	environmentFilter := self metaNode filters
		detect: [:ea | ea isKindOf: SVNOBEnvironmentFilter]
		ifNone: [^ nil].
	^ environmentFilter svnEnvironment.! !

!OBCodeNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 02:51'!
usedTraits

	"MetaNode>>allChildrenForNode: gives a dnu if this method is not implemented"
	^ #()! !

!OBClassNode methodsFor: '*SqueakSVN' stamp: 'rt 5/9/2008 14:09'!
belongsToCurrentSvnProject

	self currentSvnProject ifNil: [^ false].
	^ self currentSvnProject includes: (SVNClass forExistingClass: self theNonMetaClass).! !

!OBClassNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/15/2008 04:20'!
svnElement

	self svnEnvironment ifNil: [^ nil].
	^ self svnEnvironment findSvnClassFor: self theClass.! !

OBClassNode subclass: #OBRBroClassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-RepositoryBrowsing'!

!OBRBroClassNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:03'!
childNodes
	| categories |
	categories := (self theClass versionedMethods collect: [:ea | ea category]) asSet.
	^ (categories collect: [:ea | OBRBroMethodCategoryNode
			on: ea asString
			inClass: self theClass]) asOrderedCollection.! !

!OBRBroClassNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:03'!
definition
	^ OBClassDefinition 
		environment: nil 
		template: theClass asString! !

!OBRBroClassNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:03'!
displayString
	^ theClass theName! !

!OBRBroClassNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:05'!
displayStringForChild: aNode
	^ aNode name! !

!OBRBroClassNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:02'!
metaNode

	^ OBMetaNode named: 'nothing'! !

!OBRBroClassNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 08:28'!
setClass: aClass
	self theClass: aClass! !

!OBRBroClassNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 08:46'!
theNonMetaClassName
	^ self theClass theName! !

OBCmdBrowse subclass: #OBSVNCmdBrowse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Commands'!

!OBSVNCmdBrowse methodsFor: 'as yet unclassified' stamp: 'per 4/24/2008 15:51'!
execute
	(target isKindOf: OBClassCategoryNode) ifTrue:[OBSVNSystemBrowser 
		openOnEnvironment: target container 
		category: target name 
		onSVNEnvironment: requestor browser svnEnvironment].

	(target isKindOf: OBClassNode) ifTrue: [OBSVNSystemBrowser
		openOnClass: target theClass
		onSVNEnvironment: requestor browser svnEnvironment].
	
	(target isKindOf: OBMethodCategoryNode) ifTrue: [OBSVNSystemBrowser
		openOnClass: target theClass
		category: target name
		onSVNEnvironment: requestor browser svnEnvironment].
	
	(target isKindOf: OBMethodNode) ifTrue: [OBSVNSystemBrowser
		openOnClass: target theClass
		selector: target selector
		onSVNEnvironment: requestor browser svnEnvironment].! !

!OBMethodNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/14/2008 12:02'!
belongsToCurrentSvnProject

	self currentSvnProject ifNil: [^ false].
	^ self currentSvnProject includes: (SVNMethod forExistingMethod: self reference compiledMethod).! !

!OBMethodNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/23/2008 23:41'!
classBelongsToCurrentSvnProject

	self currentSvnProject ifNil: [^ false].
	^ self currentSvnProject includes: (SVNClass forExistingClass: self theClass).! !

!OBMethodNode methodsFor: '*SqueakSVN' stamp: 'rkrk 4/15/2008 04:51'!
svnElement

	self svnEnvironment ifNil: [^ nil].
	^ self svnEnvironment findSvnMethodForMethodRef: self reference.! !

OBMethodNode subclass: #OBRBroMethodNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-RepositoryBrowsing'!

!OBRBroMethodNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:14'!
annotationString
	^ ''! !

!OBRBroMethodNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:08'!
metaNode

	^ OBMetaNode named: 'nothing'! !

!OBRBroMethodNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:15'!
source
	^ (self theClass versionedMethods detect: [:ea | ea theName = selector]) source asText makeSelectorBold! !

OBFilter subclass: #OBSVNStatusIconClassFilter
	instanceVariableNames: 'currentProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNStatusIconClassFilter methodsFor: 'accessing' stamp: 'cop 4/8/2008 19:57'!
currentProject
	^currentProject! !

!OBSVNStatusIconClassFilter methodsFor: 'accessing' stamp: 'cop 4/9/2008 16:14'!
currentProject: aSVNProject
	currentProject := aSVNProject! !

!OBSVNStatusIconClassFilter methodsFor: 'filtering' stamp: 'cop 4/21/2008 16:45'!
icon: aSymbol forNode: aNode 

	self currentProject ifNil: [^ #blank].
	^ (self svnElementFrom: aNode)
		ifNil: [#blank]
		
		ifNotNilDo: [:svnElement | svnElement status].! !

!OBSVNStatusIconClassFilter methodsFor: 'updating' stamp: 'cop 4/9/2008 11:11'!
selectedProjectChanged: anAnn
	self currentProject: anAnn currentProject! !

!OBSVNStatusIconClassFilter methodsFor: 'updating' stamp: 'cop 4/9/2008 16:30'!
subscribeAt: aBrowser
	aBrowser announcer
		observe: SVNCurrentProjectChanged
		send: #selectedProjectChanged:
		to: self! !

!OBSVNStatusIconClassFilter methodsFor: 'filtering' stamp: 'rkrk 4/12/2008 22:05'!
svnElementFrom: aNode

	^ self currentProject versionedClasses
		detect: [:ea | ea theName = aNode name]
		ifNone: [nil].! !

OBSVNStatusIconClassFilter subclass: #OBSVNStatusIconMethodFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNStatusIconMethodFilter methodsFor: 'filtering' stamp: 'rkrk 4/29/2008 23:34'!
svnElementFrom: aNode

	^ self currentProject allVersionedMethods
		detect: [:ea | ea = aNode svnElement ]
		ifNone: [nil].! !

OBFilter subclass: #SVNOBEnvironmentFilter
	instanceVariableNames: 'svnEnvironment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Environment'!

!SVNOBEnvironmentFilter class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/14/2008 03:52'!
with: svnEnvironment

	^ self new
		svnEnvironment: svnEnvironment;
		yourself.! !

!SVNOBEnvironmentFilter methodsFor: 'as yet unclassified' stamp: 'rkrk 4/14/2008 11:03'!
displayString: aString forParent: pNode child: cNode

	self metaNode allChildrenForNode: pNode.
	^ aString asText! !

!SVNOBEnvironmentFilter methodsFor: 'as yet unclassified' stamp: 'rkrk 4/21/2008 10:56'!
initialize

	super initialize.
	self svnEnvironment: (SVNEnvironment forSvnProjects: Set new).! !

!SVNOBEnvironmentFilter methodsFor: 'accessing' stamp: 'rkrk 4/14/2008 03:44'!
svnEnvironment
	^ svnEnvironment! !

!SVNOBEnvironmentFilter methodsFor: 'accessing' stamp: 'rkrk 4/14/2008 03:44'!
svnEnvironment: anObject
	svnEnvironment := anObject! !

!SVNOBEnvironmentFilter methodsFor: 'as yet unclassified' stamp: 'rkrk 4/14/2008 02:28'!
wantsButton

	^ true! !

OBSystemBrowser subclass: #OBSVNSystemBrowser
	instanceVariableNames: 'svnEnvironment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNSystemBrowser class methodsFor: 'configuration' stamp: 'cop 4/9/2008 13:47'!
buildMetagraphOn: root class: classSel comment: commentSel metaclass: metaclassSel
	^ (OBSVNMetagraphBuilder
		on: root
		class: classSel
		comment: commentSel
		metaclass: metaclassSel) execute! !

!OBSVNSystemBrowser class methodsFor: 'initialization' stamp: 'per 4/24/2008 13:38'!
cmdBrowse
	^OBCmdBrowse! !

!OBSVNSystemBrowser class methodsFor: 'configuration' stamp: 'cop 3/6/2008 13:26'!
definitionPanel
	^ OBSVNDefinitionPanel new! !

!OBSVNSystemBrowser class methodsFor: 'initialization' stamp: 'rkrk 4/15/2008 20:33'!
initialize

	"self initialize"
	self registerInOpenMenu.! !

!OBSVNSystemBrowser class methodsFor: 'instance creation' stamp: 'rkrk 4/14/2008 02:30'!
metaNode: metaNode root: rootNode selection: selectedNode panels: panels

	^ (super metaNode: metaNode root: rootNode selection: selectedNode panels: panels)
		registerSVNFilters;
		yourself.! !

!OBSVNSystemBrowser class methodsFor: 'opening' stamp: 'per 4/24/2008 15:42'!
onClass: aClass category: aSymbol onSVNEnvironment: anSVNEnvironment
	| browser |
	browser := self selection: (OBMethodCategoryNode on: aSymbol inClass: aClass).
	
	"browser svnEnvironment currentProject: anSVNEnvironment currentProject."							
	(browser panels first currentProject: anSVNEnvironment currentProject).
	^browser.! !

!OBSVNSystemBrowser class methodsFor: 'opening' stamp: 'per 4/24/2008 15:39'!
onClass: aClass onSVNEnvironment: anSVNEnvironment
	| browser |
	browser := self selection: aClass asNode.
	
	"browser svnEnvironment currentProject: anSVNEnvironment currentProject."							
	(browser panels first currentProject: anSVNEnvironment currentProject).
	^browser.! !

!OBSVNSystemBrowser class methodsFor: 'opening' stamp: 'per 4/24/2008 15:43'!
onClass: aClass selector: aSelector onSVNEnvironment: anSVNEnvironment
	| browser |
	browser := self selection: (OBMethodNode on: aSelector inClass: aClass).
	
	"browser svnEnvironment currentProject: anSVNEnvironment currentProject."							
	(browser panels first currentProject: anSVNEnvironment currentProject).
	^browser.! !

!OBSVNSystemBrowser class methodsFor: 'opening' stamp: 'per 4/24/2008 15:35'!
onEnvironment: anEnvironment category: aSymbol onSVNEnvironment: anSVNEnvironment
	| browser |
	browser := self selection: (OBClassCategoryNode 
					on: aSymbol 
					inEnvironment: anEnvironment).
	"browser svnEnvironment currentProject: anSVNEnvironment currentProject."							
	(browser panels first currentProject: anSVNEnvironment currentProject).
	^browser.! !

!OBSVNSystemBrowser class methodsFor: 'opening' stamp: 'per 4/24/2008 15:42'!
openOnClass: aClass category: aSymbol onSVNEnvironment: anSVNEnvironment
	^ (self onClass: aClass category: aSymbol onSVNEnvironment: anSVNEnvironment) open! !

!OBSVNSystemBrowser class methodsFor: 'opening' stamp: 'per 4/24/2008 15:40'!
openOnClass: aClass onSVNEnvironment: anSVNEnvironment
	^ (self onClass: aClass onSVNEnvironment: anSVNEnvironment) open! !

!OBSVNSystemBrowser class methodsFor: 'opening' stamp: 'per 4/24/2008 15:44'!
openOnClass: aClass selector: aSelector onSVNEnvironment: anSVNEnvironment
	^ (self onClass: aClass selector: aSelector onSVNEnvironment: anSVNEnvironment) open! !

!OBSVNSystemBrowser class methodsFor: 'opening' stamp: 'per 4/24/2008 15:18'!
openOnEnvironment: anEnvironment category: aSymbol onSVNEnvironment: anSVNEnvironment
	^ (self onEnvironment: anEnvironment category: aSymbol onSVNEnvironment: anSVNEnvironment) open! !

!OBSVNSystemBrowser class methodsFor: 'configuration' stamp: 'cop 4/8/2008 19:39'!
panels
	^ super panels asOrderedCollection
		addFirst: SVNOBProjectSelectionPanel new;
		yourself! !

!OBSVNSystemBrowser class methodsFor: 'initialization' stamp: 'rkrk 4/15/2008 20:34'!
registerInOpenMenu

	TheWorldMenu registerOpenCommand: {'SVNSystemBrowser'. {self. #open}}.! !

!OBSVNSystemBrowser methodsFor: 'command' stamp: 'per 4/24/2008 13:47'!
cmdBrowse
	^OBSVNCmdBrowse! !

!OBSVNSystemBrowser methodsFor: 'commands' stamp: 'cop 3/6/2008 12:09'!
cmdMultiView
	^ OBSVNCmdMultiView! !

!OBSVNSystemBrowser methodsFor: 'commands' stamp: 'rkrk 5/5/2008 12:10'!
cmdSvn
	^ { 
		SVNCommitCommand.
		SVNUpdateCommand.
		SVNUpdateToRevisionCommand.
		SVNResolveWithMineCommand.
		SVNResolveWithTheirsCommand.
		SVNRevertCommand.
		SVNDeleteClassCommand.
		SVNDeleteMethodCommand.
		
		SVNAddClassToCurrentProjectCommand.
		SVNAddMethodToCurrentProjectCommand.
	 }! !

!OBSVNSystemBrowser methodsFor: 'accessing' stamp: 'rkrk 4/12/2008 21:52'!
definitionPanel
	^ self class definitionPanel! !

!OBSVNSystemBrowser methodsFor: 'demo hack' stamp: 'rkrk 5/5/2008 14:06'!
newNodeWasAdded: ann

	"This method is called when an OBNodeCreatedannouncement was made. It triggers
	the AddMethod and AddClass commands when new methods/classes were created and
	the user has selected a current project"
	| command |
	self flag: #TODO. "Let the nodes know their add commands? Would be polymorphic..."
	svnEnvironment currentProject ifNil: [^ self].
	(ann node isKindOf: OBMethodNode)
		ifTrue: [command := SVNAddMethodToCurrentProjectCommand].
	(ann node isKindOf: OBClassNode)
		ifTrue: [command := SVNAddClassToCurrentProjectCommand].
	command ifNil: [^ self].
	(command on: ann node for: self) execute.! !

!OBSVNSystemBrowser methodsFor: 'configuration' stamp: 'rkrk 4/11/2008 19:41'!
registerSVNFilters

	self subscribeEdgesRecursivly: self navigationPanel root metaNode edges! !

!OBSVNSystemBrowser methodsFor: 'initializing' stamp: 'rkrk 5/3/2008 18:14'!
setMetaNode: aMetaNode node: aNode

	| filter |
	svnEnvironment := SVNRegistry current createSvnEnvironment.
	svnEnvironment subscribeWithAnnouncer: self announcer.
	filter := SVNOBEnvironmentFilter with: svnEnvironment.
	aMetaNode svnWithAllChildrenDo: [ :each | each addFilter: filter].
	super setMetaNode: aMetaNode node: aNode! !

!OBSVNSystemBrowser methodsFor: 'demo hack' stamp: 'rkrk 5/3/2008 17:11'!
subscribe

	super subscribe.
	(self announcer)
		observe: OBNodeCreated
		send: #newNodeWasAdded:
		to: self! !

!OBSVNSystemBrowser methodsFor: 'configuration' stamp: 'rkrk 5/3/2008 17:10'!
subscribeEdges: aCol

	self flag: #TODO.
	aCol
		select: [:each | each class canPerform: #subscribeAt:]
		thenDo: [:each | each subscribeAt: self]! !

!OBSVNSystemBrowser methodsFor: 'configuration' stamp: 'rkrk 4/17/2008 10:57'!
subscribeEdgesRecursivly: aCol

	aCol do: [:each |
		self subscribeEdgesRecursivly: each metaNode edges.
		self subscribeEdges: each metaNode svnFilters].! !

!OBSVNSystemBrowser methodsFor: 'accessing' stamp: 'rkrk 4/21/2008 10:38'!
svnEnvironment
	self flag: #TODO. "Use accessor sonsistently"
	^ svnEnvironment! !

!OBSVNSystemBrowser methodsFor: 'accessing' stamp: 'rkrk 4/21/2008 10:37'!
svnEnvironment: anObject
	svnEnvironment := anObject! !

OBSystemBrowser subclass: #SVNRepositoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-RepositoryBrowsing'!

!SVNRepositoryBrowser class methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 08:17'!
browseSvnEnvironment: svnEnvironment

	self openRoot: (SVNRBroEnvironmentNode on: svnEnvironment)! !

!SVNRepositoryBrowser class methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 08:08'!
defaultRootNode
	^ OBEnvironmentNode forImage! !

!SVNRepositoryBrowser class methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 08:08'!
title
	^ 'SVNRepositoryBrowser'! !

!SVNRepositoryBrowser methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:16'!
defaultBackgroundColor
	^ Color lightGray lighter lighter lighter! !

OBClassCategoryNode subclass: #SVNRBroCategoryNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-RepositoryBrowsing'!

!SVNRBroCategoryNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 08:56'!
childNodes
	^ self classes asOrderedCollection! !

!SVNRBroCategoryNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 08:28'!
classes
	^ environment currentProject allClasses
		select: [:ea | ea category = name]
		thenCollect: [:ea | OBRBroClassNode on: ea].! !

!SVNRBroCategoryNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 08:55'!
definition
	^ OBClassDefinition 
		environment: nil 
		template: ''! !

!SVNRBroCategoryNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 08:47'!
displayStringForChild: aNode
	^ aNode theClass theName! !

!SVNRBroCategoryNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:01'!
metaNode

	^ OBMetaNode named: 'nothing'! !

OBEnvironmentNode subclass: #SVNRBroEnvironmentNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-RepositoryBrowsing'!

!SVNRBroEnvironmentNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 08:25'!
categories
	| categories |
	categories := environment currentProject allClasses collect: [:ea | ea category].
	^ categories collect: [:ea | SVNRBroCategoryNode
			on: ea asString
			inEnvironment: environment]
! !

OBTextPanel subclass: #SVNOBProjectSelectionPanel
	instanceVariableNames: 'currentProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!SVNOBProjectSelectionPanel methodsFor: 'accessing' stamp: 'rkrk 4/21/2008 10:45'!
accept: aText notifying: anObject 

	self currentProject: (self browser svnEnvironment findSvnProjectNamed: aText asString).! !

!SVNOBProjectSelectionPanel methodsFor: 'accessing' stamp: 'rkrk 4/11/2008 19:49'!
announceCurrrentProjectChanged

	self
		announce: (SVNCurrentProjectChanged forProject: self currentProject);
		announce: OBRefreshRequired new.! !

!SVNOBProjectSelectionPanel methodsFor: 'accessing' stamp: 'rkrk 5/5/2008 23:27'!
browseCurrentProject

	| node svnProjectBrowser |
	currentProject ifNil: [^ self].
	svnProjectBrowser := SVNProjectBrowser open.
	node := svnProjectBrowser projectNodes
		detect: [:ea | ea svnElement = currentProject]
		ifNone: [nil].
	svnProjectBrowser
		setSelectedNode: node;
		updateTree.
	! !

!SVNOBProjectSelectionPanel methodsFor: 'accessing' stamp: 'per 4/24/2008 16:28'!
browseCurrentProject: aSVNProject

	| node |
	aSVNProject ifNotNil:
	[browser := SVNProjectBrowser open.
	node := browser projectNodes detect: [:ea | ea svnElement = aSVNProject]
	ifNone:[].
	browser setSelectedNode: node.
	browser updateTree.]
	! !

!SVNOBProjectSelectionPanel methodsFor: 'building' stamp: 'cop 4/8/2008 17:27'!
buildOn: aBuilder 
	^ aBuilder textfield: self with: []! !

!SVNOBProjectSelectionPanel methodsFor: 'accessing' stamp: 'cop 4/8/2008 18:02'!
currentProject
	^currentProject! !

!SVNOBProjectSelectionPanel methodsFor: 'accessing' stamp: 'rkrk 4/11/2008 19:50'!
currentProject: aSVNProject

	currentProject := aSVNProject.
	self changed: #text.
	self announceCurrrentProjectChanged! !

!SVNOBProjectSelectionPanel methodsFor: 'callbacks' stamp: 'rkrk 5/5/2008 23:31'!
menu: aMenu shifted: aBoolean selection: aTextSelection

	aMenu 
		add: self noProjectText
		selector: #currentProject:
		argument: nil.
	self browser svnEnvironment svnProjects isEmpty
		ifFalse: [aMenu addLine].
	self browser svnEnvironment svnProjects do: [:each |
		aMenu
		add: each theName
		selector: #currentProject:
		argument: each].
	aMenu 
		addLine;
		add: 'Browse current project'
		action: #browseCurrentProject.	
	
	^aMenu
	! !

!SVNOBProjectSelectionPanel methodsFor: 'text' stamp: 'rkrk 5/5/2008 23:28'!
noProjectText
	
	^ 'No SVNProject selected'! !

!SVNOBProjectSelectionPanel methodsFor: 'callbacks' stamp: 'cop 4/8/2008 17:42'!
selection
	^ 1 to: 0! !

!SVNOBProjectSelectionPanel methodsFor: 'callbacks' stamp: 'rkrk 5/5/2008 23:31'!
text
	^ (currentProject ifNil: [^self noProjectText]) theName! !

!SVNOBProjectSelectionPanel methodsFor: 'building' stamp: 'cop 4/8/2008 19:44'!
vResizing
	^ #shrinkWrap! !

!WindowsProcess methodsFor: '*SqueakSVN' stamp: 'rt 4/27/2008 01:16'!
waitForCommand: aCommandString
	"copied for UnixProcess"
	
	| proc d |
	self flag: #TODO. "sometimes the image stops"
	d := Delay forMilliseconds: 50.
	proc := self command: aCommandString.
	proc ifNil: [self class noAccessorAvailable].
	[proc isComplete] whileFalse: [d wait].
	^ proc
! !

!MorphicToolBuilder methodsFor: '*SqueakSVN' stamp: 'rkrk 5/13/2008 01:17'!
buildDiffSpec: aSpec

	| widget |
	self flag: #TODO. "Make diff morph pluggable.
	Now the creator hast to access the morph directly e.g. 
	for setting the diff text."
	widget := DiffMorph new.
	self register: widget id: aSpec name.
	self setFrame: aSpec frame in: widget.
	parent ifNotNil: [self add: widget to: parent].
	^ widget! !

OBMethodCategoryNode subclass: #OBRBroMethodCategoryNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-RepositoryBrowsing'!

!OBRBroMethodCategoryNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:09'!
childNodes
	^ (theClass versionedMethods
		select: [:ea | ea category = name]
		thenCollect: [:ea | OBRBroMethodNode
			on: ea theName
			inClass: theClass]) asOrderedCollection.! !

!OBRBroMethodCategoryNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:15'!
definition
	^ OBMethodDefinition
		selection:  (1 to: 0)
		source: ''
		inClass: self theClass! !

!OBRBroMethodCategoryNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:11'!
displayStringForChild: aNode
	^ aNode selector! !

!OBRBroMethodCategoryNode methodsFor: 'as yet unclassified' stamp: 'rkrk 5/13/2008 09:09'!
metaNode

	^ OBMetaNode named: 'nothing'! !

!FileDirectory methodsFor: '*SqueakSVN' stamp: 'rkrk 4/21/2008 14:55'!
deleteRecursivelyPlatformIndependent

	| p |
	"You will need the recursiveDelete.bat in a path which OSProcess can reach."
	self exists ifFalse: [^ self].
	SmalltalkImage current platformName =  'Win32'
		ifTrue: [p := ExternalOSProcess command:
			'recursiveDelete.bat "' , self pathName , '"'.
				[p isComplete] whileFalse: [(Delay forMilliseconds: 5) wait]].
	self exists ifTrue: [self recursiveDelete].! !

OBDefinitionPanel subclass: #OBSVNDefinitionPanel
	instanceVariableNames: 'morph contentMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-OBSystemBrowser'!

!OBSVNDefinitionPanel methodsFor: 'building' stamp: 'cop 5/10/2008 16:14'!
buildOn: aBuilder
	"Copied and refactored code"
	self morph ifNil: [self morph: (aBuilder panelArea: self with: [])].
	^self morph! !

!OBSVNDefinitionPanel methodsFor: 'functionality' stamp: 'cop 5/10/2008 16:14'!
changeToDiff
	"Copied and refactored code"
	( self contentMorph isKindOf: DiffMorph ) not
		ifTrue: [ self removeDependent: self contentMorph.
				 ^self exchangeContentWith: self createDiffMorph. ]! !

!OBSVNDefinitionPanel methodsFor: 'functionality' stamp: 'cop 5/10/2008 16:14'!
changeToTable
	"Copied and refactored code"
	( self contentMorph isKindOf: PluggableMultiColumnListMorph ) not
		ifTrue: [ self removeDependent: self contentMorph.
				 ^self exchangeContentWith: self createTableMorph. ]! !

!OBSVNDefinitionPanel methodsFor: 'functionality' stamp: 'cop 5/10/2008 16:14'!
changeToText
	"Copied and refactored code"
	(self contentMorph isNil or: [ (self contentMorph isKindOf: OBPluggableTextMorph) or: [self contentMorph isKindOf: OBPluggableTextMorphWithShout]] ) not
		ifTrue: [ | tempMorph |
				 tempMorph := self createTextMorph.
				 self exchangeContentWith: tempMorph.
				 self addDependent: tempMorph.
				 tempMorph refreshWorld ]! !

!OBSVNDefinitionPanel methodsFor: 'accessing' stamp: 'cop 5/10/2008 16:13'!
contentMorph
	
	^contentMorph! !

!OBSVNDefinitionPanel methodsFor: 'accessing' stamp: 'cop 5/10/2008 16:13'!
contentMorph: aMorph
	
	contentMorph := aMorph! !

!OBSVNDefinitionPanel methodsFor: 'morphic' stamp: 'cop 5/7/2008 15:00'!
createContentMorph

	^ self createTextMorph! !

!OBSVNDefinitionPanel methodsFor: 'morphic' stamp: 'cop 5/5/2008 16:43'!
createDiffMorph

	| diffMorph |
	diffMorph := DiffMorph from: self definition oldText to: self definition newText.
	diffMorph
		font: Preferences standardCodeFont;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.	
     ^diffMorph! !

!OBSVNDefinitionPanel methodsFor: 'morphic' stamp: 'cop 5/10/2008 16:15'!
createTableMorph
	"Copied and changed code"
	| tableMorph |
	tableMorph := PluggableMultiColumnListMorph
				on: self
				list: #list
				selected: nil
				changeSelected: nil.
	tableMorph
		font: Preferences standardCodeFont;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.	
     ^tableMorph! !

!OBSVNDefinitionPanel methodsFor: 'morphic' stamp: 'cop 5/10/2008 16:15'!
createTextMorph
	"Copied code"
	| textMorph |
	textMorph := self textMorphClass 
				on: self
				text: #text
				accept: #accept:notifying:
				readSelection: #selection
				menu: #menu:shifted:. 
	textMorph
		font: Preferences standardCodeFont;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.	
     ^textMorph! !

!OBSVNDefinitionPanel methodsFor: 'accessing' stamp: 'cop 4/7/2008 17:22'!
definition
	^definition! !

!OBSVNDefinitionPanel methodsFor: 'updating' stamp: 'cop 5/10/2008 16:16'!
definitionChanged: ann

	self definition: ann definition.
	self handleDefinition.
	self changed: #text! !

!OBSVNDefinitionPanel methodsFor: 'updating' stamp: 'cop 5/10/2008 16:16'!
exchangeContentWith: aMorph
	"Copied and refactored code"
    self morph removeMorph: self contentMorph. 
    aMorph vResizing: #spaceFill. 
    aMorph hResizing: #spaceFill.
    self contentMorph: aMorph. 
    self morph addMorphBack: self contentMorph.
    self contentMorph changed.! !

!OBSVNDefinitionPanel methodsFor: 'model access' stamp: 'cop 4/8/2008 11:43'!
getListSize
	^0! !

!OBSVNDefinitionPanel methodsFor: 'functionality' stamp: 'cop 5/5/2008 17:07'!
handleDefinition

	(self definition isKindOf: OBSVNBlameDefinition)
				ifTrue: [^ self changeToTable ].
	(self definition isKindOf: OBSVNDiffDefinition)
				ifFalse: [^ self changeToText ]
				ifTrue: [^ self changeToDiff ].! !

!OBSVNDefinitionPanel methodsFor: 'testing' stamp: 'cop 5/10/2008 16:17'!
hasReferencePanel
	"Copied and refactored code"
    ^ self browser class hasReferencePanel! !

!OBSVNDefinitionPanel methodsFor: 'functionality' stamp: 'cop 4/8/2008 11:22'!
list
	(self definition isKindOf: OBSVNBlameDefinition)
				ifFalse: [^Array new ]
				ifTrue: [^self definition blameArray ]! !

!OBSVNDefinitionPanel methodsFor: 'accessing' stamp: 'cop 5/10/2008 16:12'!
morph
	
	^morph! !

!OBSVNDefinitionPanel methodsFor: 'accessing' stamp: 'cop 5/10/2008 16:13'!
morph: aMorph
	
	morph := aMorph! !

!OBSVNDefinitionPanel methodsFor: 'updating' stamp: 'cop 4/8/2008 12:15'!
selectionChanged: ann
	self changeToText.
	super selectionChanged: ann.! !

!OBSVNDefinitionPanel methodsFor: 'accessing' stamp: 'cop 5/10/2008 20:13'!
setContentMorph: aMorph
	
	self contentMorph: aMorph! !

!OBSVNDefinitionPanel methodsFor: 'updating' stamp: 'cop 4/8/2008 12:15'!
subscribe
	self announcer 
		observe: OBDefinitionChanged 
		send: #definitionChanged:
		to: self.
	self announcer 
		observe: OBSelectionChanged 
		send: #selectionChanged:
		to: self! !

!OBSVNDefinitionPanel methodsFor: 'configuration' stamp: 'cop 5/10/2008 16:18'!
textMorphClass
	"Copied code"
	| shoutInstalled |
	shoutInstalled := (Smalltalk classNamed: #SHTextStylerST80) notNil.
	^shoutInstalled 
				ifTrue: [OBPluggableTextMorphWithShout]
				ifFalse: [OBPluggableTextMorph].! !
SVNRegistry initialize!
SVNTestDirectoryManager initialize!
SVNCreateRepositoryTool initialize!
SVNProjectBrowser initialize!
OBSVNSystemBrowser initialize!
